/**
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
'use strict';
var isLoaded = false;
var arrPath = [];
var imageURLs = [];
var jsonContentObj = [];
var currObjTemplate;
var contentInfoJson;
var callbackDesignTemplate;
var elementNo = 1;
var translateYCor = 0;
var deltaRotation = 0;
var isAnimNeeded = false;
var arrDeg = [10, -5, -9, -20, 24, -15, 30, -7, -33];
var arrCord = [[0.5, 0.5], [0.85, 0.5], [0.5, 0.15], [0.15, 0.15], [0.15, 0.5], [0.5, 0.85], [0.85, 0.15], [0.15, 0.85], [0.85, 0.85]];
var arrSelectedContent = [];
var folderPath;
var callBackFetchList;
var arrContentList = [];
var categoryGType = ""; 
var srcCounter = 0;
var play_Shuffle = null;
var isClassigBG = false;
var isModernBG = false;
var isVintageBG = false;
var arrBGList = [];
var arrBckImgList=[];
var backgroundCustomLst = [];
var isMax=false;
var galleryContentSel = {
    initialize : function() {
        this.bindEvents();
    },       
    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    /* deviceready Event Handler*/
    onDeviceReady : function() {        
    	 document.addEventListener("backbutton", onBackkeyDown, false);
        tplUIObj.updateOrientation(orientationMode);
        Utils.registerKeyboardObserver();         
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
          systemRootPath = fileSystem.root.toURL().replace("file://", "");            
        }, function(evt) {
            console.log("NOT ABLE TO GET SYTEM ROOT PATH");
        });               
    },
    receivedEvent : function(id) {       
        console.log('Received Event: ' + id);
    },
DragDrop:function() {
    var error = function(message) {
    };
    var success = function(message) {
    };
    mUiHandler.DragDrop(success, error);
},
addSelection:function(flagSelect, path) {
    var error = function(message) {  };
    var success = function(message) {  };
    mUiHandler.addSelection(flagSelect, path, success, error);
},
addGallery:function(flagShow,galleryStep,iMode) {     
    var error = function(message) {        
       if(message=="CLOSE")
       {
           Utils.isGalleryOpen=false;	       
       }        
    };
    var success = function(contentInfo) {
        if(galleryStep==STEP_TWO)
        {
            galleryContentSel.addCntntTOFrames(contentInfo);
        }
        else
        {
            Utils.isGalleryOpen=false;
            jsonContentObj=contentInfo;
            tplUIObj.updateDropArea();           
        }        
    };
    mUiHandler.addGallery(flagShow, galleryStep,jsonContentObj, success, error,iMode);
},
getSmallThumbDim:function(iWidth,iHeight)
{
    var aspectRatio=1,calW,calH,wPer,hPer;
    var aspctToken=W_EQ_H;    
    if(iWidth>iHeight)
    {
      aspectRatio= iWidth/iHeight;
      aspctToken=W_GT_H;
    }
    else if(iWidth<iHeight)
    {
       aspectRatio= iHeight/iWidth;
       aspctToken=W_LT_H; 
    }
    else
    {
        aspectRatio=1;
        aspctToken=W_EQ_H;
    }
    aspectRatio=parseFloat(aspectRatio).toFixed(2);    
    if(aspectRatio>=1.00 && aspectRatio<1.10)
    {
        wPer=0.198;
        hPer=0.198;              
    }
    else if(aspectRatio>=1.10 && aspectRatio<=1.60)
    {
        wPer=0.2364;
        hPer=0.130;        
    }
    else if(aspectRatio>=1.61)
    {
        wPer=0.2785;
        hPer=0.1464;        
    }
   
    if(aspctToken==W_LT_H)
    {
        calH=Math.round(WIN_INNER_H*hPer);
        calW=Math.round(calH/aspectRatio);  
    }
    else
    {        
        calW=Math.round(WIN_INNER_W*wPer);
        calH=Math.round(calW/aspectRatio);
    }
    return {w:calW,h:calH};
},
addContntFromGallery:function(contentInfo)
{
    jsonContentObj=[];
    $(".drpAreaImgCls").remove();       
    if(contentInfo.length==0)
    {   
        $('.tplDropAreaText').show();        
        return;
    }    
    var uniqueId,actualPath,thumbPath,mWidth,counter=0;
    var mHeight,item;
    var iteration,finlTmbHW;        
    $('.tplDropAreaText').hide();
        ttlDur=0;    
    $.each(contentInfo, function(index, result) {
        uniqueId = result["uniqueId"];
        actualPath = Utils.encodeThumbPath(result["actualPath"]);            
        thumbPath = Utils.encodeThumbPath(result["thumbPath"]);       
        mWidth = getParseIntInDec(result["width"]);
        mHeight = getParseIntInDec(result["height"]);
        $('#tplGalleyDropArea').append('<img class="drpAreaImgCls" id="' + uniqueId + '" src="' + thumbPath + '"/>');
        item = {};
        item["actualPath"] = result["actualPath"];
        item["thumbPath"] = result["thumbPath"];
        item["imgPath"] = "";
        item["uniqueId"] = uniqueId;
        item["fileType"] = result["fileType"];
        item["width"] = mWidth;
        item["height"] = mHeight;
        item["fileName"] = result["fileName"];
        item["duration"] = result["duration"];
        adClipUtils.updateDuration(result["duration"],true);
        jsonContentObj.push(item);
        finlTmbHW=galleryContentSel.getSmallThumbDim(mWidth,mHeight);                               
        counter = jsonContentObj.length - 1;            
        iteration = Math.round(counter / 9);
        counter = counter % 9;
        galleryContentSel.setAnimFrDrpAraElm({id:uniqueId,cntr:counter,w:finlTmbHW.w,h:finlTmbHW.h});       
        counter += iteration;
        counter = counter % 9;
        galleryContentSel.setStylFrDrpAreaElm(uniqueId,arrDeg[counter]);         
    });
    galleryContentSel.setImgCount();
    adClipUtils.getEstimatedTime();    
    console.log("---x----2galleryContentSel.getSelectedImgCount()::"+galleryContentSel.getSelectedImgCount());
},
addCntntTOFrames:function(contentInfo)
{       
    var xCord=contentInfo["xCordinate"];
    var yCord=contentInfo["yCordinate"];
    var elmObj=galleryContentSel.getElmObjFromJson(contentInfo,false);
    templateObj.addElementInFrame(elmObj, xCord, yCord,false); 
},
setImgCount:function()
{   
    $("#imggIconTextId1").html(galleryContentSel.getSelectedImgCount());
    if(galleryContentSel.getSelectedImgCount() < getParseIntInDec(themeInfo.MinImageNum)){
    	$("#tmpltNxtBtnId").addClass("icon-disabledForNext");
    }
    else{
    	$("#tmpltNxtBtnId").removeClass("icon-disabledForNext");
    }
},
getElmObjFromJson:function(json,isEncode)
{    
    var elmObj = {
        type : json["fileType"],
        imgPath : isEncode ? Utils.encodeThumbPath(json["imgPath"]):json["imgPath"],
        thumbPath : json["thumbPath"],
        orgImgPath : json["actualPath"],
        fileName : json["fileName"],
        orgW : getParseIntInDec(json["width"]),
        orgH : getParseIntInDec(json["height"]),
        duration : json["duration"]
    };
    return elmObj;
},
addBgGallery:function(flagShow,galleryStep,callBackToTemplate){
    var error = function(message) {
    };
    var success = function(contentInfo) {
    
        arrBckImgList=[];
        if (contentInfo == "addGallerySuccess") {
           
            return;
        } else {
            var isValidContent = contentInfo["isValidContent"];
            if (isValidContent == false || isValidContent == "false") {
                var errMsg = contentInfo["errMsg"];
                Utils.showToast(errMsg);              
                return false;
            }

        }
    	    Utils.isGalleryOpen=false;            
            arrBckImgList=contentInfo;
            callBackToTemplate.apply();
        
    }; 
    mUiHandler.addGallery(flagShow, galleryStep,null, success, error,DEFAULT_VALUE);   
},
createThumbnail:function(callBack){
   
   mUiHandler.addOverLay(true);
    callbackDesignTemplate = callBack;
    arrSelectedContent = [];
    arrSelectedContent = jsonContentObj;
    galleryContentSel.callStepInfoPlugIn(2,3);     
    loaderObj.showLoader({text:""});
    adClipUtils.updtAnalysingLodr(0);
    isAdClipAnalysingStart=true;
    selCntntMap={};
        
    var error = function(message) {        
        isAdClipAnalysingStart=false;
        adClipUtils.hidePageLoader();
        if(Utils.isIOSDvice()){
           window.clearInterval(adClipProgressTimer);
        }
    };
    var success = function(contentInfo) {
        selCntntMap={};
        $.each(contentInfo, function(index, result) {
            if (result['fileType'] == "image") {
                selCntntMap[result["actualPath"]]={
                    orgW:getParseIntInDec(result["width"])
                    ,orgH:getParseIntInDec(result["height"])
                    ,imgPath:result["imgPath"]
                    ,thumbPath: result["thumbPath"]
                };             
            }        
        }); 
        log.debug("selCntntMap: "+JSON.stringify(selCntntMap));    
        var successInr = function(value) {     
        	log.debug("inside sucess, value:"+value);   
            if(!isNaN(value))
            {
                value=value*0.8;
                if(value<1)
                {
                    value=1;
                }
                adClipUtils.updtAnalysingLodr(getParseIntInDec(value));    
            }
            else
            {    		
                 window.clearInterval(adClipProgressTimer);
                if(value == "ADCLIP_BG_CANCEL_COMPLETED"){  
                    adClipUtils.hidePageLoader();
                    return;
                }            
                else if(value == "FILE_NOT_FOUND"){
                    adClipUtils.hidePageLoader();
                    window.clearInterval(adClipProgressTimer);
                    return;
                }  
                themeSlotObj=JSON.parse(value);
                initTemplateModule();
            }    
        };     
        mAdclipManager.startADClip(successInr, error,UserInputContext);
        if(Utils.isIOSDvice()){
           adClipProgressTimer = setInterval(getProgressValueForIOS, 500);
        }
    };
mUiHandler.createCopyThumbnail(jsonContentObj, success, error);
},
callStepInfoPlugIn:function (currStep,nextStep)
{
        StepInfo.currStep = currStep;
        StepInfo.nextStep = nextStep;
        currStep = nextStep;
        var error = function() {
            log.debug("result: error ");
        };
        var success = function(result) {
            log.debug("result: success ");
        };
        mAdclipManager.adClipStepInfo(success, error, StepInfo);
},
capturePhoto:function() {
    /*Take picture using device camera and retrieve image as base64-encoded string*/
    navigator.camera.getPicture(onPhotoURISuccess, onFail, {
        quality : 50,
        destinationType : Camera.DestinationType.FILE_URI,
        allowEdit : false,
        saveToPhotoAlbum : true,
        correctOrientation : true
    });
    
},

onPhotoURISuccess:function(imageURI) {
},

onFail:function(message) {
},

contentValidation:function(categoryType){

    var msg="";
    var selectedContent = jsonContentObj.length;
    if (categoryType == Category.PROMOTION && selectedContent < 1) {
        msg = MIA_SID_SELECT_1_IMAGE_PROMOTION;        

    } else if (categoryType == Category.SLIDESHOW && selectedContent < 2) {
        msg = MIA_SID_SELECT_LEASE_2_IMG_SLIDSHOW;       
    }    
    return msg;
    
},
getSelectedVideoCount:function()
{
	var vdoCounter = 0;
	$.each(jsonContentObj, function(index, result) {
        if (result["fileType"] == "video") {            
            vdoCounter++;
        }
    });
  return vdoCounter;
},

getSelectedImgCount:function()
{
    var imgCounter = 0;
    $.each(jsonContentObj, function(index, result) {
        if (result["fileType"] == "image") {
            imgCounter++;
        }
    });
  return imgCounter;
},
delDropAreaItem:function(id)
{
    $("#" + id).remove();
    var indexDelete;    
    $.each(jsonContentObj, function(index, result) {
        if (result["uniqueId"] == id) {                            
            indexDelete = index; 
            adClipUtils.updateDuration(result["duration"],false);                           
        }
    });
    jsonContentObj.splice(indexDelete, 1);            
    galleryContentSel.setImgCount();
    adClipUtils.getEstimatedTime();
    showGuideMsg(); 
},
setAnimFrDrpAraElm:function(objProp)
{
    var cWidth = $("#tplGalleyDropArea").width();
    var cHeight = $("#tplGalleyDropArea").height();
    var elmObj=$("#"+objProp.id);  
    elmObj.css({              
        'width' : objProp.w + 'px',
        'height' : objProp.h + 'px'
    });
    elmObj.animate({
        'left' : (arrCord[objProp.cntr][0] * cWidth - (objProp.w / 2)) + 'px',
        'top' : (arrCord[objProp.cntr][1] * cHeight - (objProp.h / 2)) + 'px'
    }, 900);  
},
setStylFrDrpAreaElm:function(elmId,deg)
{
    try
    {
        var elmObj=$("#"+elmId);         
        elmObj.css({
            '-webkit-transform' : 'rotate(' + deg + 'deg)'
        });
        elmObj.draggable({
          stop: function() {                      
            var id=$(this).attr("id");
            var cWidth = $("#tplGalleyDropArea").width();
            var cHeight = $("#tplGalleyDropArea").height();
            var dpOffSet = $("#tplGalleyDropArea").offset();
            var eleObj=$("#"+id); 
            var elmW=eleObj.width();
            var elmH=eleObj.height();
            var elmOffSet=eleObj.offset();
            var elmX=elmOffSet.left+(elmW/2);
            var elmY=elmOffSet.top+(elmH/2);
            if(elmX<dpOffSet.left || elmX>(dpOffSet.left+cWidth) || elmY<dpOffSet.top || elmY>(dpOffSet.top+cHeight))
           {
               galleryContentSel.delDropAreaItem(id);
           }                    
          }           
        });           
    }
    catch(ex)
    {
        log.debug("Error: "+ex.message,"setStylFrDrpAreaElm");
    }   
},

getFileList:function(folderPath,funCallBack){
    
    arrBGList=[];
    callBackFetchList=funCallBack;
    folderPath=folderPath;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotDS1, fail1);

    function gotDS1(fileSystem) {
        entry = fileSystem.root.toURL();
        rootPath = fileSystem.root.toURL();

        if (deviceType == "iPad" || deviceType == "iPhone") {
            entry = folderPath;
        } else {
            entry = "/" + entry.split('///').pop() + folderPath;
        }

        this.filesys = fileSystem;
        fileSystem.root.getDirectory(entry, {
            create : true,
            exclusive : false
        }, onGetDirectoryWin1, onGetDirectoryFail1);
    }
    
    function fail1(error) {}
    function onGetDirectoryWin1(directoryEntry) {
        var directoryReader = directoryEntry.createReader();
        directoryReader.readEntries(gotDirectoryEntry1, fail1);
    }
    function onGetDirectoryFail1(directoryEntry) { }
    function gotDirectoryEntry1(entries) {
        for (var i = 0; i < entries.length; ++i) {
            arrBGList.push(entries[i].name);
        }
        callBackFetchList.apply();
        }    
},

ShuffleSound:function() {
    var resource = getPhoneGapPath() + 'resource/audio/Shuffle.wav';
    play_Shuffle = new Media(resource,
    function() {
        console.log("ShuffleSound():Audio Success");
    },
    function(err) {
        console.log("ShuffleSound():Audio Error: " + err);
    });

},

getPhoneGapPath:function() {
    var path = window.location.pathname;
    path = path.substr( 0, path.length - 22 );
    return path;
},

deleteFile:function(strPath,funCall){
    
    callBackFetchList=funCall;
    var relativeFilePath = strPath;

    if (deviceType == "iPad" || deviceType == "iPhone") {
        relativeFilePath = relativeFilePath.split("Documents/")[1];
    }

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
        fileSystem.root.getFile(relativeFilePath, {
            create : false
        }, function(fileEntry) {
            fileEntry.remove(function(file) {
                callBackFetchList.apply(this, [true]);
                console.log("File removed!");
            }, function() {
                callBackFetchList.apply(this, [false]);
                console.log("error deleting the file " + error.code);
            });
        }, function() {
            callBackFetchList.apply(this, [false]);
            console.log("file does not exist");
        });
    }, function(evt) {
        callBackFetchList.apply(this, [false]);
        console.log(evt.target.error.code);
    });

}
};


function onBackkeyDown(){
	var el = document.getElementById("_coachmarkpopUpId");
	if (el != null && el.style.display == "block") {
		closeCoachmarkGenericPopUp();
		return;
	}	
	 if (genericPopUpObj.isPopUpVisible()) {
        genericPopUpObj.hidePopUp();
        return false;
    }else if(Utils.isGalleryOpen){
	 	 mUiHandler.hideGallery();
	 	 Utils.isGalleryOpen = false;
	 	 return;
	 }else if(Utils.isHandwritingOpen){
	     return;
	 }else if(isAdClipAnalysingStart) {  
	    cancelAnalysing();
        return;
     }else if($('.stepCls').hasClass('step2-on') && isAdClipAnalysingStart==false){
     	goFromAdclipToQukStart();
     	return;
     }else if($('#cc_loaderId').is(':visible') && $('.stepCls').hasClass('step4-on')){
	 	$('#tpl_shuffleBtnId').trigger('tap');
	 	return;
	 }else if($('.textEnterCls').is(':visible')){
		$('.close-btn').trigger('tap');
		return;
	}else if($('.setting-slider').is(':visible')){
		$('.close-slider').trigger('tap');
		return;
		
	}else if( $('#TimePicker').css('display') == 'block' ) 
    {
        closeTimePicker();
        return;
    }else if(!handleMenuOnBack() && !$("#frameImagesDivId").is(':visible')){
			return false;
	}
	else{
	    if($('.stepCls').hasClass('step4-on')){
	    	   if ($("#tpl_shuffleBtnId").hasClass("addCancel")) {
	        	adClipUtils.cancelAdClip();
        } else{
            galleryContentSel.callStepInfoPlugIn(4,3);
            tplUIObj.hLightStep(3);            
            adClipUtils.changeBtnState("");            
            $("#shuffleBtnArea").show();
            $("#shuffleDownBtnId").show();
            $("#tmpltNxtBtnId,#showListBtnId").css("visibility","visible");           
            $("#tpl_shuffleBtnId").hide();
        }}
         else if($('.stepCls').hasClass('step3-on')){
         	if($(".parentDiv").is(':visible')){
         		$(".parentDiv").hide();
         		$('#shuffleBtnArea').show();
         	}
         	else if($("#frameImagesDivId").is(':visible')){
         		$("#frameImagesDivId").hide();
         	}
         	else{ 
         		galleryContentSel.callStepInfoPlugIn(3,2);
               tplUIObj.hLightStep(2);
               tplUIObj.rndrStepOne();
         	}
           
        }
        else{
            galleryContentSel.callStepInfoPlugIn(2,0);
                if(isAdClipAnalysingStart)
		        {           
		            cancelAnalysing();
		        }  
		        else
		        { 
		            goFromAdclipToQukStart();
		        }
            
        }
     }
      return;
 }
 function goFromAdclipToQukStart()
{
    document.location.href = "../quickstart/QuickStart.html?isadClip=true";
}

function cancelAnalysing()
{
    var successError=function(message){        
        adClipUtils.hidePageLoader();  
       isAdClipAnalysingStart = false;    
    };    
    loaderObj.showLoader({text:langObj.Adclip.MIA_SID_CANCELING_DOT,dimRect:{w:"100%",h:"100%",x:"0%",y:"0%"},alpha:0.5});            
    mAdclipManager.cancelADClip(successError,successError); 
    
} ;
 var adClipProgressTimer; 
function getProgressValueForIOS(){
    var error = function(message) { };
    var success = function(value) {
        value=value*0.8;
        if(value<1)
        {
            value=1;
        }        
        adClipUtils.updtAnalysingLodr(getParseIntInDec(value));
    };
    mAdclipManager.getProgressValue(success, error);
}