/*
* Created by p.pathak 24Jun2015
* Dependent Files : templateFrames.js, template.js
*
*/
'use strict';
var tplCategory;
var currRegion = REGION_OTHERS;
var orientationMode = LANDSCAPE;
var STEP1 = "step1";
var STEP2 = "step2";
var SCHUFFLE = "schuffle";
var CUSTOMDESIGN = "customDesign";
var currState = "";
var currRndrTmpltID = "";
var ZOOM_FACTOR = 25;
var MAX_ZOOM = 100;
var MAX_ZOOM_SNAP = 90;
var MIN_ZOOM = 0;
var MIN_ZOOM_SNAP = 10;
var ZOOM_STEP = 10;
var shuffleTimeout = null;
var MIN_FONT_SIZE = 20;
var MAX_FONT_SIZE = 200;
var templatePathFrmUrl;
var TEMPLATE = 501;
var BACKGROUND = 502;
var CAMERA = 503;
var GALLERY = 504;
var WIDGET = 505;
var VIDEO =506;
var bTextEditXOrDone = false;
var step1Region = REGION_OTHERS;
$(function() {
    var urlVars=Utils.getUrlVars();
    currModel = Utils.getActivePlayerType();
    tplCategory = urlVars["category"];
    var tplOrientation;
    templatePathFrmUrl = urlVars["templatePath"];
   $(".backwardCls").html(langObj.template.MIA_SID_BACKWARD);   
   $(".forwardCls").html(langObj.template.COM_TV_SID_FORWARD);
   $(".backCls").html(langObj.template.MIA_SID_BACK);   
   $(".frontCls").html(langObj.template.MIA_SID_FONT);
   $(".camcoderTxtCls").html(langObj.CoachMark.COM_SID_VIDEO);
    adClipUtils.loadFontXMLObj();
   Utils.setCurrStep(STEP_ONE);
    tplUIObj.showhide(STEP1);
    tplUIObj.hLightStep(2);
    $("#tmpltNxtBtnId").addClass("icon-disabledForNext");
    tplOrientation = getParseIntInDec(urlVars["orientation"]);
    tplUIObj.updateOrientation(LANDSCAPE);
    showGuideMsg();    
  $("#enterText").css({
    'height':window.innerHeight+'px',
                      'width':window.innerWidth+'px'
  });
    $("#txtEditAreaId").on("blur", function(e){
        if(Utils.isIOSDvice()){
            if(bTextEditXOrDone){
                bTextEditXOrDone = false;
            }else{
                $("#editTxtDoneBtnId").trigger("tap");
            }
        }
    });
    /* Binding events on ready : START*/
    $('#selectedOrientation').off("tap").on('tap', function(e) {
        tplUIObj.switchOrientation($(this));
    });
    $(".sourceBrowser").off("tap").on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();   
        var type=eval($(this).attr("type"));
     if ( !$(this).hasClass("icon-disabled")) {
           showBtmMenuDtaDv(type);
        }
        return false;
    });
    $('.scheduleCls').off("tap").on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        callTemplateFunc(constForTmpl.OUTSIDETAP);
        SaveTemplate.scheduleCustomTemplate();
        return false;
    });
    /*stop propagation for menu data divs*/
    $(document).off("tap", ".stopPropagationCls");
    $(document).on("tap", ".stopPropagationCls", function(e) {
        e.preventDefault();
        e.stopPropagation();
        return false;
    });
    /******shuffleButton Area click*****/
    $('#shuffleDownBtnId').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        $('#shuffleBtnArea').hide();
        tplUIObj.showhide(SCHUFFLE);
        return false;
    });
    $('.shuffleDownCls').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        $('.parentDiv').hide();
        $('#shuffleBtnArea').show();
        return false;
    });

    /********************* help button (coach mark) event*****/
    $(".helpBtnCls").off('tap').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();        
        if( $('.stepCls').hasClass('step2-on') )
        {
            HelpPopUp("AD_STEP2");
        }
        else if( $('.stepCls').hasClass('step3-on') )
        {
            if( $(".parentDiv").css('display') == 'block' )
            {
                HelpPopUp("AD_STEP3_3");
            }
            else if (  $("#frameImagesDivId").css('display') == 'block'  )
            {
                HelpPopUp("AD_STEP3_2");
            }
            else
            {
                HelpPopUp("AD_STEP3_1");
            }
        }
        else if( $('.stepCls').hasClass('step4-on') )
        {
            if( $("#tpl_shuffleBtnId").text() == langObj.Adclip.COM_TEXT_CREATE_P_KR_MIS20  )
            {
                HelpPopUp("AD_STEP4_1");
            }
            else if ( $("#tpl_shuffleBtnId").text() == langObj.Schedule.COM_BUTTON_SAVE )
            {
                HelpPopUp("AD_STEP4_2");
            }            
        }
    });
    
    /********************* Home Button click event*****/
    $("#homeBtnId").on('tap', function(e) {
    	if($("#homeBtnId").hasClass('icon-disabled')){
    		return;
    	}
        e.preventDefault();
        e.stopPropagation();  
        callTemplateFunc(constForTmpl.OUTSIDETAP);  
        exitFromAdClip();
        return false;
    });   
    $("#tpl_shuffleBtnId").on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
           if ($("#tpl_shuffleBtnId").hasClass("addCancel")) {
                adClipUtils.cancelAdClip();
            } else if ($("#tpl_shuffleBtnId").hasClass("addSave")) {
                adClipUtils.openAdClipSavePopup();
            } else {                
                  console.log("creating Start::"+getTimeWithMiliSec());   
                adClipUtils.startCreatingAdClip();
            }
        return false;
    });
    $("#showListBtnId").on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        $('#shuffleBtnArea').hide();
        callTemplateFunc(constForTmpl.RNDR_FRAME_THUMB);     
        return false;
    });
    $("#previewBtnId").on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();      
        templateObj.showTemplatePreview();
        return false;
    });
    
    /******shuffleButton Area click end*****/
    $("#tmpltNxtBtnId").on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        if($('.stepCls').hasClass('step2-on')){
            
            var validObj=adClipUtils.isSelCntntValid();
            if(!validObj.flag)
            {
                Utils.showToast(validObj.msg);
                return;
            } 
            var msg = galleryContentSel.contentValidation(tplCategory);
            if (msg.length >= 1) {
                Utils.showToast(msg);
                return;
            }
           adClipUtils.updateUserInputCntxt();
            galleryContentSel.createThumbnail(function() {
                console.log("inside thumbnail"); 
                showHideTmpltArea(true);          
                tplUIObj.showhide(STEP2);
                tplUIObj.hLightStep(3);  
                Utils.setCurrStep(STEP_TWO);                          
            });
        }
        else if($('.stepCls').hasClass('step3-on')){
        	var isTmpEdit=templateObj.isEdited;
        	log.debug("isTmpEdit :"+isTmpEdit);
            tplUIObj.hLightStep(4); 
            $('.parentDiv').hide();
            callTemplateFunc(constForTmpl.OUTSIDETAP);
            var frame=templateObj.getActiveFrame();
            frame.activeEleIndex=0;
            templateObj.renderActvElmOfFrame(frame.id);
            isListRendrOnce=false;
            $("#shuffleBtnArea").show();        
            $("#tpl_shuffleBtnId").show();
            $("#shuffleDownBtnId").hide();
            $("#tmpltNxtBtnId,#showListBtnId").css("visibility","hidden"); 
            if(!isTmpEdit)
      	   {
      		   adClipUtils.changeBtnState("save");
      	   }
            else
           {
            adClipUtils.changeBtnState("create");
           }
        }   
        return false;
    });
    $("#tmpltPrevBtnId").on('tap', function(e) {
    	if($("#tmpltPrevBtnId").hasClass('icon-disabled')){
    		return;
    	}
        e.preventDefault();
        e.stopPropagation();
        $("#tmpltNxtBtnId").css("visibility","visible");
        if($('.stepCls').hasClass('step4-on')){
            galleryContentSel.callStepInfoPlugIn(4,3);
            tplUIObj.hLightStep(3);            
            adClipUtils.changeBtnState("");            
            $("#shuffleBtnArea").show();
            $("#shuffleDownBtnId").show();
            $("#tmpltNxtBtnId,#showListBtnId").css("visibility","visible");           
            $("#tpl_shuffleBtnId").hide();
        }
         else if($('.stepCls').hasClass('step3-on')){
             galleryContentSel.callStepInfoPlugIn(3,2);
               tplUIObj.hLightStep(2);
               tplUIObj.rndrStepOne();
        }
        else{
            galleryContentSel.callStepInfoPlugIn(2,0);
            document.location.href = "../quickstart/QuickStart.html?isadClip=true";            
        }     
        return false;
    });
    $(".close-btn").off("tap").on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        if($(this).hasClass('close-web')){
            $("#enterURL").hide();    
        }else if($(this).hasClass('close-rss')){
            $("#enterRssURL").hide();    
        }else{
            bTextEditXOrDone = true;
            $('#txtEditAreaId').trigger("blur");
            $("#enterText").hide();    
        }
        return false;
    });
    $("#editTxtDoneBtnId").off("tap").on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        bTextEditXOrDone = true;
        $('#txtEditAreaId').trigger("blur");
        var text = $.trim($('#txtEditAreaId').val().replace(/[\n\r]/g, "<br>"));
        text = text.replace(/<br\/>/g, "<br>");
        text = text.replace(/&nbsp;/ig, "");
        if (text.substring(text.length - 4) == "<br>") {
            text = text.replace(/<br>$/, "");
        }
        log.debug(text, "TxtEditScreen");
        callTemplateFunc(constForTmpl.CLOSE_TXT_EDIT, text);
        return false;
    });
    uploadAllTemplateRelatedFiles();   
});
/*------ready end------*/
function uploadAllTemplateRelatedFiles()
{	
	setTimeout(function(){		
		loadjscssfile("js/adClipFrames.js","js");
		loadjscssfile("js/adClipTemplate.js","js");
	},400);
	/*setTimeout(function(){
        loadjscssfile("../template/js/TemplateUtils.js","js");
        loadjscssfile("../template/js/SaveTemplate.js","js");
    },500);*/
};

var TemplateUI = function() {};
TemplateUI.prototype.calResolDivDim=function()
{
    var hight=getParseIntInDec(window.innerHeight*0.0758);
    var fontS=Math.round(hight*0.30);
    $(".resolDivCls").css({
        'height':hight+'px'
        ,'font-size':fontS+'px'
        ,'line-height':hight+'px'
    });
};
TemplateUI.prototype.rndrStepOne = function() {
    closeAuthorMenu();
    showHideTmpltArea(false);
    $("#frameImagesDivId").hide();    
    this.showhide(STEP1);
    this.updateDropArea();
    Utils.setCurrStep(STEP_ONE);
    this.hLightStep(2);    
    $('.source-browser').css({
        'width' : '97%'
    });        
    hideBottomMenu();
};

TemplateUI.prototype.getCurrTmpltType = function() {
    if ($("#tmpltTypeIconId").hasClass("portraitTypeCls")) {
        return PORTRAIT;
    } else {
        return LANDSCAPE;
    }
};
TemplateUI.prototype.hLightStep = function(iStep) {
    console.log("iStep5:"+iStep);
    var i=1;    
    for (i = 1; i <= 4; i++) {
        $("#stepId_" + i).removeClass("step" + i + "-on step-past step" + i + "-off");
        if(i<iStep)
        {
            $("#stepId_" + i).addClass("step-past");
        }
        else if(i>iStep)
        {
            $("#stepId_" + i).addClass("step" + i + "-off");
        }
        else
        {
            $("#stepId_" + i).addClass("step" + i + "-on");
        }      
    }
};
TemplateUI.prototype.updateOrienBtnUI = function($this) {
    if ($this.hasClass('landSelected')) {
        $this.removeClass('landSelected').addClass('portSelected');
        $('.mediaContainerCls').addClass('showPortrait');
        this.updateOrientation(PORTRAIT);
    } else if ($this.hasClass('portSelected')) {
        $this.removeClass('portSelected').addClass('landSelected');
        $('.mediaContainerCls').removeClass('showPortrait');
        this.updateOrientation(LANDSCAPE);
    }
};
TemplateUI.prototype.switchOrientation = function($this) {
    if (currModel == RMD_MODEL && tplCategory == Category.LIVETV && orientationMode == LANDSCAPE) {
        Utils.showToast(langObj.template.MIS_SID_VIDEOS_INPUT_NOT_SUPPORTED_MODE);
        return;
    }
    var currObj = this;
    var totalLength = jsonContentObj.length;
    var flag = false;
    if (totalLength != 0) {
        var imgCnter = galleryContentSel.getSelectedImgCount();
        var vdoCnter = galleryContentSel.getSelectedVideoCount();
        if (tplCategory == Category.LIVETV && orientationMode == LANDSCAPE && (currModel == RHE_MODEL || currModel == TIZEN_MODEL)) {
            if (imgCnter <= 2 || (vdoCnter == 1 && totalLength == 1)) {
                currObj.updtDrpAreaAndOrient($this);
            } else {
                genericPopUpObj.createPopUp("", "Type1");
                genericPopUpObj.appendHTMLData([MIA_SID_MIX_SELECT_UP_IMAGES_PROTRAIT_MODE.replace('<<A>>', LIVE_TV_PORTRAIT_IMG)]);
                genericPopUpObj.addFooterBtns([{
                    "btntxt" : COM_SID_CANCEL,
                    "callback" : "closeGenericPopUp"
                }, {
                    "btntxt" : COM_SID_OK,
                    "callback" : function() {
                        var tempJsonArr = [];
                        var tempImgCounter = 0;
                        $.each(jsonContentObj, function(index, result) {
                            if (result["fileType"] == "image") {
                                tempImgCounter++;
                                if (tempImgCounter <= 2) {
                                    tempJsonArr.push(result);
                                }
                            } else {
                                tempJsonArr.push(result);
                            }
                        });
                        jsonContentObj = tempJsonArr;
                        arrSelectedContent = [];
                        arrSelectedContent = jsonContentObj;
                        currObj.updtDrpAreaAndOrient($this);

                    }
                }]);
                genericPopUpObj.showPopUp();
            }
        } else {
            currObj.updtDrpAreaAndOrient($this);
        }
    } else {
        currObj.updtDrpAreaAndOrient($this);
    }
};
TemplateUI.prototype.updtDrpAreaAndOrient = function($this) {
    this.updateOrienBtnUI($this);
    this.updateDropArea();
};
TemplateUI.prototype.updateDropArea = function() {
    galleryContentSel.addContntFromGallery(jsonContentObj);    
};
TemplateUI.prototype.browseContent = function($this) {
    Utils.isGalleryOpen == true;    
    galleryContentSel.addGallery(true, Utils.getCurrStep(),DEFAULT_VALUE);
};
TemplateUI.prototype.openCamera = function($this) {
    mUiHandler.addCamera();
};
TemplateUI.prototype.updateOrientation = function(iOrien) {
    try {
        orientationMode = 1000;
        localStorage.setItem("orientationType", orientationMode);
        mUiHandler.setOrientation(iOrien);
    } catch(ex) {
        log.debug("Error in updateOrientation function: " + ex.message);
    }
};
function getRgbaClrInRgbnAlpha(rgbaColor)
{     
     var rgbColor=$.trim(rgbaColor.replace("rgba","").replace("(","").replace(")",""));
     log.debug("1rgbColor:" +rgbColor);
     rgbColor=rgbColor.split(",");
     var i=0;
     var len=rgbColor.length;
     for(i=0;i<len;i++)
     {
         rgbColor[i]=getParseIntInDec($.trim(rgbColor[i]));
     }
     var colorObj={};
     colorObj.rgb="rgb("+rgbColor[0]+","+rgbColor[1]+","+rgbColor[2]+")";
     colorObj.alpha=rgbColor[3];
     log.debug("3rgbColor:" +JSON.stringify(colorObj));
     return colorObj;
}
function initTemplateModule()
{
    log.debug("START","initTemplateModule");
    updtTmpltObjToNew();            
    templateObj.initTemplate(LANDSCAPE, FIXED_LAYOUT);            
    templateObj.fillFramesFromImageUrl([], [],'AD');
    log.debug("COMPLETE","initTemplateModule");
};
function updtTmpltObjToNew() {
    try {
        if (templateObj != null) {
            for (var prop in templateObj) {
                if (templateObj.hasOwnProperty(prop)) {
                    delete templateObj[prop];
                }
            }
        }
    } catch(ex) {
        log.debug("Error in deleting the prev obj properties", "updtTmpltObjToNew");
    }
    templateObj = null;
    templateObj = new template();
    $("#frameResDivID").hide();
}

function addCSSStrInPage(iHTML) {
    var special_font = document.createElement("style");
    special_font.type = "text/css";
    special_font.innerHTML = iHTML;
    document.getElementsByTagName('head')[0].appendChild(special_font);
}

function showHideTmpltArea(iFlag) {
    if (iFlag) {
        $("#dropAreaMnDivId").hide();
        $("#tplMainContainer").show();
        $(".parentDiv").hide();
        $("#shuffleBtnArea").show();
    } else {
        $("#dropAreaMnDivId").show();
        $("#tplMainContainer").hide();
        $(".parentDiv").show();
        $('#shuffleBtnArea').css({
            'bottom' : '4.7%'
        });

        $('#shuffleDownBtnId').removeClass('shuffleDownCls').addClass('shuffleHamburgerCls');
        $("#shuffleBtnArea").hide();
    }
}
function createAdClipFooter(){    
    $("#adClipFooterContainer").remove();
    var addClipContainer=$('<div id="adClipFooterContainer" style="margin-top:7.5%; width:85%; margin-left:7%; height:8.8%; ">'
       +'<div id="imggIconId"></div><div id="imggIconTextId1"></div>'
       +'<div id="imggIconTextId2"></div><div id="videoFileIconId"></div><div id="videoFileIconTextId"></div><div id="runTymTextId"></div><div id="runTymIconId"></div></div>');
       $("#dropAreaMnDivId").append(addClipContainer);
        $("#runTymTextId").html(adClipUtils.replaceSecInSecSID(0));
       $("#imggIconTextId1").html("0");
       $("#videoFileIconTextId").html(adClipUtils.replaceSecInSecSID(0));
}
function showBtmMenuDtaDv(iToken) {
    switch(iToken) {
    case GALLERY:
        tplUIObj.browseContent();
        break;
         case VIDEO:
         mAdclipManager.launchVideoCamera();
         
        break; 
    case CAMERA:
        tplUIObj.openCamera();
        break;
        case TEXT:
            showEditMenu(3);
            $('#TemplateMainMenuId').addClass("animateContentMenu");
            break;
        case TEMPLATE:            
            if ($("#catDDArwId").hasClass("catDDArowUpCls")) {
                $("#catDDArwId").trigger("tap");
            }     
            tplUIObj.selCurrRndrTmpltIcon();
            callTemplateFunc(constForTmpl.SHIFTFORMENU,UP);
            $('#tmpltIcnsParID').addClass("animateContentMenu");            
            break;       
        case STICKER:
           $('#stickerContainer').addClass("animateContentMenu");
            break;
        case BACKGROUND:
           $('#backgrndMenuHeaderTab2Id').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
            showEditMenu(2);
            $('.bckgrndEditSubmenu').addClass("animateContentMenu");
            break;       
        default:
            break;
    }
    if (templateObj != null && templateObj != undefined) {
        templateObj.bCanvasAnyElmSel = true;
    }
}

TemplateUI.prototype.selCurrRndrTmpltIcon=function()
{
    $('.tmpltIconsCls').removeClass("tmpltIconsSelCls");
    $('.tmpltIconsCls[tmpltID="' + currRndrTmpltID + '"]').addClass("tmpltIconsSelCls");
};
TemplateUI.prototype.showhide = function(step) {
    switch(step) {
    case STEP1:
        currRegion = step1Region;
        
        $('.customDesignCls').hide();
        $(".stepHeaderCls").show();
        $('#stepId_1').removeClass('step-on').addClass('step-past');
        $(".shuffleBtnArea").hide();
        $("#previewBtnArea").hide();
        $('.source-browser').css({
            'width' : '100%'
        });
          $('.step1').css({
            'width' : '19%'
        });
        $('.schuffleCls').hide();
        $(".step1").show();
        $(".step2").hide();
        $(".camCoder").show();
        createAdClipFooter();
         adClipUtils.setInfoFromUserSelectedTheme();
        currState = step;
        break;
    case STEP2:   
           step1Region = currRegion;     
       $('.step1,.step2').css({
                'width' : '22.5%'
              });
        $('.customDesignCls').hide();
        $(".stepHeaderCls").show();
        $(".camCoder").hide();
        $(".step2").show();
        $("#previewBtnArea").show();
        /*if (tplCategory == Category.LIVETV) {
            $(".source").show();
        }*/
        currState = step;
         var loc = sessionStorage.getItem('locale');
         if(loc=="de")
          {
           $('.shfCls').addClass('shfdeCls');    
          }
        break;
    case SCHUFFLE:
        $('.source-browser').css({
            'width' : '84%'
        });
    
        $('.parentDiv').show();
        $('.schuffleCls').show();
        $("#previewBtnArea").show();
        break;
    case CUSTOMDESIGN:
        $("#tpl_shuffleBtnId").hide();
        $('.customDesignCls').show();
         $('#templateNameDiv').show();
           $('.step1,.step2').css({
                'width' : '21.8%'
              });
       
        $('.customCls').show();
        $(".step2").show();
        $("#previewBtnArea").show();  
        $('#customTextId').autoFontSize({ maxFontPixels: 18,minFontPixels:12});      
        $(".quickStartStepCls").hide();
        $(".orientationPrevCls").hide();
        $(".orientationNextCls").hide();
        $(".stepHeaderCls").hide();
        currState = step;
        if((SaveTemplate.templateName=="") ||(SaveTemplate.templateName==null)){
             $("#templateNameDiv").html(langObj.template.MIS_SID_UNTITLED); 
            
        }
        else{
            
             $("#templateNameDiv").html(SaveTemplate.templateName); 
            
        }
        break;
    default:
        break;
    }
};

function showCurrentHrd(iFlag) {
    if (iFlag) {
        if (currState == CUSTOMDESIGN) {
            $('.customDesignCls').show();
            $('.customCls').show();
        } else {
            $(".stepHeaderCls").show();
        }
    } else {

        if (currState == CUSTOMDESIGN) {
            $('.customDesignCls').hide();
        } else {
            $(".stepHeaderCls").hide();
        }
    }
}

function hideAllBtmDtaDvs() {
   $('.animateContentMenu').removeClass('animateContentMenu');     
}

function hideBottomMenu() {
    hideAllBtmDtaDvs();
    Utils.isGalleryOpen = false;
    mUiHandler.hideGallery();
}

function callTemplateFunc(iType, param) {
    if (templateObj == null || templateObj == undefined) {
        return null;
    }
    switch(iType) {
    case constForTmpl.SHIFTFORMENU:
        templateObj.shiftTemplateForMenu(param);
        break;
    case constForTmpl.SHOWMAINFRAME:
        templateObj.showMainFrame();
        break;
    case constForTmpl.KEYBOARDCLOSE:
        templateObj.processKeyBoardClose();
        break;
    case constForTmpl.HIDEITEMLIST:
        templateObj.hideItemList(param);
        break;
    case constForTmpl.OUTSIDETAP:
        templateObj.callOutSideTap();        
        break;
    case constForTmpl.RNDR_FRAME_THUMB:
        var frameID = templateObj.getActiveFrame().id;
        if (frameID.indexOf("_Main") == -1) {
            templateObj.renderFrameThumbs(frameID);
        }
        break;
    case constForTmpl.CLOSE_TXT_EDIT:
        templateObj.closeTxtEditScreen(param);
        break;
    case constForTmpl.SHOW_HIDE_FRAME_CTRLS:
        var frame=templateObj.getActiveFrame();
        templateObj.showHideFrameControls(frame, param.bCtrlPt, param.bRotation);
        break;
    case constForTmpl.SHOW_HIDE_ELEMENT_CONTROLS:
        var frame=templateObj.getActiveFrame();         
        if (frame.id.indexOf("_Main") != -1) {
            templateObj.showhideMainFrameElmControls(param);
        }
        else
        {           
           templateObj.showHideFrameControls(frame, param, true); 
        }
        break;  
    case constForTmpl.ARRANGE_LAYER_ELM_CNT:
        return templateObj.getArrangeLayerElmCount();
    break;   
    default:
        break;
    }
}

function exitFromAdClip()
{      
    genericPopUpObj.createPopUp("", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Adclip.MIA_SID_STOP_CREATING_AD_CLIP_NOT_SAVE_VIDEO]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_CANCEL,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : COM_SID_OK,
        "callback" : function() {
            galleryContentSel.callStepInfoPlugIn(StepInfo.currStep,0);
            mUiHandler.addOverLay(false);    
            Utils.hideGallery(GALLERY_STEP1,true,false);                
            document.location.href = "../quickstart/QuickStart.html";
        }
    }]);
    genericPopUpObj.showPopUp();
}
function showGuideMsg() {
    if ($("#tplGalleyDropArea img").length == 0) {
        $('.tplDropAreaText').show();
        setTimeout(function() {
             $(".tplDropAreaText").html(langObj.Adclip.MIA_SID_ADD_VIDEOS_IAMGE_CREATE_CLIP);        
        }, 50);
    }
}
var tplUIObj = new TemplateUI();
