/* 
 * 
 * 
 * Firmware And Store
 * Created By k.Sravani
 */
var thisVal;
$(function()
{
     //*******************************FirmwareWare Click Events Start ***********************************/
    
    $('.list').on('tap', 'li', function(e) {

        e.stopPropagation();
        e.preventDefault();
        settingsPageType = 2;
        var storageInfoTxt = $(this).find('.storageInfo').text();
        if(storageInfoTxt == langObj.Settings.COM_TV_SID_CHECKING_DOT_KR_KOR ||
           storageInfoTxt == langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE ||
           storageInfoTxt == langObj.Settings.MIS_SID_NOT_SUPOORT ||
           storageInfoTxt.indexOf(langObj.Send.MIA_SID_20_LOCKED) != -1){
            return false;
        }

        if ( isFirmwareProgress == true )
            return;
        
        thisVal = $(this);

        deviceID = $(this).attr('id');
        deviceIp = $(this).attr('ip');
        tlsReq = $(this).attr('tls');
        pin = $(this).attr('pin');
        var mac =  $(this).attr('mac');
        var deviceName = $(this).attr('deviceName');
        devicename = deviceName;
        deviceListContainerRef = $(this);

        $(this).removeClass('send-failed');
        if ($('.list>li#' + deviceID).attr('isAddedManually')) {
            $('.list>li#' + deviceID).find('.function_icon').removeClass('err_icon').addClass('del_icon');    
        } else {
            $('.list>li#' + deviceID).find('.function_icon').removeClass('err_icon');
        }
        
        // FIRMWARE UPDATE INITIALIZE
        deviceIp = deviceIp.trim();
        /*deviceIp = deviceIp.split(".").map(function(i) {
            return parseFloat(i);
        }).join(".");*/

        mLFDInfoArrayList = new Array();
        mLFDInfo = new mLFDDeviceInfo();
        mLFDInfo.mDeviceIP = deviceIp;
        mLFDInfo.mDeviceName = deviceName;
        mLFDInfo.mDeviceId = deviceID;
        mLFDInfo.mMetaInfo = "";
        mLFDInfo.mStatus = INITIALIZE;
        mLFDInfo.mTLSRequired = tlsReq;
        mLFDInfo.mPin = pin;
        mLFDInfo.mMacAddr = mac;


        if (Utils.checkConnection() == 3) {
             if(tlsReq == '1' && pin.length == 0){
                 $('#pin_verification_page_Id').attr('isManual',false);
                 var pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_ENTER_PIN_NUMBER_FOR.replace("<<A>>", devicename) + " " + langObj.Send.MIA_SID_20_PROCESS_REQUIRED_CONNECTING_TARGET_FIRST);
                 askToEnterCorrectPIN(deviceIp,false,pinHeaderStr);
                 //$('#pinboxd').focus();
             }else{
                mLFDInfoArrayList.push(mLFDInfo);
            $('.AddsignageTvCls').addClass('AddDisableAddManual');
            $('#updatefooterIcon>.refresh').addClass('icon-disabled');
            mProtocolManager.initNetworkConnection(CONNECTION_TYPE_FIRMWARE_UPGRADE);
            oldFirmwareVersion = $('.list>li#' +deviceID).find('.storageInfo').text();
            setTimeout(function() {
                showFirmwareCancelPopup();
            }, 500);
             }

        } else {
			mLFDInfoArrayList.push(mLFDInfo);
            var showWifiSetUpPopUp = true;

            if (showWifiSetUpPopUp) {
               /* $('.list>li#' + deviceID + '>.icon').hide();*/
                genericPopUpObj.createPopUp("Notification", "Type1","Wi-Fi");
                genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_UNABLE_CONNECT_TAGET_DEVICE + " " + langObj.Settings.MIA_SID_WIFI_TURNED_OFF]);
                genericPopUpObj.addFooterBtns([{
                    "btntxt" : langObj.Settings.MIA_SID_SET_UP_WI_FI,
                    "callback" : function() {
                        closeGenericPopUp();
                        mUtilityManager.openWiFiSettings();

                    }
                }, {
                    "btntxt" : langObj.Send.COM_SID_CANCEL,
                    "callback" : function() {
                        closeGenericPopUp();
                    }
                }, {
                    "btntxt" : COM_SID_OK,
                    "callback" : function() {
                        closeGenericPopUp();
                        mProtocolManager.initNetworkConnection(CONNECTION_TYPE_FIRMWARE_UPGRADE);
                        oldFirmwareVersion = $('.list>li#' +deviceID).find('.storageInfo').text();
                        setTimeout(function() {
                            showFirmwareCancelPopup();
                        }, 500);
                    }
                }]);
                genericPopUpObj.showPopUp();
            } else {
                setTimeout(function() {
                	genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Settings.COM_FAILED_TO_CONNECT_TO_THE_NETWORK + " " + langObj.Settings.MIA_SID_WIRELESS_ROUTER_NOT_WORKING_OFF]);
                }, 500);

                $('.list>li#' + deviceID).find('.storageInfo').text(oldFirmwareVersion);
                $('.list>li#' + deviceID).find('.function_icon').removeClass('cancel_checkbox').addClass('err_icon');
                $('.list>li#' + deviceID).find('.function_icon').removeClass('icon-disabled');
                $('.list>li#' + deviceID).addClass('send-failed');
            }
        }
    });


    $('ul#list').on('tap', '.cancel_checkbox', function(e) {

        e.stopPropagation();
        e.preventDefault(); 

        deviceID = $(this).parent('.auto-LFD-List').attr('id');

        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.MIA_CANCEL_THE_SOFTWARE_UPDATE]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_TV_SID_NO,
            "callback" : function() {
                closeGenericPopUp();
            }
        }, {
            "btntxt" : COM_TV_SID_YES,
            "callback" : function() {
                isFirmwareProgress = false;
                if ($('.list>li#' + deviceID).attr('isAddedManually') == "true" ) {
                    $('.list>li#' + deviceID).find('.function_icon').removeClass('cancel_checkbox').addClass('del_icon');   
                } else {                   
                    $('.list>li#' + deviceID).find('.function_icon').removeClass('cancel_checkbox');
                }
                showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);      
                cancelExcutionTask(0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
                closeGenericPopUp();
            }
        }]);
        genericPopUpObj.showPopUp();
    });


    $('ul#list').on('tap', '.del_icon', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        var devDelIcon = $(this);
        if ( isFirmwareProgress == true )
            return;    
        
       // var thisVal = $(this);
        var mDeviceIP = $(this).closest('li.auto-LFD-List').attr('ip');
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.COM_TV_DELETE_THE_DEVICE_FROM_THE_LIST_YES_NO]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : "closeGenericPopUp"
        }, {
            "btntxt" : COM_SID_OK,
            "callback" : function() {
                deleteDeviceFromDB(mDeviceIP);
                devDelIcon.closest('li').remove();
            }
        }]);
        genericPopUpObj.showPopUp();
    });
    
    
    $("#wrappper_updateId .iptext").keyup(function(e) {
        /*Can not use space at the first of string*/
        if ($(this).val().charAt(0) == " ") {
            $(this).val("");
        }
        console.log("keyCode0========" + e.keyCode);
        /*Click the 'Go' button in android keypad or enter key*/
        if (e.keyCode == 13) {
            $('.iptext:focus').blur();
            ValidIPEnterUpdate();
            
        }
    });


    $('#Add_SinageTV_Close_Btn_ID').on('tap', function(e) {

        e.stopPropagation();
        e.preventDefault(); 

        // if something is foucused
        if( document.activeElement.tagName == "INPUT") {
            $('.iptext').blur(); 
            setTimeout(function(){
                $('.iptext').val('');

                $('#settings_ContentsId').show();
                $('.custom-header').show();
                $('#settings_manually_add-ipID').hide();
                $('#manually_add-ip-panel').hide();    

                $('.AddsignageTvCls').show();
            },400);
        }else {
            $('.iptext').val('');

            $('#settings_ContentsId').show();
            $('.custom-header').show();
            $('#settings_manually_add-ipID').hide();
            $('#manually_add-ip-panel').hide();    

            $('.AddsignageTvCls').show();   
        }

    });


    $('#Add_SinageTV_Done_Btn_ID').on('tap', function(e) {
        
        e.stopPropagation();
        e.preventDefault(); 

        // if something is foucused
        if( document.activeElement.tagName == "INPUT") {
            $('.iptext').blur(); 
            setTimeout(function(){
                ValidIPEnterUpdate();
            },400);
        }else {
            ValidIPEnterUpdate();    
        } 
        
    });    

        
    $('.AddsignageTvCls').on('click', '#addSmartSignagebtnId', function() {

        if ($('.AddsignageTvCls').hasClass('AddDisableAddManual')) {
            return false;
        }

        $('#settings_ContentsId').hide();
        $('.custom-header').hide();
        $('#settings_manually_add-ipID').show();
        $('#header-part2_addSignage').autoFontSize({ maxFontPixels: 18,minFontPixels:12}); 
        $('#manually_add-ip-panel').show();

        $('#firmIpbox1').focus();
        $('#AddsignageTvId').hide();

        isOnOffTimerIP = false;

    });
    $('.AddsignageTvCls_open').on('tap', '.AddsignageTvCls_openContent>#updateenterId', function(e) {
        e.stopPropagation();
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        $('.AddsignageTvCls_open').hide();
        $('#AddsignageTvId').show();
        ValidIPEnterUpdate();
        return false;
    });
    
    $('.AddsignageTvCls_open').on('tap', '.AddsignageTvCls_openContent>#updatecancelId', function(e) {
        e.stopPropagation();
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        $('.iptext').val('');
        $('.iptext').blur();
        $('.AddsignageTvCls_open').hide();
        $('#AddsignageTvId').show();
        var addupdateIpvalue = $('#firmIpbox1').val().trim();

        if (addupdateIpvalue == "" || addupdateIpvalue == " ") {
            $('#updateenterId').addClass('AddDisable');
        } else {
            $('#updateenterId').removeClass('AddDisable');
        }
        return false;

    });
    // Refresh button for firmware upgrade device discovery list
    $('.network-footer-update').on('tap', '#updatefooterIcon', function() {
        if (isWiFiEnable) {
            if ($(this).hasClass('icon-disabled')) {
                return false;
            }
            $('.addNoDeviceMsgCls>.addNoDeviceMsgTxtCls').text('');
            $('.list').html('');
            mProtocolManager.startDeviceDiscovery();
            $('#AddsignageTvId').show();
            $('.AddsignageTvCls_open').hide();
            $('.AddsignageTvCls').addClass('AddDisableAddManual');
            $('.list').html('');
            showLoader('updatefooterIcon');
        }
    });

    
     //*******************************FirmwareWare Events End***********************************//
    
    // ******************Store Click Events Start******************************//
    $('ul.Store_list').on('click', 'li', function(e) {
        $('.active-store').removeClass('active-store');
        $('.storelist-delete').removeClass('AddDisable');
        $('.storelist-edit').removeClass('AddDisable');
        $(this).find('div.store-list-li').addClass('active-store');
        $(this).find('div.storelist-delete').addClass('AddDisable');
        var deviceName = $(this).find('div.store-list-li').text();
        var storeId = $(this).attr('id');
        Utils.setActiveStore(deviceName, storeId);
    });
    

  $('.AddStoreCls').on('click', '#AddStoreBtnId', function() {

        if ($('.AddStoreCls').hasClass('AddDisable')) {
            return false;
        }

        sessionStorage.setItem('editStoreFromSettings', true);
        StoreListLengthLimit = 0;

        $('.Store_list').find('li').each(function() {
            StoreListLengthLimit++;
        });

        if (StoreListLengthLimit <= 9) {

            document.location.href = "../index.html?OperationType=ADD&WhereFrom=SETTINGS";
        }

    });
        $('.Store_list').on('click', '.storelist-delete', function(e) {

        e.stopPropagation();
        var deletelist = $(this);
        var StoreName = deletelist.closest('li').text();
        var StoreId = deletelist.closest('li').attr('id');
        //alert(StoreId);
        isStoreDeleted = true;
        if (deletelist.hasClass('AddDisable')) {
            return false;
        }
        var myStoreInfoJson = JSON.parse(sessionStorage.getItem("STORE_INFO"));
        storelistlength = myStoreInfoJson.myStoreInfoArrs.length;
        if (storelistlength > 1) {

            deletelist.addClass('removeDisable');

            genericPopUpObj.createPopUp("Check", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_DELETE_THIS_STORE]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_TV_SID_NO,
                "callback" : function() {
                    isStoreDeleted = false;
                }
            }, {
                "btntxt" : COM_TV_SID_YES,
                "callback" : function() {
                    
                    deleteStoreFromDBWithStoreId(StoreId);
                    isStoreDeleted = false;
                    StoreName = StoreName.trim();
                    deletelist.closest('li').remove();
                    setTimeout(function(){
                         $('.Store_list').html('');
                         CreateStoreList();
                    },500);
                    /*deletelist.closest('li').remove();
                    $('.AddStoreCls').removeClass('AddDisable');
                    if ($('.Store_list').length == 1) {
                        $('.Store_list li:last').addClass('ui-last-child');
                    }*/

                }
            }]);
            genericPopUpObj.showPopUp();
        }

    });
        
    
        // EDIT STORE INFO
    $('.Store_list').on('click', '.storelist-edit', function(e) {
        e.stopPropagation();
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        sessionStorage.setItem('editStoreFromSettings', true);
        var index = $(this).closest('li').attr('index');
        document.location.href = "../index.html?OperationType=EDIT&StoreIndex=" + index + "&WhereFrom=SETTINGS";
    });
    // ******************Store Click Events End******************************//

});//function closed


//***********************Firmware Functions******************************//

function firmwareUpdateFail(mMaxIndex, deviceID) {
    isFirmwareProgress = false;
    mProtocolManager.stopConnectionService();
    mLFDInfoArrayList[mMaxIndex].mStatus = FAIL;

    console.log("firmwareUpdateFail deviceID : " + deviceID);
    var lsitID = $('.list>li#' + deviceID);
    var fIcon = lsitID.find('.function_icon');
    
    lsitID.find('.storageInfo').text(oldFirmwareVersion);
    fIcon.removeClass('cancel_checkbox').addClass('err_icon');
    fIcon.removeClass('icon-disabled');
    lsitID.addClass('send-failed');
/*
    setTimeout(function(){
        if ($('.list>li#' + deviceID).attr('isAddedManually')) {
            $('.list>li#' + deviceID).find('.function_icon').removeClass('err_icon').addClass('del_icon');    
        } else {
            $('.list>li#' + deviceID).find('.function_icon').removeClass('err_icon');
        }
    },2000);
*/
    // Either incase pin wrong reset the list pin info
    if(mLFDInfoArrayList[mMaxIndex].mTLSRequired=='1')
    {
        var isPinEmpty = Utils.getMacPinValue(mLFDInfoArrayList[mMaxIndex].mMacAddr);
        if(isPinEmpty.length == 0){
            $('.list>li#' + deviceID).attr('pin',"");
        }
    }
    mLFDInfoArrayList = new Array();
    $('.AddsignageTvCls').removeClass('AddDisableAddManual');
    $('#updatefooterIcon>.refresh').removeClass('icon-disabled');
    updateExportProgressBar(deviceID, 0);
}

function firmwareUpdateSuccess(mMaxIndex, deviceID) {
    isFirmwareProgress = false;
    mLFDInfoArrayList[mMaxIndex].mStatus = DONE;
    mProtocolManager.stopConnectionService();
    closeGenericPopUp();

    $('.list>li#' + deviceID).find('.function_icon').removeClass('del_icon cancel_checkbox').addClass('com_icon');
    $('#updatefooterIcon>.refresh').removeClass('icon-disabled');
    $('.AddsignageTvCls').removeClass('AddDisableAddManual');
    updateExportProgressBar(deviceID, 0);
    $('.list>li#' +deviceID).find('.storageInfo').text(langObj.Settings.COM_SID_COMPLETE_COMPLETE);
    setTimeout(function(){
      $('.list>li#' +deviceID).find('.storageInfo').text(oldFirmwareVersion);
    },2000);
    mLFDInfoArrayList = new Array();
}

function cancelFirmwareUpgrade(deviceID) {
    try {
        isFirmwareProgress = false;
        loaderObj.hideLoader();

        $('.list>li#' +deviceID).find('.storageInfo').text(oldFirmwareVersion);
        $('.AddsignageTvCls').removeClass('AddDisableAddManual');
        $('#updatefooterIcon>.refresh').removeClass('icon-disabled');
        updateExportProgressBar(deviceID, 0);
        mProtocolManager.stopConnectionService();
    } catch(e) {
        loaderObj.hideLoader();
    }
}
function showFirmwareCancelPopup() {
    genericPopUpObj.createPopUp("Notification", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Settings.COM_BDP_CHECKING_SOFTWARE_VERSION_MSG]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Settings.COM_SID_CANCEL,
        "callback" : function() {
            
            showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
            isCheckingFWVersion = false;
            mLFDInfoArrayList[0].isCanceled = true;
            cancelExcutionTask(0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
            closeGenericPopUp();            
        }
    }]);
    isCheckingFWVersion = true;
    genericPopUpObj.showPopUp();
}
// Firmware upgrade
function ValidIPEnterUpdate() {
    var AddIpValue = 0;
    AddIpValue = $('#firmIpbox1').val().trim();
    AddIpValue = AddIpValue.trim();
    if (Utils.checkIP(AddIpValue) && AddIpValue != "...") {
        /*AddIpValue = AddIpValue.split(".").map(function(i) {
            return parseFloat(i);
        }).join(".");*/
	AddIpValue = Utils.removeZeros(AddIpValue);
        var isIPUnique = false;
        var listItems = $(".list li");
        listItems.each(function(li) {
            var mDeviceIP = $(this).attr('ip');
            mDeviceIP.trim();
            if (mDeviceIP == AddIpValue) {
                isIPUnique = true;
                return false;
            }
        });

        listItems = $("#deviceListOnOffTimer li");
        listItems.each(function(li) {
            var mDeviceIP = $(this).attr('ip');
            mDeviceIP.trim();
            if (mDeviceIP == AddIpValue) {
                isIPUnique = true;
                return false;
            }
        });

        if (!isIPUnique) {
            
            if(checkingID != null){
               $('.list>li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
               checkingID = null;
            }

            $('#settings_ContentsId').show();
            $('.custom-header').show();
            $('#settings_manually_add-ipID').hide();
            $('#manually_add-ip-panel').hide();

            addManuallyDevice(STATE_INIT,STATE_INIT,'false',AddIpValue, AddIpValue, '', '', '', '',Utils.getActivePlayerType(),"",0,"");
            
        } else {

            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Schedule.MIA_SID_ALREADY_EXISTS_LIST]);
            }, 500);
            $('.iptext').val('');
        }
    } else {
        if (AddIpValue == "...") {
            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        } else if (AddIpValue != "...") {
            setTimeout(function() {                
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        }
    }
}

function initProgressBar(deviceID) {

    $('<input>').appendTo('.list>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'position' : 'absolute !important'
            });
            $('.ui-slider-track').css({
                "height" : Liheight + 'px',
                'width' : Liwidth + 'px'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions

            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");

}


//***********************Firmware Functions******************************//


// ===============================================  store ============================//

function CreateStoreList() {
    var listStoreItem = "";
    var storelistlength = 0;
    $('.Store_list').html('');
    var myStoreInfoJson = JSON.parse(sessionStorage.getItem("STORE_INFO"));
    storelistlength = myStoreInfoJson.myStoreInfoArrs.length;
    for (var i = 0; i < storelistlength; i++) {
        var storeName = myStoreInfoJson.myStoreInfoArrs[i].StoreName;
        listStoreItem += '<li data-icon="false" id="' + myStoreInfoJson.myStoreInfoArrs[i].id + '" index="' + i + '"><a class="ui-btn"><div class="store-list-li textEllipsis">' + storeName + '</div><div class="edit-section"><div class="editWrappper"><div class="storelist-edit" active-class="true"></div><div class="storelist-delete" active-class="true"></div></div></div></div></div></a></li>';
    }

    $('.Store_list').html(listStoreItem);
    $('.Store_list li:last').addClass('ui-last-child');
    if (storelistlength == 1) {
        $('.storelist-delete').addClass('AddDisable');
        $('.Store_list').find('div.store-list-li').addClass('active-store');
        Utils.setActiveStore(myStoreInfoJson.myStoreInfoArrs[0].StoreName, myStoreInfoJson.myStoreInfoArrs[0].id);
    } else {
        $('.storelist-delete').removeClass('AddDisable');
    }
    var actvStoreID = $('.Store_list').find('li#' + Utils.getActiveStoreId());
    actvStoreID.find('div.storelist-delete').addClass('AddDisable');
    actvStoreID.find('div.store-list-li').addClass('active-store');
    if (myStoreInfoJson.myStoreInfoArrs.length >= 10) {
        $('.AddStoreCls').addClass('AddDisable');
    } else {
        $('.AddStoreCls').removeClass('AddDisable');
    }
    $("#AddStoreBtnId").text("+ " + langObj.index.MIA_SID_ADD_STORE);
}
// ================================================  STORE END ===========================================//
