/*
 * 
 * For Font,
 * Design Elements And
 * About Software 
 * Created by k.sravani
 */

var DLiheight;
var DLiwidth;
var FontLiHeight;
var FontwiHeight;
var isDesignElement = false;
var EnglishFontID = "";
var curDeviceID = "";


var mDownloadedEngFontPath = ".ETabletAuthor/Fonts/Downloads/english";
var mDownloadedKorFontPath = ".ETabletAuthor/Fonts/Downloads/korean";
var mDownloadedChiFontPath = ".ETabletAuthor/Fonts/Downloads/chinese";
var english,korean,chinese;

var mFontInfo = function() {
    this.mFontFileName = null;
    this.mFontFilePath = null;
    this.mFontFileType = null;
    this.mFontFileUrl = null;
};

//var mDownloadedFontList = new Array();
$(function() {

    //********************** FONT EVENTS ******************************//

    $('#disclaimerID').on('click', function(e) {

        if ( isProgress )
        {
            genericPopUpObj.createPopUp("Check", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_LEAVE_PAGE_DATA_STOPPED_PROCEDD]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : langObj.Schedule.COM_SID_CANCEL,
                "callback" : "closeGenericPopUp"
            }, {
                "btntxt" : langObj.Schedule.COM_SID_OK,
                "callback" : function() {

                    if ( curDeviceID != "" )
                    {
                        $('.design-list>li#' + curDeviceID).find('.designlist-download').removeClass('designlist-cross');
                        mProtocolManager.performCancelOperation(0, curDeviceID, CONNECTION_TYPE_RSITE_DOWNLOAD);

                        curDeviceID = "";
                    }
                    disclaimerOrAbtSwClick(true);
                }
            }]);
            genericPopUpObj.showPopUp();
        }
        else
        {
            disclaimerOrAbtSwClick(true);
        }
    });

    $('#fontlicenseBack').on('click', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        
        $('#settings_fontLicenseId').hide();
        $('#settings_ContentsId').show();
        $('#font-panel').show();
        $('.custom-header').show();
        $('.tablet_ContentsCls > .custom-license-header > .header-part2').css({'width':'70%'});
        $('.header-text').css({'font-size':'19px'});
        $('.tablet_ContentsCls > .custom-license-header > .header-part3').css({'width':'15%'});
    });
    $('#disclaimer-back').on('click', function() {

        $('#font-disclaimer-panel').hide();
        $('#Font-panel').show();

    });
    $('#license-back').on('click', function() {
        $('#License-panel').hide();
        $('#Font-panel').show();
    });
    $('#openlicense-back').on('click', function() {
        $('#OpenSourceLicense-panel').hide();
        $('#AboutSoftware-panel').show();
    });

    $('.font-list-downloadUl').on('tap', '.Downloadfontlist-download', function(e) {

        var currentLI = $(this);
        var closestLi = $(this).closest('li');
        if ($(this).hasClass('Downloadfontlist-cross')) {
            showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
            var deviceId = closestLi.attr('id');
            mProtocolManager.performCancelOperation(0, deviceId, CONNECTION_TYPE_RSITE_DOWNLOAD);
            return false;
        }
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        if ($(this).hasClass('Downloadfontlist-tick')) {
            return false;
        }
        //Disable delete font button
        $('.font-list div.fontlist-delete').addClass('icon-disabled');

        var mUrl = closestLi.attr('url');
        var mPath = closestLi.attr('path');
        var deviceId = closestLi.attr('id');
        $(this).addClass('Downloadfontlist-cross');
        initProgressBarFont(deviceId);
		isBackPressOn = true;
        isProgress = true;
        mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
        
        var fileType = langObj.Settings.MIA_SID_ENGLISH_FONTS;
		mProtocolManager.downloadRSiteDesignElements(fileType,mUrl, mPath, deviceId);
        
        $('.font-list-downloadUl>li').find('.Downloadfontlist-download').not(this).addClass('AddDisable');
    });

    //****************************** FONT EVENTS END *******************//
    
    
    //********************** DESIGN ELEMENTS EVENTS *********************//
    // Design element BG image download
    $('.design-list').on('click', '.designlist-download', function(e) {
        console.log("Design elements click to download");
        var closestLi = $(this).closest('li');
        $(this).siblings('.designlist-error').css({
            'visibility' : 'hidden'
        });
    
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        // CANCEL DOWNLOAD
        if ($(this).hasClass('designlist-cross')) {
            showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
            var deviceId = closestLi.attr('id');
            mProtocolManager.performCancelOperation(0, deviceId, CONNECTION_TYPE_RSITE_DOWNLOAD);
            return false;
        }

        // DELETE DOWNLOADED
        if ($(this).hasClass('designlist-delete')) {
            
        
            var currentLI = $(this);
            genericPopUpObj.createPopUp("Notification", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_DELETE_SELECTED_DWON_AGAIN]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_TV_SID_NO,
                "callback" : function() {
                    closeGenericPopUp();
                }
            }, {
                "btntxt" : COM_TV_SID_YES,
                "callback" : function() {
                    currentLI.removeClass('designlist-delete');
                        var filePath = currentLI.closest('li').attr('path');
                    var deviceId = currentLI.closest('li').attr('id');
                    var id = deviceId.split('_');
                    updateDesignElementsFromDB(id[1], '0');
                    mProtocolManager.deleteRSiteElements(filePath, deviceId);
                }
            }]);
            genericPopUpObj.showPopUp();
            return false;
        }

        if ($(this).hasClass('designlist-done')) {
            return false;
        }
        
        if ($(this).hasClass('designlist-tick')) {
            return false;
        }

        var mUrl = closestLi.attr('url');
        var mPath = closestLi.attr('path');
        var deviceId = closestLi.attr('id');
        var fileType =  closestLi.attr('fileType');
        
        $(this).addClass('designlist-cross');
        initProgressBarDE(deviceId);
		mProtocolManager.downloadRSiteDesignElements(fileType,mUrl, mPath, deviceId);
        isProgress = true;
	    isBackPressOn = true;
        mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
        $('.design-list>li').find('.designlist-download').not(this).addClass('AddDisable');
    });
   //********************** DESIGN ELEMENTS EVENTS End*********************//
   
   //***********************AboutSoftware Start*****************************//
   
    // Download software from market
    
    $('.aboutsft-list').on('click', '.abtsft-download', function(e) {
        console.log("About Software click to download Version");
        if($(this).hasClass('AddDisable'))
        {
            return false;
        }
        mProtocolManager.launchPlayStore();
    });

    //About software licence
    $('.aboutsft-list').on('click', '#abtSft0', function(e) {
        console.log("About Software click to open license");
        e.stopPropagation;
        e.preventDefault();
        disclaimerOrAbtSwClick(false);
    });
    
    $('#opensourcelicenseBack').on('click', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        
        $('#settings_opensourceLicenseId').hide();
        $('#settings_ContentsId').show();
        $('#AboutSoftware-panel').show();
        $('.custom-header').show();

        $('.tablet_ContentsCls > .custom-license-header > .header-part2').css({'width':'70%'});
        $('.tablet_ContentsCls > .custom-license-header > .header-part3').css({'width':'15%'});
    });
    
    /**********AboutSoftware End****************/
    
    /**************************Model Selection events*****************************/ 
    
    $('.ModelsListUl_set').on('tap', 'li', function() {
    
 		if (!$(this).find('.ModelListLiContent_set').hasClass('active-li-model') && ( $(this).attr('id') != "changeModelTypeID" )) {

           var SelectedModelName = $(this).attr('id');
           
            var loc = sessionStorage.getItem('locale');
            if (loc == "pt") {
                $('#liveTVvideoId').css({'font-size':'12px'});
    
            }
        
            genericPopUpObj.createPopUp("Notification", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.MIS_SID_CHANGE_MODEL_RETURNED_HOME_SCREEN_PROCEED]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_TV_SID_NO,
                "callback" : function() {
                    closeGenericPopUp();
                }
            }, {
                "btntxt" : COM_TV_SID_YES,
                "callback" : function() {
                    $('.ModelListLiContent_set').removeClass('active-li-model');
                    SelectedModelName = SelectedModelName.replace("Model_set", '');
                    SelectedModelName = SelectedModelName.trim();
                    Utils.setActivePlayerType(SelectedModelName);
                    $(this).find('.ModelListLiContent_set').addClass('active-li-model'); 
                    //$('#Model-selection').text(langObj.Settings.MIS_SID_MIX_MODE_COLON.replace('<<A>>', Utils.getPlayerName(SelectedModelName)));
  					$('#setting_ModelId').text(langObj.Settings.COM_TV_MODEL);

                    //document.location.href = "../quickstart/QuickStart.html";
                }
            }]);
            genericPopUpObj.showPopUp();
        }        
    }); 

    /**************************Model Selection events*****************************/ 
});



//***************************** Font Start***********************************************/
function createFontList() {
    mTaskType == CONNECTION_TYPE_RSITE_DOWNLOAD;
    mProtocolManager.registerWiFiStateChangeReceiver();
    isDesignElement = false;
    var fontLiItem = "";
    var fontLiItem_download = "";
    $('.ui-collapsible-inset .ui-collapsible-heading .ui-btn').css({
        "width" : "90%"
    });
    var myFontElementsInfoJson = JSON.parse(localStorage.getItem("FontElements_INFO"));
    var myFontElementsInfoArrObj;
   	var fontLists=[langObj.Settings.MIA_SID_ENGLISH_FONTS, langObj.Settings.MIA_SID_KOREAN_FONTS, langObj.Settings.MIA_SID_CHINESE_FONTS];
   	
	var r_site_base_URL_update = "";

    for (var i = 0; i < 1; i++) {
        myFontElementsInfoArrObj = myFontElementsInfoJson.myFontElementsInfoArr[i];
		if(i==0){
			r_site_base_URL_update=R_SITE_BASE_URL;
		}
		else{
			r_site_base_URL_update=R_SITE_BASE_URL_2;
		}
		
		var deviceid = "";

        if (myFontElementsInfoArrObj.DesignElementsStatus == 1) {
            fontLiItem_download += '<li data-icon="false" class="fontLiItem_downloadCls" id="DownloadedFont_' + myFontElementsInfoArrObj.id + '" url="' + r_site_base_URL_update + myFontElementsInfoArrObj.DesignElementsUrl + '" path="' + myFontElementsInfoArrObj.DesignElementsPath + '"><a class="ui-btn"><div class="font-list-li">'+fontLists[i]+'</div><div class="edit-section"><div class="editWrappper"><div class="Downloadfontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="Downloadfontlist-download  Downloadfontlist-tick" active-class="true"></div></div></div></a></li>';
            deviceid = "DownloadedFont_" + myFontElementsInfoArrObj.id;
            EnglishFontID = deviceid;
        } else {
            fontLiItem_download += '<li data-icon="false" class="fontLiItem_downloadCls" id="DownloadedFont_' + myFontElementsInfoArrObj.id + '" url="' + r_site_base_URL_update + myFontElementsInfoArrObj.DesignElementsUrl + '" path="' + myFontElementsInfoArrObj.DesignElementsPath + '"><a class="ui-btn"><div class="font-list-li">'+fontLists[i]+'</div><div class="edit-section"><div class="editWrappper"><div class="Downloadfontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="Downloadfontlist-download" active-class="true"></div></div></div></a></li>';
			deviceid = "DownloadedFont_" + myFontElementsInfoArrObj.id;
            EnglishFontID = deviceid;
        }
        
        if(i==0)
		{
			english=deviceid;
			console.log("english deviceid"+deviceid);
		}
		else if(i==1)
		{
			korean=deviceid;
			console.log("korea deviceid"+deviceid);
		}
		else if(i==2)
		{
			chinese=deviceid;
			console.log("chinees deviceid"+deviceid);
		}
    }
    
    $('.font-list-downloadUl').html(fontLiItem_download);
    $('.Downloadfontlist-download').authorActiveClass();

	if(myFontElementsInfoJson.myFontElementsInfoArr.length>=3){
		$('.font-list-downloadUl li:last').addClass('ui-last-child');
	}
	
	getDownloadedFontFileList(mDownloadedEngFontPath, english);
	/*setTimeout(function(){
	   getDownloadedFontFileList(mDownloadedKorFontPath, korean);
	},800);
	
	setTimeout(function(){
	   getDownloadedFontFileList(mDownloadedChiFontPath, chinese);
	},1500);*/
	
	FontLiHeight = $('.font-list-downloadUl >li').height();
	FontLiwidth = $('.font-list-downloadUl >li').width();

}

function downloadUnzipped(deviceId) {
   	if (isDesignElement == false) {
	   getDwFontListByLang(deviceId);
	}
	isBackPressOn = false;
	var id = deviceId.split('_');
	updateDesignElementsFromDB(id[1], '1');
}

function createDownloadedFont(mDownloadedFontList,deviceId) {
//	alert("Length: "+ mDownloadedFontList.length);
	var deviceIdNew=deviceId;
    console.log("inside function deviceid"+deviceIdNew);
    $("#fontListFamlyStyl"+deviceId).remove();
	var fontLiItem = "";
	var createUL="";
	
	/*if (!isFontRendered) {
		showAnimationLoader('');
	}*/
	createUL = '<ul data-role="listview" id="fontlist-ul'+deviceIdNew+'" class="font-list"></ul>';
	$('.font-list-downloadUl>li#'+deviceIdNew).append(createUL);

	$('#fontlist-ul'+deviceIdNew).html('');
	console.log("mDownloadedFontList.length: " + mDownloadedFontList.length);
	var string="";
	for (var i = 0; i < mDownloadedFontList.length; i++) 
	{
		var path = mDownloadedFontList[i].mFontFileUrl;
		if(path.substr(-3,3).toLowerCase()!="zip")
        {
            path = path.replace('file://', "");
            console.log("Name: " + mDownloadedFontList[i].mFontFileName + " , URL: "+ mDownloadedFontList[i].mFontFileUrl +", Path: " + path);

              fontLiItem += '<li data-icon="false" parentLi='+deviceId+' id="DoFont_'+deviceIdNew+i+'" path="' + mDownloadedFontList[i].mFontFilePath + '">'
                  +'<a class="ui-btn"><div class="font-list-li"  style="font-family:'+mDownloadedFontList[i].mFontFileName+';">' + Utils.formatFontName(mDownloadedFontList[i].mFontFileName) + '</div><div class="edit-section"><div class="editWrappper"><div class="fontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="fontlist-delete" active-class="true"></div></div></div></a></li>';

            //including font file and font family dynamically
            string+="@font-face {font-family: " + mDownloadedFontList[i].mFontFileName + ";  src: url(" + mDownloadedFontList[i].mFontFileUrl + ");}";
	    }
	}
	Utils.addCSSStrInPage(string,"fontListFamlyStyl"+deviceId);
	$('#fontlist-ul'+deviceIdNew).html(fontLiItem);
	$('#fontlist-ul'+deviceIdNew+' li:first').addClass('BorderTopLi');
    if (!isFontRendered) {
        setTimeout(function() {
            loaderObj.hideLoader();
            isFontRendered = true;
        }, 2500);
    }

		$('.font-list-downloadUl>li#' + deviceId).css({
			"border-bottom" : "0px"
		});
		$('.fontLiItem_downloadCls').off("tap").on("tap", ".fontlist-delete", function(event, ui) {
		if($(this).hasClass('icon-disabled')){
			return false;
		}
		var filePath = $(this).closest('li').attr('path');
		var currentLI = $(this);
		var parentLiVal = $(this).closest('li').attr('parentLi');
		
		//alert('parentLiVal: '+parentLiVal);
		genericPopUpObj.createPopUp("Notification", "Type1");
		genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_DELETE_FONT_DOWNLOAD_AGAIN]);
		genericPopUpObj.addFooterBtns([{
			"btntxt" : COM_TV_SID_NO,
			"callback" : function() {
				closeGenericPopUp();
			}
		}, {
			"btntxt" : COM_TV_SID_YES,
			"callback" : function() {
				currentLI.closest('li').remove();
				$('.font-list-downloadUl>li#' + parentLiVal).find('.Downloadfontlist-download').removeClass('Downloadfontlist-tick');
				$('.font-list li:first').addClass('addborderTop');
				console.log("length" + $('.font-list').length);
				if ($('.font-list').length <= 0) {
					$('.font-list-downloadUl li:first').addClass('addborderTop');
				}
				console.log("Delete button parent ID Before: "+deviceId);
				var id = parentLiVal.split('_');
				console.log("Delete button parent ID After: "+id[1]);
	            updateDesignElementsFromDB(id[1], '0');
	            mProtocolManager.deleteRSiteElements(filePath, deviceId);
                getDwFontListByLang(deviceId);
			}
		}]);
		genericPopUpObj.showPopUp();
		return false;
		//to change icon to download if any font is deleted inside element
	});
}
function getDwFontListByLang(deviceId){
    if(deviceId == english){
        getDownloadedFontFileList(mDownloadedEngFontPath, deviceId);
    }else if(deviceId == korean){
        getDownloadedFontFileList(mDownloadedKorFontPath, deviceId);
    }else if(deviceId == chinese){
        getDownloadedFontFileList(mDownloadedChiFontPath, deviceId);
    }
}
function getDownloadedFontFileList(parentDir, deviceId) {
	
	var mDownloadedFontList = new Array();
	var fontPathList = "";
	
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
		fileSystem.root.getDirectory(parentDir, {
			create : false
		}, function(dirEntry) {
			var directoryReader = dirEntry.createReader();
			directoryReader.readEntries(function(entries) {
				console.log("Entries Count:" + entries.length);
				if (entries.length > 0) {
					for (var i = 0; i < entries.length; i++) {
						if (entries[i].isFile) {
							var mFontFileInfo = new mFontInfo();
							var fileNameWithEx = entries[i].name;
							var fileExt = fileNameWithEx.substring(fileNameWithEx.lastIndexOf('.') + 1);
							var fileName = fileNameWithEx.substring(0, fileNameWithEx.lastIndexOf('.'));
							mFontFileInfo.mFontFilePath = entries[i].fullPath;
							fontPathList = fontPathList +","+entries[i].fullPath;
							
							mFontFileInfo.mFontFileType = fileExt;
							mFontFileInfo.mFontFileName = fileName;
							mFontFileInfo.mFontFileUrl = entries[i].toURL();
							mDownloadedFontList.push(mFontFileInfo);
							console.log("FileName: " + mFontFileInfo.mFontFileName + " ,FileType: " + mFontFileInfo.mFontFileType + ", FilePath: " + mFontFileInfo.mFontFilePath);
						}
					}
					console.log("enter function "+parentDir+"deviceid"+deviceId);
					
					if (fontPathList.length > 0) {
						try{
						createDownloadedFont(mDownloadedFontList , deviceId);
						}catch(e){}
						console.log(JSON.stringify(mDownloadedFontList));
						syncDownloadedItemsStatus(deviceId,true,fontPathList);
					} else {
						syncDownloadedItemsStatus(deviceId,false,null);
					}
				} // entries if end
				else
				{
                    var id = deviceId.split('_');
                    $("#DownloadedFont_" +id[1]+" .Downloadfontlist-tick").removeClass("Downloadfontlist-tick");
                    updateDesignElementsFromDB(id[1], '0');
				}
			}, fail);
		}, fail);
	}, fail);

	function fail(deviceId) {
		console.log("Failed to interator directory - "+deviceId);
		syncDownloadedItemsStatus(deviceId,false,null);
	}
}


 function  syncDownloadedItemsStatus(deviceId,status,fontPathList){
 	if(fontPathList == undefined){
 		fontPathList = null;
 	}
	if(deviceId == english){
		localStorage.setItem("EnglisDownalodedFont_INFO", fontPathList);
		Utils.setLocalStorageValue('englishFont',status);
	}else if(deviceId == korean){
		localStorage.setItem("KoreanDownalodedFont_INFO", fontPathList);
		Utils.setLocalStorageValue('koreanFont',status);
	}else if(deviceId == chinese){
		localStorage.setItem("ChineseDownalodedFont_INFO", fontPathList);
		Utils.setLocalStorageValue('chineseFont',status);
	}
 }

function initProgressBarFont(deviceID) {

    curDeviceID = deviceID;
    
    $('<input>').appendTo('.font-list-downloadUl>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'height' : 0 + 'px',
                'position' : 'relative !important'
            });
            $('.ui-slider-track').css({
                "height" : FontLiHeight + 'px',
                'width' : FontLiwidth + 'px',
                'position' : 'absolute',
                'padding' : '1px 0'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions
            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");

}

function resetFontUI() {
    var listItems = $(".font-list-downloadUl>li");
    listItems.each(function(li) {
        $('.Downloadfontlist-download').not(this).removeClass('AddDisable');
    });
}

//************* Font Related Functions End ****************/

//********************************************* DESIGN ELEMENTS Start************************/
function createDesignElmList() {
    isDesignElement = true;
    mTaskType == CONNECTION_TYPE_RSITE_DOWNLOAD;
    mProtocolManager.registerWiFiStateChangeReceiver();
    var DesignElements=[langObj.template.COM_LFD_SID_TEMPLATES_KR_TEMPLATE,langObj.Settings.MIA_SID_MIX_BACKGROUND_IMAGES+'('+langObj.Settings.MIA_SID_CLASSIC+')',langObj.Settings.MIA_SID_MIX_BACKGROUND_IMAGES+'('+langObj.Settings.MIA_SID_MODERN+')',langObj.Settings.MIA_SID_MIX_BACKGROUND_IMAGES+'('+langObj.Settings.MIA_SID_VINTAGE+')',langObj.Settings.IDS_WEATHER_IMAGE]; 
    var myDesignElementsInfoJson = JSON.parse(localStorage.getItem("DesignElements_INFO"));
    var DesignElmLi = "";
    var r_site_base_URL_update="";
    var myDesignElementsInfoArrLen = myDesignElementsInfoJson.myDesignElementsInfoArr.length;
    var myDesignElementsInfoArrObj;
    for (var i = 0; i < myDesignElementsInfoArrLen; i++) {
    	r_site_base_URL_update=R_SITE_BASE_URL;
    	myDesignElementsInfoArrObj = myDesignElementsInfoJson.myDesignElementsInfoArr[i];
        if (myDesignElementsInfoArrObj.DesignElementsStatus == 1) {
            DesignElmLi += '<li data-icon="false" id="design_' + myDesignElementsInfoArrObj.id + '" url="' + r_site_base_URL_update + myDesignElementsInfoArrObj.DesignElementsUrl + '"  fileType="' + DesignElements[i] + '" path="' + myDesignElementsInfoArrObj.DesignElementsPath + '"><a class="ui-btn"><div class="design-list-li textEllipsis">' + DesignElements[i] + '</div><div class="edit-section-design-element"><div class="designeditWrappper"><div class="designlist-error" active-class="true" style="visibility:hidden"></div><div id="designlist-downloadId_' + myDesignElementsInfoArrObj.id + '" class="designlist-download designlist-delete" active-class="true"></div></div></div></div></div></a></li>';
        } else {
            DesignElmLi += '<li data-icon="false" id="design_' + myDesignElementsInfoArrObj.id + '" url="' + r_site_base_URL_update + myDesignElementsInfoArrObj.DesignElementsUrl + '" fileType="' + DesignElements[i] + '" path="' + myDesignElementsInfoArrObj.DesignElementsPath + '"><a class="ui-btn"><div class="design-list-li textEllipsis">' + DesignElements[i]+ '</div><div class="edit-section-design-element"><div class="designeditWrappper"><div class="designlist-error" active-class="true" style="visibility:hidden"></div><div id="designlist-downloadId_' + myDesignElementsInfoArrObj.id + '"class="designlist-download" active-class="true"></div></div></div></div></div></a></li>';
        }
    }

    $('.design-list').html(DesignElmLi);
    $('.designlist-download').authorActiveClass();

    if(myDesignElementsInfoJson.myDesignElementsInfoArr.length>=5){
        $('.design-list li:last').addClass('bottomborder');
       
    }
    DLiheight = $('.design-list >li').height();
    DLiwidth = $('.design-list >li').width();
}

function initProgressBarDE(deviceID) {
    $('<input>').appendTo('.design-list>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'height' : 0 + 'px',
                'position' : 'relative !important'
            });
            $('.ui-slider-track').css({
                "height" : DLiheight + 'px',
                'width' : DLiwidth + 'px',
                'position' : 'absolute',
                'padding' : '0px 0'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions
            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");
}

function resetDesignElementUI() {
    var listItems = $(".design-list>li");
    listItems.each(function(li) {
        $('.designlist-download').not(this).removeClass('AddDisable');
    });
}


//***************************DESIGN ELEMENTS END**************************************************//

//***************************Common Functions for Design elements and Font start*****************//
function downloadFailed(deviceId){
    if (isDesignElement) {
        $('.design-list>li#' + deviceId).find('.designlist-download').removeClass('designlist-cross');
        $('.design-list>li#' + deviceId).find('.designlist-download').css({
            'visibility' : 'hidden', 'width' : '0%'
        });
        
        $('.design-list>li#' + deviceId).find('.designlist-error').css({
            'visibility' : 'visible', 'width' : '100%'
        });

      setTimeout(function(){
         $('.design-list>li#' + deviceId).find('.designlist-error').css({
             'visibility' : 'hidden', 'width' : '0%'
         });


          $('.design-list>li#' + deviceId).find('.designlist-download').css({
               'visibility' : 'visible', 'width' : '100%'
           }).removeClass('designlist-delete');
       }, 1000);
        curDeviceID = "";
        
    } else {
        $('.font-list-downloadUl>li#' + deviceId).find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross Downloadfontlist-tick');
        $('.font-list-downloadUl>li#' + deviceId).find('.Downloadfontlist-error').css({
            'visibility' : 'visible'
        });
    }
    isProgress = false;
    loaderObj.hideLoader();
    updateExportProgressBar(deviceId, 0);
    resetDesignElementUI();
    resetFontUI();
}

function downloadSuccess(deviceId) {
    var fontLiItem = "";
    if (isDesignElement) {
        $('.design-list>li#' + deviceId).find('.designlist-download').removeClass('designlist-cross').addClass('designlist-tick');
        setTimeout(function() {
            $('.design-list>li#' + deviceId).find('.designlist-download').removeClass('designlist-tick').addClass('designlist-delete');
        }, 2000);
    } else {

        $('.font-list-downloadUl>li#' + deviceId).find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross').addClass('Downloadfontlist-tick');

    }
    //Enable delete font button
    $('.font-list div.fontlist-delete').removeClass('icon-disabled');
    updateExportProgressBar(deviceID, 0);
    resetDesignElementUI();
    resetFontUI();
    showAnimationLoader(langObj.Settings.COM_MESSAGE_UPLOADER_UNZIP_FILE_P);
    var id = deviceId.split('_');
    updateDesignElementsFromDB(id[1], '1');
    isProgress = false;
    curDeviceID = "";
}

function downloadCancel(deviceId) {
    updateExportProgressBar(deviceId, 0);
    resetDesignElementUI();
    resetFontUI();
    $('.font-list-downloadUl>li#' + deviceId).find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross');
    $('.design-list>li#' + deviceId).find('.designlist-download').removeClass('designlist-cross');
    $('.font-list div.fontlist-delete').removeClass('icon-disabled')
    isProgress = false;
    curDeviceID = "";
}
//**************Common Functions for Design elements and Font End*********************************//

//*****************************************ABOUT SOFTWARE START***********************************//
function createAboutSftElmList() {
    var aboutsftLi = "";
    for (var i = 0; i < 2; i++) {
        if (i == 0)
            aboutsftLi += '<li data-icon="true" id="abtSft' + i + '" ><a class="ui-btn"><div class="aboutsft-list-li textEllipsis">'+ langObj.Settings.COM_BDP_SID_OPEN_SOURCE_LINCENSE_NOTI_TEXT+'</div><div class="edit-section-abtsft"><div class="editWrappper"><div class="abtsft-edit" active-class="true" style="visibility:hidden;">Ver 1.0</div><div class="abtsft-arrow" active-class="true"></div></div></div></div></div></a></li>';
        if (i == 1)
            aboutsftLi += '<li data-icon="false" id="abtSft' + i + '" ><a class="ui-btn"><div class="aboutsft-list-li textEllipsis">'+ langObj.Schedule.COM_EBD_SID_MIX_CURRENT_VERSION.replace(': <<A>>','') +'</div><div class="edit-section-abtsft"><div class="editWrappper"><div class="abtsft-edit" active-class="true">' + SOFT_VER + '</div><div style="width:30%;" active-class="true" style="visibility:hidden;"></div></div></div></div></div></a></li>';
    }
    $('.aboutsft-list').html(aboutsftLi);
    $('.aboutsft-list li:last').addClass('ui-last-child');
}
function disclaimerOrAbtSwClick(isDisclaimerClicked){
    $('#settings_ContentsId').hide();
    $('.custom-header').hide();

    if(isDisclaimerClicked){
        $('#settings_fontLicenseId').show();
        $('#font-disclaimer-panel').show();
    }else{
        $('#settings_opensourceLicenseId').show();
        $('#OpenSourceLicense-panel').show();
    }

    if ( langObj.Settings.MIA_SID_ABOUT_FONT_LICENSE.length > 20 )
    {
        $('.tablet_ContentsCls > .custom-license-header > .header-part2').css({'width':'85%'});
        if(isDisclaimerClicked){
            $('.header-text').css({'font-size':'15px'});
        }
        $('.tablet_ContentsCls > .custom-license-header > .header-part3').css({'width':'0%'});
    }
}
//******************************************* ABOUT SOFTWARE END***********************************//
