/**
 * Copyright (c) 2014 Samsung Electronics Co., Ltd. All rights reserved.
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * 
 * To handle My Template info using  sqlite DB
 * & excute content mapping with my MyTemplate module.
 * 
 * @version 1.2
 * @module : Template Database
 * @author rishu.yadav
 * Modified : riten @ 28-01-15 
 */
var db;
var dbCreated = false;
var mTemplateName = "";
var mTempPath = "";
var mThumbPath = "";
var mCategoryName = "";
var mOrientationType = "";
var mPlayerType = "";
var mDuration = "";
var mTimeStamp = "";
var funCallBack ;
var DB_DEBUG_TAG = "MyTemplate::  ";
var tempContentRoothPAth=".ETabletAuthor/RHE/";
/*var templateDb = {
	templateNameList:[],	
};*/
var myTemplateInfoJson = {};
var myTemplateInfoArr = [];
myTemplateInfoJson.myTemplateInfoArrs = myTemplateInfoArr;

/***
 * To insert template info in MyTemaplate DB 
 * 
 * @param 
 *      templateName -> Template Name
 *      tempPath ->  Tempplate Path
 * 		thumbPath ->  Thumb Path
 *      categoryName -> Template Category Name
 *      orientationType -> Template Orientation Type
 * 		playerType -> Player Type
 */
function insertTemplateInfo(templateName, tempPath, thumbPath, categoryName, orientationType, playerType,duration) {	
    console.log(DB_DEBUG_TAG+"@insertTemplateInfo: " + "templateName: " + templateName
            + " ,tempPath: " + tempPath + ", thumbPath: " + thumbPath
            +", categoryName: "+ categoryName +", orientationType: "+ orientationType + ", playerType: "+ playerType + ", duration: "+ duration );

    mTemplateName = templateName;
    mTempPath = tempPath;
    mThumbPath = thumbPath;
    mCategoryName = categoryName;
    mOrientationType = orientationType;
    mPlayerType = playerType;
    mDuration = duration;
    mTimeStamp = new Date().getTime();
    
    db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    console.log(DB_DEBUG_TAG+"@insertTemplateInfo: open db success - TabletAuthorDB");
    db.transaction(populateTemplateDB, TemplateDBError);
    getTemplateInfo(); 
}

function copyTemplateData(){
	  db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
      console.log(DB_DEBUG_TAG+"@copyTemplateDataToDB: open db success - TabletAuthorDB");
      
      db.transaction(copyToTemplateDB, TemplateDBError);
}


function copyToTemplateDB(tx) {
    console.log(DB_DEBUG_TAG+"@getTemplateInfo insertTemplateDB for Insert Operation");
    var sql = "CREATE TABLE IF NOT EXISTS tbl_templates ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "TemplateName VARCHAR(256), " + "TempPath VARCHAR(500), "
              + "ThumbPath VARCHAR(500), "+ "CategoryName VARCHAR(50), "
              + "OrientationType VARCHAR(50), " + "PlayerType VARCHAR(50), " + "Duration VARCHAR(50), " + "TimeStamp VARCHAR(50))";
     console.log(DB_DEBUG_TAG+sql);
     tx.executeSql(sql);
      var templatedata = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
      var templateArr=[];
	      templateArr= templatedata.myTemplateInfoArrs;
     // alert("templatedata"+ templatedata.myTemplateInfoArrs.length);
      if(templateArr.length > 0)
	    {
	    	var playerType=2;
	    	var duration = 600;
	    	for(var i=0;i<templateArr.length;i++)
	        {
	        var thumbPath=templateArr[i].thumbPath;
	        var tempPath=templateArr[i].tempPath;
	        thumbPath=tempContentRoothPAth+ thumbPath.substring(thumbPath.indexOf("MyTemplate"));
	        tempPath=tempContentRoothPAth+ tempPath.substring(tempPath.indexOf("MyTemplate"));
	        console.log("templateName"+templateArr[i].templateName);
	    	console.log("tempPath"+templateArr[i].tempPath);
	    	console.log("thumbPath"+thumbPath);
	    	console.log("categoryName"+templateArr[i].categoryName);
	    	console.log("orientationType"+templateArr[i].orientationType);
	    	console.log("playerType"+playerType);
	    	console.log("duration"+duration);
	    	console.log("timeStamp"+templateArr[i].timeStamp);
	    	tx.executeSql("INSERT INTO tbl_templates (TemplateName,TempPath,ThumbPath,CategoryName,OrientationType,PlayerType,Duration,TimeStamp) VALUES ("
                    + "'" + templateArr[i].templateName+ "'" + ","
                    + "'" + tempPath+ "'" + ","
                    + "'" + thumbPath+ "'" + ","
                    + "'" + templateArr[i].categoryName+ "'" + ","
                    + "'" + templateArr[i].orientationType+ "'" + "," 
                    + "'" + playerType+ "'" + "," 
                    + "'" + duration+ "'" + "," 
                    + "'" + templateArr[i].timeStamp+ "'" + ")");
	    	
	    	
	    	}
	    	 console.log(DB_DEBUG_TAG+"Inserted one item success");
	    }
  
 }


function populateTemplateDB(tx) {
    console.log(DB_DEBUG_TAG+"@getTemplateInfo populateTemplateDB for Insert Operation");
    var sql = "CREATE TABLE IF NOT EXISTS tbl_templates ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "TemplateName VARCHAR(256), " + "TempPath VARCHAR(500), "
              + "ThumbPath VARCHAR(500), "+ "CategoryName VARCHAR(50), "
              + "OrientationType VARCHAR(50), " + "PlayerType VARCHAR(50), " + "Duration VARCHAR(50), " + "TimeStamp VARCHAR(50))";
     console.log(DB_DEBUG_TAG+sql);
     tx.executeSql(sql);
     tx.executeSql("INSERT INTO tbl_templates (TemplateName,TempPath,ThumbPath,CategoryName,OrientationType,PlayerType,Duration,TimeStamp) VALUES ("
                    + "'" + mTemplateName+ "'" + ","
                    + "'" + mTempPath+ "'" + ","
                    + "'" + mThumbPath+ "'" + ","
                    + "'" + mCategoryName+ "'" + ","
                    + "'" + mOrientationType+ "'" + "," 
                    + "'" + mPlayerType+ "'" + "," 
                    + "'" + mDuration+ "'" + ","                     
                    + "'" + mTimeStamp+ "'" + ")");
     console.log(DB_DEBUG_TAG+"Inserted one item success");
 }


/**
 * To get the template information list
 */
function getTemplateInfo(callBack) {
	
	if(callBack != undefined)
	  funCallBack = callBack;
    console.log(DB_DEBUG_TAG+"@getTemplateInfo");
    db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    db.transaction(readTemplateDB, TemplateDBError, populateTemplateDBOnSuccess);
 }

/**
 * To populate readTemplateDB
 * @param tx
 */
function readTemplateDB(tx) {
    console.log(DB_DEBUG_TAG+"@readTemplateDB");
   var sql = "CREATE TABLE IF NOT EXISTS tbl_templates ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "TemplateName VARCHAR(256), " + "TempPath VARCHAR(500), "
              + "ThumbPath VARCHAR(500), " + "CategoryName VARCHAR(50), "
              + "OrientationType VARCHAR(50), " + "PlayerType VARCHAR(50), " + "Duration VARCHAR(50), " + "TimeStamp VARCHAR(50))";
    console.log(DB_DEBUG_TAG+"SqlQuery: "+sql);
    tx.executeSql(sql);
}

function TemplateDBError(tx, error) {
    //alert("Database Error: " + error);
    console.log(DB_DEBUG_TAG+"@transaction_error");
    if(funCallBack!= undefined)
        funCallBack.apply(this,[false]);
}

function populateTemplateDBOnSuccess() {
    console.log(DB_DEBUG_TAG+"@populateDB_success");
    db.transaction(excuteTemplateQuery, TemplateDBError);
}
/**
 * To execute template query for fetching db list
 * @param tx
 */
function excuteTemplateQuery(tx) {
    console.log(DB_DEBUG_TAG+"@excuteTemplateQuery");
    var playerType = Utils.getActivePlayerType();
    var sql = "select * from  tbl_templates WHERE tbl_templates.PlayerType = '"+ playerType + "' order by TimeStamp desc";
      /* 
	if(playerType == RMD_MODEL){
		sql = "select * from  tbl_templates WHERE tbl_templates.PlayerType = '" + playerType + "' order by TimeStamp desc";
	}else if(playerType == RHE_MODEL || playerType == STRETCH_MODEL){
		sql = "select * from  tbl_templates WHERE tbl_templates.PlayerType != '" + TIZEN_MODEL + "' order by TimeStamp desc";
	}else{
		sql = "select * from  tbl_templates order by TimeStamp desc";
	}
	*/
	console.log(DB_DEBUG_TAG + "@excuteScheduleTemplateQuery: " + sql);
	tx.executeSql(sql, [], fetchTemplateItemList);
	
  }


function dropTemplateTableForcely(callback) {
    console.log("drop StoreTable");
    var db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    db.transaction(function(tx) {
        tx.executeSql("DROP TABLE tbl_templates");
        console.log(STORE_DB_TAB + "DROP TABLE tbl_templates");
        if(typeof callback === 'function')
        {
        	callback.call();
        }
    });
}



/**
 * To show list of template item list
 * here user can populate using html components
 */ 
function fetchTemplateItemList(tx, results) {
    console.log(DB_DEBUG_TAG+"@ fetchTemplateItemList");
	//templateDb.templateNameList = [];
    myTemplateInfoJson.myTemplateInfoArrs = new Array();
  
	for ( var i = 0; i < results.rows.length; i++) {
		var myTemplateRows = results.rows.item(i);
		var myTemplateInfo = {};
		myTemplateInfo.templateId = myTemplateRows.id;
		myTemplateInfo.templateName = myTemplateRows.TemplateName;
    	myTemplateInfo.tempPath = myTemplateRows.TempPath;
    	myTemplateInfo.thumbPath = myTemplateRows.ThumbPath;
    	myTemplateInfo.categoryName = myTemplateRows.CategoryName;
    	myTemplateInfo.orientationType = myTemplateRows.OrientationType;
    	myTemplateInfo.playerType = myTemplateRows.PlayerType;
    	myTemplateInfo.duration = myTemplateRows.Duration;
    	myTemplateInfo.timeStamp = myTemplateRows.TimeStamp;

    	   myTemplateInfoJson.myTemplateInfoArrs.push(myTemplateInfo);
    	
       /* if(($.inArray(myTemplateRows.TemplateName, templateDb.templateNameList+".LFD") < 0))
        {
            templateDb.templateNameList.push(myTemplateRows.TemplateName.replace(".LFD",""));           
        }*/
    }
	createTemplateSessionJsonList();
}
function createTemplateSessionJsonList(){
	// Put the object into session storage
	
	sessionStorage.setItem("TEMPLATE_INFO", JSON.stringify(myTemplateInfoJson));
	
	 if(typeof funCallBack =='function')
	 {
	 	funCallBack.apply(this,[true]);
	 }
}
function getTemplateNameList(){
	var templateNameList  = new Array();
	var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
    var templateLength=templateInfo.myTemplateInfoArrs.length;
    var templateArr=templateInfo.myTemplateInfoArrs;
    for(var i=0; i<templateLength; i++){
    	templateNameList.push(templateArr[i].templateName.replace(".LFD",""));    	
    }
    return templateNameList;
}
/**
 * To deleteTemplateFromDB according to specified attribute 
 * @param templateName
 */
function deleteTemplateFromDB(templateID) {
    console.log(DB_DEBUG_TAG+"@deleteTemplateFromDB");
    var db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    db.transaction(function(tx) {
        tx.executeSql("DELETE FROM tbl_templates WHERE tbl_templates.id = '"
                + templateID + "'");
        console.log(DB_DEBUG_TAG+" Delete one item success");
    });
    getTemplateInfo();
}

/***
 * To delete a Template info from MyTemplate DB by Name
 * 
 * @param 
 *      TemplateName ->   Template Name
 */
function deleteTemplateFromDBByName(templateName, playerType) {
	
    db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
   
    db.transaction(function(tx) {
        tx.executeSql("DELETE FROM tbl_templates WHERE tbl_templates.TemplateName = '"
                + templateName + "'" + "AND PlayerType='"+playerType+"'");
        console.log(DB_DEBUG_TAG+" Delete one item success");
    });
    getTemplateInfo();
}

/**
 * To updateTemplateFromDB according to specified attribute 
 * @param templateName
 */
function updateTemplateFromDB(templateName, tempPath, thumbPath, categoryName,orientationType,playerType,duration) {
    console.log(DB_DEBUG_TAG+"@updateTemplateFromDB");
    var timeStamp = new Date().getTime();
    templateName=templateName.trim();
    var db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    var sql="UPDATE tbl_templates SET " 
        + "TemplateName='"+templateName+"',"
        + "TempPath='"+tempPath+"',"
        + "ThumbPath='"+thumbPath+"',"
        + "CategoryName='"+categoryName+"',"
        + "OrientationType='"+orientationType+"',"
        + "Duration='"+duration+"',"        
        + "TimeStamp='"+timeStamp+"'"
		+ "WHERE tbl_templates.TemplateName = '"
        + templateName+ "'" 
        + "AND PlayerType='"+playerType+"' ";
     //+ "PlayerType='"+playerType+"',"
    
    console.log(DB_DEBUG_TAG+"@updateSQL"+sql);
    db.transaction(function(tx) {
        tx.executeSql(sql);
        console.log(DB_DEBUG_TAG+" Updated one item success");
    });
    getTemplateInfo();
}
function getNewTemplatePath(currTemplatePath){
	var currTemplateName = currTemplatePath.substring(currTemplatePath.lastIndexOf('/') + 1);
	var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
	var templateArr = templateInfo.myTemplateInfoArrs;	
	if(templateArr.length > 0){
		var thumbPath = templateArr[0].thumbPath;
	}
	var maxCount = 0;
	for(var i=0; i<templateArr.length; i++){
		var templateName=templateArr[i].templateName;
		if(templateName.indexOf(currTemplateName+"_") > -1){
			var count = getParseIntInDec(templateName.replace(currTemplateName+"_",""));			
			if(maxCount < count ){
				maxCount = count;
			}
		}	
	}
	maxCount++;
	if(maxCount == 0){
		return currTemplatePath + "_01";
	}else{
		if(maxCount < 10){
			return currTemplatePath + "_0" + maxCount;
		}
		return currTemplatePath + "_" + maxCount;
	}
};
function setTemplateDurationInDb(templateName,duration,playerType){
	var db = window.openDatabase("TabletAuthorDB", "1.0", "MagicInfo",200000);
    var sql="UPDATE tbl_templates SET "         
        + "Duration='"+duration+"'"                
		+ " WHERE tbl_templates.TemplateName = '"
        + templateName+ "'" 
        + " AND PlayerType='"+playerType+"' ";    
    console.log(DB_DEBUG_TAG+"@updateDuration"+sql);
    db.transaction(function(tx) {
        tx.executeSql(sql);
        console.log(DB_DEBUG_TAG+" Updated one item success");        
    });    
    getTemplateInfo();
}
function getTemplateDurationFrmTemplateId(templateId){
		var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
		var templateLength = templateInfo.myTemplateInfoArrs.length;
		for (var i=0; i<templateLength; i++) {
			if(templateInfo.myTemplateInfoArrs[i].templateId == templateId){
				return getParseIntInDec(templateInfo.myTemplateInfoArrs[i].duration);
			}
		}
}
function getTemplateDurationFrmTemplateName(templateName){
		var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
		var templateLength = templateInfo.myTemplateInfoArrs.length;
		for (var i=0; i<templateLength; i++) {
			if(templateInfo.myTemplateInfoArrs[i].templateName == templateName){
				return getParseIntInDec(templateInfo.myTemplateInfoArrs[i].duration);
			}
		}
}