var LEFT = 1130246;
var RIGHT = 1130108;
var rectFlag = true;

template.prototype.handleCropForShapes=function(elmObj,selElmId)
{
	log.debug("START","handleCropForShapes");
	var currObj=this;
	var FillColor=	elmObj.shapeDetails.FillColor;
   	var thumbPath=	elmObj.thumbPath;
   	currObj.isCroppedMode=true;
   	$(".mnFrmElmCpGenricCls").hide();
   	currObj.cropInfoFrUndo.setCropInfo(selElmId, elmObj.xOffset, elmObj.yOffset, elmObj.scale);
   	elmObj.shapeDetails.FillColor = 'rgba(79,129,189,1)';
   	elmObj.thumbPath = '';
   	currObj.setMainFrmElmAngle(selElmId,0);
   	 var currentShape = shapeInfoMapping[elmObj.elementType].Id;
        require([currentShape], function(currentShape){
            currentShape.draw(elmObj).then(function(valImg){
                $("#"+selElmId+"_InrElm").attr('src',valImg);
                elmObj.shapeDetails.FillColor = FillColor;
					elmObj.thumbPath = thumbPath;
					 currObj.aspectFillShape(elmObj,selElmId);
					 $("#"+selElmId+"_InrElm_CrpImgHolder").show();
					 currObj.showCropOverlayForShapes(elmObj,selElmId,true);				
   	        });
        });
};
template.prototype.resetCropModeForShapes=function(elmObj,selElmId)
{
	if(this.isCroppedMode && TemplateUtils.isShape(elmObj.elementType))
	{
		this.handleCropUndoForShapes(elmObj,selElmId,this.cropInfoFrUndo);		
	}
};

template.prototype.handleCropDoneForShapes=function(elmObj,selElmId)
{
	var currObj=this;
	if(currObj.isCroppedMode && TemplateUtils.isShape(elmObj.elementType)){		 
		currObj.isCroppedMode=false;
		$("#ElmCover-"+selElmId).attr("zoom",elmObj.scale);
        var currentShape = shapeInfoMapping[elmObj.elementType].Id;        
        require([currentShape], function(currentShape){
            currentShape.draw(elmObj).then(function(valImg){
                elmObj.imageSrc=valImg; 
                $("#"+selElmId+"_InrElm").attr('src',valImg);
                $("#"+selElmId+"_InrElm_CrpImgHolder").hide();
            });
        });
        currObj.cropInfoFrUndo.clearCropInfo();
        currObj.showCropOverlayForShapes(elmObj,selElmId,false);
	}
	currObj.setMainFrmElmAngle(selElmId,elmObj.rotation);
};
template.prototype.handleCropUndoForShapes=function(elmObj,selElmId,cropInfo)
{
	var currObj=this; 
	currObj.isCroppedMode=false;
	elmObj.xOffset = cropInfo.xOffset;
	elmObj.yOffset = cropInfo.yOffset;
	elmObj.scale = cropInfo.scale;
	currObj.showCropOverlayForShapes(elmObj,selElmId,false);
     	var currentShape = shapeInfoMapping[elmObj.elementType].Id;
          require([currentShape], function(currentShape){
              currentShape.draw(elmObj).then(function(valImg){
                  $("#"+selElmId+"_InrElm").attr('src',valImg);
                  currObj.chkElmOfstForShapes(elmObj); 
                  currObj.transformActvShapes(elmObj,selElmId);  
          		  $("#"+selElmId+"_InrElm_CrpImgHolder").hide();
     	        });
          });
          currObj.setMainFrmElmAngle(selElmId,elmObj.rotation);
};
template.prototype.showCropOverlayForShapes=function(elmObj,selElmId,flag)
{
    log.debug("Adding shadow on Elm: "+selElmId+",flag:"+flag,"showCropOverlayForShapes");
    $(".boxShadowCls").remove();
  
    if(flag)
    { 
        $("#ElmCover-"+selElmId).append('<div id="leftShadowId-'+selElmId+'" class="boxShadowCls"></div>'
                                        +'<div id="rightShadowId-'+selElmId+'" class="boxShadowCls"></div>'
                                        +'<div id="topShadowId-'+selElmId+'" class="boxShadowCls"></div>'
                                        +'<div id="bottomShadowId-'+selElmId+'" class="boxShadowCls"></div>');
        this.setCropOverlayDivPosForShapes(elmObj,selElmId);
    } 
    log.debug("COMPLETED1","showCropOverlay");
};
template.prototype.setCropOverlayDivPosForShapes=function(elmObj,selElmId)
{
	 log.debug("START","setCropOverlayDivPos");	  
	    var frameImgDivObj=$("#"+selElmId+"_InrElm_CrpImgHolder");
	    var imgOffset = frameImgDivObj.offset();
	    var frmOffset = $("#"+selElmId).offset();
	    var w1 = (frmOffset.left - imgOffset.left)/this.mainFrame.scale;
	    var h1 = (frmOffset.top - imgOffset.top)/this.mainFrame.scale;    
	    var w2 = frameImgDivObj.width()*elmObj.scale - (w1 + elmObj.w);
	    var h2 = frameImgDivObj.height()*elmObj.scale - (h1 + elmObj.h);    
	    this.setDimXYWH("leftShadowId-"+selElmId, -w1,-BORDER_WIDTH, w1-BORDER_WIDTH, (elmObj.h+2*BORDER_WIDTH));
	    this.setDimXYWH("topShadowId-"+selElmId, -w1,-h1, (w1+elmObj.w+w2),(h1-BORDER_WIDTH));   
	    $("#rightShadowId-"+selElmId).css({
	        'right':'-'+w2+'px'
	        ,'width':(w2-BORDER_WIDTH)+'px'
	        ,'top':'-'+BORDER_WIDTH+'px'
	        ,'height':(elmObj.h+2*BORDER_WIDTH)+'px'
	    });    
	    $("#bottomShadowId-"+selElmId).css({
	        'left':'-'+w1+'px'
	        ,'width':(w1+elmObj.w+w2)+'px'
	        ,'bottom':'-'+h2+'px'
	        ,'height':(h2-BORDER_WIDTH)+'px'
	    });
	    log.debug("COMPLETED","setCropOverlayDivPos");
};
template.prototype.handleCropZoomEventForShapes=function(elmObj,selElmId,iVal)
{    
	if(!this.isCroppedMode || rotateMode)
	{
	        return false;
	}
    elmObj.scale=iVal;        
    this.chkElmOfstForShapes(elmObj); 
    this.transformActvShapes(elmObj,selElmId);  
    this.setCropOverlayDivPosForShapes(elmObj,selElmId);    
};
template.prototype.transformActvShapes=function(elmObj,selElmId)
{
        var transFormStr='translate('+ (elmObj.xOffset)+'px,'+(elmObj.yOffset)+'px) scale('+ elmObj.scale+','+elmObj.scale+') rotate(0deg)';
        this.applyCenterTransformOnId(selElmId+"_InrElm_CrpImgHolder", transFormStr, elmObj.shapeDetails.w, elmObj.shapeDetails.h);
};
template.prototype.chkElmOfstForShapes = function(elmObj){
    var ele = elmObj.shapeDetails;
    var scale=elmObj.scale;    
    var scaledW = ele.w*scale;
    var scaledH = ele.h*scale;
    var x1 = elmObj.xOffset - (scaledW-ele.w)/2;
    var y1 = elmObj.yOffset - (scaledH-ele.h)/2;

    var x2 = x1 + scaledW;
    var y2 = y1 + scaledH;        
    if(x1 > 0){
    	elmObj.xOffset = (scaledW - ele.w)/2;
    }
    if(y1 > 0){
    	elmObj.yOffset = (scaledH - ele.h)/2;
    }        
    if(x2 <elmObj.w){
    	elmObj.xOffset = Math.floor(elmObj.w - (ele.w + scaledW)/2);
    }
    if(y2 < elmObj.h){
    	elmObj.yOffset = Math.floor(elmObj.h - (ele.h + scaledH)/2);
    }        
    return elmObj;
};
template.prototype.aspectFillShape=function(elmObj,selElmId)
{	
        var imgDivObj=$("#"+selElmId+"_InrElm_CrpImgHolder");      
      	var calH=elmObj.orgH,calW=elmObj.orgW;
	    var wRatio,hRatio,marginStr,newH,newW,margin=0;		
		wRatio=elmObj.w/calW;
		hRatio=elmObj.h/calH;
		if(wRatio > hRatio)
		{		
			newW=wRatio*calW;
			newH=wRatio*calH;
			margin=getParseIntInDec((newH-elmObj.h)/2);
			elmObj.shapeDetails.y=0;
            elmObj.xOffset -= elmObj.initXOffset;
            elmObj.yOffset -= elmObj.initYOffset;
            elmObj.initXOffset = 0;
            elmObj.initYOffset = -margin;
            elmObj.xOffset += elmObj.initXOffset;
            elmObj.yOffset += elmObj.initYOffset;
		}
		else
		{
			newW=hRatio*calW;
			newH=hRatio*calH;
			margin=getParseIntInDec((newW-elmObj.w)/2);		
			elmObj.shapeDetails.x=0;
            elmObj.xOffset -= elmObj.initXOffset;
            elmObj.yOffset -= elmObj.initYOffset;
            elmObj.initXOffset = -margin;
            elmObj.initYOffset = 0;
            elmObj.xOffset += elmObj.initXOffset;
            elmObj.yOffset += elmObj.initYOffset;
		}		
		elmObj.shapeDetails.w=newW;
		elmObj.shapeDetails.h=newH;        
        imgDivObj.css({
            'width':newW+'px'
            ,'height':newH+'px'
        });
        this.chkElmOfstForShapes(elmObj); 
        this.transformActvShapes(elmObj,selElmId);  
};
template.prototype.attachPanEventOnShape=function(elmObj,selElmId)
{
	var myEle = document.getElementById(selElmId);
    var mc = new Hammer(myEle);  
    var currObj=this;
    mc.on('panstart panmove panend', function(e){         
        currObj.onShapePanEvent(e,elmObj,TemplateUtils.getMainFrameElmIdFromCoverId(selElmId));
    });     
};
template.prototype.onShapePanEvent=function(e,elmObj,selElmId)
{
	try{
		log.debug("START- e.type:"+e.type+",selElmId:"+selElmId,"onShapePanEvent");
		//disable Panning event when rotation mode is enabled
		if(!this.isCroppedMode || rotateMode)
		{
			return false;
		}	
        if(elmObj.scale < 1){
            return;
        }
        if(e.type == 'panstart'){	        	
            this.mainFrame.common.prevPoint = e.center;
        }	        
        elmObj.xOffset += e.center.x -  this.mainFrame.common.prevPoint.x;
        elmObj.yOffset += e.center.y -  this.mainFrame.common.prevPoint.y;
        this.chkElmOfstForShapes(elmObj); 
        this.transformActvShapes(elmObj,selElmId);  	     
        this.mainFrame.common.prevPoint = e.center;
	    this.setCropOverlayDivPosForShapes(elmObj,selElmId);
   }
   catch(ex)
   {
   	    log.debug("Handeled error : "+ ex.message,"onShapePanEvent");
   }
};
template.prototype.getShapesImageCropXYWH=function(elmObj)
{
	var cropCord=this.getShapeImgElmCropCoord(elmObj,false);
	var cropImgXYWH={x:0,y:0,w:0,h:0};
	cropImgXYWH.x = cropCord.l;
	cropImgXYWH.w =cropCord.r - cropCord.l;
	cropImgXYWH.y = cropCord.t;
	cropImgXYWH.h = cropCord.b-cropCord.t;
	return cropImgXYWH;
};
template.prototype.getShapeImgElmCropCoord=function(elmInfo,isForLFD){    
    log.debug("1START info = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"getShapeImgElmCropCoord");
    var widthRatio =1;
    var heightRatio = 1;
    if(isForLFD)
    {
    	widthRatio =elmInfo.orgW/elmInfo.shapeDetails.w;
       heightRatio =elmInfo.orgH/elmInfo.shapeDetails.h;
    }
    else
    {
    	widthRatio =elmInfo.shapeDetails.thumbOrgW/elmInfo.shapeDetails.w;
        heightRatio =elmInfo.shapeDetails.thumbOrgH/elmInfo.shapeDetails.h;
    }
    var scaledW = elmInfo.shapeDetails.w * elmInfo.scale;
    var scaledH = elmInfo.shapeDetails.h * elmInfo.scale;   
    var cropX = 0,cropY = 0,offX=0,offY=0;
    cropX = (scaledW - elmInfo.w)/2;
    cropY = (scaledH - elmInfo.h)/2; 
    offX = elmInfo.xOffset - elmInfo.initXOffset;
    offY = elmInfo.yOffset - elmInfo.initYOffset;
    var cenX = (scaledW - elmInfo.w)/2;
    var cenY = (scaledH - elmInfo.h)/2;
    var l = cenX - offX;
    var t = cenY - offY;
    var r = l + elmInfo.w;
    var b = t + elmInfo.h;    
    var orgl = (l*widthRatio)/elmInfo.scale;
    var orgt = (t*heightRatio)/elmInfo.scale;
    var orgr = (r*widthRatio)/elmInfo.scale;
    var orgb = (b*heightRatio)/elmInfo.scale;
    if(orgl < 0){
        orgl = 0;
    }
    if(orgt < 0){
        orgt = 0;
    }
    if(orgr > elmInfo.orgW){
        orgr = elmInfo.orgW;
    }
    if(orgb > elmInfo.orgH){
        orgb = elmInfo.orgH;
    }        
    return {l:orgl,t:orgt,r:orgr,b:orgb};
};
template.prototype.setShapeImgOffsetFromCropCoord=function(elmInfo, cropRect){    
    log.debug("START elmInfo = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"setShapeImgOffsetFromCropCoord");
    var hRatio = 0,wRatio = 0,newW = 0, newH = 0,margin=0;
    elmInfo.shapeDetails.x=0;
    elmInfo.shapeDetails.y=0;  
    var orgW=elmInfo.orgW;
    var orgH=elmInfo.orgH;
    wRatio=elmInfo.w/orgW;
    hRatio=elmInfo.h/orgH;
    if(wRatio > hRatio)
    {
        newW=wRatio*orgW;
        newH=wRatio*orgH;
        margin=getParseIntInDec((newH-elmInfo.h)/2);
        elmInfo.initXOffset = 0;
        elmInfo.initYOffset = -margin;
    }
    else
    {
        newW=hRatio*orgW;
        newH=hRatio*orgH;
        margin=getParseIntInDec((newW-elmInfo.w)/2);
        elmInfo.initXOffset = -margin;
        elmInfo.initYOffset = 0;
    }
    elmInfo.shapeDetails.w=newW;
    elmInfo.shapeDetails.h=newH;
    
    var scaledW = newW * elmInfo.scale;
    var scaledH = newH * elmInfo.scale;
    var widthRatio = orgW/newW;
    var heightRatio = orgH/newH;
    var l = (cropRect.l * elmInfo.scale)/widthRatio;
    var t = (cropRect.t * elmInfo.scale)/heightRatio;
    var r = (cropRect.r * elmInfo.scale)/widthRatio;
    var b = (cropRect.b * elmInfo.scale)/heightRatio;
    var cenX = (scaledW - elmInfo.w)/2;
    var cenY = (scaledH - elmInfo.h)/2;
    var offX = 0;
    var offY = 0;
    if(elmInfo.rotation==180){
        offX = l - cenX;
        offY = t - cenY;
    }else{
        offX = cenX - l;
        offY = cenY - t;
    }
    elmInfo.xOffset = offX + elmInfo.initXOffset;
    elmInfo.yOffset = offY + elmInfo.initYOffset;    
};
template.prototype.tocuhStartOnYellowCP=function(eventDivId,e)
{	 
      if(log.bDebug){
          log.debug("ON TOUCHSTART EVENT  MAIN_FRAME_ELM_YCP",".mainFrameElmYCpCLs");
      }        
      this.dragLocation=MAIN_FRAME_ELM_YCP;
      this.mainElmDragBtnID=eventDivId;
      var tapDivID=eventDivId.split("-YCP_")[0];
      $("#"+eventDivId).addClass("mainFrameElmYCpSelCLs");		
      this.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX,y:e.originalEvent.changedTouches[0].clientY};
      this.setDragElmFrame(tapDivID);
      var splitArr=this.mainElmDragBtnID.split("-YCP_");
      var elmID=splitArr[0];
      var ypIndx=splitArr[1];
      this.resetCropModeForShapes(this.mainFrameSelElmObj,tapDivID);
      if(UNDO_REDO_ALLOWED){
            this.getShapeYcpDetailsFrUndo(true,elmID,ypIndx);
      }
	  yllwPtLimit = this.getYllwPtLimit(this.mainFrameSelElmObj,getParseIntInDec(splitArr[1]));
	  //this.mainFrameSelElmObj.shapeDetails.FigureStrokeWidth=0;
	  this.mainFrameSelElmObj.shapeDetails.previewMode = true;
};
template.prototype.tocuhEndOnYellowCP=function(eventDivId,e)
{
	if(this.mainElmDragBtnID!=eventDivId){
        log.debug("WRONG ELEMENT TOUCHEND EVENT  MAIN_FRAME_ELM_YCP",".mainFrameElmYCpCLs");
        return;
    }
    this.dragLocation=DEFAULT_VALUE;
    $("#"+eventDivId).removeClass("mainFrameElmYCpSelCLs");     
    var elmID;
    var $thisObj = this;
    if(this.dragElmFrame!=null)
    {
        var splitArr=this.mainElmDragBtnID.split("-YCP_");
    	elmID=splitArr[0];
        var ypIndx=splitArr[1];
        $("#"+elmID+"_InrElm_projtn").hide();
        $("#"+elmID+"_InrElm").attr("src",this.mainFrameSelElmObj.imageSrc);       

        if (this.mainFrameSelElmObj.elementType == shapeInfo.RECTCAL && ypIndx == 1) {
            var yllwPtObj = this.mainFrameSelElmObj.shapeDetails.ylowPts[ypIndx];
            var yllwPtX = yllwPtObj.x;
            var yllwPtY = yllwPtObj.y;
            this.resizeElementFrameOnYcpDrag(elmID, this.mainFrameSelElmObj, {x: yllwPtX, y: yllwPtY});
        }
        if(UNDO_REDO_ALLOWED){
            this.getShapeYcpDetailsFrUndo(false,elmID,ypIndx);
        }
        this.mainElmDragBtnID="";        
        this.mainFrameSelElmObj.shapeDetails.previewMode = false;
        setTimeout(function(){
            /*
            Touchend is called immediately after touchmove so canvas is not able to render subsequent shapes at one go.
             So giving some timeout for touchend call shape drawing
             */
            $thisObj.getImgSrcForShape(elmID,$thisObj.mainFrameSelElmObj,true);
        }, 100);
    }          
};
template.prototype.renderShapes=function(shapeObj){
	var $this = this;
	for (var i = 0,len = shapeObj.length; i < len; i++){
	    $(document).queue('tasks', $this.createShapeInRender(shapeObj[i]));
	}
	$(document).dequeue('tasks');
};
template.prototype.createShapeInRender=function(currShapeObj){	
    var $this = this;
    return function(next){
        $this.renderCurrShape(currShapeObj, next);
    };
};
template.prototype.renderCurrShape=function(currShapeObj, next){
	var elmObj = currShapeObj.prop;	//this.getTextObjectFromId(currShapeObj.divID);
	var shapeType = currShapeObj.shapeType;
	elmObj.shapeDetails.previewMode = false;
	this.setYCpLocationForShape(elmObj.elementType,elmObj);
	if(elmObj.thumbPath!="")
    {
        this.aspectFillShape(elmObj,currShapeObj.divID);
    }
	require([shapeType], function(shapeType){
		shapeType.draw(currShapeObj.prop).then(function(val){
			elmObj.imageSrc=val; 
			$("#"+currShapeObj.divID+"_InrElm").attr('src',val);
			next();
		});
	});
};
template.prototype.onMnFrmElmYCpDrag=function(e)
{
	var splitArr=this.mainElmDragBtnID.split("-YCP_");
	var ypIndx=getParseIntInDec(splitArr[1]);
	//log.debug("---------123------------"+this.dragElmFrame.id);
    this.isCroppedMode = false;
	var touches = e.originalEvent.changedTouches;
	
	var origin = {x:0, y:0};
	var startPoint = {
			x:this.cpDragStartPt.x, 
			y:this.cpDragStartPt.y
			};
	var endPoint = {
			x:touches[0].clientX, 
			y:touches[0].clientY
			};
	
	/*rotating start and end point w.r.t origin and then doing calculation*/
	var rotatedStartPoint =  utilR.doTransformation(origin, startPoint, -this.mainFrameSelElmObj.rotation, true);
	var rotatedEndPoint = utilR.doTransformation(origin, endPoint, -this.mainFrameSelElmObj.rotation, true);

	var deltaX = (rotatedEndPoint.x - rotatedStartPoint.x)/this.mainFrame.scale;
	var deltaY = (rotatedEndPoint.y - rotatedStartPoint.y)/this.mainFrame.scale;
   
    this.cpDragStartPt.x = touches[0].clientX;
    this.cpDragStartPt.y = touches[0].clientY;    
    var elmID=splitArr[0];
    var shapeObj=this.mainFrameSelElmObj.shapeDetails.ylowPts[ypIndx];    
    var currLeft=shapeObj.x;
    var currTop=shapeObj.y;
    var dir=shapeObj.direction;   
    switch(dir)
    {
        case 0:
        	currLeft=currLeft+deltaX;        	                                 
        break;
        case 1:
        	currTop=currTop+deltaY;
        break;
        case 2:
        	currLeft=currLeft+deltaX;
        	currTop=currTop+deltaY;      
        break;      
        default:
        break;
    }

    var ellipsePoint = null;
    rectFlag = true;
    // get point on ellipse for ARC shape
    if (this.mainFrameSelElmObj.elementType == shapeInfo.ARC) {
        var mouse_x = pointerEventToXY(e).x;
        var mouse_y = pointerEventToXY(e).y;
        ellipsePoint = this.getPointOnEllipse(this.mainFrameSelElmObj, elmID, mouse_x, mouse_y);
        console.log("ellipsePoint.x: " + ellipsePoint.x + ", ellipsePoint.y: " + ellipsePoint.y);
        var offset = $('#ElmCover-' + elmID).offset();
        ellipsePoint.x -= offset['left'];
        ellipsePoint.y -= offset['top'];
        currLeft = ellipsePoint.x;
        currTop = ellipsePoint.y;
    } else if (this.mainFrameSelElmObj.elementType == shapeInfo.RECTCAL) {
        if (ypIndx == 1) {
            var mainFramePt = this.getXYJson(currLeft, currTop);
            var rotatedPoint = utilR.doTransformation(this.getXYJson(this.mainFrameSelElmObj.w/2, this.mainFrameSelElmObj.h/2), mainFramePt, this.degreesToRadians(this.mainFrameSelElmObj.rotation));
            var pt = this.getXYJson(rotatedPoint.x + this.mainFrameSelElmObj.x, rotatedPoint.y + this.mainFrameSelElmObj.y);
            /*rotatedPoint.x += this.mainFrame.x + this.mainFrameSelElmObj.x;
            rotatedPoint.y += this.mainFrame.y + this.mainFrameSelElmObj.y;
            var resizedInnerRectObj = {
                x: this.mainFrameSelElmObj.x + (this.mainFrameSelElmObj.shapeDetails.InnerRect.x / 100) * this.mainFrameSelElmObj.w,
                y: this.mainFrameSelElmObj.y + (this.mainFrameSelElmObj.shapeDetails.InnerRect.y / 100) * this.mainFrameSelElmObj.h,
                w: (this.mainFrameSelElmObj.shapeDetails.InnerRect.w / 100) * this.mainFrameSelElmObj.w,
                h: (this.mainFrameSelElmObj.shapeDetails.InnerRect.h / 100) * this.mainFrameSelElmObj.h,
                rotation: this.mainFrameSelElmObj.rotation
            };*/
            if (!this.resizeElementFrameOnYcpDrag(elmID, this.mainFrameSelElmObj, mainFramePt, true) ||
                /*(utilR.pointInsideRect(resizedInnerRectObj, rotatedPoint)) ||*/ (pt.x < 0 || pt.y < 0 || pt.x > this.mainFrame.w || pt.y > this.mainFrame.h))
            {
                rectFlag = false;
            }
        }
    }

    if (rectFlag && (currLeft >= yllwPtLimit.x1 && currTop >= yllwPtLimit.y1 && currLeft <= yllwPtLimit.x2 && currTop <= yllwPtLimit.y2))
    {                         	
    	//$("#" + elmID + "_InrElm_projtn").show();
    	shapeObj.x = currLeft;
    	shapeObj.y = currTop;
    	this.updatePropertyForShape(ypIndx, elmID, ellipsePoint);
    	//this.getImgSrcForShape(elmID,this.mainFrameSelElmObj, false);
    	this.redrawShape(this.mainFrameSelElmObj,elmID);
    	var hlfCpHW = this.zoomObj.hw/2;
    	$("#"+this.mainElmDragBtnID).css({
    		'left': (currLeft - hlfCpHW) + 'px',
    		'top': (currTop - hlfCpHW) + 'px'
    	});
    }
};
template.prototype.getYllwPtLimit=function(elem,ypIndx){
	console.log("getYellwPtLimit"+ypIndx);
	var minWH = Math.min(elem.w, elem.h);
	var yllwPtObj={x1 :0,
				y1 : 0,
			    x2 : elem.w,
			    y2 : 0 
			    };
	switch(elem.elementType){
		case shapeInfo.RECT:
		case shapeInfo.FRAME:
			if(elem.w<=elem.h){
				yllwPtObj.x2 = elem.w/2;
				yllwPtObj.y2 = elem.w/2;	
			}else{
				yllwPtObj.x2 = elem.h/2;
				yllwPtObj.y2 = elem.h/2;
			}
		break;
		case shapeInfo.DONUT:
			yllwPtObj.y1 =0;
			yllwPtObj.y2 = elem.h/2+5;
			yllwPtObj.x2 = elem.w/2;		
		break;
		case shapeInfo.FOLDEDCOR:
		    yllwPtObj.x1 = Math.round(elem.w-(elem.w>elem.h?(elem.h/2):(elem.w/2)));
            yllwPtObj.y1 = Math.round(elem.h);
            yllwPtObj.x2 = Math.round(elem.w);
            yllwPtObj.y2 = Math.round(elem.h);
		break;
		case shapeInfo.ONESDEARROW:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w;
			yllwPtObj.y2 = elem.h/2;
		break;
		case shapeInfo.TWOSDEARROW:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w/2;
			yllwPtObj.y2 = elem.h/2;
		break;
		case shapeInfo.RIGHTBRACE:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w;
			if(ypIndx===1)
			yllwPtObj.y2 = elem.h*0.25;
			else
			 yllwPtObj.y2 = elem.h;
		break;
		case shapeInfo.LEFTBRACE:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w;
			if(ypIndx===1)
			yllwPtObj.y2 = elem.h*0.25;
			else
			 yllwPtObj.y2 = elem.h;
		break;
		case shapeInfo.CROSS:
            yllwPtObj.x1 = 0;
            yllwPtObj.y1 = 0;
            yllwPtObj.x2 = minWH*0.5;
            yllwPtObj.y2 = 0;
        break;
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:

		case shapeInfo.TRPZOID:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w*0.5;
			yllwPtObj.y2 = 0;
		break;
		case shapeInfo.PARLGRM:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w;
			yllwPtObj.y2 = 0;
		break;
		case shapeInfo.STAR:
		 //Pass Through
		case shapeInfo.STAR24P:
			yllwPtObj.x1 = Math.round(elem.w*0.5);
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = Math.round(elem.w*0.5);
			yllwPtObj.y2 = Math.round(elem.h*0.5);
		   break;
		   case shapeInfo.SUN:
 			yllwPtObj.x1 = Math.round(elem.w/8);
			yllwPtObj.y1 = Math.round(elem.h*0.5);
			yllwPtObj.x2 = Math.round(elem.w*0.5);
			yllwPtObj.y2 = Math.round(elem.h*0.5);;
		   break;
		case shapeInfo.WAVE:
			if(ypIndx===1){
			yllwPtObj.x1 = elem.w*4/10;
			yllwPtObj.y1 = ele.h;
			yllwPtObj.x2 = elem.w*6/10;
			yllwPtObj.y2 = elem.h;
			}
			else{
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = 0;
			yllwPtObj.y2 = elem.h*1/5;
			}
		break;
		case shapeInfo.ARC:
		    console.log("ARC Here");
		    yllwPtObj.x1 = 0;
            yllwPtObj.y1 = 0;
            yllwPtObj.x2 = elem.w;
            yllwPtObj.y2 = elem.h;
		    break;
		case shapeInfo.RECTCAL:
		    if (ypIndx == 0) {
		        yllwPtObj.x1 = 0;
                yllwPtObj.y1 = 0;
                yllwPtObj.x2 = elem.w / 2;
                yllwPtObj.y2 = 0;
		    } else {
		        yllwPtObj.x1 = -10000;
                yllwPtObj.y1 = -10000;
                yllwPtObj.x2 = 10000;
                yllwPtObj.y2 = 10000;
		    }
		break;
		default:
			yllwPtObj.x1 = 0;
			yllwPtObj.y1 = 0;
			yllwPtObj.x2 = elem.w;
			yllwPtObj.y2 = elem.h; 
		break;
	}
	return yllwPtObj;
};
template.prototype.getImgSrcForShape=function(elmID,ele,updateOriginal)
{   
    var shapeType=ele.elementType;
    ele.shapeDetails.typeName = shapeInfoMapping[shapeType].typeName;    
    ele.shapeDetails.elementName = shapeInfoMapping[shapeType].elementName;
    var currentShape = shapeInfoMapping[shapeType].Id;
    require([currentShape], function(currentShape){
        currentShape.draw(ele).then(function(val){
        	ele.imageSrc=val;  
        	if(updateOriginal){
        		$("#"+elmID+"_InrElm").attr("src",ele.imageSrc);
        		$("#"+elmID+"_InrElm_projtn").hide();
        	}else{
        	$("#"+elmID+"_InrElm_projtn").attr("src",ele.imageSrc);
        	}
        });
    });
};
template.prototype.updatePropertyForShape=function(ypIndx,elmID, ellipsePoint) // for ARC shape
{
	var elmType=this.mainFrameSelElmObj.elementType;
	var shapeDetails=this.mainFrameSelElmObj.shapeDetails;
	var yPoints=shapeDetails.ylowPts[ypIndx];
	var elmH=this.mainFrameSelElmObj.h;
    var elmW=this.mainFrameSelElmObj.w;
    var minWH = Math.min(elmW, elmH);
	var prevValue;
	switch(elmType)
	{
		case shapeInfo.TRI:
			shapeDetails.ApexRatio=Math.round((yPoints.x/elmW)*100);
		break;
		case shapeInfo.RECT:
			shapeDetails.FigureRoundRatio=Math.round((yPoints.x/(minWH/2))*100);
		break;
		case shapeInfo.FRAME:
			shapeDetails.FrameWidth=Math.round((yPoints.x/(minWH/2))*100);
		break;
		case shapeInfo.DONUT:
			shapeDetails.DonutWidth=Math.round((yPoints.x/(elmW))*100);
		break;
		case shapeInfo.HEXAGN:
			shapeDetails.PolygonWidth=100-Math.round((yPoints.x/(elmW*0.5))*100);
		break;
			case shapeInfo.OCTAGN:
			shapeDetails.PolygonWidth=100-Math.round((yPoints.x/(elmW*0.5))*100);
		break;
		case shapeInfo.CROSS:
			shapeDetails.BarWidth=100-Math.round((yPoints.x/(minWH*0.5))*100);
		break;
		case shapeInfo.TRPZOID:
			shapeDetails.Slope=Math.round((yPoints.x/(elmW*0.5))*100);
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:
		    shapeDetails.StartWidth=100-Math.round((yPoints.y/(elmH*0.5))*100);
		break;
		case shapeInfo.SUN:
		    shapeDetails.EllipseSize = Math.round(((yPoints.x-(elmW*1/8))/(elmW*1/2-elmW*1/8))*100);
		break;
		case shapeInfo.FOLDEDCOR:
            var distance=0;
            if(elmH<elmW)
            {
                distance=(elmH*0.5);
            }
            else
            {
                distance=(elmW*0.5);
            }
            shapeDetails.FoldedRatio=100-Math.round(((elmW-yPoints.x)/distance)*100);
		break;
		case shapeInfo.ONESDEARROW:
			shapeDetails.ArrowHeadLength=100-Math.round((((yPoints.x)/elmW)*100));
			shapeDetails.ArrowBodyWidth=100-Math.round((yPoints.y)/(elmH/2)*100);
		break;
		case shapeInfo.TWOSDEARROW:
			shapeDetails.ArrowHeadLength=Math.round(((yPoints.x)/(elmW*0.5))*100);
			shapeDetails.ArrowBodyWidth=100-Math.round(((yPoints.y)/(elmH/2))*100);
		break;
		case shapeInfo.LEFTBRACE:
			if(ypIndx===0)
			shapeDetails.VertexPosition=Math.round((yPoints.y/elmH)*100);
			else
			shapeDetails.RoundCornerRatio=Math.round((yPoints.y/(elmH*0.25))*100);

		break;
		case shapeInfo.RIGHTBRACE:
		if(ypIndx===0)
			shapeDetails.VertexPosition=Math.round((yPoints.y/elmH)*100);
			else
			shapeDetails.RoundCornerRatio=Math.round((yPoints.y/(elmH*0.25))*100);
		break;
		case shapeInfo.PARLGRM:
			shapeDetails.Slope=Math.round((yPoints.x/(elmW))*100);
		break;
		case shapeInfo.WAVE:
			//shapeDetails.BarWidth=(yPoints.x/elmW)*100;
		    if(ypIndx===0)
		        shapeDetails.CurvedRatio=Math.round((yPoints.y/(elmH*1/5))*100);
	        else
	            shapeDetails.HorizontalSlope=100-Math.round(((yPoints.x-(elmW*6/10))/(elmW*4/10-elmW*6/10))*100);
		break;
		case shapeInfo.ARC:
            console.log("Inside arc shape update");
            if (ypIndx == 0) {
                shapeDetails.StartAngle = Math.round(ellipsePoint.angle);
            } else {
                shapeDetails.EndAngle = Math.round(ellipsePoint.angle);
            }
        break;
        case shapeInfo.RECTCAL:
            if (ypIndx == 1) {
                shapeDetails.CalloutPoint.x = Math.round((yPoints.x / elmW) * 100);
                shapeDetails.CalloutPoint.y = Math.round((yPoints.y / elmH) * 100);
            } else {
                shapeDetails.FigureRoundRatio = Math.round(((yPoints.x/* + 7.5*/) / (elmW / 2)) * 100);
            }
        break;
		default:
		break;
	}	
};
template.prototype.setYCpLocationForShape=function(shapeType,ele)
{
	log.debug("---1---shapeType: "+ shapeType,"setYCpLocationForShape");
	var shapeDetObj = ele.shapeDetails;
	var minWH = Math.min(ele.w, ele.h);
	switch(shapeType) 
	{
		case shapeInfo.BLOCKARROW:
			shapeDetObj.ylowPts=[{x:Math.round(ele.w*0.60),y:Math.round(ele.h*0.25),direction:2}];
		break;
		case shapeInfo.TRI:
			shapeDetObj.ylowPts=[{x:Math.round(ele.w*(shapeDetObj.ApexRatio/100)),y:0,direction:0}];
		break;
		case shapeInfo.RECT:
			shapeDetObj.ylowPts=[{x:Math.round((minWH/2)*(shapeDetObj.FigureRoundRatio/100)),y:0,direction:0}];
		break;
		case shapeInfo.FRAME:
			shapeDetObj.ylowPts=[{x:Math.round((minWH/2)*(shapeDetObj.FrameWidth/100)),y:0,direction:0}];
		break;
		case shapeInfo.DONUT:
			shapeDetObj.ylowPts=[{x:Math.round((ele.w)*(shapeDetObj.DonutWidth/100)),y:Math.round(ele.h/2),direction:0}];
		break;
		case shapeInfo.HEXAGN:
			shapeDetObj.ylowPts=[{x:Math.round((ele.w/2)-((ele.w/2)*(shapeDetObj.PolygonWidth/100))),y:0,direction:0}];
		break;
		case shapeInfo.OCTAGN:
			shapeDetObj.ylowPts=[{x:Math.round((ele.w/2)-((ele.w/2)*(shapeDetObj.PolygonWidth/100))),y:0,direction:0}];
		break;
		case shapeInfo.CROSS:
		    var yllwPtX = Math.round((minWH/2)-((minWH/2)*(shapeDetObj.BarWidth/100)));
			shapeDetObj.ylowPts=[{x:yllwPtX,y:0,direction:0}];
		break;
		case shapeInfo.STAR:
	    case shapeInfo.STAR24P:
	    	shapeDetObj.ylowPts=[{x:Math.round(ele.w*0.5),y:Math.round(ele.h*0.5*((100-shapeDetObj.StartWidth)/100)),direction:1}];
		break;
	    case shapeInfo.SUN:
	    			//shapeDetObj.ylowPts=[{x:Math.round(ele.w*(shapeDetObj.EllipseSize/100)),y:ele.h*0.5,direction:0}];
	    			shapeDetObj.ylowPts=[{x:Math.round(((ele.w*1/8)+(ele.w*1/2-ele.w*1/8)*(shapeDetObj.EllipseSize/100))),y:Math.round(ele.h/2),direction:0}];
			//shapeDetObj.ylowPts=[{x:Math.round(ele.w/2),y:Math.round(ele.h*(shapeDetObj.EllipseSize/100)),direction:1}];
		break;
        case shapeInfo.WAVE:
            shapeDetObj.ylowPts=[{x:0,y:ele.h*1/5*(shapeDetObj.CurvedRatio/100),direction:1},{x:Math.round(((ele.w*4/10)+(ele.w*6/10-ele.w*4/10)*(shapeDetObj.HorizontalSlope/100))),y:ele.h,direction:0}];
	        //shapeDetObj.ylowPts=[{x:0,y:ele.h*1/5*(shapeDetObj.CurvedRatio/100),direction:1}];
	        //shapeDetObj.ylowPts=[{x:ele.w*6/10*(shapeDetObj.HorizontalSlope/100),y:ele.h,direction:0}];
		break;
		case shapeInfo.FOLDEDCOR:
			var distance=0;
            if(ele.h<ele.w)
            {
                distance=(ele.h*0.5);
            }
            else
            {
                distance=(ele.w*0.5);
            }
            distance=distance*((100-shapeDetObj.FoldedRatio)/100);
            shapeDetObj.ylowPts=[{x:Math.round(ele.w-distance),y:Math.round(ele.h),direction:0}];
		break;
		case shapeInfo.LEFTBRACE:
			shapeDetObj.ylowPts=[{x:0,y:Math.round(ele.h*(shapeDetObj.VertexPosition/100)),direction:1},{x:Math.round(ele.w/2),y:Math.round((ele.h*0.25)*(shapeDetObj.RoundCornerRatio/100)),direction:1}];
		break;
		case shapeInfo.RIGHTBRACE:
			shapeDetObj.ylowPts=[{x:Math.round(ele.w),y:Math.round(ele.h*(shapeDetObj.VertexPosition/100)),direction:1},{x:Math.round(ele.w/2),y:Math.round((ele.h*0.25)*(shapeDetObj.RoundCornerRatio/100)),direction:1}];
		break;
		case shapeInfo.ONESDEARROW:
			shapeDetObj.ylowPts=[{x:Math.round(ele.w-(ele.w*(shapeDetObj.ArrowHeadLength/100))),y:Math.round((ele.h/2)-((ele.h/2)*(shapeDetObj.ArrowBodyWidth/100))),direction:2}];
		break;
		case shapeInfo.TWOSDEARROW:
			shapeDetObj.ylowPts=[{x:Math.round(((ele.w*0.5)*(shapeDetObj.ArrowHeadLength/100))),y:Math.round((ele.h*0.5)-((ele.h*0.5)*(shapeDetObj.ArrowBodyWidth/100))),direction:2}];
		break;
		case shapeInfo.TRPZOID:
			shapeDetObj.ylowPts=[{x:Math.round(((ele.w*0.5)*(shapeDetObj.Slope/100))),y:0,direction:0}];
		break;
		case shapeInfo.PARLGRM:
		    shapeDetObj.ylowPts=[{x:Math.round(((ele.w)*(shapeDetObj.Slope/100))),y:0,direction:0}];
		break;
		case shapeInfo.ARC:
		    var a = Math.round(ele.w / 2);
		    var b = Math.round(ele.h / 2);

		    var x1 = a * Math.cos(this.degreesToRadians(shapeDetObj.StartAngle)) + a;
            var y1 = b * Math.sin(this.degreesToRadians(shapeDetObj.StartAngle)) + b;

		    var x2 = a * Math.cos(this.degreesToRadians(shapeDetObj.EndAngle)) + a;
            var y2 = b * Math.sin(this.degreesToRadians(shapeDetObj.EndAngle)) + b;

            shapeDetObj.ylowPts = [{x: x1, y: y1, direction: 0}, {x: x2, y: y2, direction: 0}];
        break;
        case shapeInfo.RECTCAL:
            shapeDetObj.ylowPts = [{x:Math.round((ele.w/2)*(shapeDetObj.FigureRoundRatio/100)), y: 0, direction: 0}, {x: (shapeDetObj.CalloutPoint.x / 100) * ele.w, y: (shapeDetObj.CalloutPoint.y / 100) * ele.h, direction: 2}];
        break;
		default:
		break;
	}
};
template.prototype.redrawShape=function(elmObj, selElmId){
	var currentShape = shapeInfoMapping[elmObj.elementType].Id;
	require([currentShape], function(currentShape){
		currentShape.draw(elmObj).then(function(valImg){
			elmObj.imageSrc=valImg; 
			$("#"+selElmId+"_InrElm").attr('src',valImg);
		});
	});
};
template.prototype.isShapeWithYlowCp=function(iElmType)
{	
	var shapeInfo=shapeInfoMapping[iElmType];	
	if(shapeInfo!=null && shapeInfo!=undefined && shapeInfo.yellowPoint)
	{
		return true;
	}
	return false;
};
template.prototype.addYellowCpOnElm=function(divID)
{
	$(".mainFrameElmYCpCLs").remove();
	var elmIndx= divID.split("-elm_")[1].split("_")[0];	
	var mnFrmElm=this.mainFrame.element[elmIndx];	
	var yellowPoints=mnFrmElm.shapeDetails.ylowPts;
	var halfHW=this.zoomObj.hw/2;
	if(yellowPoints!=null)
	{		
		var len=yellowPoints.length;		
		 for(var i=0;i<len;i++)
		 {
			 $("#ElmCover-"+divID).append('<div id="'+divID+'-YCP_'+i+'" class="mainFrameElmYCpCLs mnFrmElmCpGenricCls" style="top:'+(yellowPoints[i].y-halfHW)+'px;left:'+(yellowPoints[i].x-halfHW)+'px;"></div>');//box-shadow:0px 0px 0px 1px blue;
		 }	   
	}   
};
template.prototype.updateYellowCpOnElm=function(mnFrmElm,divID)
{
	var yellowPoints=mnFrmElm.shapeDetails.ylowPts;
	var halfHW=this.zoomObj.hw/2;
	if(yellowPoints!=null)
	{		
		var len=yellowPoints.length;		
		 for(var i=0;i<len;i++)
		 {
			 $("#"+divID+"-YCP_"+i).css({
				 'top':(yellowPoints[i].y-halfHW)+'px',
				 'left':(yellowPoints[i].x-halfHW)+'px'
			 });			 
		 }	   
	}   
};
template.prototype.createUndoShapeElmObjForBgImage=function(elmObj){
	var undoShapeObj = {};
	undoShapeObj.fileName = elmObj.fileName;
	undoShapeObj.imgPath = elmObj.thumbPath;
	undoShapeObj.orgImgPath = elmObj.OriginalPath;
	undoShapeObj.orgW = elmObj.orgW;
	undoShapeObj.orgH = elmObj.orgH;	
	undoShapeObj.imgPathOrgW = elmObj.shapeDetails.thumbOrgW;
	undoShapeObj.imgPathOrgH = elmObj.shapeDetails.thumbOrgH;	
	undoShapeObj.FillColor = elmObj.shapeDetails.FillColor;
	undoShapeObj.FillOpacity = elmObj.shapeDetails.FillOpacity;
	return undoShapeObj;
};
template.prototype.updateShapeElmObjForBgImage=function(elmntObj,iObj,elmId)
{	
	elmntObj.thumbPath= iObj.imgPath;
	elmntObj.OriginalPath=iObj.orgImgPath;
	elmntObj.orgW=getParseIntInDec(iObj.orgW);
	elmntObj.orgH=getParseIntInDec(iObj.orgH);	
	elmntObj.fileName=iObj.fileName;
	elmntObj.shapeDetails.FillColor="";
	elmntObj.shapeDetails.thumbOrgW=getParseIntInDec(iObj.imgPathOrgW);
	elmntObj.shapeDetails.thumbOrgH=getParseIntInDec(iObj.imgPathOrgH);
	elmntObj.shapeDetails.divID = elmId;
	var type =  elmntObj.elementType;
	var currentShape = shapeInfoMapping[type].Id;
	var currObj=this;
	currObj.aspectFillShape(elmntObj,elmId);
	$("#"+elmId+"_InrElm_CrpImgHolder").attr('src',elmntObj.thumbPath);
    require([currentShape], function(currentShape){
        currentShape.draw(elmntObj).then(function(valImg){
            elmntObj.imageSrc=valImg; 
            $("#"+elmId+"_InrElm").attr('src',valImg);                        
        });
    });
};

// return corresponding y-coordinate for x-coordinate
template.prototype.getYForX = function(h, k, x, M) {
    return (M * (x - h) + k);
};


// find (x, y) using equation (((x - h)^2 / a^2) + ((y - k)^2 / b^2) = 1) and ((y - k) = (x - h) * ((n - k) / (m - h)))
template.prototype.getPointOnEllipse = function(elementObj, elementID, m, n, isRectCall) {
    var a = elementObj.w / 2;
    var b = elementObj.h / 2;
    var centre = this.getCentreOfEllipse(elementID);
    var innerRectObj = elementObj.shapeDetails.InnerRect;
    if (isRectCall) {
        a = ((innerRectObj.w / 100) * elementObj.w) / 2;
        b = ((innerRectObj.h / 100) * elementObj.h) / 2;
        centre.x += (innerRectObj.x / 100) * elementObj.w;
        centre.y += (innerRectObj.y / 100) * elementObj.h;
    }
    var h = a + centre.x;
    var k = b + centre.y;
    console.log("elementObj.w = " + elementObj.w + ", elementObj.h = " + elementObj.h);
    console.log("h: " + h + ", k: " + k);
    var a2 = Math.pow(a, 2); // a^2
    var b2 = Math.pow(b, 2); // b^2
    var M = (k - n) / (h - m); // (y2 - y1) / (x2 - x1)
    var M2 = Math.pow(M, 2); // M^2
    var num = (a2 * b2);
    var den = (b2 + M2 * a2);
    var x_h2 = (num / den); // (x - h)^2
    var x_h = Math.sqrt(x_h2); // (x - h)
    var x1 = (x_h + h);
    var x2 = (-x_h + h);
    var y1 = this.getYForX(h, k, x1, M);
    var y2 = this.getYForX(h, k, x2, M);
    console.log("x1: " + x1 + ", y1: " + y1);
    console.log("x2: " + x2 + ", y2: " + y2);
    var dist1 = Math.round(Math.pow(m - x1, 2) + Math.pow(n - y1, 2));
    var dist2 = Math.round(Math.pow(m - x2, 2) + Math.pow(n - y2, 2));

    var x, y;
    if (dist1 < dist2) { // store the point which is closer to the cursor

        x = x1;
        y = y1;

    } else {

        x = x2;
        y = y2;

    }

    /*var angle = this.getAngleForEllipse(x, y, h, k);
    console.log(angle);*/

    m -= h;
    n -= k;

    var radians = Math.atan((a * n) / (b * m));

    var degrees = this.radiansToDegrees(radians);
    console.log(degrees);

    if (x-centre.x < a) {
        degrees += 180;
    }

    //x = a * Math.cos(angle) + a; // x = a * cos(angle)
    //y = b * Math.sin(angle) + b; // y = b * sin(angle)

    var dist = Math.sqrt(Math.pow(h - x, 2) + Math.pow(k - y, 2));
    var angleOffset = 0.05 * ((dist) * (Math.max(a, b) / Math.min(a, b)));

    return {
        x: x,
        y: y,
        angle: degrees,
        angleOffset: angleOffset
    };
};

// get angle of point w.r.t ellipse
// not used anymore
template.prototype.getAngleForEllipse = function(x, y, cx, cy) {

    var deltaX = (x - cx);
    var deltaY = (y - cy);

    var angle = Math.atan2(deltaY, deltaX);

    return angle;
};


// get centre of ellipse using the width and height of Element Cover
template.prototype.getCentreOfEllipse = function(elementID) {
    var element = $('#ElmCover-' + elementID);
    var offset = element.offset();
    var x = offset['left'];
    var y = offset['top'];
    console.log("x: " + x + ", y: " + y);
    return {
        x: x,
        y: y
    };
};

template.prototype.degreesToRadians = function(degrees) {
    return (degrees * (Math.PI / 180));
};

template.prototype.radiansToDegrees = function(radians) {
    return (radians * (180 / Math.PI));
};
template.prototype.reDrawShapeOnCpTouchStart=function(tapDivID)
{
    var elmObj;
    if(this.multiSelectMode)
  	{
  	    var multiElmLen=this.multiSelElmArr.length-1;
  	    var curObj;
  	    for(var i = 0; i <= multiElmLen; i++)
        {
            curObj=this.multiSelElmArr[i];
            elmObj = curObj.ref;
            if(TemplateUtils.isShape(elmObj.elementType)){
                elmObj.shapeDetails.previewMode = true;
                this.redrawShape(elmObj,curObj.id);
            }
        }
  	}
  	else
  	{
        elmObj = this.mainFrameSelElmObj;
        if(TemplateUtils.isShape(elmObj.elementType)){
            if($('.mainFrameElmYCpCLs').length>0){
                $('.mainFrameElmYCpCLs').css({'visibility':'hidden'});
            }
            elmObj.shapeDetails.previewMode = true;
            this.redrawShape(elmObj,tapDivID);
        }
  	}
};
template.prototype.reDrawShapeOnCpTouchEnd=function(elmObj,elmID)
{
    log.debug("ElmID:"+elmID,"reDrawShapeOnCpTouchEnd");
    var currObj=this;
    var yellowPointHtmlObj=$("#ElmCover-"+elmID+" .mainFrameElmYCpCLs");
    if(yellowPointHtmlObj.length>0){
        currObj.setYCpLocationForShape(elmObj.elementType,elmObj);
        currObj.updateYellowCpOnElm(elmObj,elmID);
        yellowPointHtmlObj.css({'visibility':'visible'});
    }
    if(elmObj.thumbPath!="")
    {
        currObj.aspectFillShape(elmObj,elmID);
    }
    elmObj.shapeDetails.previewMode = false;
    setTimeout(function() {
            currObj.redrawShape(elmObj,elmID);
    }, 100);
};
template.prototype.reDrawShapeOnTouchMove=function(elmObj,shapeID,currentShape,flagArr,indx)
{
    elmObj.shapeDetails.previewMode = true;
    require([currentShape], function(currentShape){
        currentShape.draw(elmObj).then(function(valImg){
            elmObj.imageSrc=valImg;
            log.debug("5elmID:"+shapeID,"createShapeForId");
            $("#"+shapeID+"_InrElm").attr('src',valImg);
                    flagArr[indx] = true;
        });
    });
};

template.prototype.resizeElementFrameOnYcpDrag = function(elementID, elementObj, yllwPtObj, dragFlag) {

    var addW = 0, addH = 0, addX = 0, addY = 0, innerAddX = 0, innerAddY = 0;
    var hlfCpHW = this.zoomObj.hw/2;
    var newLeft, newTop;
    var shapeDetailsObj = elementObj.shapeDetails;
    var innerRectObj = shapeDetailsObj.InnerRect;
    var oldW = elementObj.w, oldH = elementObj.h;
    var innerRectW = (innerRectObj.w / 100) * oldW;
    var innerRectH = (innerRectObj.h / 100) * oldH;
    var innerRectX = (innerRectObj.x / 100) * oldW;
    var innerRectY = (innerRectObj.y / 100) * oldH;

    elementObj.w -= (oldW - innerRectW);
    elementObj.h -= (oldH - innerRectH);
    elementObj.x += innerRectX;
    elementObj.y += innerRectY;
    yllwPtObj.x -= innerRectX;
    yllwPtObj.y -= innerRectY;

    if (yllwPtObj.x < 0) {

        if (yllwPtObj.y < 0) {

            addW = yllwPtObj.x * (-1);
            addH = yllwPtObj.y * (-1);

            addX = yllwPtObj.x;
            addY = yllwPtObj.y;

            newLeft = 0;
            newTop = 0;

            innerAddX += addW;
            innerAddY += addH;
        } else {
            addW = yllwPtObj.x * (-1);
            addH = Math.max(0, yllwPtObj.y - elementObj.h);

            addX = yllwPtObj.x;
            //addY = innerRectObj.y;

            newLeft = 0;
            newTop = yllwPtObj.y;

            innerAddX += addW;
            //innerAddY += -innerRectObj.y;
        }
    } else {

        if (yllwPtObj.y < 0) {

            addW = Math.max(0, yllwPtObj.x - elementObj.w);
            addH = yllwPtObj.y * (-1);

            //addX = innerRectObj.x;
            addY = yllwPtObj.y;

            newLeft = yllwPtObj.x;
            newTop = 0;

            //innerAddX += -innerRectObj.x;
            innerAddY += addH;
        } else {
            addW = Math.max(0, yllwPtObj.x - elementObj.w);
            addH = Math.max(0, yllwPtObj.y - elementObj.h);

            //addX = -innerRectX;
            //addY = -innerRectY;

            newLeft = yllwPtObj.x;
            newTop = yllwPtObj.y;

            //innerAddX += -innerRectObj.x;
            //innerAddY += -innerRectObj.y;
        }
    }

    var curElmObjPoints ={mainFrameSelElmObj:{x:elementObj.x + addX,y:elementObj.y + addY,w:elementObj.w + addW,h:elementObj.h + addH,rotation:elementObj.rotation},mainFrame:this.mainFrame};
    var isElmResizePossible = TemplateUtils.isElmInsideMainFrame(curElmObjPoints);
    if (/*!rectFlag || */!isElmResizePossible || dragFlag) {
        //rectFlag = false;
        elementObj.w += (oldW - innerRectW);
        elementObj.h += (oldH - innerRectH);
        elementObj.x -= innerRectX;
        elementObj.y -= innerRectY;
        yllwPtObj.x += innerRectX;
        yllwPtObj.y += innerRectY;
        return isElmResizePossible;
    }

    elementObj.w += addW;
    elementObj.h += addH;
    elementObj.x += addX;
    elementObj.y += addY;

    innerRectObj.x = Math.round((innerAddX / elementObj.w) * 100);
    innerRectObj.y = Math.round((innerAddY / elementObj.h) * 100);

    this.recalculateInnerRectWH(oldW, oldH, elementObj, innerRectObj);

    this.resetMnFrmElementPos(elementID, elementObj);
    this.updateMainFrameCpPosition(elementID);

    yllwPtObj = {
        x: newLeft - innerAddX,
        y: newTop - innerAddY
    };

    shapeDetailsObj.CalloutPoint.x = Math.round((newLeft / elementObj.w) * 100);
    shapeDetailsObj.CalloutPoint.y = Math.round((newTop / elementObj.h) * 100);

    this.setYcpDirectionForRC(elementObj, yllwPtObj);
    this.setYCpLocationForShape(elementObj.elementType, elementObj);
    this.updateYellowCpOnElm(elementObj, elementID);
};

template.prototype.recalculateInnerRectWH = function(oldW, oldH, elementObj, innerRectObj) {

    var newW = elementObj.w;
    var newH = elementObj.h;
    var perW = innerRectObj.w;
    var perH = innerRectObj.h;
    var valW = (perW / 100) * oldW;
    var valH = (perH / 100) * oldH;
    var newPerW = (valW / newW) * 100;
    var newPerH = (valH / newH) * 100;

    innerRectObj.w = Math.round(newPerW);
    innerRectObj.h = Math.round(newPerH);
};

template.prototype.setYcpDirectionForRC = function(elementObj, yllwPtObj) {

    var x = new Array(), y = new Array(), linePts = new Array(), dir = elementObj.shapeDetails.CalloutPoint.direction;

    var innerRectObj = elementObj.shapeDetails.InnerRect;

    var width = (innerRectObj.w / 100) * elementObj.w, height = (innerRectObj.h / 100) * elementObj.h;

    x.push(0);          y.push(height/2);
    x.push(0);          y.push(0);
    x.push(width/2);    y.push(0);
    x.push(width);      y.push(0);
    x.push(width);      y.push(height/2);
    x.push(width);      y.push(height);
    x.push(width/2);    y.push(height);
    x.push(0);          y.push(height);

    for (var i = 0; i < 8; i++) {
        linePts.push({
            a: this.getXYJson(x[i], y[i]),
            b: this.getXYJson(x[(i+4) % 8], y[(i+4) % 8])
        });
    }

    console.log("line points are: " + linePts);

    //var newYllwPtObj = this.getXYJson(yllwPtObj.x - (innerRectObj.x / 100) * elementObj.w, yllwPtObj.y - (innerRectObj.y / 100) * elementObj.h);

    for (var i = 0; i < 8; i++) {
        if (this.getPointLocationWrtLine(linePts[i].a, linePts[i].b, yllwPtObj) == LEFT
            && this.getPointLocationWrtLine(linePts[(i+1) % 8].a, linePts[(i+1) % 8].b, yllwPtObj) == RIGHT) {

            dir = i;
            break;

        }
    }

    elementObj.shapeDetails.CalloutPoint.direction = dir;

};

template.prototype.getXYJson = function(a, b) {
    return {
        x: a,
        y: b
    };
};

template.prototype.getPointLocationWrtLine = function(a, b, p) {

    var det = Math.sign(((b.x - a.x) * (p.y - a.y)) - ((b.y - a.y) * (p.x - a.x)));

    if (det < 0) { // verify first if left or right; verified left is correct
        return LEFT;
    } else {
        return RIGHT;
    }

};