var previewTextSticker = function(){
     this.CanvasWidth = 1;
     this.CanvasHeight = 1;
     this.PreviewWidth = 1;
     this.PreviewHeight = 1;
     this.orientation=LANDSCAPE;
     this.lfdSize={w:1920,h:1080};
 };

previewTextSticker.prototype.updateCanvasPreviewWidthHeight=function()
{
    if(this.orientation==LANDSCAPE)
    {
        this.CanvasWidth = $('#tplFrameId_Main').width();
        this.CanvasHeight = (this.CanvasWidth*9)/16;
        this.PreviewHeight = screen.width;
        this.PreviewWidth = (this.PreviewHeight *16)/9;
    }
    else
    {
        this.CanvasHeight = $('#tplFrameId_Main').height();
        this.CanvasWidth = (this.CanvasHeight*9)/16;
        this.PreviewWidth= screen.width;
        this.PreviewHeight =(this.PreviewWidth *16)/9;
    }
};
previewTextSticker.prototype.getPreviewElmObjOfDiffLayers=function(textStickerLayer,frameId)
{
    var textStickerBodyHtml = this.getBodyHtmlWithTextAndStickerOnly(textStickerLayer,frameId);
    textStickerBodyHtml = textStickerBodyHtml.replace(/"/g ,"'");
    if(textStickerLayer)
    {
        return this.getFinalObjForPreview(textStickerBodyHtml,true);
    }
    else
    {
        return textStickerBodyHtml;
    }
};
previewTextSticker.prototype.getFinalObjForPreview=function(htmlStr,isMainFrame)
{
    return {TextStickerLayerHtml:htmlStr,PositionX:0,PositionY:0,Width:this.lfdSize.w,Height:this.lfdSize.h,type:TEXT_STICKER_LAYER_HTML,fileType:isMainFrame?"MainFrame":"InnerFrame",fontListHtml:($("#allFontListStylID").text())};
}
previewTextSticker.prototype.setResetMenuBoardItemsforPreview = function(elementArr,setIt)
{
    for(elmItr in elementArr)
    {
        this.convertCanvasDimToPrevOfHtml(elementArr[elmItr],setIt);
    }
};

previewTextSticker.prototype.getBodyHtmlWithTextAndStickerOnly = function(showMainFrameElm,frameIdOrHiddenArr)
{
    var resultStr = "";
    var hiddenElmArr=frameIdOrHiddenArr;
    if(showMainFrameElm && hiddenElmArr.length>0)
    {
        for(elmItr in hiddenElmArr)
        {
            if(showMainFrameElm)
                resultStr+=this.getModifiedHtmlAsPerPreviewDim(hiddenElmArr[elmItr]);
            else
            {
                $(hiddenElmArr[elmItr].id).hide();
            }
        }
    }
    retStr = this.getModifiedBodyHTMLPreview();
    if(!showMainFrameElm && hiddenElmArr.length>0)
     {
         for(elmItr in hiddenElmArr)
         {
             $(hiddenElmArr[elmItr].id).show();
         }
     }
    if(!showMainFrameElm)
    {
       resultStr = $("#"+frameIdOrHiddenArr).outerHTML();
       resultStr = resultStr.replace("tmplTxtDivSelCls","");
       return resultStr;
    }
    retStr+=resultStr;
    retStr+="</div>";
    return retStr;
};
previewTextSticker.prototype.getModifiedBodyHTMLPreview = function()
{
     var tplMainFrameObj = $("#tplFrameId_Main");
     var leftOffset = tplMainFrameObj.css('left');
     var topOffset = tplMainFrameObj.css('top');
     var backgroundColor = tplMainFrameObj.css('background-color');
     var Width = tplMainFrameObj.css('width');
     var Height = tplMainFrameObj.css('height');
     var mainFrameScaling = tplMainFrameObj.css('transform');
     var bodyWidth = $('body').width();
     var boxShadow = tplMainFrameObj.css('box-shadow');
     var backgroundImage = tplMainFrameObj.css('background-image');
     tplMainFrameObj.removeClass("tpl_frameMainCls");
     tplMainFrameObj.css({'background-image':'url("")','box-shadow':'rgb(255, 255, 255) 0px 0px 0px 0px','left':'0px','top':'0px','background-color':'rgba(0,0,0,0)','width':this.PreviewWidth+'px','height':this.PreviewHeight + 'px','transform':'translate(0px, 0px) scale(1, 1)'});
     var textStickerBodyHtml = $('body').html();
     tplMainFrameObj.addClass("tpl_frameMainCls");
     tplMainFrameObj.css({'background-image':backgroundImage,'box-shadow':boxShadow,'left':leftOffset,'top':topOffset,'background-color':backgroundColor,'width':Width,'height':Height,'transform':mainFrameScaling});
     textStickerBodyHtml = textStickerBodyHtml.substring(textStickerBodyHtml.indexOf('<div id="tplFrameId_Main"'));
     var retStr = textStickerBodyHtml.substring(0,1);
     textStickerBodyHtml = textStickerBodyHtml.substring(1);
     retStr+=textStickerBodyHtml.substring(0,textStickerBodyHtml.indexOf('<div'));
     return retStr;
};

previewTextSticker.prototype.getModifiedHtmlAsPerPreviewDim = function(elemObj)
{
    this.convertCanvasDimToPrevOfHtml(elemObj,true);
    var newDivStyle=$(elemObj.id).attr("style");
    var newDivCls=$(elemObj.id).attr("class");
    var htmlStr=$(elemObj.id).outerHTML();
    this.convertCanvasDimToPrevOfHtml(elemObj,false);
    if(elemObj.type == TEXT && elemObj.objRef.bTextSlide)
    {
        htmlStr=this.getTextSlideHtml(elemObj,newDivStyle,newDivCls);
    }
    return htmlStr;
};
previewTextSticker.prototype.convertCanvasDimToPrevOfHtml = function(elemObj,CanvasToPreview)
{
    var idHandler = elemObj.id;
    $(idHandler).css(this.getModifiedObjDimAsPerPerview($(idHandler),CanvasToPreview));
    if(elemObj.type == TEXT && !elemObj.objRef.bTextSlide)
    {
     var slideIdHandler = elemObj.id + "_SlideElm";
     $(slideIdHandler).css(this.getModifiedObjDimAsPerPerview($(slideIdHandler),CanvasToPreview));
     var elmdivId = (elemObj.id).replace("#","");
     var alltextDivId = "#"+elmdivId+"_SlideElmStrokeId,"+"#"+elmdivId+"_SlideElmMainId,"+"#"+elmdivId+"_SlideElmShadowId";
     $(alltextDivId).css('font-size',this.convertCanvasScreenToPreviewDim( $("#"+elmdivId+"_SlideElmStrokeId").css('font-size'),false,CanvasToPreview)+"px");
     if(CanvasToPreview && elemObj.toHide)
     {
       $(alltextDivId).text("");
     }
     else
     {
       $(alltextDivId).text(elemObj.text);
     }
     if( $("#"+elmdivId+"_SlideElmMainId").text()!="")
     {
       templateObj.textSlideShow(elmdivId , templateObj.getTextObjectFromId(elmdivId),true);
     }
    }
};
previewTextSticker.prototype.getModifiedObjDimAsPerPerview = function(idHandlerObj,CanvasToPreview){

    return {'left':this.convertCanvasScreenToPreviewDim( idHandlerObj.css('left'),true,CanvasToPreview)+"px",
            'width':this.convertCanvasScreenToPreviewDim( idHandlerObj.css('width'),true,CanvasToPreview)+"px",
            'top':this.convertCanvasScreenToPreviewDim( idHandlerObj.css('top'),false,CanvasToPreview)+"px",
            'height':this.convertCanvasScreenToPreviewDim( idHandlerObj.css('height'),false,CanvasToPreview)+"px"} ;
};

previewTextSticker.prototype.convertCanvasScreenToPreviewDim = function(val,dir,canvasToScreen)
{
    if(typeof val === 'string')
    {
       val=parseFloat(val.replace("px",""));
    }
    if(dir) // dir true for horizontal Direction
    {
        return (val*(canvasToScreen?(this.PreviewWidth/this.CanvasWidth):(this.CanvasWidth/this.PreviewWidth)));
    }
    else
    {
        return (val*(canvasToScreen?(this.PreviewHeight/this.CanvasHeight):(this.CanvasHeight/this.PreviewHeight)));
    }

};
previewTextSticker.prototype.stickerOrTextWithOutSlideEle = function(ele){
     if(ele.elementType == STICKER || ele.elementType == HANDWRITING || ele.elementType == TEXT)
        return true;
    return false;
};

previewTextSticker.prototype.addTextElementToHiddenArr=function(isMenuBoard,hiddenElmArr,eleRef)
{
	var elmDivText = eleRef.text;
	var textImgName = eleRef.textImageName;
	var elmDivId = "#"+textImgName.substring(0,textImgName.indexOf("_InrElm"));
	var txtElmObj = {id:elmDivId,toHide:false,text:elmDivText,type:TEXT,objRef:eleRef};
	if(((elmDivText == IDS_DOCKINGPANE_MENU ) && isMenuBoard) || (!isMenuBoard && elmDivText == MIA_SID_DOUBLE_TAP_TO_EDIT))
	{
		txtElmObj.toHide = true;
	}
	hiddenElmArr.push(txtElmObj);
};
previewTextSticker.prototype.getTextSlideHtml=function(elmObj,elmStyle,elmCls)
{
   var elmID=elmObj.id.replace(/#/ig,"");
   var newDiv=$('<div id="textSlidePreviewId_'+elmID+'" class="'+elmCls+' textSlidePreviewCls"></div>').attr("style",elmStyle);
   newDiv.css("visibility","hidden");
   var width = newDiv.css("width");
   var height = newDiv.css("height");
   var refObj=elmObj.objRef;
   var slideSpeed = refObj.slideSpeed;
   var elementText=elmObj.text;
   if (slideSpeed < 10)
   {
       slideSpeed = 2;
   }
   else
   {
       slideSpeed = slideSpeed / 10;
   }
   var startHtml = "<div id='mybody' style='margin:0px !important; padding:0px !important;overflow:hidden;position:fixed; background-color:"+templateObj.getBGColorandAlpha(refObj)+"; width:"+width+"; height:"+height+"; font-family:"+refObj.fontFamily+"'>"
                   + "<marquee id='mar' direction='"+this.getDirection(refObj.slideType)+"' scrollamount='"+slideSpeed+"' width='"+width+"' height='"+height+"'>";
   var slideDirection=getParseIntInDec(refObj.slideType);
    startHtml+="<div id='one' style='position:relative;font-family:"+refObj.fontFamily+"'>"
               +this.generateDivHtmlWithShadowAndStroke(elmObj)
               +"</div></marquee></div>";
    newDiv.html(startHtml);
    $("body").append(newDiv);

    width = getParseIntInDec(width);
    height = getParseIntInDec(height);
    var divH= $("#two").outerHeight(true);
    var divW= $("#two").outerWidth(true);
    var divOne=$("#one");
    divOne.css({
        'width':divW+"px"
        ,'height':divH+"px"
    });
    if(slideDirection==TXT_DIRECTION_LEFT || slideDirection==TXT_DIRECTION_RIGHT)
    {
        if(refObj.vAlign == 'bottom') {
            divOne.css("top",(height-divH)+'px');
        }
        else if(refObj.vAlign == 'top')
        {
            divOne.css("top",'0px');
        }
        else
        {
            divOne.css("top",((height-divH)/2)+'px');
        }
    }
    else if(slideDirection==TXT_DIRECTION_TOP || slideDirection==TXT_DIRECTION_BOTTOM)
    {
        if(refObj.hAlign == 'right')
        {
         divOne.css("left",(width-divW)+'px');
        }
        else if(refObj.hAlign == 'left')
        {
            divOne.css("left",'0px');
        }
        else
        {
           divOne.css("left",((width-divW)/2)+'px');
        }
    }
    newDiv.css("visibility","visible");
    var htmlString=$("#textSlidePreviewId_"+elmID).outerHTML();
    $(".textSlidePreviewCls").remove();
    return htmlString;
 };
 previewTextSticker.prototype.getShadowDivHtml=function(elmObj,hAlign,fontSize)
 {
     var refObj=elmObj.objRef;
     var textString = "";
     var shadowDepth=Math.round(this.convertCanvasScreenToPreviewDim(templateObj.resizeTextToTabSize(refObj.shdwDpt),false,true));
     var shadowRgba = getRGBColorInRGBA(refObj.shdwClr,refObj.shdwOpc);
     textString = "<div style ='color:"+shadowRgba+";font-family:"+refObj.fontFamily+";font-size:"+fontSize+"px; position:absolute;top:"+shadowDepth+"px;left:"+shadowDepth+"px;z-index:-16;text-align:"+hAlign+";white-space:nowrap;'>";
     return textString;
 };
 previewTextSticker.prototype.getStrokeDivHtml=function(elmObj,hAlign,fontSize)
 {
     var refObj=elmObj.objRef;
     var textString = "";
     var strokeDepth=Math.round(this.convertCanvasScreenToPreviewDim(templateObj.resizeTextToTabSize(refObj.strkDpt),false,true));
     var strokeRgba = getRGBColorInRGBA(refObj.strkClr,refObj.strkOpc);
     textString = "<div style ='font-family:"+refObj.fontFamily+";font-size:"+fontSize+"px; position:absolute;top:0px;left:0px;-webkit-text-stroke: "+strokeDepth+"px "+strokeRgba+";z-index:-10;text-align:"+hAlign+";white-space:nowrap;'>";
     return textString;
 };
previewTextSticker.prototype.generateDivHtmlWithShadowAndStroke=function(elmObj)
{
   var elementText=elmObj.text;
   var hasNewLine = elementText.indexOf("<br>")!=-1? true : false;
   if(!hasNewLine)
   {
    elementText=elementText.replace("&nbsp;"," ");
   }
   elementText=elementText.replace(/&nbsp;/,"");
   elementText=elementText.replace(/\n/ig,"");
   var refObj=elmObj.objRef;
   var hAlign = refObj.hAlign;
   var fontSize = Math.round(this.convertCanvasScreenToPreviewDim(templateObj.resizeTextToTabSize(refObj.fontSize),false,true));
   var textString="<div id='two' style ='color:"+refObj.fontColor+";font-family:"+refObj.fontFamily+";font-size:"+fontSize+"px; position:absolute;top:0px;left:0px;z-index:0;text-align:"+hAlign+";white-space: nowrap;'>"
                  +elementText+"</div>";
   if (refObj.isShdwApplied)
   {
      textString+=this.getShadowDivHtml(elmObj,hAlign,fontSize)+elementText+"</div>";
   }
   if (refObj.isStrkApplied)
   {
      textString+=this.getStrokeDivHtml(elmObj,hAlign,fontSize)+elementText+"</div>";
   }
   return textString;
};
previewTextSticker.prototype.getDirection=function(slideType)
{
	switch(getParseIntInDec(slideType))
	{
		case 1:
			return TXT_ALIGN_RIGHT;
		case 2:
			return TXT_ALIGN_LEFT;
		case 3:
			return TXT_ALIGN_DOWN;
		case 4:
			return TXT_ALIGN_UP;
		default:
			return "";
	}
};