define('Circle', ['Shape'], function (Shape) {
    'use strict';
     var prop ={};
     return {
         draw : function (options){
                var d = $.Deferred();
                var prop = $.extend(true, {},Shape.default, options);
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                this.drawOutline(prop);
                var $this = this;
                Shape.fillImage(prop).done(function(value) {
                    $this.drawOutline(prop,'source-over');
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                    
                }).fail(function() {
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });    
                return d.promise();
            },
            drawOutline : function (prop, composite){
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                var width = Shape.width;
                var height = Shape.height;
                Shape.resetAlpha(composite);
                Shape.context.beginPath();
                Shape.context.ellipse(width/2+Shape.canvasMargin/2, height/2+Shape.canvasMargin/2, width/2, height/2, 0 * Math.PI/180, 0, 2 * Math.PI);
                Shape.drawStroke(prop);
           }
     };
});