'use strict';
var StickersUI = function(){   
};
var WidgetUI = function(){    
};
var stickersUIObj = new StickersUI();
var doneBtn;
var textSource;
var inpSrcSelcted = null;
var step1Region = REGION_OTHERS;
function resetDropDown(){
	var customArrowDiv = $(".customArrowDiv");
    var listDownUiMainDiv = $(".listDownUiMainDiv");
	customArrowDiv.removeClass('tplMenuUpArrowIcon');
    listDownUiMainDiv.hide();
    customArrowDiv.addClass('tplMenuDownArrowIcon');
}
function resetCheckIpSrc(){
	$(".checkImgClass").css({
         "visibility" : "hidden"
    });
}    
StickersUI.prototype.setStickerMenuGuiHandler = function(stickersList){
    var scrollingHeight = window.innerHeight;
    var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);  
    var leftMargin = getParseIntInDec(scrollingWidth * 0.037);
    
    var stickerContainer = $('<div>').attr("id", "stickerContainer").css({
        "background-color" : "#181818",
    }).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");   
    
    var stickerArea = $('<div>').attr("id", "stickerArea").css({            
    	"background-color": "#181818"         
    }).addClass("inpSrcTabContentCls"); 
    
    var headerHeight = window.innerHeight * 0.458 * .165;
    var textSize = headerHeight * 0.50;
    
    var stickerHeader = $('<div>').attr("id", "stickerHeader").css({
        "font-family" : "NotoSans-Regular",
        "font-size" : textSize + "px",
        "padding-left":"4%"
    }).addClass("inpSrcMainHeaderCls").html(langObj.template.COM_STICKERS);
    stickerHeader.addClass("vAlignmiddle");
    
    stickerContainer.append(stickerHeader);
    stickerContainer.append(stickerArea);    
    
    $("#templatePage").append(stickerContainer);    
    
    $('#stickerMenuScrollArea').remove();
    var stickerMenuScrollArea = $('<div>').attr({"id":"stickerMenuScrollArea","class":"tmpltSubDataCls"}).css({
        "height" : '93%',
        "width" : scrollingWidth + 'px',
        "padding-top" : '4%',
        "padding-bottom" : '2%',
        "margin-left" : leftMargin + 'px',
        "margin-right" : leftMargin + 'px',     
        "overflow":"scroll"  
    });
    
    var midStickerArr = new Array;
    for (var counter = 0; counter < stickersList.length; counter = counter + 1) {       
        var midSticker = 1 +(counter-1)*3;
        midStickerArr.push(midSticker); 
    }
  
    for (var counter = 0; counter < stickersList.length; counter = counter + 1) {       
       
        var stkrRtLeftMargin = 0;        
        
        if($.inArray(counter,midStickerArr) > -1){
            stkrRtLeftMargin = Math.round(scrollingWidth * 0.024);          
        }        
        var stkrBottomMargin = Math.round(scrollingWidth * 0.024);    
        
        var stickerDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',            
            "float" : "left",
            "margin-left" : stkrRtLeftMargin + 'px',
            "margin-right" : stkrRtLeftMargin + 'px',
            "margin-bottom" : stkrBottomMargin + 'px',
            "background-image" : "url('" + stickersList[counter].path + "')",            
            "background-color" : "#4F4F52"
        }).addClass("stickerMenuDiv inptSrcIconCls").attr("stickerName", stickersList[counter].name);       
        stickerMenuScrollArea.append(stickerDiv1);
    } 
    stickerArea.append(stickerMenuScrollArea);
};
    
StickersUI.prototype.getStickerList = function(){
    var rootStickerPath = '../resource/img/sticker/thumb/';
    var stickers = [];
    $.ajax({
        type : "GET",
        url : "../resource/XML/stickers.xml",
        dataType : "xml",
        async : true,
        success : function(xml) {
            var xmlObj = $(xml).find("stickers");
            xmlObj.find("sticker").each(function() {
                stickers.push({
                    name : $(this).find("image").text(),
                    path : rootStickerPath + $(this).find("thumb").text(),
                });
            });
            stickersUIObj.setStickerMenuGuiHandler(stickers);
        },
        error : function(jqXHR, textStatus, errorThrown) {
        }
    });
};
var BackgroundUI = function(){};
var backgroundUIObj = new BackgroundUI();
BackgroundUI.prototype.getBackGroundContentSize= function(){
    var size= $(".bckImageCls").length;
    return size;
};
stickersUIObj.getStickerList();