'use strict';
var timeIntrvl=100;
var isMoving=false;
var leftIntrv=null;
var rightIntrv=null;
var divOffSet=0;
var parWidth=0;
var step=20;
var childW=0;
var distance=15; 
var scrollLft=0;
var isItemDropped=false;
var scrolPosRght=0,scrolPosLft=0;;
function clearAllIntervals()
{
    console.log("clearing all intervals");
    clearInterval(leftIntrv);
    leftIntrv=null;
    clearInterval(rightIntrv);
    rightIntrv=null;
    isMoving=false; 
}
function enableDragDrop(listID)
{
    divOffSet=$("#"+listID).offset();
    parWidth=$("#"+listID).width();    
    $("#" + listID + " li").draggable("enable");
    scrollLft = $("#"+listID).scrollLeft();
}
function disableDragDrop(listID)
{
    try
    {
        $("#" + listID + " li").draggable("disable");        
    }
    catch(ex)
    {
      console.log(ex.message);   
    }
    $("#" + listID + " li").removeClass("ui-draggable-disabled ui-state-disabled ui-droppable-disabled");
}
function initHorizontalSwap(listID) {
    divOffSet=$("#"+listID).offset();
    parWidth=$("#"+listID).width();    
    childW=$("#"+listID +" ul").width();
   initDraggable(listID);
   initDroppable(listID);
   $("#dsableDragbleStylId").remove();
   Utils.addCSSStrInPage('.ui-draggable-helper,.ui-draggable-dragging{display:none !important}',"dsableDragbleStylId");   
   disableDragDrop(listID);
}

function initDraggable(listID) {
    $("#" + listID + " li").draggable({
        helper :"clone",
        cursor : "move",
        revert : "invalid",
        scroll : false,   
        drag : function(e) {            
            isMoving = false;
                        
            if ((e.pageX >= (divOffSet.left + parWidth-30)) && leftIntrv == null) {
                isMoving = true;
                scrolPosLft=e.pageX;
                rightIntrv = null;
                leftIntrv = setInterval(function() {                    
                    scrollLft = $("#"+listID).scrollLeft();                    
                    if (scrollLft <= (childW - parWidth)) {
                        $("#"+listID).scrollLeft(scrollLft + step);                        
                    }                  
                }, timeIntrvl);
            }
            if (e.pageX <= (divOffSet.left+30) && rightIntrv == null) {
                isMoving = true;
                scrolPosRght=e.pageX;
                leftIntrv = null;
                rightIntrv = setInterval(function() {                    
                    scrollLft = $("#"+listID).scrollLeft();                    
                    if (scrollLft >= 0) {
                        $("#"+listID).scrollLeft(scrollLft - step);                        
                    }                   
                }, timeIntrvl);
            }
            if (!isMoving && ((leftIntrv!=null && scrolPosLft-e.pageX>=distance)|| (rightIntrv!=null && e.pageX-scrolPosRght>=distance)))
            {
                clearAllIntervals();
            }                
        }
    });
}

function initDroppable(listID) {
    $("#" + listID + " li").droppable({ 
        hoverClass:"drop-hover",       
        accept : ":not(.ui-sortable-helper)",
        over : function(event, ui) {
          var $this = $(this);
          //log.debug("ID: "+$this.attr("id")+",has Class:"+$this.hasClass("notReplaceableCls"),"initDroppable");
          if($this.hasClass("notReplaceableCls"))
          {
           $this.removeClass("drop-hover");
          }
        },
        drop : function(event, ui) {
            isItemDropped=true;
           console.log("In Drop");
            var $this = $(this);            
            var draggedElm=$(ui.draggable);
            templateObj.swapSlotData($this.attr("id"),draggedElm.attr("id"));           
           console.log($this.attr("id") +"--18 1dragitemid: "+draggedElm.attr("id"));           
        }
    });

}