'use strict';
var adClipCreateProgTimer;
var themeInfo;
var ttlDur=0;
var themeSlotObj=null;
var selCntntMap={};
var tmpltTxtImgArr=[];
var fontXMLObj=null;
var cropJson = {};
cropJson.filesToCropArrs = [];
var locLangCode="";
var isFontLoded=false;
var isAdClipAnalysingStart=false;
var isFontLoded=false;
var fontIncludedArray = [];
var fontListArrDefault = ["NanumBrush.ttf", "NanumPen.ttf", "NotoSans-Bold.ttf", "NotoSans-BoldItalic.ttf", "NotoSans-Italic.ttf", "NotoSans-Regular.ttf", "NotoSerif-Bold.ttf", "NotoSerif-BoldItalic.ttf", "NotoSerif-Italic.ttf", "NotoSerif-Regular.ttf", "SamsungSmart_Latin_Bold.ttf", "SamsungSmart_Latin_Light.ttf", "SamsungSmart_Latin_Medium.ttf", "SamsungSmart_Latin_Thin.ttf", "SamsungSVDScript_Latin.ttf"];
var fontListArrLang = {	A: ["AlegreyaSans-Thin.ttf","AlegreyaSans-ThinItalic.ttf","AlegreyaSans-Light.ttf","AlegreyaSans-LightItalic.ttf","AlegreyaSans-Regular.ttf","AlegreyaSans-Italic.ttf","AlegreyaSans-Medium.ttf",
"AlegreyaSans-MediumItalic.ttf","LobsterTwo-Regular.ttf","EBGaramond-Regular.ttf","IMFePIrm28P.ttf","Slabo13px-Regular.ttf","JosefinSlab-Thin.ttf","JosefinSlab-Light.ttf",
"JosefinSlab-Regular.ttf","DancingScript-Regular.ttf","DancingScript-Bold.ttf","LobsterTwo-Italic.ttf","IMFePIit28P.ttf","JosefinSlab-ThinItalic.ttf","JosefinSlab-LightItalic.ttf",
"JosefinSlab-Italic.ttf","LobsterTwo-Bold.ttf","AlegreyaSans-Bold.ttf","AlegreyaSans-ExtraBold.ttf","AlegreyaSans-Black.ttf","JosefinSlab-SemiBold.ttf","JosefinSlab-Bold.ttf",
"Tangerine_Regular.ttf","Tangerine_Bold.ttf","LobsterTwo-BoldItalic.ttf","AlegreyaSans-BoldItalic.ttf","AlegreyaSans-ExtraBoldItalic.ttf","AlegreyaSans-BlackItalic.ttf",
"JosefinSlab-SemiBoldItalic.ttf","JosefinSlab-BoldItalic.ttf"],
	B: ["AlegreyaSansSC-Thin.ttf","AlegreyaSansSC-ThinItalic.ttf","AlegreyaSansSC-Light.ttf","AlegreyaSansSC-LightItalic.ttf","AlegreyaSansSC-Regular.ttf",
"AlegreyaSansSC-Italic.ttf","Economica-Regular.ttf","Economica-Italic.ttf","Oswald-Light.ttf","AlegreyaSansSC-Medium.ttf","AlegreyaSansSC-MediumItalic.ttf","Amaranth-Bold.ttf"
,"Amaranth-BoldItalic.ttf","Oswald-Regular.ttf","Economica-Bold.ttf","Economica-BoldItalic.ttf","Oswald-Bold.ttf","nobile.ttf","nobile_italic.ttf","ContrailOne-Regular.ttf"
,"nobile_bold.ttf","nobile_bold_italic.ttf","LobsterTwo-Regular.ttf","Amaranth-Regular.ttf","LobsterTwo-Italic.ttf","Amaranth-Italic.ttf","LobsterTwo-Bold.ttf","AlegreyaSansSC-Bold.ttf"
,"AlegreyaSansSC-ExtraBold.ttf","AlegreyaSansSC-Black.ttf","LobsterTwo-BoldItalic.ttf","AlegreyaSansSC-BoldItalic.ttf","AlegreyaSansSC-ExtraBoldItalic.ttf","AlegreyaSansSC-BlackItalic.ttf"],
	C: ["AlegreyaSansSC-Thin.ttf","AlegreyaSansSC-ThinItalic.ttf","AlegreyaSansSC-Light.ttf","AlegreyaSansSC-LightItalic.ttf","AlegreyaSansSC-Regular.ttf","AlegreyaSansSC-Italic.ttf"
,"JuliusSansOne-Regular.ttf","PoiretOne-Regular.ttf","AlegreyaSansSC-Medium.ttf","AlegreyaSansSC-MediumItalic.ttf","RibeyeMarrow-Regular.ttf","Sacramento-Regular.ttf","NixieOne-Regular.ttf"
,"AlegreyaSansSC-Bold.ttf","AlegreyaSansSC-ExtraBold.ttf","AlegreyaSansSC-Black.ttf","AlegreyaSansSC-BoldItalic.ttf","AlegreyaSansSC-ExtraBoldItalic.ttf","AlegreyaSansSC-BlackItalic.ttf"],
	N: ["SamsungOneUI-200.ttf", "SamsungOneUI-300.ttf", "SamsungOneUI-400.ttf", "SamsungOneUI-600.ttf", "NotoSans-Regular.ttf", "NotoSans-Italic.ttf", "NotoSerif-Regular.ttf"
, "NotoSerif-Italic.ttf", "NotoSerif-Bold.ttf", "NotoSerif-BoldItalic.ttf"],
	E: ["SamsungOneUIKorea-200.ttf", "SamsungOneUIKorea-300.ttf", "SamsungOneUIKorea-400.ttf", "SamsungOneUIKorea-600.ttf", "SamsungSVDLight_Korean.ttf", "SamsungSVDMedium_Korean.ttf"],
	R: ["SamsungOneUIThai-300.ttf", "SamsungOneUIThai-600.ttf", "NotoSansThai-Regular.ttf", "NotoSansThai-Bold.ttf"]	
};
var slotType={
    SLOT_IMAGE:0,
    SLOT_IMAGE_SEPARATOR:1,
    SLOT_SEPARATOR:2,
    SLOT_VIDEO:3,
    SLOT_VIDEO_SEPARATOR:4
};
var layerType={
    LAYER_IMAGE:0,
    LAYER_VIDEO:1,
    LAYER_SEPARATOR:2,
    LAYER_TEXT:3,
    LAYER_STICKER:4
};

var UserInputContext={
    nThemeNum:1,          
    nImageNum:0,          
    nVideoNum:0,          
    ImageList:[],          
    VideoList:[],          
    nThumnailWidth:0,         
    nThumnailHeight:0,            
    nWorkspaceWidth:0,            
    nWorkspaceHeight:0,           
    SaveTempPath:"",
    SaveOutputPath:""           
};
var StepInfo={
	currStep:0,
	nextStep:0
};
var adClipUtils={};
adClipUtils.getThumbSeperatorImg=function(path)
{
	var arr=path.split("/");
	var imgName=arr[arr.length-1];
	imgName=imgName.split("-")[0];
	
	if (imgName!="")
	{
		imgName="../resource/img/icon_clip slot/"+imgName+".png";
	}	
	return imgName;
};
adClipUtils.getEncodedPath=function(path)
{
	return encodeURIComponent(path).replace(/%2F/ig,"/");
};
adClipUtils.updtAnalysingLodr=function(value)
{
    loaderObj.updateLoaderText("&nbsp;&nbsp;&nbsp;"+langObj.Adclip.MIA_SID_ANALYZING_DOT+"</br>"+langObj.Adclip.MIA_SID_MIX_PECENT_COMPLETE.replace('<<A>>',value));
};
adClipUtils.removeFontExt=function(font)
{
    var indx=font.indexOf(".");
    return font.substring(0,indx);
};
adClipUtils.getMatchedFont=function(fontName)
{   
    var matchedFont=null;
    fontXMLObj.find("font").each(function(){
            var font=adClipUtils.removeFontExt($(this).attr("name"));                      
            if(font.toLowerCase()==fontName.toLowerCase())
            {
                matchedFont=$(this);
                return matchedFont;               
            }
    });
    return matchedFont;
};
adClipUtils.getMappedFont=function(fontName)
{    
    log.debug("Input fontName1:"+fontName,"getMappedFont");
    try
    {             
         if(locLangCode!="en")
         {
             var matchFont=adClipUtils.getMatchedFont(fontName);
            if(matchFont!=null && matchFont.length>0)
            {
                 var localName=matchFont.find("langName[code*='"+locLangCode+"']");
                 if(localName.length>0)
                 {                        
                     localName=localName.text();
                     fontName=localName.substring(0, localName.lastIndexOf('.'));
                 }
             }              
         }             
    }
    catch(ex)
    {
        log.debug("Error in mapping font");
    }
    log.debug("Return fontName:"+fontName,"getMappedFont");
    return fontName;
};
adClipUtils.loadFontXMLObj=function()
{
  
  if(fontXMLObj==null)
  {
      log.debug("Loading font XML obj","loadFontXMLObj");
      $.ajax({      
        type: "GET",
        url: "../resource/XML/fontList.xml",
        dataType: "xml", 
        async:true,   
        success: function(xml) {                            
           fontXMLObj=$(xml);
        },
        error:function(jqXHR, textStatus, errorThrown)
        {   
            log.debug(textStatus + " :: "+ errorThrown,"loadFontXMLObj");            
        }
    }); 
  } 
};
adClipUtils.rplacBase64Txt=function(imageData)
{
    imageData = imageData.replace(/data:image\/png;base64,/, '');
    return imageData;
};
adClipUtils.getLayrTypFromTmpltTyp=function(elmType)
{
    var layerTyp=-1;
    switch(elmType)
    {
        case TEXT:
            layerTyp=layerType.LAYER_TEXT;
        break;
        case STICKER:
        case HANDWRITING:
            layerTyp=layerType.LAYER_STICKER;
        break;
        default:
           layerTyp=layerType.LAYER_SEPARATOR; 
        break;
    }
    return layerTyp;
};
adClipUtils.getLayerStruct=function()
{
  return    {"nLayerType":0
            ,"layerSourcePath":""
            ,"layerSourcePosition":{"nWidth":0,"nHeight":0
            ,"leftTopPosition":{"xPos":0,"yPos":0}}
            ,"textInformation":{"nTextFontSize":0,"FillColor":"","TextColor":"","TextFontname":""
            ,"TextHAlign":"","TextVAlign":"","TextHTML":""}};  
};
adClipUtils.getElmRect=function(layerObj)
{
    var rect={};
    rect.w=getParseIntInDec(layerObj.layerSourcePosition.nWidth);
    rect.h=getParseIntInDec(layerObj.layerSourcePosition.nHeight);
    rect.x=getParseIntInDec(layerObj.layerSourcePosition.leftTopPosition.xPos);
    rect.y=getParseIntInDec(layerObj.layerSourcePosition.leftTopPosition.yPos);
    return rect;
};
adClipUtils.changeBtnState=function(stage)
{
    $("#tpl_shuffleBtnId").removeClass("adClipCreate addCancel addSave");
    adClipUtils.addPlayBtnToScrn(false);
    $("#shuffleBtnArea").css("z-index","999999999");
    switch(stage)
    {
      case "create":
        $("#tpl_shuffleBtnId").html(langObj.Adclip.COM_TEXT_CREATE_P_KR_MIS20);
        $("#tpl_shuffleBtnId").addClass("adClipCreate");
      break;
      case "cancel":
        $("#tpl_shuffleBtnId").html(COM_SID_CANCEL);
        $("#tpl_shuffleBtnId").addClass("addCancel");
        $("#shuffleBtnArea").css("z-index","9999999999");
      break;
      case "save":
        $("#tpl_shuffleBtnId").html(langObj.Schedule.COM_BUTTON_SAVE);        
        $("#tpl_shuffleBtnId").addClass("addSave");
        templateObj.isEdited=false;
        adClipUtils.addPlayBtnToScrn(true);
      break;
      default:
      break;  
    };
};
adClipUtils.addPlayBtnToScrn=function(flag)
{
    log.debug("START flag:"+flag+",templateObj:"+templateObj,"addPlayBtnToScrn");
    $("#adClipPlyIcnDivId").remove();
    if(flag && templateObj!=null)
    {        
        
        $("#"+templateObj.mainFrame.id).append('<div id="adClipPlyIcnDivId" class="adClipPlyIcnDivCls"></div>');
        $("#adClipPlyIcnDivId").authorActiveClass();
        var success=function(){
           log.debug("playadclip callback.");
        };
        $("#adClipPlyIcnDivId").off("tap").on("tap",function(){            
            mAdclipManager.playAdClip(success,success);            
        });
    }    
    log.debug("COMPLETE","addPlayBtnToScrn");
};
adClipUtils.startCreatingAdClip=function()
{
   log.debug("START","startCreatingAdClip");  
    tmpltTxtImgArr=[];
   var error=function(){
       adClipUtils.hide();
       adClipUtils.changeBtnState("create");
       log.debug("ERROR","startCreatingAdClip");
   };
   var success=function(result){
       log.debug("COMPLETE,result:"+result,"startCreatingAdClip");       
       if(result == "ADCLIP_BG_CANCEL_COMPLETED"){
           adClipUtils.hide();
           adClipUtils.changeBtnState("create");       		
          console.log("creating end::"+getTimeWithMiliSec());  
           return;
       }       
       adClipUtils.creatingAdClip();
   };   
      var obj=$("#tplFrameId_Main");
   var width=obj.width();
   var height=obj.height();
   var offsetVal = obj.offset();
   var left=offsetVal.left;
   var top=offsetVal.top;
   $("#tmpltPrevBtnId,#homeBtnId,.helpBtnCls").addClass("icon-disabled");
    $("#tpl_ContainerId").append('<div id="maskDiv" style="width:'+width+'px; height:'+height+'px;left:'+left+'px;top:'+top+'px; position:absolute;z-index:999999999; background-color:rgba(0,0,0,0.4);" class=""></div>');
    loaderObj.showLoader({text: "<div class='adClipEncodingCls'>"+langObj.Adclip.MIA_SID_ENDORDING_DOT+"</br>"+langObj.Adclip.MIA_SID_MIX_PECENT_COMPLETE.replace("<<A>>",0)+"</br></br>"+langObj.Adclip.MIA_SID_STAY_SCREEN_UNTIL_ENCODING_UNEXPECTEDLY+"</div>"});
   adClipUtils.changeBtnState("cancel");
   if(templateObj!=null)
   {
      templateObj.updtThmSlotFrmTmplObj();
   }         
   mAdclipManager.createTextImage(success,error,tmpltTxtImgArr);  
};
adClipUtils.hide=function(){
	loaderObj.hideLoader();
    $("#maskDiv").remove();
    $('.icon-disabled').removeClass('icon-disabled');
};
adClipUtils.creatingAdClip=function()
{
    log.debug("START","creatingAdClip");
    var error=function(){
       loaderObj.hideLoader();
       adClipUtils.changeBtnState("create");
       log.debug("ERROR","creatingAdClip");
    };
    var success=function(result){
       log.debug("result: "+result,"creatingAdClip");
       if(result == "ADCLIP_BG_CANCEL_COMPLETED" || result == "FILE_NOT_FOUND"){
           window.clearInterval(adClipCreateProgTimer);
            adClipUtils.changeBtnState("create");
            adClipUtils.hide();
           return;
       }
       if(!isNaN(result))
       {
           adClipUtils.UpdtCretingAdClpLodr(result);
       }
       else if(result=="CREATE_ADCLIP_COMPLETE")
       {
           window.clearInterval(adClipCreateProgTimer);
           adClipUtils.UpdtCretingAdClpLodr(100);
            adClipUtils.hide();           
           console.log("creating end::"+getTimeWithMiliSec());
           adClipUtils.changeBtnState("save");
       }
    };
    mAdclipManager.createADClip(success,error,themeSlotObj);
    if(isIOS()){
        adClipCreateProgTimer = setInterval(getCreateProgForIOS, 500);
    }
};
adClipUtils.getElmTypFrmLyrTyp=function(layerTyp,indx)
{
    switch(getParseIntInDec(layerTyp))
    {
       case  layerType.LAYER_IMAGE:              
        return IMAGE;
       break;
       case layerType.LAYER_SEPARATOR:
            if(indx==0)
            {
                return IMAGE;
            }
            return DECO_IMAGE;
       break;
       case  layerType.LAYER_VIDEO:
        return VIDEO;
       break;
       case  layerType.LAYER_TEXT:
        return TEXT;
       break;
       case  layerType.LAYER_STICKER:
        return STICKER;
       break;      
       default:
       break;
    };
};
adClipUtils.setInfoFromUserSelectedTheme=function()    
{      
   themeInfo=JSON.parse(sessionStorage.getItem("themeInfo"));
   themeInfo.themeNo=getParseIntInDec(sessionStorage.getItem("themeNo"));   
   themeInfo.MaxVideoSec=getParseIntInDec(themeInfo.MaxVideoSec);
   themeInfo.MaxImageNum=getParseIntInDec(themeInfo.MaxImageNum);
   themeInfo.MinImageNum=getParseIntInDec(themeInfo.MinImageNum);
   themeInfo.MinVideoSec=getParseIntInDec(themeInfo.MinVideoSec);     
   $("#imggIconTextId1").html("0");
   $("#videoFileIconTextId").html(adClipUtils.replaceSecInSecSID(0));
   $("#runTymTextId").html(adClipUtils.replaceSecInSecSID(0));   
};
adClipUtils.replaceSecInSecSID=function(value)
{
    return langObj.Adclip.COM_SID_MIX_SEC_KR_BLANK.replace("<<A>>",value);
};
adClipUtils.isWithInLimit=function(addedElmDur,fileType)
{
    var flag=false;
    addedElmDur=getParseIntInDec(addedElmDur);
    if(fileType=="video" && (ttlDur+addedElmDur)<=themeInfo.MaxVideoSec)
    {
         adClipUtils.updateDuration(addedElmDur,true);
         flag=true;   
    }
    else if(fileType=="image" && (galleryContentSel.getSelectedImgCount()+1)<=themeInfo.MaxImageNum)
    {        
        flag=true;
    }
    if(!flag)
    {
        Utils.showToast(langObj.Adclip.MIA_SID_MIX_PLAY_TIME_SELELCED_VIDEOS_NOT_EXCEED_RECOMMENDED.replace("<<B>>",themeInfo.MaxVideoSec).replace("<<A>>",themeInfo.MinVideoSec).replace("<<B>>",themeInfo.MaxVideoSec));
    }
    return flag;
};
adClipUtils.updateDuration=function(duration,flag)
{
    log.debug("updateDuration::duration::"+duration);
    if(isIOS()){
        duration=Math.floor(getParseIntInDec(duration));
    }else{
        duration=Math.floor(getParseIntInDec(duration)/1000);
    }
    
   if(flag)
   {
    ttlDur=ttlDur+duration;
   }
   else
   {
      ttlDur=ttlDur-duration; 
   }
   if(ttlDur<0)
   {
       ttlDur=0;
   }   
   $("#videoFileIconTextId").html(adClipUtils.replaceSecInSecSID(ttlDur));
};
adClipUtils.getEstimatedTime=function()
{  
    var error = function(result) {
        log.debug("error :" + result);
    };
    var success = function(result) {
        $("#runTymTextId,#playTimeId").html(adClipUtils.replaceSecInSecSID(result));
        log.debug("Est Limit :" + result);
    };       
    var curImage=galleryContentSel.getSelectedImgCount();    
    if(curImage<themeInfo.MinImageNum)
    {
        $("#runTymTextId,#playTimeId").html(adClipUtils.replaceSecInSecSID(0));
    }
    else
    {
        mAdclipManager.getEstimatedTimeSec(success, error,themeInfo.themeNo, galleryContentSel.getSelectedImgCount(), ttlDur);
    }  
};

adClipUtils.calculateWorkSpaceDim=function()
{
   var aspectRatioLFD = 1920/1080;
    var rect = {w:0,h:0};    
    rect.w = Math.round(window.innerWidth * 0.598);
    rect.w=this.shiftValue(rect.w); 
    rect.h = Math.round(rect.w/aspectRatioLFD);
    rect.h=this.shiftValue(rect.h);
    return rect;    
};
adClipUtils.shiftValue=function(pValue)
{
	pValue=pValue>>1;
	return pValue<<1;
};
adClipUtils.updateUserImgVdoList=function()
{
    $.each(jsonContentObj, function(index, result) {
        if (result['fileType'] == "image") {
           UserInputContext.ImageList.push(result["actualPath"]);                              
        } else {        
            UserInputContext.VideoList.push(result["actualPath"]);                                    
        }
        
    });
};
adClipUtils.updateUserInputCntxt=function()
{
    var rect=adClipUtils.calculateWorkSpaceDim();    
    UserInputContext.ImageList=[];   
    UserInputContext.VideoList=[];
    adClipUtils.updateUserImgVdoList();
    UserInputContext.nThemeNum=themeInfo.themeNo;              
    UserInputContext.nImageNum=galleryContentSel.getSelectedImgCount();          
    UserInputContext.nVideoNum=galleryContentSel.getSelectedVideoCount();
    UserInputContext.nThumnailWidth=160;         
    UserInputContext.nThumnailHeight=90;            
    UserInputContext.nWorkspaceWidth=rect.w;            
    UserInputContext.nWorkspaceHeight=rect.h;           
    UserInputContext.SaveTempPath="";
    UserInputContext.SaveOutputPath="";
};
adClipUtils.isSelCntntValid=function()
{
   var retrnObj={};
   retrnObj.flag=true;
   if(galleryContentSel.getSelectedImgCount()<themeInfo.MinImageNum)
   {
       retrnObj.flag=false;
       retrnObj.msg=langObj.Adclip.MIA_SID_MIX_NEED_SELECT_MORE_IMAGE_RECOMMNEDED.replace("<<A>>",themeInfo.MinImageNum).replace("<<B>>",themeInfo.MaxImageNum);
   }   
   return retrnObj;
};
adClipUtils.cancelAdClip=function()
{
    var successError=function(message){
    	$("#maskDiv").remove();
        loaderObj.hideLoader();
        adClipUtils.changeBtnState("create");
        $("#tmpltPrevBtnId,#homeBtnId,.helpBtnCls").removeClass("icon-disabled");    };    
    genericPopUpObj.createPopUp("", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Adclip.MIA_SID_STOP_ENCODDING_FINISH_ENCODING_SAVE]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_CANCEL,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : COM_SID_OK,
        "callback" : function() {
           loaderObj.hideLoader();
           loaderObj.showLoader({text:langObj.Adclip.MIA_SID_CANCELING_DOT,dimRect:{w:"50%",h:"50%",x:"25%",y:"25%"},alpha:0});            
           mAdclipManager.cancelADClip(successError,successError); 
        }
    }]);
    genericPopUpObj.showPopUp();
};
adClipUtils.openAdClipSavePopup=function(fileName)
{    
    var success=function(){
        
         Utils.showToast(langObj.Adclip.COM_MIV_SCHEDULE_SUCCESS_SAVE+langObj.Adclip.MIA_SID_FIND_VIDEO_MY_CONTENT);  
         galleryContentSel.callStepInfoPlugIn(4,0);
         window.location.href="../quickstart/QuickStart.html";
    };
    var error=function(fileName){
        if(Utils.isIOSDvice())
        {
            Utils.showToast(fileName);
        }
        else
        {
       genericPopUpObj.createPopUp("", "Type1");
       genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_NAME_ALREAY_USE_OVERWRITE]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : langObj.Schedule.COM_TV_SID_NO,
            "callback" : function(){
                adClipUtils.openAdClipSavePopup(fileName);
            }
        }, {
            "btntxt" : langObj.Schedule.COM_TV_SID_YES,
            "callback" : function() {
               mAdclipManager.saveADClip(success,error,fileName,true);
            }
        }]);
        genericPopUpObj.showPopUp();        
        }
    };
    if(Utils.isIOSDvice())
    {
        genericPopUpObj.createPopUp("", "Type2", "");
        genericPopUpObj.appendHTMLData([langObj.Adclip.MIA_SID_SAVE_THIS_A_VIDEO_FILE]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : function() {
            }},{
            "btntxt" : langObj.Schedule.COM_BUTTON_SAVE,
            "callback" : function() {
                mAdclipManager.saveADClip(success,error,langObj.Adclip.adClipFileName+adClipUtils.getFileName(),true);
            }
        }]);
        genericPopUpObj.showPopUp();
                
    }
    else
    {
        genericPopUpObj.createPopUp("", "Type2", "renameProj");
        genericPopUpObj.appendHTMLData(['<div class="renameTitleTxt">' + langObj.template.MIA_SID_TENTER_FILE_NAME_SAVE_FILE + '</div>' 
                                    + '<div class="renamePrjInputParCls">' 
                                    + '<div class="titleTxt">' + langObj.Adclip.COM_SID_MIX_FILE_NAME_COLON + '</div>' 
                                    + '<div id="renameProjInputId" class="renamePrjInputCls">' 
                                        + '<input type="text" maxlength="25" value="" class="inputSchCls disableCopy"  data-role="none" id="inputSchName" />' 
                                    + '</div>' 
                                   + '</div>']);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : function() {}},{
            "btntxt" : langObj.Schedule.COM_BUTTON_SAVE,
            "callback" : function() {    
            	$('#inputSchName').blur();                        
                mAdclipManager.saveADClip(success,error,$.trim($("#inputSchName").val()),false);
            }
        }]);
        genericPopUpObj.showPopUp();
        $('#inputSchName').val(langObj.Adclip.adClipFileName+adClipUtils.getFileName());
		$('#inputSchName').focus();
    }	
};
adClipUtils.getCropObj=function()
{
  return {SrcPath:"",
          DestPath:"",
          Rotation:0,
          ClipLeft:0,
          ClipRight:0,
          ClipTop:0,
          ClipBottom:0};  
};
adClipUtils.cropAndRotateImages=function(caseToken,slotNo,selctToken){
    log.debug("Curr Time: "+getTimeWithMiliSec(),"cropAndRotateImages");    
    if(cropJson!= null && cropJson.filesToCropArrs.length>0){        
        updtSlotCallObj.callCnt++;
        mAdclipManager.adClipImageCrop(function(responseImageSave) {                    	
        	updtSlotCallObj.successCnt++;
        	log.debug("responseImageSave: "+responseImageSave);     
        	if(responseImageSave == "ADCLIP_BG_CANCEL_COMPLETED"){  
        		adClipUtils.hidePageLoader();
                Utils.setCurrStep(STEP_ONE);
                return;
        	}  
        	if(responseImageSave==100)
        	{
                if(caseToken==1)
                {
                	$("#tmpltPrevBtnId,#homeBtnId,.helpBtnCls").removeClass("icon-disabled");
                    adClipUtils.updtAnalysingLodr(responseImageSave);
                }
                switch(caseToken)
                {
                    case 1:                        
                        templateObj.proceedWithRendering();
                    break;
                    case 2:
                        templateObj.getUpdtSlotSeprtor(slotNo,selctToken);
                    break;
                    case 3:
                    	templateObj.hideUpdateSlotLoader();
                    break;
                    default:
                    break;
                }
             }
             else
             {
             	adClipUtils.updtAnalysingLodr(responseImageSave);
             }   
        }, function(){
            log.debug("Error callback","cropAndRotateImages");            
            adClipUtils.hidePageLoader();
            templateObj.resetUpdtSlotCallObj();  
                      
        },cropJson);
    }               
};
adClipUtils.hidePageLoader=function()
{	
	loaderObj.hideLoader(); 
    mUiHandler.addOverLay(false);    
};
adClipUtils.UpdtCretingAdClpLodr=function(value)
{      
	 	 loaderObj.updateLoaderText( "<div class='adClipEncodingCls'>"+langObj.Adclip.MIA_SID_ENDORDING_DOT+"</br>"+langObj.Adclip.MIA_SID_MIX_PECENT_COMPLETE.replace("<<A>>",value)+"</br></br>"+langObj.Adclip.MIA_SID_STAY_SCREEN_UNTIL_ENCODING_UNEXPECTEDLY+"</div>");     
};
adClipUtils.showUpdtSlotLoader=function()
{
	 loaderObj.showLoader();
     mUiHandler.addOverLay(true);  
};
adClipUtils.getFileName=function()
{ 
  var currentdate = new Date();  
  var datetime = "_"+currentdate.getFullYear()
                            +Utils.convertToDblDigit(currentdate.getMonth()+1)
                            +Utils.convertToDblDigit(currentdate.getDate())
                            +Utils.convertToDblDigit(currentdate.getHours())
                            +Utils.convertToDblDigit(currentdate.getMinutes());  
 return  datetime;
};
function getTimeWithMiliSec()
{
  var currentdate = new Date(); 
  var datetime = currentdate.getHours() + ":"  
                + currentdate.getMinutes() + ":" 
                + currentdate.getSeconds()+":"
                +currentdate.getMilliseconds();
 return  datetime;           
}
function getCreateProgForIOS(){
    var error = function(message) {};
    var success = function(value) {
        if(!isNaN(value))
        {
            value = getParseIntInDec(value);
            adClipUtils.UpdtCretingAdClpLodr(value);
        }
    };
    mAdclipManager.getProgressValue(success, error);
}