/**
 * @filename Logger.js
 * @date 27Feb2015 </br> </br>
 * @author amber.m
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
var logger = function(){
    this.bDebug = true;
    this.bError = true;
};

logger.prototype.setDebug = function(debug){
    this.bDebug = debug;
};

logger.prototype.setError = function(error){
    this.bError = error;
};

logger.prototype.debug = function(message, funcName){
    if(this.bDebug){
        console.log("DEBUG :: "+funcName+" :: "+message);
    }
};

logger.prototype.error = function(message, funcName){
    if(this.bError){
        console.log("ERROR :: "+funcName+" :: "+message);
    }
};