var LoaderUtil = function() {
    var imgPath = "../resource/img/loading_01/";
    this.imgArr = new Array();
    intervalVar = null;
    var count = 0;
    var lodrImgHW=window.innerWidth*.24;
    for (var i = 0; i <= 52; i++) {        
            this.imgArr.push(imgPath + 'sequence_' + i + '.png');    }
    this.showLoader = function (options) {
        //Remove previous loader if any
        this.hideLoader();
        
        settings = $.extend({}, {
            interval : '100',
            size : $(document).width() * 0.04,
            imgarr : this.imgArr,
            text : '',
            alpha:'0.4',
            showImage:true,
            color:'',
            lodrW:lodrImgHW,
            lodrH:lodrImgHW,
            dimRect:{x:0,y:0,w:"100%",h:"100%"}
        }, options);
        var imgHTML = "";
        var mainDivHght=119;
        if(settings.showImage)
        {
            imgHTML = '<img id="cc_img_loaderId" src="' + settings.imgarr[0] + '" width="'+settings.lodrW+'" height="'+settings.lodrH+'">';
        }
        else
        {
            imgHTML = "";
        }
        if(settings.text!= '')
        {
            mainDivHght=143;
        }
        var dim=settings.dimRect;
        $('<div>').attr('id', 'cc_loaderId').css({
            'display' : '-webkit-box',
            '-webkit-box-align':' center',
            '-webkit-box-pack': 'center',
            'align-item' : 'center',
            'justify-content' : 'center',
            'position' : 'fixed',
            'text-align' : 'center',
            'width' : dim.w,
            'height' : dim.h,
            '-webkit-align-items' : 'center',
            'left' : dim.x,
            'top' : dim.y,
            'background-color' : 'rgba(0,0,0,'+settings.alpha+')',
            'text-shadow' : 'none',
            'z-index' : 999999999
        }).html('<div style="width:auto;height: '+mainDivHght+'px;">'
                +'<div style="height:'+settings.lodrH+'px;display:-webkit-box;-webkit-box-align: center;-webkit-box-pack: center;">'
                    +imgHTML
                +'</div>'
                +'<div id="loaderTxtDivId">' 
                + settings.text 
                + '</div></div>').appendTo('body');

        //Disable any click event
        $("#loaderTxtDivId").css({
           'display':'-webkit-box',
           '-webkit-box-align':'center',
           '-webkit-box-pack':'center',
           'font-size':'15px',
           'font-family':'NotoSans-Regular',
           'font-weight':'normal',
           'color':'#ffffff' 
        });
        $('#cc_loaderId').click(function() {
            return false;
        });
        
         if(settings.showImage)
        {
                 //Start animation
            intervalVar = setInterval(function() {
                $('#cc_img_loaderId').attr('src', settings.imgarr[count]);
                count++;
                if (count >= settings.imgarr.length) {
                    count = 0;
                }
    
            }, settings.interval);  
        }
       
    };
    this.updateLoaderText=function(text){
        $("#loaderTxtDivId").html(text);
    };
    this.hideLoader = function() {
        clearInterval(intervalVar);
        $('#cc_loaderId').remove();
    };
};
//Declare loader object
var loaderObj = new LoaderUtil(); 

function showAnimationLoader(text) {	
    var imgarr = ['../resource/img/'];
    loaderObj.showLoader({
        'text' : text,
        'size' : 120,
        'interval' : 150,
        'color' : '#000000',
        'alpha' : '0.4'
    });
}
$(function(){
	 //Disable any click event
         $(document).off('tap', '#cc_loaderId').on('tap', '#cc_loaderId', function(e) {
       
        	e.preventDefault();
        	e.stopPropagation();
        	console.log("loader click");
            return false;
        });
});
/*
 * Below functions are being used in Send, Settings & Firmware update pages.
 * Please do not remove below functions.
 */

function showLoader(divID, path, size) {
   $('#' + divID).removeClass('refresh').addClass('spinner');
}

function hideLoader(divID) {
    $('#' + divID).removeClass('spinner').addClass('refresh');
}
