var db;
var dbCreated = false;
var mStoreName = "";
var mStoreLogo = "";
var mStoreOpenDay = "";
var mStroreOpenTime = "";
var isOpenFullDay = "";
var mTimeStamp = "";
var STORE_DB_TAB = "Store:: ";

var myStoreInfoJson = {};
var myStoreInfoArr = [];
myStoreInfoJson.myStoreInfoArrs = myStoreInfoArr;

/***
 * To insert store info in DB
 *
 * @param
 *      mStoreName -> Store Name
 *      mStoreOpenDays ->store open days  (sun||mon||tue||wed||thu||fri||sat)
 *      mStroreOpenTime -> store open time(10:20:AM-08:20:PM||10:20:AM-08:20:PM||10:20:AM-08:20:PM||10:20:AM-08:20:PM)
 *      isOpenFullDay -> store full day info (T||T||F||F)
 */
function insertStoreInfo(storeName, storeLogo, storeOpenDay, stroreOpenTime,isFullDay) {
    console.log(STORE_DB_TAB + "@insertStoreInfo: " + "storeName: " + storeName + " ,StoreLogo: " + storeLogo + 
    ", storeOpenDay: " + storeOpenDay + "isFullDay: " + isFullDay +"StroreOpenTime: " + stroreOpenTime);
    
    mStoreName = encodeData(storeName);
    mStoreLogo = storeLogo;
    mStoreOpenDay = storeOpenDay;
    mStroreOpenTime = stroreOpenTime;
    isOpenFullDay = isFullDay;
    mTimeStamp = new Date().getTime();

    db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    console.log(STORE_DB_TAB + "@insertStoreInfo: open db success - StoreDB");
    db.transaction(populateStoreDB, StoreDBError);
}


/**
 * To get the Store information list
 */
function getStoreInfo() {
    console.log(STORE_DB_TAB + "@getStoreInfo");
    db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    db.transaction(readStoreDB, StoreDBError, populateStoreDBOnSuccess);
}



/**
 * To deleteStoreFromDB according to specified attribute
 * @param StoreName
 */
 /*
function deleteStoreFromDBWithStoreName(StoreName) {
    console.log(STORE_DB_TAB + "@deleteStoreFromDB");
    StoreName = encodeData(StoreName);
    var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    db.transaction(function(tx) {
    tx.executeSql("DELETE FROM tbl_Stores WHERE tbl_Stores.StoreName = '" + StoreName + "'");
    console.log(STORE_DB_TAB + " Delete one item success" + StoreName);
    });
    sessionStorage.setItem("STORE_INFO", "");
    getStoreInfo();
}*/
/* To deleteStoreFromDB according to storeId */
function deleteStoreFromDBWithStoreId(storeId) {
    console.log(STORE_DB_TAB+",storeId:"+storeId+ ":: @deleteStoreFromDB");
    var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    db.transaction(function(tx) {
        tx.executeSql("DELETE FROM tbl_Stores WHERE tbl_Stores.id = '" + storeId + "'");
        console.log(STORE_DB_TAB + " Delete one item success with storeId:" + storeId);
    });
    sessionStorage.setItem("STORE_INFO", "");
    getStoreInfo();
}

function updateStoreFromDB(id, StoreName, StoreLogo,StoreOpenDay,StoreOpenTime,isFullDay) {
    console.log(STORE_DB_TAB + "@updateStoreFromDB");
    var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    var whr = "WHERE tbl_Stores.id = '"+id+"'";
    StoreName = encodeData(StoreName);
    var sql = "UPDATE tbl_Stores SET " + " StoreName='" + StoreName + "'," + "StoreLogo='" + StoreLogo + "'," + "StoreOpenDay='" +  StoreOpenDay +"'," 
    + "StoreOpenTime='" +  StoreOpenTime +"'," + "isOpenFullDay='" + isFullDay +"' "+whr;
    console.log(STORE_DB_TAB + sql);
    db.transaction(function(tx) {
    tx.executeSql(sql);
        console.log(STORE_DB_TAB + " Updated one item success");
    });
    getStoreInfo();
}



function populateStoreDB(tx) {
    console.log(STORE_DB_TAB + "@getStoreInfo populateStoreDB for Insert Operation");
    var sql = "CREATE TABLE IF NOT EXISTS tbl_Stores ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "StoreName VARCHAR(100), " + "StoreLogo VARCHAR(350), " +"StoreOpenDay VARCHAR(200)," 
    +"StoreOpenTime VARCHAR(200) , " +"isOpenFullDay VARCHAR(50),"+ "TimeStamp VARCHAR(50))";
    
    console.log(STORE_DB_TAB + sql);
    tx.executeSql(sql);
    tx.executeSql("INSERT INTO tbl_Stores (StoreName,StoreLogo,StoreOpenDay,StoreOpenTime,isOpenFullDay,TimeStamp) VALUES (" + 
       "'" + mStoreName + "'" + "," + 
       "'" + mStoreLogo + "'" + "," + 
       "'" + mStoreOpenDay + "'" +"," + 
       "'" + mStroreOpenTime + "'" +"," + 
       "'" + isOpenFullDay + "'" +"," + 
       "'" + mTimeStamp + "'" + ")");
   // alert("Inserted success");
    console.log(STORE_DB_TAB + "Inserted one item success");
    sessionStorage.setItem("STORE_INFO", "");
    getStoreInfo();
}



/**
 * To populate readStoreDB
 * @param tx
 */
function readStoreDB(tx) {
    console.log(STORE_DB_TAB + "@readStoreDB");
     var sql = "CREATE TABLE IF NOT EXISTS tbl_Stores ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "StoreName VARCHAR(100), " + "StoreLogo VARCHAR(350), " +"StoreOpenDay VARCHAR(200)," 
    +"StoreOpenTime VARCHAR(200) , " +"isOpenFullDay VARCHAR(50),"+ "TimeStamp VARCHAR(50))";
    console.log(STORE_DB_TAB + "SqlQuery: " + sql);
    tx.executeSql(sql);
    //alert("excute read success");
}

function StoreDBError(tx, error) {
    //alert("Database Error: " + error);
    console.log(STORE_DB_TAB + "@transaction_error");
}

function populateStoreDBOnSuccess() {
    console.log(STORE_DB_TAB + "@populateDB_success");
    db.transaction(excuteStoreQuery, StoreDBError);
}

/**
 * To excute Store query for fetching db list
 * @param tx
 */
function excuteStoreQuery(tx) {
    console.log(STORE_DB_TAB + "@excuteStoreQuery");
   // var sql = "select id from  tbl_Stores order by id desc";
    var sql = "select * from  tbl_Stores order by id asc";
    console.log(STORE_DB_TAB + "@excuteQuery: " + sql);
    tx.executeSql(sql, [], fetchStoreItemList);
}

/**
 * To show list of Store item list
 * here user can populate using html components
 */
function fetchStoreItemList(tx, results) {
    myStoreInfoJson = {};
    myStoreInfoArr = [];
    myStoreInfoJson.myStoreInfoArrs = myStoreInfoArr;
    var len = results.rows.length;
    if(len == 1){
       Utils.setActiveStore(results.rows.item(0).StoreName,results.rows.item(0).id);
    }
    
    for (var i = 0; i < len; i++) {
        var myStoreRows = results.rows.item(i);
        var myStoreInfo = {};
        myStoreInfo.id = myStoreRows.id;
        myStoreInfo.StoreName = decodeData(myStoreRows.StoreName);
        myStoreInfo.StoreLogo = myStoreRows.StoreLogo;
        myStoreInfo.StoreOpenDay = myStoreRows.StoreOpenDay;
        myStoreInfo.StoreOpenTime = myStoreRows.StoreOpenTime;
        myStoreInfo.isOpenFullDay = myStoreRows.isOpenFullDay;
        myStoreInfoJson.myStoreInfoArrs.push(myStoreInfo);
        if(Utils.getActiveStoreId() == myStoreRows.id){
           Utils.setActiveStore(myStoreInfo.StoreName,myStoreInfo.id);
        }
    }
    createStoreSessionJsonList();
  }

function createStoreSessionJsonList(){
    // Put the object into session storage
    //alert("Add "+JSON.stringify(myStoreInfoJson));
    sessionStorage.setItem("STORE_INFO", JSON.stringify(myStoreInfoJson));
    
}

function checkRecord() {
    var sql = "select id from  tbl_Stores order by id desc";
    var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    db.transaction(function(tx) {
        tx.executeSql(sql, [], dropStoreTable);
    });

}

function dropStoreTable(tx, results) {

    //alert("results.rows.length  "+results.rows.length);
    if (results.rows.length == 0) {
        var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
        db.transaction(function(tx) {
            tx.executeSql("DROP  TABLE  tbl_Stores");
            console.log(STORE_DB_TAB + " Updated one item success");
            projectCounter = 0;
        });
    }

}

function dropStoreTableForcely() {

    console.log("drop StoreTable");
    var db = window.openDatabase("StoreDB", "1.0", "MagicInfo", 200000);
    db.transaction(function(tx) {
        tx.executeSql("DROP TABLE tbl_Stores");
        console.log(STORE_DB_TAB + "DROP TABLE tbl_Stores");
        projectCounter = 0;
    });
   
}


function encodeData(s){
    return encodeURIComponent(s).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29");
}

function decodeData(s){
    try{
        return decodeURIComponent(s.replace(/\%2D/g, "-").replace(/\%5F/g, "_").replace(/\%2E/g, ".").replace(/\%21/g, "!").replace(/\%7E/g, "~").replace(/\%2A/g, "*").replace(/\%27/g, "'").replace(/\%28/g, "(").replace(/\%29/g, ")"));
    }catch (e) {
    }
    return "";
}



