var weekDays_DB = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"];
var weekDays = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var weekDaysID = ["Sun_id", "Mon_id", "Tue_id", "Wed_id", "Thu_id", "Fri_id", "Sat_id"];
var CompleteDaysID = ["Complete_Sun_id", "Complete_Mon_id", "Complete_Tue_id", "Complete_Wed_id", "Complete_Thu_id", "Complete_Fri_id", "Complete_Sat_id"];
var selectedDay = [false, false, false, false, false, false, false];

var bCheck = true;
var bUnCheck = false;
var defaultAllDay= false;
var MAX_NUM_STORE = 10;
var DEFAULT_OPEN_TIME  = "08:00 am";
var DEFAULT_CLOSE_TIME = "10:00 pm";
var OPERATION_TYPE_ADD = "ADD";
var OPERATION_TYPE_EDIT = "EDIT";
var WHERE_INITIAL_SETUP = "INITIAL_SETUP";
var WHERE_SETTINGS = "SETTINGS";
var swiper;
//series constants
var modelSeries={
		RMD:'RMD,RMH',
		RHE:'DHE,DME,DBE,OHE,OME,MLE,RHE,SSB-SSE',
		RHE_STRETCH:'SHF',
		TIZEN:'OHF,OMF,OMH,PHF,PHF-P,PMF,PMF-BC,PMH,SBB-SSF',
		TIZEN_S5:'DBJ,OHH,QBH,QHH,QMH',
        TIZEN_S6:'QMN,QBN,OHN,OMN,QBR,QMR,QHR'
};
var StoreLists;
var nCurStoreIndex;
var nFirstSelectedDay;
var CurShowingDay;
var currentTime;
var lastIndex;
var lastTextBox;
var IsSetDefaultOpenCloseTime;
var defaultOpenTime = DEFAULT_OPEN_TIME;
var defaultCloseTime = DEFAULT_CLOSE_TIME;
var isPlateOpen;
var OperationType;
var updateStoreTime = null;
var check_Bg = 1;
var deviceModel;
var checkInputText = null;

var play_BGM = null;
var play_Dial = null;

var exitCounter=0;
var checkBlur = false;
var prevStoreName = "";

var param_whereFrom = "";

$(document).ready(function() {
    //Dynamically Show version name after page loaded
    appset.initialize();
    //sessionStorage.setItem("StoreExit",false);
});

function OpenCloseTimeforDay_Array()
{
    openTime:null;
    closeTime:null;
    isSet:null;
    allDay:false;
}
function Store_Array()
{
    id:null;
    storeName:null;
    this.OpenCloseTimeforDays = [];
}

function StoreLists_Array()
{
    this.Stores = [];
}

var appset = {
    // Application Constructor
    initialize : function() {
        this.bindEvents();
        this.setContentRoot();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady : function() {
        appset.receivedEvent('deviceready');

        //check the device model
        deviceModel = device.model;

        //Initialize prevStoreName
        prevStoreName = $("#Store_name_input_box").val();

        playBackgroundmusic();
        document.addEventListener("backbutton", onBackkeyDown, false);
        Utils.registerKeyboardObserver();
        setTimeout(function(){
        registerActivityStatus();
        },1000);
    },
    // Update DOM on a Received Event
    receivedEvent : function(id) {
    },
    setContentRoot : function(){
    	getStoreInfo();
		var len = 0;
		switch(Utils.getActivePlayerType()) {
					    case RHE_MODEL:
					    	window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/RHE");
					    break;
					    case TIZEN_MODEL:
					    	window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/TIZEN");
					    break;
					    case STRETCH_MODEL:
					       window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/RHE_STRETCH");
					    break;
					    case RMD_MODEL:
					    	 window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/RMD");
					    break;
					    case TIZEN_S5:
					    	 window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/TIZEN_S5");
					    break;
                        case TIZEN_S6:
                             window.localStorage.setItem("CONTENTS_ROOT", ".ETabletAuthor/TIZEN_S6");
                        break;
					    default:
						     console.log("INCORRECT ACTIVE PLAYER TYPE start.html");
                        break;
		}
    }

};


$(function() {
	var playerType = localStorage.getItem('player_type');
	var $storeInputBox = $('#Store_name_input_box');
	var $deleteBtn = $('#Delete_text_btn');
    var fontSizeVal;
    fontSizeVal=24;
    if(deviceType == 'iPhone'){
        fontSizeVal=22;
    }
    nCurStoreIndex = 0;
    nFirstSelectedDay = 0;
    IsSetDefaultOpenCloseTime = false;
    isPlateOpen = false;

    $("#ModelSel_OKBtnId").text(langObj.Schedule.COM_SID_OK);
     var tempgturlVar= Utils.getUrlVars();
    var param_operationType = tempgturlVar["OperationType"];
    var param_storeIndex = tempgturlVar["StoreIndex"];
    param_whereFrom = tempgturlVar["WhereFrom"];
    var storeNameLocal=localStorage.getItem('storeName_local');
    if(param_whereFrom=="Model" || (localStorage.getItem('active_store')!=null && playerType==null&&param_operationType != OPERATION_TYPE_EDIT&& param_operationType != OPERATION_TYPE_ADD))
    {
        showModelSelection();
    }

    loadStoreInfo();
    checkTextlength();

    if ( param_operationType == OPERATION_TYPE_ADD )
    {
        AddNewStoreInfo();
        OperationType = OPERATION_TYPE_ADD;
        StoreLists.Stores[nCurStoreIndex].storeName = storeNameLocal;

        if(playerType) $("#HomeBtn").show();
    }
    else if ( param_operationType == OPERATION_TYPE_EDIT )
    {
        selectStore(param_storeIndex);
        OperationType = OPERATION_TYPE_EDIT;

        nFirstSelectedDay = jQuery.inArray(true, selectedDay);
        SaveBtnActivation();

        $('#ilStoreName').attr('fill', '#3196FF');

        document.getElementById("expandOpenPlateBg").beginElement();
        document.getElementById("expandClosePlateBg").beginElement();

        $("#BusinessText1").animate({"opacity":"0"});
        $("#BusinessText2").animate({"opacity":"0"});

        $("#OpenText").delay(300).animate({'opacity':'1'});
        $('#Title').removeClass('MIA_SID_ADD_STORE').addClass('MIA_SID_EDIT_STORE');
        $deleteBtn.css({'display':'block'});

        /*Slide animation*/
        svgSignSlide();

        IsSetDefaultOpenCloseTime = true;
        displayArrow();

        if(playerType) $("#HomeBtn").show();
        $('#select_day_title').css({'opacity':'1'});
    }
    else
    {
        /* dropStoreTableForcely();  temporary. It need to be removed. */
        AddNewStoreInfo();
        OperationType = OPERATION_TYPE_ADD;
        StoreLists.Stores[nCurStoreIndex].storeName = storeNameLocal;

    }

    createStoreList();
    introAnimation();


    /* =================================*/
    /*      Action bar button click     */
    /* =================================*/

    /* HOME BUTTON */
    $("#HomeBtn").on('tap',function () {
        checkBlur = true;
        // if something is foucused
        $storeInputBox.blur();
        setTimeout(function(){
            QuitEditStore();
        },400);

    });

    /* SAVE BUTTON */
    $('#SaveBtn').on('tap', function() {
        checkBlur = true;

        // Next page can access when the store name and information is entered
        if( $storeInputBox.val() == "" || !$(".Select_day_float_cls").hasClass('Select_day_float_Leftimg_cls') )
        {
            Utils.showToast(langObj.index.MIA_SID_ENTER_BOTH_STORE_NAME_BUSINESS_HOURS);
            return;
        }else if (!checkDuplicateStoreName())
        {
            Utils.showToast(langObj.index.MIA_SID_STORE_NAME_ALREADY_USE);
            return;
        }


		if (document.activeElement.tagName == "INPUT") {
			$storeInputBox.blur();
			setTimeout(function() {
				saveBtnInptFun();
			}, 400);
		} else {
			saveBtnInptFun();
		}

    });


    /* =========================*/
    /*     Initial_setup_1      */
    /* =========================*/

    $storeInputBox.on('click', function (e) {
        checkText();
        if( deviceType != 'iPhone' )
        {
            setTimeout (function () {
                $('#Initial_setup_animation .illustration-container svg').css({'margin-top':'-60%'});
                $('#Initial_setup_bottom').css({'margin-top':'-60%'});
            }, 200);

        }

    });

    $deleteBtn.on('tap', function (e) {
        e.stopPropagation();
        e.preventDefault();
         HideWarningMsg();
        $storeInputBox.val("");
        prevStoreName = "";
        $deleteBtn.css({'display':'none'});
        $('#szyld').text(langObj.index.MIS_SID_MY_STORE);

        SaveBtnActivation();
        $('#select_day_title').css({'opacity':'0.3'});

        $storeInputBox.click();
        $storeInputBox.focus();
    });

    	$storeInputBox.blur(function (e) {
        HideWarningMsg();
        window.clearInterval(checkInputText);
        checkInputText = null;

        $('#Initial_setup_animation .illustration-container svg').css({'margin-top':'0'});
        $('#Initial_setup_bottom').css({'margin-top':'0'});

        if( $storeInputBox.val() == ""){
            $('#szyld').text(langObj.index.MIS_SID_MY_STORE);
            $('#ilStoreName').attr('fill', '#575757');

        }else{
            $('#szyld').text($storeInputBox.val());
            $('#ilStoreName').attr('fill', '#3196FF');
        }

        StoreLists.Stores[nCurStoreIndex].storeName = $storeInputBox.val();

        $storeInputBox.removeClass('keypad_up');

        /*Slide animation*/
        svgSignSlide();
        if( deviceType == 'iPhone' ) {
            if( checkBlur == false ) $('#select_day_title').click();
        }
        checkBlur = false;
    });

    $storeInputBox.on('focus input',function (e) {
      
    	var tempStrnameInbxVal=$storeInputBox.val();
        var diff = Math.abs(prevStoreName.length - tempStrnameInbxVal.length);
        if(diff>4){
            //Do Nothing
        }else{
            prevStoreName = tempStrnameInbxVal;
        }
        if( tempStrnameInbxVal == "")
        {
            $('#Delete_text_btn').css({'display':'none'});
        }else
        {
            $('#Delete_text_btn').css({'display':'block'});
        }
        /* Begin of string check the empty space */
        if( tempStrnameInbxVal.charAt(0) == " ")
        {
            var checkSpace = $storeInputBox.val().trim();
            $storeInputBox.val(checkSpace);
        }
        HideWarningMsg();
         if (!checkDuplicateStoreName())
        {
            showWarningMsg(langObj.index.MIA_SID_STORE_NAME_ALREADY_USE)
            return;
        }
        if ( tempStrnameInbxVal.length >= 40 ){
            var checkSpace = $storeInputBox.val().slice(0,40);
            $storeInputBox.val(checkSpace);
            showWarningMsg(langObj.index.MIA_SID_YOU_CAN_ENTER_UP_TO_40_CHARACTERS);
            return;
        }

        /*Special text can not use*/

        var specialChars = '*\"\\/:?|<>Ã—Ã·%â‚¬Â£Â¥â‚©^\.`â–ªâ—‹â—�â–¡â– â™¤â™¡â™¢â™§â˜†âŠ™Â°â€¢Â¤ã€Šã€‹Â¡â€¹â€ºâ‚¹Â¿-';

        var checkSpecial;

        for(var i = 0,len = specialChars.length; i < len;i++){
            if(tempStrnameInbxVal.indexOf(specialChars[i]) > -1){
                checkSpecial = tempStrnameInbxVal.replace(specialChars[i], '');
                $storeInputBox.val(checkSpecial);
                showWarningMsg(langObj.index.MIS_SID_MIX_ONLY_FLOOWING_SPECIAL_CHAR);
            }
        }
        var validateTxt =  tempStrnameInbxVal;
        var updatedTxt=Utils.removeSpecialCharacter(validateTxt);
        if(validateTxt!=updatedTxt)
        {
            $storeInputBox.val(updatedTxt);
            showWarningMsg(langObj.index.MIS_SID_MIX_ONLY_FLOOWING_SPECIAL_CHAR);
        }
        SaveBtnActivation();
    });

    $storeInputBox.keyup('input',function (e) {
        /* 'Done' button click */
        if(e.keyCode==13)
        {
            $storeInputBox.blur();
            $('#select_day_title').click();
        }
        if($(this).val()!=""){
        	 $('#select_day_title').css({'opacity':'1'});
        }else{
        	 $('#select_day_title').css({'opacity':'0.3'});
        }
    });

    /* =========================*/
    /*        select_name       */
    /* =========================*/

    $('#store_name_title').on("click", function(e) {
        e.stopPropagation();
        e.preventDefault();

        if( $storeInputBox.css('display') == 'block' || $('#Initial_setup_animation').css('opacity') == '0' ) return;

        $storeInputBox.css({'display':'block'});
        $deleteBtn.css({'display':'block'});
        showTimeexpand(2);

        $('#select_day_display').animate(
            {
                'opacity':'0'
            },
            {
                duration:'fast',
                easing:'easeOutQuad',
                complete: function(){
                    $('#select_day_display').css({'display':'none'});
                    $('#select_day_title').animate(
                        {
                            'top':'52%'
                        },
                        {
                            duration:'fast',
                            complete: function(){
                                $('#select_day_display').css({'display':'none'});
                                $('#store_name_display').animate({'opacity':'1'});

                                $('#store_name_title').css({ 'background-image': 'none' });
                                $('#select_day_title').css({ 'background-image': 'url("resource/img/action_bar/ic_title_arrow_down.png")' });

                                $("body").animate({scrollTop: 0 });
                            }
                        }

                    );

                }
            }
        );
    });


    /* =========================*/
    /*        select_day        */
    /* =========================*/

    $('#select_day_title').on("click", function(e) {
        e.stopPropagation();
        e.preventDefault();

        if( $storeInputBox.val() == "" || $('#Initial_setup_animation').css('opacity') == '0' || $storeInputBox.css('display') == 'none' ) return;

        $storeInputBox.css({'display':'none'});
        $deleteBtn.css({'display':'none'});
        $('#select_day_display').css({'display':'block'});


        $('#store_name_display').animate(
            {
                'opacity':'0'
            },
            {
                duration:'fast',
                easing:'easeOutQuad',
                complete: function(){
                    $('#store_name_display').css({'display':'none;'});
                    $('#select_day_title').animate(
                        {
                            'top':'5%'
                        },
                        {
                            duration:'fast',
                            complete: function(){
                                $('#select_day_display').css({'display':'block'});
                                $('#select_day_display').animate({'opacity':'1'});

                                $('#select_day_title').css({ 'background-image': 'none' });
                                $('#store_name_title').css({ 'background-image': 'url("resource/img/action_bar/ic_title_arrow_down.png")' });

                                if( $(".Select_day_float_cls").hasClass('Select_day_float_Leftimg_cls') )
                                showTimeexpand(1);
                                $("body").animate({scrollTop: $(window).height() });
                            }
                        }

                    );

                }
            }
        );
        checkStartEndTime();
    });


    /*Select business days*/
    $('#Select_day_area>div').on("click", function(event) {
        event.stopPropagation();
        var nIndex = jQuery.inArray(this.id, weekDaysID);
		var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[nIndex];
        if ( !$(this).hasClass('Select_day_float_Leftimg_cls')) {

            var bFlagExist=false;

            if( jQuery.inArray(true, selectedDay) == -1)
            {
                document.getElementById("expandOpenPlateBg").beginElement();
                document.getElementById("expandClosePlateBg").beginElement();

                $("#BusinessText1").animate({"opacity":"0"});
                $("#BusinessText2").animate({"opacity":"0"});


                // Open_text in sign
                $("#OpenText").delay(300).animate({'opacity':'1'});

                isPlateOpen = true;
                nFirstSelectedDay = nIndex;
            }

            selectedDay[nIndex] = true;
            changeDay(this.id,bCheck); //this.id = 'sun_id...'

            storeListObj.isSet = true;
            if(IsSetDefaultOpenCloseTime)
            {
            	storeListObj.openTime = defaultOpenTime;
            	storeListObj.closeTime = defaultCloseTime;
            	storeListObj.allDay = defaultAllDay;
            }

            if( nFirstSelectedDay > nIndex ) nFirstSelectedDay = nIndex;
            $(this).addClass('Select_day_float_Leftimg_cls');
        }

        else if ($(this).hasClass('Select_day_float_Leftimg_cls')) {
            storeListObj.isSet = false;
            selectedDay[nIndex] = false;

            var currentDay = jQuery.inArray(true, selectedDay);

            if (  nFirstSelectedDay == nIndex && currentDay > -1 )
            {
                // Apply the same time at the whole business days when set the hours of first selected day.
                if( $("#dayText").text() == weekDays[nIndex] ) changeDay(weekDaysID[currentDay],bUnCheck);
                nFirstSelectedDay = currentDay;

            }else if( $("#dayText").text() == weekDays[nIndex] )
            {
                changeDay(weekDaysID[nFirstSelectedDay],bUnCheck);
            }

            // It is not selected anything.
            if( jQuery.inArray(true, selectedDay) == -1) {
                if ( isPlateOpen == true ) {
                    showTimeexpand(2);
                    document.getElementById("shrinkOpenPlateActiveBg").beginElement();

                    $("#OpenText").animate({'opacity':'0'});

                    $("#BusinessText1").delay(300).animate({'opacity':'1'});
                    $("#BusinessText2").delay(300).animate({'opacity':'1'});

                    isPlateOpen = false;
                }
            }
            $(this).removeClass('Select_day_float_Leftimg_cls');

        }

        checkAllDays();
        checkStartEndTime();
        displayArrow();

        SaveBtnActivation();
    });

    /* Click the All_Day button */

    $('#checkbox_id').on('tap', function() {
        $(this).toggleClass("checkbox_checked");

        if($(this).hasClass('checkbox_checked')) {
            StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].allDay = true;

        } else {
            StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].allDay = false;
        }

        checkAllDays();
        checkStartEndTime();
    });

    var startX;
    var endX;

    $('#checkbox_id').on('touchstart', function(e) {
        startX = e.originalEvent.touches[0].clientX;

    });

    $('#checkbox_id').on('touchmove', function(e) {
        endX = e.originalEvent.touches[0].clientX;

    });

    $('#checkbox_id').on('touchend', function(e) {
        var diff = endX - startX;
        var iconWid = $('#checkbox_id').css('width').replace("px","");

        // - : off / + : on
        if( diff > 0 )
        {
            $(this).addClass("checkbox_checked");
            StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].allDay = true;
        }else if ( diff < 0 )
        {
            $(this).removeClass("checkbox_checked");
            StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].allDay = false;
        }

        checkAllDays();
        checkStartEndTime();

        startX = undefined;
        endX = undefined;
    });

    /* Click Arrow */
    /*    Right    */
    $("#rightArrowIcon").click(function(event) {
        event.stopPropagation();
        if ( getNumberSelectedDays() == 1 )
            return;

        /* Apply the same time at the whole business days when set the hours of first selected day. */
        SetDefaultOpenCloseTime(IsSetDefaultOpenCloseTime);

        if(CurShowingDay < 6)
            CurShowingDay = CurShowingDay + 1;
        else
            CurShowingDay = 0;

        for (var i = 0, len = selectedDay.length; i < len ; i++) {
            if (selectedDay[CurShowingDay] == true) {
                $("#dayText").text(weekDays[CurShowingDay]);

                break;
            }
            else{
                CurShowingDay = CurShowingDay + 1;
                if(CurShowingDay == 7)
                    CurShowingDay = 0;
            }
        }

        OpenCloseplate(1);
        showOpenCloseTime();
        /* Click the All_Days button */
        checkAllDays();
        checkStartEndTime();
        document.getElementById("rotateOpenPlate").beginElement();

        lastIndex = null;
        lastTextBox = null;

    });


    /* Click Arrow */
    /*    left     */

    $("#leftArrowIcon").click(function(event) {
        event.stopPropagation();
        if ( getNumberSelectedDays() == 1 )
            return;

        /* Apply the same time at the whole business days when set the hours of first selected day. */
        SetDefaultOpenCloseTime(IsSetDefaultOpenCloseTime);

        if( CurShowingDay > 0)
            CurShowingDay = CurShowingDay - 1;
        else
            CurShowingDay = 6;

        for (var i = 0, len = selectedDay.length; i < len ; i++) {
            if ( selectedDay[CurShowingDay] == true) {
                $("#dayText").text(weekDays[CurShowingDay]);
                break;
            }
            else{
                CurShowingDay = CurShowingDay-1;
                if(CurShowingDay == -1)
                    CurShowingDay = 6;
            }
        }

        OpenCloseplate(1);
        showOpenCloseTime();
        /* Click the All_Days button */
        checkAllDays();
        checkStartEndTime();
        document.getElementById("rotateOpenPlate").beginElement();

        lastIndex = null;
        lastTextBox = null;

    });

    /*****************
    Click Time picker
    *****************/

    //start time
    $('#startTimeDiv').click(function() {

        if( $('#checkbox_id').hasClass('checkbox_checked') )
            return;

       // $('#cancel-popup').text(langObj.Schedule.COM_SID_CANCEL);
        $("#ok-popup").text(langObj.Schedule.COM_SID_OK);

        $('#startTimeDiv').css({'font-weight':'bold'});
        OpenCloseplate(1);

        // Scroll to bottom of screen
        $("body").animate({scrollTop: $(document).height() });


         var setTime = StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].openTime;
         createTimePickers(3);
         var CurrentTimePicker = $('body').find('#TimePicker');
         //$('.commonColonCls').addClass('lineheightCls');
         CurrentTimePicker.timeSpinner(
            {
                type: '3',
                fontPadding :'0',
                fontSize: fontSizeVal,
                fontHeight: FonttimerValFrNote_5,
                fontBoldSize: '26',
                MinSecSuffix:true,
                time3 : {
                            hour : parseInt(setTime.slice(0,2)),
                            min : parseInt(setTime.slice(3,5)),
                            ampm : setTime.slice(6,8)
                        },

                onTimeSet:function(val)
                {
                        if( $('#endTimeDiv').css('font-weight') == 'bold' )return;

                        StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].openTime = val;
                        document.getElementById("openingHour").textContent  = val;
                        showOpenCloseTime();
                        checkStartEndTime();
                }
            }
        );

    });


    // end time
    $('#endTimeDiv').click(function() {

        if( $('#checkbox_id').hasClass('checkbox_checked') )
            return;
        $("#ok-popup").text(langObj.Schedule.COM_SID_OK);

        $('#endTimeDiv').css({'font-weight':'bold'});
        OpenCloseplate(2);

        $("body").animate({scrollTop: $(document).height() });

        /*
        $('#popupID').show();
                $('.popup-body').append('<div id="timePicker"> </div>');

                var timepickerLayout =  '<div id="line_1" class="timepicker_Line"> </div>' +
                                        '<div id="line_2" class="timepicker_Line"> </div>' +
                                        '<div id="semi_1" class="timepicker_semi"> : </div>';

                $('.popup-body').append(timepickerLayout);


                var timeHeight = 150;

                if ( deviceType == 'iPhone' )
                {
                    timeHeight = 140;
                    $('#line_2').css('top','65%');
                }*/

         var subTitle = "SET TO " + StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].closeTime;
         var setTime = StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].closeTime;
         createTimePickers(3);
         var CurrentTimePicker = $('body').find('#TimePicker');
         //$('.commonColonCls').addClass('lineheightCls');
         CurrentTimePicker.timeSpinner(
            {
                type: '3',
                fontHeight: FonttimerValFrNote_5,
                fontPadding:'0',
                fontSize: fontSizeVal,
                fontBoldSize: '26',
                MinSecSuffix:true,
                time3 : {
                            hour : parseInt(setTime.slice(0,2)),
                            min : parseInt(setTime.slice(3,5)),
                            ampm : setTime.slice(6,8)
                        },

                onTimeSet:function(val)
                {

                    StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].closeTime = val;
                    document.getElementById("openingHour").textContent  = val;
                    showOpenCloseTime();
                    checkStartEndTime();
                }

            }
        );

    });

    // Popup close
    $(document).on('touchstart',".headerClsTi", function(e) {
        console.log('headerClsTi');
        e.stopPropagation();
        e.preventDefault();
    });

    $(document).on('touchstart',".TimePickerConCls", function(e) {
        console.log('TimePickerConCls');
        e.stopPropagation();
        e.preventDefault();
    });
    $('.buttonClsTi').off('touchstart');
    $(document).on('touchstart', ".buttonClsTi", function(e) {
        e.stopPropagation();
        e.preventDefault();
        console.log('buttonClsTi');

        $('.buttonClsTi').css(
            {
                'background-color':'#3196ff',
                'color':'#ffffff',
            }
        );

        setTimeout ( function (){
            closeTimePicker();
            $('.buttonClsTi').css(
                {
                    'background-color':'#e6e6e6',
                    'color':'#242424',
                }
            );

        },200);

        $('#startTimeDiv').css({'font-weight':'normal'});
        $('#endTimeDiv').css({'font-weight':'normal'});
    });

    $(document).on('touchstart',".bodyCls ",function(e){
        if( $('#TimePicker').css('display') == 'block' ){
            console.log(' documnet' );
            e.stopPropagation();
            e.preventDefault();
            closeTimePicker();

            $('#startTimeDiv').css({'font-weight':'normal'});
            $('#endTimeDiv').css({'font-weight':'normal'});
        }
    });


    /* =========================*/
    /*     Initial_setup_2      */
    /* =========================*/

    /* if Done button is clicked. */
    $('#Done_btn').on('click', function(){

        var isPlayerTypeSet = localStorage.getItem('player_type');
        if(isPlayerTypeSet != null ){
            sessionStorage.setItem("isSettingStore",true);
            document.location.href = "settings/Settings.html";
        }
        else
        {
            sessionStorage.setItem("isSettingStore",false);

            $('#Store').animate(
                {
                    'opacity':'0'
                },
                {
                    complete: function() {
                        showModelSelection();
                    }
                }
            );
        }
    });



    $('#ModelSel_RadioBtn1Id, #ModelSel_BtnPlayer1Id').on('click', function(){
		console.log("ModelSel_RadioBtn1Id click event");
    	radioBtnSel(1,"ss_img_model_e.png",modelSeries.RMD);
    	$('#Model_RatioId').css('visibility', 'hidden');
    });
    $('#ModelSel_RadioBtn2Id, #ModelSel_BtnPlayer2Id').on('click', function(){
    	console.log("ModelSel_RadioBtn2Id click event");
        if($('#ratio1_RadioBtnId').hasClass('ratio1_RadioBtnCls_selected'))
        {
        	radioBtnSel(2,"ss_img_model_s3.png",modelSeries.RHE);
        }
        else if($('#ratio2_RadioBtnId').hasClass('ratio2_RadioBtnCls_selected'))
        {
        	radioBtnSel(2,"ss_img_model_s3_2.png",modelSeries.RHE_STRETCH);
        }
        $('#Model_RatioId').css('visibility', 'visible');
    });
    $('#ModelSel_RadioBtn3Id, #ModelSel_BtnPlayer3Id').on('click', function(){
    	console.log("ModelSel_RadioBtn3Id click event");
    	radioBtnSel(3,"ss_img_model_s4.png",modelSeries.TIZEN);
    	$('#Model_RatioId').css('visibility', 'hidden');
    });
    $('#ModelSel_RadioBtn4Id, #ModelSel_BtnPlayer4Id').on('click', function(){
    	console.log("ModelSel_RadioBtn4Id click event");
		radioBtnSel(4,"ss_img_model_s5.png",modelSeries.TIZEN_S5);
    	$('#Model_RatioId').css('visibility', 'hidden');
    });
    $('#ModelSel_RadioBtn5Id, #ModelSel_BtnPlayer5Id').on('click', function(){
       console.log("ModelSel_RadioBtn5Id click event");
       radioBtnSel(5,"ss_img_model_s6.png",modelSeries.TIZEN_S6);
       $('#Model_RatioId').css('visibility', 'hidden');
    });
  
    $('#ratio1_RadioBtnId').on('click', function(){
    	$(".ratio_RadioBtnCls_selected").removeClass("ratio_RadioBtnCls_selected");
        $(this).addClass('ratio_RadioBtnCls_selected');
        $('#ratio1_RadioBtnId').addClass('ratio1_RadioBtnCls_selected').removeClass('ratio1_RadioBtnCls');
        $('#ratio2_RadioBtnId').addClass('ratio2_RadioBtnCls').removeClass('ratio2_RadioBtnCls_selected');
        $('#Model_InfoTxtId').text(langObj.index.MIS_SID_MIX_SERIES.replace('<<A>>',modelSeries.RHE));
        $('.ModelSel-PlayerContainerImgCls').css('background-image', "url(resource/img/ss_img_model_s3.png)");

    });
    $('#ratio2_RadioBtnId').on('click', function(){
    	$(".ratio_RadioBtnCls_selected").removeClass("ratio_RadioBtnCls_selected");
    	$('#ratio1_RadioBtnId').addClass('ratio1_RadioBtnCls').removeClass('ratio1_RadioBtnCls_selected');
        $('#ratio2_RadioBtnId').addClass('ratio2_RadioBtnCls_selected').removeClass('ratio2_RadioBtnCls');
        $(this).addClass('ratio_RadioBtnCls_selected');
        $('#Model_InfoTxtId').text(langObj.index.MIS_SID_MIX_SERIES.replace('<<A>>',modelSeries.RHE_STRETCH));
        $('.ModelSel-PlayerContainerImgCls').css('background-image', "url(resource/img/ss_img_model_s3_2.png)");

    });


    $('#ModelSel_OKBtnId').on('click', function(){
        if(!$('#ModelSel_OKBtnId').hasClass('AddDisable'))
        {
            var deviceType = "";
            if($('#ModelSel_RadioBtn1Id').hasClass('ModelSel_RadioBtnCls_selected')){
                deviceType = RMD_MODEL;
            }
            else if($('#ModelSel_RadioBtn2Id').hasClass('ModelSel_RadioBtnCls_selected')){
                if($('#ratio1_RadioBtnId').hasClass('ratio1_RadioBtnCls_selected')){
                    deviceType = RHE_MODEL;
                }
                else
                {
                    deviceType = STRETCH_MODEL; // instead of STRETCH_MODEL
                }
            }
            else if($('#ModelSel_RadioBtn3Id').hasClass('ModelSel_RadioBtnCls_selected')){
                deviceType = TIZEN_MODEL;
            }
             else if($('#ModelSel_RadioBtn4Id').hasClass('ModelSel_RadioBtnCls_selected')){
                deviceType = TIZEN_S5;
            }
             else if($('#ModelSel_RadioBtn5Id').hasClass('ModelSel_RadioBtnCls_selected')){
                deviceType = TIZEN_S6;
            }

            if(play_BGM != null && play_BGM !=undefined){
                play_BGM.stop();
            }
            Utils.setActivePlayerType(deviceType);

            if ( param_whereFrom == "Model" )
            {
                sessionStorage.setItem("modelFromSettings",true);
                document.location.href = "settings/Settings.html";
            }
            else
            {
                document.location.href = "quickstart/QuickStart.html";
            }
        }

    });

    $('.helpBtnCls').on('click', function(e){
        e.preventDefault();
        e.stopPropagation();

        $('#ModelContainerscrollArea').css({ 'display' : 'none' });
        $('#ModelContainerHelpPage').css({ 'display' : 'block' });

        $('.close-btn').css({ 'visibility' : 'visible' });
        $('.helpBtnCls').css({ 'visibility' : 'hidden' });
    });

    $('.close-btn').on('click', function(e){
        e.preventDefault();
        e.stopPropagation();

        $('#ModelContainerscrollArea').css({ 'display' : 'block' });
        $('#ModelContainerHelpPage').css({ 'display' : 'none' });

        $('.close-btn').css({ 'visibility' : 'hidden' });
        $('.helpBtnCls').css({ 'visibility' : 'visible' });
    });

     /* if Edit button is clicked. */
    $('#Edit_btn').on('click', function(){
        if ( nCurStoreIndex == null )
            nCurStoreIndex = 0;
        document.location.href = "index.html?OperationType=EDIT&StoreIndex="+nCurStoreIndex;
    });


    /* Select store (button/swipe) using swiper.js*/
    swiper = new Swiper('.swiper-container', {
        pagination: '.swiper-pagination',
        paginationClickable: true,
        spaceBetween: 50
    });

    //Callbacks after swipe
    $('.swiper-container').on('touchend', function(e){
        selectStore(swiper.activeIndex);

        /*Slide animation*/
        svgSignSlide();
    });

    //Callbacks after click pagination
    $('.swiper-pagination').click(function(){
        selectStore(swiper.activeIndex);

        /*Slide animation*/
        svgSignSlide();
    });
});

/* ------------------------------------------------------------ */
/* For step1 function                                           */
/* ------------------------------------------------------------ */
function introAnimation()
{
    $('#Welcome').delay(200).fadeIn("slow", "swing");

    /* Welcome > Initial setup1 */
    setTimeout(function() {

        /*Action bar animation*/
        $('#Initial_setup_actionBar').css({ 'display' : 'block' });
        $('#Initial_setup_actionBar').animate(
            {
                'margin-top' : '0%'
            },
            {
                duration: 'slow',
                easing:'easeOutQuad'
            }
        );

        /*Initial setup1_SVG animation*/
        $('#Initial_setup_animation').animate({
                'height' : '55%',
                'padding-top':'12%',
                'background-color': 'white'
            },
            {
                duration: 'slow',
                easing:'easeOutQuad'
            }
        );

        $('#Initial_setup_1').animate({
                'opacity':'1'
            },
            {
                duration: 'slow',
                easing:'easeOutQuad'
            }
        );

  $('.illustration-container,#ilMyStore,#storeRoof,#initialSetupMaskCircle,#ilBgBuildings,#ilMainCloud1initial,#ilMainCloud2initial').css('-webkit-animation-play-state', 'running');

        /*Initial_setup_bottom*/

        $('#Initial_setup_bottom').animate({
                'height' : '38.1%'
            },
            {
                duration: 'slow',
                easing:'easeOutQuad'
            }
        );

        $('#Initial_setup_welcome').animate({
                    'opacity' : '0'
                },
                {
                    duration: 'fast',
                    easing:'easeOutQuad',
                    complete: function(){
                        $('#Initial_setup_welcome').css({'display':'none'});
                        $('#Initial_setup_1').css({'display':'block'}).animate({
                                'opacity' : '1'
                            },
                            {
                                duration: 'slow',
                                easing:'easeOutQuad'
                            }
                        );
                    }
                }
            );
        $('#Welcome').fadeOut();
        $('#TimeSetting_Expand').show();
        $('body').css({'overflow':'auto'});

    },1500);
}


function checkTextlength()
{
    if($('#Store_name_input_box').val() == ""){
        $('#szyld').text(langObj.index.MIS_SID_MY_STORE);
    }

    $('#Welcome').text(langObj.index.COM_BDP_SID_INIT_SETTINGS_SMART_HUB_WELCOME_TITLE);

    // sign text size
    if ( langObj.index.MIS_SID_MY_STORE.length > 15 )
    {
        $('#szyld').css('font-size', "20px" );
    }else if ( langObj.index.MIS_SID_MY_STORE.length > 10 )
    {
        $('#szyld').css('font-size', "28px" );
    }

    // sub title font size
    setTimeout (function () {
            if( langObj.index.MIA_SID_SELECT_BUISNESS_DAYS.length > 30)
            {
                $('#select_day_text').css('font-size', "70%" );
            }

            if( langObj.index.MIA_SID_ENTER_BUSINESS_HOURS_SELECTED_DAY.length > 50)
            {
                $('#Enter_hours_selected_text').css('font-size', "60%" );
            }


            if( langObj.index.MIA_SID_WHAT_STORE_NAME.length > 30 || langObj.index.MIA_SID_WHEN_YOU_OPEN.length > 30 )
            {
                $('.Initial_sub_title').css({'font-size':'85%'});
            }

    }, 300);

    setTimeout(function() {
            $("#dayText").text(weekDays[CurShowingDay]);
    }, 310);
}

function svgSignSlide() {
	 var slidertxt1=$('#slideText1');
	 var textWidth = document.getElementById('szyld').getComputedTextLength();
    if(textWidth >= 180){

        var a = "0 0;" + -(textWidth) + "  0 ";
        var b =  textWidth/2 + 100 + " 0; 0 0 ";
       
        if( slidertxt1.attr('begin') == 'indefinite' ) {
        	slidertxt1.attr('begin', '0s');

        }
        slidertxt1.attr('values', a );
        slidertxt1.attr('begin','slideText2.end');
        $('#slideText2').attr('values', b );
                
    }else{
    	slidertxt1.attr('values', '0 0');
        $('#slideText2').attr('values', '0 0');
        
        if( slidertxt1.attr('begin') == 'slideText2.end' )
        {
        	slidertxt1.attr('begin', 'indefinite');
        }
    }
}

/* touch event (mouse, tablet touch, click) */
var pointerEventToXY = function(e){
    var out = {x:0, y:0};
        if(e.type == 'touchstart' || e.type == 'touchmove' || e.type == 'touchend' || e.type == 'touchcancel'){
            var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
            out.x = touch.pageX;
            out.y = touch.pageY;
        } else if (e.type == 'click' || e.type == 'mousedown' || e.type == 'mouseup' || e.type == 'mousemove' || e.type == 'mouseover'|| e.type=='mouseout' || e.type=='mouseenter' || e.type=='mouseleave') {
            out.x = e.pageX;
            out.y = e.pageY;
        }
    return out;
};    

function checkText()
{
	var storeNameVal=$("#Store_name_input_box").val();
    if ( updateStoreTime != null )
    {
        return;
    }
 		if( storeNameVal == "")
        {
            $('#Delete_text_btn').css({'display':'none'});
            //$('#select_day_title').css({'opacity':'0.3'});
        }else
        {
            $('#Delete_text_btn').css({'display':'block'});
            //$('#select_day_title').css({'opacity':'1'});
        }
   /* checkInputText = setInterval(function ()
    {
       
        var $warnMsg = $("#Warning_msg");

        if (!checkDuplicateStoreName())
        {
            showWarningMsg(langObj.index.MIA_SID_STORE_NAME_ALREADY_USE)
 
        }else if ( storeNameVal.length >= 40 ){
            if( storeNameVal.length > 40 ) {
                var checkSpace = storeNameVal.slice(0,40);
                $("#Store_name_input_box").val(checkSpace);
                prevStoreName = checkSpace;
            }
        
            showWarningMsg(langObj.index.MIA_SID_YOU_CAN_ENTER_UP_TO_40_CHARACTERS)
        }else {
            if( $warnMsg.text() == langObj.index.MIA_SID_STORE_NAME_ALREADY_USE || $warnMsg.text() == langObj.index.MIA_SID_YOU_CAN_ENTER_UP_TO_40_CHARACTERS )
                $warnMsg.css('visibility','hidden');
        }
        
        
    },50);
    */
}

function changeDay(day_id, bFlagExist)
{
    var nIndex = jQuery.inArray(day_id, weekDaysID);
    
    
    if ( bFlagExist == bCheck && getNumberSelectedDays() == 1 )
    {   
        $("#dayText").text(weekDays[nIndex]);
        CurShowingDay = nIndex;
        showOpenCloseTime();
        document.getElementById("rotateOpenPlate").beginElement();

        lastIndex = null;
        lastTextBox = null;
        
        //SetTime area open
        showTimeexpand(1);
        
        /* Set time on Open Plate */
        document.getElementById("openingHour").textContent = $('#startTime').text();
    }
    else if ( bFlagExist == bUnCheck)
    {
        $("#dayText").text(weekDays[nIndex]);
        CurShowingDay = nIndex;
        showOpenCloseTime();
    }

}

function showOpenCloseTime()
{    
	var storeInfoArr  = StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay];
    $("#startTime").text(storeInfoArr.openTime);
    $("#endTime").text(storeInfoArr.closeTime);
	storeInfoArr = null;
}


function getNumberSelectedDays()
{
    var nRet = 0;
    var i;
    for ( i = 0 ; i < 7 ; i++ )
    {
        if ( selectedDay[i] == true )
            nRet++;
    }

    return nRet;
}


function checkAllDays() {
	var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay];
    if(storeListObj.allDay == true){
        $('#checkbox_id').addClass("checkbox_checked");
        $("#startText").css({'opacity':'0.4'});
        $("#startTime").css({'opacity':'0.4'});
        $("#endText").css({'opacity':'0.4'});
        $("#endTime").css({'opacity':'0.4'});
        
        $("#startTime").text("12:00 am");
        $("#endTime").text("12:00 am");
        
        OpenCloseplate(1);
        document.getElementById("openingHour").textContent = "24H";
    }else{
        $('#checkbox_id').removeClass("checkbox_checked");
        $("#startText").css({'opacity':'1'});
        $("#startTime").css({'opacity':'1'});
        $("#endText").css({'opacity':'1'});
        $("#endTime").css({'opacity':'1'});
        
        $("#startTime").text(storeListObj.openTime);
        $("#endTime").text(storeListObj.closeTime);
        
        document.getElementById("openingHour").textContent = $('#startTime').text();
    }
}

function OpenCloseplate(i)
{
    if( i == 1)
    {
        $('#OpenText').css({'opacity':'1'});
        $('#CloseText').css({'opacity':'0'});
        document.getElementById("openingHour").textContent = StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].openTime;
    }
    else
    {
        $('#OpenText').css({'opacity':'0'});
        $('#CloseText').css({'opacity':'1'});    
        document.getElementById("openingHour").textContent = StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[CurShowingDay].closeTime;
    }
}

function getValchkStrendT(strtEndtym){
	    if( strtEndtym >= 1200 )
        {
            strtEndtym = strtEndtym - 1200;
        }
        return strtEndtym;
}
/*Start / End time value remains*/
function checkStartEndTime() {
    // am = + 3000 / pm = + 5000
    var startNum = Math.abs($("#startTime").text().substring(0,5).replace(":", ""))
       ,endNum = Math.abs($("#endTime").text().substring(0,5).replace(":", ""));
    
    if($("#startTime").text().substring(6,8) == "am")
    {    
       /* if( startNum >= 1200 )
        {
            startNum = startNum - 1200;
        }*/
        startNum=getValchkStrendT(startNum);
        startNum = startNum + 3000;
    }
    else 
    {
        /*if( startNum >= 1200 )
        {
            startNum = startNum - 1200;
        }*/
        startNum=getValchkStrendT(startNum);
        startNum = startNum + 5000;
    }
    
    if($("#endTime").text().substring(6,8) == "am")
    {
       /*
        if( endNum >= 1200 )
               {
                   endNum = endNum - 1200;
               }*/
       endNum=getValchkStrendT(endNum);
        endNum = endNum + 3000;
    }
    else
    {
        /*
        if( endNum >= 1200 )
                {
                    endNum = endNum - 1200;
                }*/
        endNum=getValchkStrendT(endNum);
        endNum = endNum + 5000;
    }
    
    if ( startNum >= endNum )
    {
        $("#endTime").css('color', 'green');
        if( endNum == 3000 && endNum != startNum)
            $("#endTime").css('color','#363638');
    }
    else
    {
        $("#endTime").css('color','#363638');
    }
}

function SetDefaultOpenCloseTime(val)
{
    if ( val == true ) return;

    defaultOpenTime = $('#startTime').text();
    defaultCloseTime = $('#endTime').text();
    
    if ($('#checkbox_id').hasClass('checkbox_checked') )
    {
        defaultAllDay = true;
    }
    else
    {
        defaultAllDay = false;                  
    }

    for ( var i = 0 ; i < 7 ; i++ )
    {
    	var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[i];
        if ( storeListObj.isSet == true )
        {
        	storeListObj.openTime = defaultOpenTime;
        	storeListObj.closeTime = defaultCloseTime;
        	storeListObj.allDay = defaultAllDay;
        }
    }    
    IsSetDefaultOpenCloseTime = true;
}

function SaveBtnActivation(){
    if( $("#Store_name_input_box").val() == "" || jQuery.inArray(true, selectedDay) == '-1' || !checkDuplicateStoreName())
    {
        $('#SaveBtn').css({'background-image':'url("resource/img/action_bar/btn_title_save_d.png")'});
    }else{
        $('#SaveBtn').css({'background-image':'url("resource/img/action_bar/btn_title_save_n.png")'});
    }
}

function HideWarningMsg()
{
    $('#Warning_msg').css({'visibility':'hidden'});
}
function showWarningMsg(msg)
{
    $("#Warning_msg").css('visibility','visible');
    $("#Warning_msg").text(msg);
}

function showTimeexpand(i)
{
    if( i == 1 ) //show
    {
        $('#Enter_hours_selected_text').show();
        $('#timePopUp').show();
    }else // hide
    {
        $('#Enter_hours_selected_text').hide();
        $('#timePopUp').hide();
    }    
}

function QuitEditStore()
{
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.index.MIA_SID_QUIT_EDITING_STORE_INFO_CHANGE_CURRENT]);
    genericPopUpObj.addFooterBtns([
        {
            "btntxt" : langObj.index.COM_TV_SID_NO,
            "callback" : function() 
            {
            }
        }, 
        {
            "btntxt" : langObj.index.COM_TV_SID_YES,
            "callback" : function() 
            {   
                sessionStorage.setItem("isSettingStore",true);
                document.location.href = "settings/Settings.html";
            }
        }
    ]);
   genericPopUpObj.showPopUp();
}

function SaveButton()
{
    exitCounter = 0;
    document.getElementById("shrinkOpenPlateActiveBg").beginElement();
    
    $('#SaveBtn').css({'background-image':'url("resource/img/action_bar/btn_title_save_s.png")'});
    $('#Welcome').css("display", "none");
    if ( sessionStorage.getItem('editStoreFromSettings') != 'true' ) 
    {
        $('#Initial_setup_animation').animate(
            {
                'opacity' : '0'
            },
            {
                duration: 'slow',
                complete : function()
                {
                    $('#initialSetupMask_Bg').attr({'fill':'white'});
                    $('#initialSetupMask').css({'display':'none'});
                    $('#Initial_setup_animation').animate({'opacity' : '1'});
                    
                    //SVG position move
                    $('#Initial_setup_animation #ilMyStore').css({'-webkit-transform-origin':'420px 630px',
                                                                  '-webkit-transform':'scale(1.8)',
                                                                });
                    $('#Initial_setup_animation #storeRoof').css({'-webkit-transform-origin':'420px 630px',
                                                                  '-webkit-transform':'scale(1.8)',                                                                        
                                                                });
                    
                    $('#Initial_setup_animation #ilMyStore').css({'opacity':'0.1'});
                                    
                    
                    $("#OpenText").css({'opacity':'0'}); 
                    
                    $("#BusinessText1").css({'opacity':'1'});
                    $("#BusinessText2").css({'opacity':'1'});
                    
                    
                    $('.swiper-container').css({'display':'block'});
                    $('.swiper-container').css({'visibility':'visible'});
                    $('#Store_list').css({'display':'block'});    

                }
            }
        );
        $('#Title').animate(
            {
                'opacity' : '0'
            },
            {
                duration: 'slow',
                complete : function()
                {
                    $("#Title").text(langObj.index.MIA_SID_STORE_INFORMATION);
                    $('#Title').animate({'opacity':'1'});
                }
            }
        );
        
        showTimeexpand(2);
        
        $('#Initial_setup_1').animate(
            {
                'opacity':'0'
            },
            {
                duration:'slow',
                complete: function(){
                    $('#Initial_setup_1').css({'display':'none'});
                    $('#Initial_setup_2').css({'display':'block'});
                    $('#Initial_setup_2').animate({'opacity':'1'});
                    $('.scaleUpLetters').css({'display':'none'});
                }            
            }            
        );
        
        
        
        $("#Initial_setup_2_text").append(langObj.index.COM_CONGRATULATIONS);
        if ( StoreLists.Stores.length > 9 )
        {
            $("#Initial_setup_2_text").append(langObj.index.MIA_SID_VERIFY_ENTERED_INFO_EDIT_STOR_INFOR);
        }
        else
        {
            $("#Initial_setup_2_text").append(langObj.index.MIA_SID_VERIFY_ENTERED_INFO_EDIT_STOR_INFOR_ADD);
        }
        
        if( $("#Initial_setup_2_text").text().length >= 100)
        {
            $("#Initial_setup_2_text").css({'font-size':'90%'});
        }
        
        $('#HomeBtn').animate({'opacity':'0'});
        $('#SaveBtn').animate(
            {
                'opacity':'0'
            },
            {
                duration:'slow',
                complete: function(){
                    $('#SaveBtn').hide();
                    $('#HomeBtn').hide();
                }
            }            
        );
        
        $('#TimeSetting_Expand').hide();
        
        // Apply the same time at the whole business days when set the hours of first selected day. 
        SetDefaultOpenCloseTime(IsSetDefaultOpenCloseTime);
    }

}

function displayArrow()
{
    if ( getNumberSelectedDays() == 1 )
    {
        $(".Arrow_cls").css({'opacity':'0.0'});
    }
    else
    {
        $(".Arrow_cls").css({'opacity':'1.0'});
    }

}


/* -------------------------------------------------------------------- */ 
/* For step2 function                                                   */
/* -------------------------------------------------------------------- */ 


function ClickAddStoreButton() {
    document.location.href = "index.html?OperationType=ADD";
}
    
function ClickEditStoreButton() {

    if ( nCurStoreIndex == null )
        nCurStoreIndex = 0;

    document.location.href = "index.html?OperationType=EDIT&StoreIndex="+nCurStoreIndex;
}

function selectStore(storeIndex) {

    nCurStoreIndex = storeIndex;
    isPlateOpen = true;
    /* + initialize screen of step1 */
    $('#szyld').text(StoreLists.Stores[nCurStoreIndex].storeName);
    $('#Store_name_input_box').val(StoreLists.Stores[nCurStoreIndex].storeName);
   
    /* - initialize screen of step1 */


    /* + initialize screen of step2 */
    for ( var i = 0 ; i < 7 ; i++ )
    {
        var ID_Day = "#" + weekDaysID[i];

        if ( StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[i].isSet == true )
        {
            $($(ID_Day)).addClass('Select_day_float_Leftimg_cls');
            selectedDay[i] = true;
        }
        else
        {
            $($(ID_Day)).removeClass('Select_day_float_Leftimg_cls');
            selectedDay[i] = false;
        }
    }

    var nStartDay = jQuery.inArray(true, selectedDay); 
    $("#dayText").text(weekDays[nStartDay]);

    CurShowingDay = nStartDay;
    
    showOpenCloseTime();
    /* check the All Day */
    checkAllDays();
    /* - initialize screen of step2 */


    /* + initialize screen of step3 */
    for ( var i = 0 ; i < 7 ; i++ )
    {
        
        var ID_Day = "#" + CompleteDaysID[i];
        var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[i];
        if ( storeListObj.isSet == true )
        {
            var openCloseTime = storeListObj.openTime + " - " + 
            storeListObj.closeTime;
            $($(ID_Day)).text(openCloseTime);
        }
        else
        {
            $($(ID_Day)).text(langObj.index.MIA_SID_CLOSED);
        }
        if(storeListObj.allDay == true) 
        {
            $($(ID_Day)).text("12:00 am - 12:00 am");
        }
    }
    /* - initialize screen of step3 */
}


function saveOrUpdateStoreInfo() {

    var id = StoreLists.Stores[nCurStoreIndex].id;
    var storeName = StoreLists.Stores[nCurStoreIndex].storeName;
    var openDays = "";
    var openTimes = "";
    var alldays = "";

    for ( var i = 0 ; i < 7 ; i++ )
    {
        var ID_Day = "#" + CompleteDaysID[i];
        var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[i];
        if (storeListObj.isSet == true )
        {
            if (openDays == '')
            {
                openDays = weekDays_DB[i];
                openTimes = storeListObj.openTime + "-" + 
                            storeListObj.closeTime;
                alldays = storeListObj.allDay;
            }
            else
            {
                openDays = openDays + "||" + weekDays_DB[i];
                openTimes = openTimes + "||" + 
                            storeListObj.openTime + "-" + 
                            storeListObj.closeTime;
                alldays = alldays + "||" + storeListObj.allDay;
            }
        }
    }
 
    if (OperationType == OPERATION_TYPE_ADD )
        insertStoreInfo(storeName, "storeLogo", openDays, openTimes, alldays);
    else 
        updateStoreFromDB(id, storeName, "storeLogo", openDays, openTimes, alldays);
}


function loadStoreInfo() {

    StoreLists = new StoreLists_Array();

    var myStoreInfoJson = JSON.parse(sessionStorage.getItem("STORE_INFO"));

    if ( myStoreInfoJson == null || myStoreInfoJson.myStoreInfoArrs == null )
        return;

    for (var i = 0, len = myStoreInfoJson.myStoreInfoArrs.length; i < len; i++)
    {
        var Store_arr = new Store_Array();
        StoreLists.Stores.push(Store_arr);
        var storeInfoArr = myStoreInfoJson.myStoreInfoArrs[i];
        StoreLists.Stores[i].id = storeInfoArr.id;
        StoreLists.Stores[i].storeName = storeInfoArr.StoreName;

        var storeWeekDayList=[];
        var startTimeEndTimeArray=[];
        var isFulldayArray=[];

        storeWeekDayList = storeInfoArr.StoreOpenDay.split("||");
        startTimeEndTimeArray = storeInfoArr.StoreOpenTime.split("||");
        isFulldayArray = storeInfoArr.isOpenFullDay.split("||");
        
        var index = 0;
        for ( var j = 0 ; j < 7 ; j++ )
        {
            var OpenCloseTimeforDay_arr = new OpenCloseTimeforDay_Array();
            StoreLists.Stores[i].OpenCloseTimeforDays.push(OpenCloseTimeforDay_arr);
           var storeListObj=StoreLists.Stores[i].OpenCloseTimeforDays[j];
            if ( weekDays_DB[j] == storeWeekDayList[index] )
            {
                var startEndTimeArray=startTimeEndTimeArray[index].split("-");
                var startTime = startEndTimeArray[0];
                var endTime = startEndTimeArray[1];
               
                storeListObj.openTime = startTime;
                storeListObj.closeTime = endTime;
                storeListObj.isSet = true;
                
                if(isFulldayArray[index] == "true")
                {
                	storeListObj.allDay = true;    
                }
                else
                {
                	storeListObj.allDay = false;                    
                }
                

                index++;
            }
            else
            {
            	storeListObj.openTime = DEFAULT_OPEN_TIME;
            	storeListObj.closeTime = DEFAULT_CLOSE_TIME;
            	storeListObj.isSet = "";
            	storeListObj.allDay = false;
            }
        }
    }
}

function AddNewStoreInfo()
{
    nCurStoreIndex = StoreLists.Stores.length;
    
    var Store_arr = new Store_Array();
    StoreLists.Stores.push(Store_arr);

    StoreLists.Stores[nCurStoreIndex].storeName="";
    
    for ( var j = 0 ; j < 7 ; j++ )
    {
        var OpenCloseTimeforDay_arr = new OpenCloseTimeforDay_Array();
        StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays.push(OpenCloseTimeforDay_arr);
        var storeListObj=StoreLists.Stores[nCurStoreIndex].OpenCloseTimeforDays[j];
        storeListObj.openTime = DEFAULT_OPEN_TIME;
        storeListObj.closeTime = DEFAULT_CLOSE_TIME;
        storeListObj.isSet = "";
        storeListObj.allDay = false;
    }  
}

function checkDuplicateStoreName()
{
	var tempStrInbx=$('#Store_name_input_box').val();
	
    for (var i = 0,len = StoreLists.Stores.length ; i < len ; i++)
    {
        if ( StoreLists.Stores[i].storeName == tempStrInbx && i != nCurStoreIndex )
        {
            return false;
        }
    }

    return true;
}

function createStoreList()
{
    for (var i = 0,len = StoreLists.Stores.length; i < len; i++) {
                
        var swiper_slide = '#swiper-slide'  + i;
        $(swiper_slide).css({'display':'block'});

        for (var j = 0; j < 7; j++) {
            var ID_Day = "#" + CompleteDaysID[j] + i;
            var storeListObj=StoreLists.Stores[i].OpenCloseTimeforDays[j];
            if (storeListObj.isSet == true) {
                var openCloseTime = storeListObj.openTime + " - " + storeListObj.closeTime;
                $($(ID_Day)).text(openCloseTime);
                
                if(storeListObj.allDay == true) $($(ID_Day)).text("12:00 am - 12:00 am");
            } 
            else {
                $($(ID_Day)).text(langObj.index.MIA_SID_CLOSED);
            }
        }
    }
    
    for (var i = StoreLists.Stores.length; i < 10; i++) {
        var swiper_slide = '#swiper-slide'  + i;
        $(swiper_slide).remove();
    }
}


function registerActivityStatus(){
    
    if(deviceType == "iPhone" || deviceType == "iPad"){
            return;
      }     
    var success = function(result){
       if(play_BGM!=undefined && play_BGM!=null){
            if(result == ON_RESUME){
                play_BGM.play();
                //play_Dial.play();
            }else if(result == ON_PAUSE){
                play_BGM.pause();
                //play_BGM.stop();
                //play_Dial.();
            }
        }
    };
    var error = function(message){
    };
    mUtilityManager.registerActivityStatus(success,error);
}

// For android ( back button click )
function onBackkeyDown(e){    
    
    if( $('#TimePicker').css('display') == 'block' ) 
    {
        closeTimePicker();
        $('#startTimeDiv').css({'font-weight':'normal'});
        $('#endTimeDiv').css({'font-weight':'normal'});
        
        return;
    }
    
    if(localStorage.getItem('player_type'))
    {
        if( genericPopUpObj.isPopUpVisible() == true ) 
        {
            genericPopUpObj.hidePopUp();
        }else if($('#ModelSelectionPage').css('display') == "block")
        {           
            if($("#ModelContainerHelpPage").css("display") == "block")
            {
                $(".close-btn").click();         
            }
            else if($("#ModelContainerscrollArea").css("display") == "block")
            {
                if(param_whereFrom == "Model")
                {
					sessionStorage.setItem("modelFromSettings",true);
                    document.location.href = "settings/Settings.html";
                } 		
            }           
        }
		else
		{
			checkBlur = true;
			// if something is foucused
			$('#Store_name_input_box').blur(); 
			setTimeout(function(){
				QuitEditStore();
			},400);
		}
    }
	else
    {
        if(exitCounter==0){
            Utils.showToast(langObj.index.COM_MIA_SID_PRESS_AGAIN_TO_EXIT_THIS_APPLICATION);
            exitCounter++;
        }
        else{
            navigator.app.exitApp();
        }    
    }
    
}
function radioBtnSel(btnIndx,bgImgName,ModelTxt)
{
    for(var i=1; i<=5; i++) {
       $('#ModelSel_RadioBtn'+i+'Id').addClass('ModelSel_RadioBtnCls').removeClass('ModelSel_RadioBtnCls_selected');
    }
    
    $('#ModelSel_RadioBtn'+btnIndx+'Id').addClass('ModelSel_RadioBtnCls_selected').removeClass('ModelSel_RadioBtnCls');
    $('#ModelSel_OKBtnId').removeClass('AddDisable');
    $('.ModelSel-PlayerContainerImgCls').css('background-image', "url(resource/img/"+bgImgName+")");
    $('#ModelSel_OKBtnId').addClass('active');
    $('#Model_RatioId').css('visibility', 'hidden');
    if(btnIndx==2){
    	 $('#Model_RatioId').css('visibility', 'visible');
    }
    $('#Model_InfoTxtId').text(langObj.index.MIS_SID_MIX_SERIES.replace('<<A>>',ModelTxt));
    $('#Model_ImageId').text('');
}
function showModelSelection()
{
    $("#Store").hide();
    $('#ModelSelectionPage').show();
    setTimeout(function(){

        if( deviceType == 'iPhone' )
        { 
            $('#ModelSel_titleId').autoFontSize({ maxFontPixels: 21,minFontPixels:12});
         }
         else{
             $('#ModelSel_titleId').autoFontSize({ maxFontPixels: 21,minFontPixels:17});
         }
        $('#ModelSel_titleId').css('visibility','visible');
    },300);
    
    if(param_whereFrom=="Model") {
    	var category=Utils.getActivePlayerType(deviceType);
    	 switch(category) {

    	    case 1 :
                radioBtnSel(1,"ss_img_model_e.png",modelSeries.RMD);
                break;
    	    case 2 :
    	    	radioBtnSel(2,"ss_img_model_s3.png",modelSeries.RHE);
                $('#ratio1_RadioBtnId').addClass('ratio1_RadioBtnCls_selected').removeClass('ratio1_RadioBtnCls');
                $('#ratio2_RadioBtnId').addClass('ratio2_RadioBtnCls').removeClass('ratio2_RadioBtnCls_selected');  
               break;
    	    case 3 :
    	    	radioBtnSel(2,"ss_img_model_s3_2.png",modelSeries.RHE_STRETCH);
                $('#ratio1_RadioBtnId').addClass('ratio1_RadioBtnCls').removeClass('ratio1_RadioBtnCls_selected');
                $('#ratio2_RadioBtnId').addClass('ratio2_RadioBtnCls_selected').removeClass('ratio2_RadioBtnCls');
                break;
            case 4 :
                 radioBtnSel(3,"ss_img_model_s4.png",modelSeries.TIZEN);
                 break;
    	    case 5 :
    	    	radioBtnSel(4,"ss_img_model_s5.png",modelSeries.TIZEN_S5);
                break;
            case 6 :
                 radioBtnSel(5,"ss_img_model_s6.png",modelSeries.TIZEN_S6);
                 break;
    	 }
            $('#ModelSel_Info').css('border-top', "solid 0px #9b9b9b");
       
    	 
    }
}

function playBackgroundmusic() {
    var resource = getPhoneGapPathIndexPage() + 'resource/audio/obe_bgm.mp3';
    play_BGM = new Media(resource,
            // success callback
             function () { console.log("playBGMAudio():Audio Success"); },
            // error callback
             function (err) { console.log("playBGMAudio():Audio Error: " + err); },
             function (status) {if( status==Media.MEDIA_STOPPED ) {
                 setTimeout(function(){
                     play_BGM.play();
                 },1000);
             } }
    
    );
     setTimeout(function(){
      play_BGM.play();
     },1000);
}

function getPhoneGapPathIndexPage() {
    var path = window.location.pathname;
    path = path.substr( 0, path.length - 10 );
    return path;
}
function saveBtnInptFun(){
	              
	SaveButton();
	saveOrUpdateStoreInfo();
	createStoreList();
	// store list rearrange
	swiper.slideTo(nCurStoreIndex, 0, false);

	if (sessionStorage.getItem('editStoreFromSettings') == 'true') {
		setTimeout(function() {
			document.location.href = "settings/Settings.html";
		}, 300);
	}

}
