var mAdclipManager;

var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : "null";
if (deviceType == "iPhone" || deviceType == "iPad") {
    mAdclipManager = {
        startSummarizer : function(successCallback, errorCallback) {
            console.log("@plugin: startSummarzer()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_START_SUMMARIZER, 10)]);
        },
        cancelSummarizer : function(successCallback, errorCallback) {
            console.log("@plugin: cacelSummarzer()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_CANCEL_SUMMARIZER, 10)]);
        },
        SummarizerInterfaceTest : function(successCallback, errorCallback) {
            console.log("@plugin: SummarzerInterfaceTest()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_INTERFACE_TEST, 10)]);
        },
        launchVideoCamera : function() {
            console.log("@plugin: launchVideoCamera()");
            var errorCallback = function(message) {
            };
            var successCallback = function(message) {
            };
            return cordova.exec(successCallback, errorCallback, "Capture", "captureVideo", []);
        },
        getThemeLimitInfo : function(successCallback, errorCallback, themeIndex) {
            console.log("@plugin: GetThemeLimitInfo()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_GET_THEME_LIMIT_INFO, 10), themeIndex]);
        },
        getEstimatedTimeSec : function(successCallback, errorCallback, nNumOfTheme, nNumOfImage, nLengthOfVideoSec) {
            console.log("@plugin: GetEstimatedTimeSec()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_GET_ESTIMATED_TIME_SEC, 10), nNumOfTheme, nNumOfImage, nLengthOfVideoSec]);
        },
        startADClip : function(successCallback, errorCallback, userInput) {
            console.log("@plugin: StartADClip()"+successCallback);
            
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_START, 10), userInput]);
        },
        cancelADClip : function(successCallback, errorCallback) {
            console.log("@plugin: cancelADClip()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_CANCEL_ENCODING, 10)]);
        },
        createADClip : function(successCallback, errorCallback, themeSlotContextArr) {
            console.log("@plugin: createADClip()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [parseInt(ADCLIP_CREATE, 10), themeSlotContextArr]);
        },
        createTextImage : function(successCallback, errorCallback,jsonArr) {
            console.log("@plugin: createTextImage()-fileName: ");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand",[parseInt(ADCLIP_CREATE_TEXT_IMAGE, 10),jsonArr]);
        },
        playAdClip : function(successCallback, errorCallback) {
            console.log("@plugin: playAdClip(): ");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand",[parseInt(ADCLIP_PLAY, 10)]);
        },
        saveADClip : function(successCallback, errorCallback,fileName,overwrite) {
            console.log("@plugin: saveADClip()-fileName: "+fileName +",overwrite:"+overwrite);
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand",[ADCLIP_SAVE,fileName,overwrite]);
        },
        updateSlot : function(successCallback, errorCallback,jsonArr) {
            console.log("@plugin: playAdClip()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [ADCLIP_UPDATE_SLOT,jsonArr]);
        },
        adClipStepInfo : function(successCallback, errorCallback,stepInfo) {
            console.log("@plugin: adClipStepInfo()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [ADCLIP_STEP_INFO, stepInfo]);
        },
        adClipImageCrop : function(successCallback, errorCallback,cropJson) {
            console.log("@plugin: adClipImageCrop()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [ADCLIP_IMAGE_CROP,cropJson]);
        },
        getProgressValue : function(successCallback, errorCallback) {
            console.log("@plugin: getProgressValue()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [ADCLIP_GET_PROGRESS_VALUE]);
        },
        adClipAssetImageSave : function(successCallback, errorCallback,assetPath) {
            console.log("@plugin: adClipAssetImageSave()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, "executeCommand", [ADCLIP_SAVE_ORIG_IMAGE,assetPath]);
        }
    };

} else {
	mAdclipManager = {
		startSummarizer : function(successCallback, errorCallback) {
			console.log("@plugin: startSummarzer()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_START_SUMMARIZER, "");
		},
		cancelSummarizer : function(successCallback, errorCallback) {
			console.log("@plugin: cacelSummarzer()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_CANCEL_SUMMARIZER, "");
		},
		SummarizerInterfaceTest : function(successCallback, errorCallback) {
			console.log("@plugin: SummarzerInterfaceTest()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_INTERFACE_TEST, "");
		},
		launchVideoCamera : function() {
			console.log("@plugin: launchVideoCamera()");
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_ADD_VIDEO_CAMERA, []);
		},
		getThemeLimitInfo : function(successCallback, errorCallback, themeIndex) {
			console.log("@plugin: GetThemeLimitInfo()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_GET_THEME_LIMIT_INFO, [themeIndex]);
		},
		getEstimatedTimeSec : function(successCallback, errorCallback, nNumOfTheme, nNumOfImage, nLengthOfVideoSec) {
			console.log("@plugin: GetEstimatedTimeSec()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_GET_ESTIMATED_TIME_SEC, [nNumOfTheme, nNumOfImage, nLengthOfVideoSec]);
		},
		startADClip : function(successCallback, errorCallback, userInput) {
			console.log("@plugin: StartADClip()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_START, [userInput]);
		},
		createADClip : function(successCallback, errorCallback, themeSlotContextArr) {
			console.log("@plugin: StartADClip()");
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_CREATE, themeSlotContextArr);
		},
		cancelADClip : function(successCallback, errorCallback) {
			console.log("@plugin: cancelADClip()");			
			cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_CANCEL_ENCODING, []);
		}, 
		saveADClip : function(successCallback, errorCallback,fileName,overwrite) {
            console.log("@plugin: saveADClip()-fileName: "+fileName +",overwrite:"+overwrite);
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_SAVE,[fileName,overwrite]);
       },
       createTextImage : function(successCallback, errorCallback,jsonArr) {
            console.log("@plugin: createTextImage()-fileName: ");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_CREATE_TEXT_IMAGE,jsonArr);
        },
       playAdClip : function(successCallback, errorCallback) {
            console.log("@plugin: playAdClip()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_PLAY,[]);
        },
       updateSlot : function(successCallback, errorCallback,jsonArr) {
            console.log("@plugin: playAdClip()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_UPDATE_SLOT,jsonArr);
        },
       adClipStepInfo : function(successCallback, errorCallback,stepInfo) {
            console.log("@plugin: adClipStepInfo()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_STEP_INFO,[stepInfo]);
       },
       adClipImageCrop : function(successCallback, errorCallback,cropJson) {
            console.log("@plugin: adClipImageCrop()");
            cordova.exec(successCallback, errorCallback, AD_CLIP_MANAGER_PLUGIN, ADCLIP_IMAGE_CROP,[cropJson]);
        }
	};
}