function playListResponse() {
	this.CustomPlaylist = new Array();
}
function Array_CustomPlaylist() { 
    Name:null;
    TimeStamp:null;
	this.CustomContent = new Array();
}
function Array_CustomContent() { 
    Duration:null;
    Name:null; 
    Path:null; 
    ActualPath:null; 
    TemplateId:null; 
    isDeleted:false;
}
var playListObj = new playListResponse();

var playListObjForDrag = new playListResponse();

var playListPar = {
		
    isPlaylistFromSch:false,
    init : function(textXML, isDraggble) {
        if (isDraggble) {
            playListObjForDrag = new playListResponse();
            playListPar.fetchPlaylistContent(playListObjForDrag, textXML, isDraggble);
        } else {
            playListObj = new playListResponse();
            playListPar.fetchPlaylistContent(playListObj, textXML, isDraggble);
        }
    },
    fetchPlaylistContent:function(targetPlaylistObj,textXML,isDraggble) {
        playListPar.isPlaylistFromSch = false;
        var xmlDoc = new DOMParser().parseFromString(textXML, 'text/xml');
        var playListArray = $(xmlDoc).find("playlist");
        var playList = null;
        var playListArrlength=playListArray.length;
        for ( index = 0; index < playListArrlength; index++) {
            playList = new Array_CustomPlaylist();
            targetPlaylistObj.CustomPlaylist[index] = playList;
            playList.Name = playListArray.attr('name');
            playList.TimeStamp = playListArray.attr('timestamp');

            var contentArray = $(playListArray).find("content");
            //This check if item deleted from Play list but not saved in Schedule file
            if (!isDraggble) {
                flag = playListPar.checkInSchObject(0, playList.Name, contentArray, targetPlaylistObj);
            } else {
                playListPar.createContentObj(contentArray, targetPlaylistObj);
            }
        }
    },
        
    createContentObj:function(contentArray,targetPlaylistObj) {
        var contentList = null;
        var contentArrayItemObj=null;
        var contentArraylength=contentArray.length;
        for ( contentIndex = 0; contentIndex < contentArraylength; contentIndex++) {            
            contentList = new Array_CustomContent();
            targetPlaylistObj.CustomPlaylist[0].CustomContent[contentIndex] = contentList;
            contentArrayItemObj=$(contentArray[contentIndex]);            
            contentList.Duration = contentArrayItemObj.children("duration").text();
            contentList.Name = contentArrayItemObj.children("name").text();
            contentList.Path = contentArrayItemObj.children("path").text();
				
            contentList.Path = playListPar.setDefaultPath(contentList.Path);

			
            contentList.ActualPath = contentArrayItemObj.children("actualPath").text();
            contentList.TemplateId = contentArrayItemObj.children("templateId").text();

            if (($.inArray(getParseIntInDec(contentList.TemplateId), templateIDArray) < 0)) {
                contentList.isDeleted = true;
            } else {
                contentList.isDeleted = false;
            }
        }
    },
    deletePlaylistContent:function(count) {
      var customPlayList=playListObj.CustomPlaylist[0];
        if (count < customPlayList.CustomContent.length) {
            if (customPlayList.CustomContent[count].isDeleted) {
               customPlayList.CustomContent.splice(count, 1);
                count = 0;
            } else {
                count++;
            }
            playListPar.deletePlaylistContent(count);
        }
    },
    checkInSchObject:function(count,playlistName,contentArray,targetPlaylistObj) {
        if (count < SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule.length) {
            playListPar.loadData(count, playlistName, contentArray, targetPlaylistObj);
        } else {
            playListPar.createContentObj(contentArray, targetPlaylistObj);
            return true;
        }
    },
    loadData:function(n,playlistName,contentArray,targetPlaylistObj) {
        var playlistLength = contentArray.length;
        var vPlaylist = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[n].Playlist;
        for (var q = 0; q < vPlaylist.length; q++) {
            if (vPlaylist[q].Playlist_Name != '' && 
                vPlaylist[q].Playlist_Name != undefined && 
                vPlaylist[q].TimeStamp != '' && 
                vPlaylist[q].TimeStamp != undefined) {
                if (vPlaylist[q].Playlist_Name == playlistName && 
                    vPlaylist[q].Content.length == playlistLength && 
                    getParseIntInDec(vPlaylist[q].TimeStamp) == getParseIntInDec(targetPlaylistObj.CustomPlaylist[0].TimeStamp)) {
                    playListPar.createContentObj(contentArray, targetPlaylistObj);
                    return true;
                } else if (vPlaylist[q].Playlist_Name == playlistName) {
                    var contentList = null;
                    var contentPlaylist=null;
                    for (var contentIndx = 0; contentIndx < vPlaylist[q].Content.length; contentIndx++) {
                        contentList = new Array_CustomContent();
                        contentPlaylist=vPlaylist[q].Content[contentIndx];
                        targetPlaylistObj.CustomPlaylist[0].CustomContent[contentIndx] = contentList;
                        contentList.Duration = contentPlaylist.Duration;
                        contentList.Name = contentPlaylist.File[0].Name;
                        contentList.Path = contentPlaylist.File[0].thumnailPath;
                         
			
				
                        contentList.Path = playListPar.setDefaultPath(contentList.Path);                        

                        contentList.ActualPath = contentPlaylist.File[0].actualPath;

				
                        contentList.ActualPath = playListPar.setDefaultPath(contentList.ActualPath);                        

                        contentList.TemplateId = contentPlaylist.File[0].TemplateId;
                    }
                    playListPar.isPlaylistFromSch = true;
                    return false;
                } else {
                    n++;
                    playListPar.checkInSchObject(n, playlistName, contentArray, targetPlaylistObj);
                }
            } else {
                n++;
                playListPar.checkInSchObject(n, playlistName, contentArray, targetPlaylistObj);
            }
        }
    },
    setDefaultPath:function(path) {
    	if(path.indexOf(".ETabletAuthor/RHE")< 0 && path.indexOf(".ETabletAuthor/RHE_STRETCH") < 0 &&  path.indexOf(".ETabletAuthor/RMD") < 0 && path.indexOf(".ETabletAuthor/TIZEN") < 0)
		{
			path = path.replace(".ETabletAuthor",".ETabletAuthor/RHE");
		}
		return path;
    }
};