/**
 * @filename Send.js
 *
 * Modified by rishu.yadav 31-01-2015
 Modified k.chainani 10 feb adding back function
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

var schedulePath = null;
var scheduleName = null;
var navigateFromSch = null;
var navigateFromTemp = null;
var category = null;
var isSendingFail = false;
var checkingID = null;
var log = null;
var deviceListContainerRef;
var mLFDInfo;

$(document).ready(function() {
    var urlList = Utils.getUrlVars();
    log = new logger();
    globlePlayerType = Utils.getActivePlayerType();
	schedulePath = urlList["schedulePath"];
	scheduleName = urlList["scheduleName"];
	navigateFromSch = urlList["navigateFromSchedule"];
	navigateFromTemp = urlList["navigateFromTemplate"];
	category = urlList["category"];
	//Dynamically Show version name after page loaded
	appset.initialize(); 
});

var progressBar = {
    setValue : function(id, value) {
        $(id).val(value);
        $(id).slider("refresh");
    }
};
var addmanualListIndex = 0;
var listlenth = 0;
var loaderInt = null;
var deviceID = 0;
var deviceIp;
var mDeviceListInfo;
var uncheckdinfo = new Array();
var addContentArr = [];
var addContentArr_S6= [];
var addContentArr_S5= [];
var addContentArr_S4=[];
var addContentArr_S3=[];
var addContentArr_E=[];
var templateIndex=0;
var uploadJsonCount = TIZEN_S6;//TIZEN_S6 = 6
var uploadJsonLastIndex = 0;
var Liheight;
var templatePathArray = [];
var subFolder = null;
var isBackPressOn = false;
var isScheduleCopy = false;
var isWiFiEnabled = false;
var isCanceled = false;
var isReady = false;
var check_animation_Sending_content = 1;
var deviceModel;
var isSyncingSend = false;
var svgDoc = document.getElementsByTagName('svg');
var flagdoubletap = true;
var Liheight = "";
var Liwidth = "";
var deviceNameSend="";

var mLFDDeviceInfo = function() {
    this.mDeviceName = null;
    this.mDeviceId = null;
    this.mDeviceIP = null;
    this.mTLSRequired = 0;
    this.mPin="";
    this.mMacAddr="";
    this.mMetaInfo = null;
    this.mStatus = null;
    this.isCanceled = false;
    this.mProgressVal = 0;
};

var mLFDInfoArrayList = new Array();

var appset = {

    initialize : function() {
        this.bindEvents();
    },

    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },

    onDeviceReady : function() {
        getDeviceInfo();
        document.addEventListener("backbutton", onBackkeyDown, false);
        //Preload background image
        console.log("@ onDeviceReady settings page");
        appset.receivedEvent('deviceready');

        deviceModel = device.model;

        mProtocolManager.registerWiFiStateChangeReceiver();
        if (!Utils.isIOSDvice()) {
            Utils.registerKeyboardObserver();
        }
        setTimeout(function() {
            if (Utils.checkConnection() == 3) {
                refreshList();
            } else {
                hideLoader('LoadercontainerId');
                noDeviceFound();
            }
        }, 500);
        $('.network-footer>#newconection').addClass('icon-disabled');
    },
    // Update DOM on a Received Event
    receivedEvent : function(id) {

        console.log('Received Event: ' + id);
    },

    switchView : function() {
        if ($(this).hasClass('close')) {
            $('#view-send').addClass('show');
            //$('#view-home').removeClass('show');
        } else if ($(this).attr('id') == 'home-button') {
            //$('#view-home').addClass('show');
            $('#view-send').removeClass('show');
        }
    }
};

//ready
$(function() {
    //create header
    this.pageHeight = window.innerHeight;
    this.pageWidth = window.innerWidth;

    if (category == 'C') {
        $('#custom_TextId').text(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN);
        $('.stepHeaderCls').hide();
    } else {
        $('#custom_TextId').text(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START);
        $('.stepHeaderCls').show();
    }
  
    $('#rightPortion_page').removeClass('.rightPortion_page_qs');
    $('#rightPortion_page').addClass('rightPortion_page_cd');

    $('#customTextId').autoFontSize({ maxFontPixels: 18,minFontPixels:12});  

    $('.homeBtnCls').on('click', function() {
        if (isCanceled) {
            return;
        }
        if (isBackPressOn) {
            cancelCurrentSend();
            return;
        }
        mProtocolManager.stopAutoDiscoveryService();
        document.location.href = "../quickstart/QuickStart.html";
    });

    var Titleheader = $('<div>').attr("id", "Title").css({
        "id" : "Title",
        "height" : "23%",
        "width" : "100%"
    });
    
    if (category != 'C') {
        Titleheader.css({
	   "padding-top":"10%"
	});
    }

    $('#rightPortion_page').append(Titleheader);

    var Titletxt = $('<div>').attr("id", "TitletxtId").css({
        "id" : "TitletxtId",
        "height" : "100%",
        "width" : "75%"
    });
    $('#Title').append(Titletxt);
    var search_loader = $('<div>').attr("id", "LoadercontainerId").css({
        "id" : "LoadercontainerId",
        "height" : (WIN_INNER_W*.14)+"px",
        "width" : (WIN_INNER_W*.14)+"px",
        "float" : "left",
        "margin-left" : "75%"
    });
    
    /*
     Loader is getting shifted above the title text
     if (category != 'C') {
       search_loader.css({
	   "top":"10%"
       });
    }*/

    $('#Title').append(search_loader);
    setTimeout(function() {
        $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
    }, 100);

    var listContainer = $('<div>').attr("id", "listContainerId").css({
        "id" : "listContainerId",
        "max-height" : 44 + '%',
        "width" : (this.pageWidth * 0.9) + 'px',
        "position" : "relative"
    });
    $('#rightPortion_page').append(listContainer);

    var listUL = $('<ul >').attr("id", "list").css({
        "id" : "list"
    });
    listContainer.append(listUL);

    //generate list
    var AddsignageTv = ' <div class="AddsignageCls">' + '<div id="newconection1" active-class="true" style="padding: 15px 0px 12px 0px !important;border:none;" class="my-btn ui-btn ui-btn-inline ">+ ' + langObj.Send.MIA_SID_ADD_SIGNAGE_TV + '</div>' + '</div>';

    $('#rightPortion_page').append(AddsignageTv);

    $('.AddsignageCls').addClass('icon-disabled');

    $('#updateenterId').addClass('icon-disabled');

    var noDevicefoundMsg = "<div id='noDeviceFoundId' class='addNoDeviceMsgCls' style='display:none;'></div>";

    $('#rightPortion_page').append(noDevicefoundMsg);

    $('#updateenterId').authorActiveClass();
    $('#updatecancelId').authorActiveClass();

    var startUpdate = '<div class="network-footer">' + '<div id="newconection" active-class="true" style="padding: 15px 0px 15px 0px !important;" class="my-btn-footer-set ui-btn ui-btn-inline ">' + langObj.Send.COM_COMMONCTRL_SEND + '</div>' + ' </div>';
    $('#rightPortion_page').append(startUpdate);
    var style = "width:100%;padding: 10px 0px 10px 0px; font-size:18px !important;";
    var loc = sessionStorage.getItem('locale');

    var resend = '<div class="network-footer-two" style="display:none;"><div id="btncontainer" style="height:100%;width:100%;">' + '<div id="newconection_resend" style="float:left;width:48%;height:100%;"><div id="resendBtnId"  style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline ">' + langObj.Send.COM_TV_SID_RESEND + '</div></div>' + '<div id="newconection_cancel" style="float:right;width:48%;height:100%;"><div id="cancelBtnId" style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline ">' + langObj.Send.COM_TV_SID_HOME + '</div></div>' + '</div>' + '</div>';
    $('#rightPortion_page').append(resend);
    $('.my-btn-footer').authorActiveClass();
    Liheight = $('#list >li').height();
    Liwidth = $('#list >li').width();


  
   // ADD MANUALLY CLOSE BUTTON
    $('#Add_SinageTV_Close_Btn_ID').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault(); 

        // if something is foucused
        if( document.activeElement.tagName == "INPUT") {
            $('.iptext').blur(); 
            setTimeout(focusIPTextFieldSend,400);
        }else {
            focusIPTextFieldSend();
        }   
    });

    function focusIPTextFieldSend(){
        $('.iptext').val('');
        $('#view-send').show();
        $('#send_manually_add-ipID').hide();
        $('#send_manually_add-ip-panel').hide();
    }

  function focusIPTextField()
  {
    $('.pintext').val('');
    $('#view-send').show();
    $('#pin_verification_page_Id').hide();
    $('#pin_verification_panel').hide();
  }
     // VERIFICATION PAGE CLOSE BUTTON
     $('#pin_verification_close_Id').on('tap', function(e) {
            e.stopPropagation();
            e.preventDefault();
            try{
             mLFDInfo.mPin = "";
            }catch(e){}
            deviceListContainerRef.parent('.auto-LFD-List').attr('id');
            // if something is foucused
            if( document.activeElement.tagName == "INPUT") {
                //$('.iptext').blur();
                setTimeout(function(){
                  focusIPTextField();
                },400);
            }else {
                focusIPTextField();
            }
            cancelPinPopUpButtonPressed();
        });

     // ADD MANUALLY DONE BUTTON
    $('#Add_SinageTV_Done_Btn_ID').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        
        // if something is foucused
        if( document.activeElement.tagName == "INPUT") {
            $('.iptext').blur(); 
            setTimeout(function(){
                ValidIPEnterUpdate();
            },400);
        }else {
            ValidIPEnterUpdate();    
        } 
    }); 
    
    /*   // PIN VERIFICATION DONE BUTTON
     $('#pin_verification_done_Id').on('tap', function(e) {
             e.stopPropagation();
             e.preventDefault();
             $('.pintext').blur();
             setTimeout(function(){

               var ip =  deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
               if(ip==undefined){
                   ip =  deviceListContainerRef.attr('ip');
               }

               var pinVal = $('#pinbox1').val().trim() + $('#pinbox2').val().trim() + $('#pinbox3').val().trim() + $('#pinbox4').val().trim();
               $('.pintext').val('');
               $('#view-send').show();
               $('#input_verification_pin').hide();
               $('#pin_box_panel').hide();
               pinVal = pinVal.trim();
               showAnimationLoader('Verifying...');
               var isManual = $('#input_verification_pin').attr('isManual');
               mProtocolManager.verifyPINInfo(ip,3,pinVal,deviceListContainerRef,isManual);
            },400);
        });
        */
    $('.AddsignageCls').on('click', '#newconection1', function(e) {

        e.stopPropagation();
        if ($('.AddsignageCls').hasClass('icon-disabled')) {
            return false;
        }
        $('#view-send').hide();        
        $('#send_manually_add-ipID').show();
        $('#header-part2_addSignage').autoFontSize({ maxFontPixels: 18,minFontPixels:12}); 
        $('#send_manually_add-ip-panel').show();
        $('#firmIpbox1').focus();
    });

    $(".iptext").keyup(function(e) {
        /*Can not use space at the first of string*/
        if ($(this).val().charAt(0) == " ") {
            $(this).val("");
        }

        /*Click the 'Go' button in android keypad or enter key*/
        if (e.keyCode == 13) {
            $('#firmIpbox1').blur();
            ValidIPEnterUpdate();
        }
    });


    $("#listContainerId").on('tap', '.del_icon', function(e) {
        e.stopPropagation();
        var thisVal = $(this);
		if (thisVal.hasClass('icon-disabled')) {
			return false;
		}
        mDeviceIP = $(this).parent().attr('ip');
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Send.COM_TV_DELETE_THE_DEVICE_FROM_THE_LIST_YES_NO]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : "closeGenericPopUp"
        }, {
            "btntxt" : COM_SID_OK,
            "callback" : function() {
                thisVal.closest('li').remove();

                if (mDeviceIP != undefined) {
                    deleteDeviceFromDB(mDeviceIP);
                }
            }
        }]);
        genericPopUpObj.showPopUp();
        
    });    


    $("#listContainerId").on('tap', 'li>.nor_checkbox', function(e) {
        e.preventDefault();
        e.stopPropagation();
        if ($(this).hasClass('icon-disabled') == false){
            var listParent = $(this).parent('.auto-LFD-List');
            deviceID = listParent.attr('id');
            deviceIp = listParent.attr('ip');
            var tlsReq = listParent.attr('tls');
            var macAddr = listParent.attr('mac');
            var pin = listParent.attr('pin');
            var devName = listParent.attr('deviceName');
            if (isNull(devName)) {
                devName = listParent.find('div.manual_name div').first().text();
            }
            deviceNameSend = listParent.find('.name div').first().text();
            if (isNull(deviceNameSend) || deviceNameSend == "") {
                deviceNameSend = devName;
            }
            deviceListContainerRef = $(this);
            if (Utils.checkConnection() == 3) {
                 $('#StartsendbtnId').removeClass('icon-disabled');
            }

            mLFDInfo = new mLFDDeviceInfo();
            mLFDInfo.mDeviceIP = deviceIp;
            mLFDInfo.mDeviceId = deviceID;
            mLFDInfo.mDeviceName = devName;
            mLFDInfo.mStatus = INITIALIZE;
            mLFDInfo.mTLSRequired = tlsReq;
            mLFDInfo.mMacAddr = macAddr;
            mLFDInfo.mPin = pin;
            mLFDInfo.isCanceled = false;

            if(tlsReq == '1' && pin.length == 0){
            $('#pin_verification_page_Id').attr('isManual', false);
             //var pinHeaderStr = 'Enter the PIN number for ' + deviceName + '. This process is required only when connecting to the target device for the first time.';
             var pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_ENTER_PIN_NUMBER_FOR.replace("<<A>>", deviceNameSend) + " " + langObj.Send.MIA_SID_20_PROCESS_REQUIRED_CONNECTING_TARGET_FIRST);
             askToEnterCorrectPIN(deviceIp, false, pinHeaderStr);
//                 $('#input_verification_pin').attr('isManual',false);
//                 askToEnterCorrectPIN(deviceIp,false);
//                 $('#pinbox1').focus();
             }else{
               $(this).removeClass('nor_checkbox').addClass('sel_checkbox');
               $('.network-footer>#newconection').removeClass('icon-disabled');
               $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').removeClass('icon-disabled');
            mLFDInfoArrayList.push(mLFDInfo);
        }
        }
        return false;
    });



    $("#listContainerId").on('tap', 'li>.sel_checkbox', function(e) {
               e.preventDefault();
               e.stopPropagation();
               var deviceParentElementObj = $(this).parent('.auto-LFD-List');
               deviceID = deviceParentElementObj.attr('id');
               deviceIp = deviceParentElementObj.attr('ip');
               var tlsReq = deviceParentElementObj.attr('tls');
               var macAddr = deviceParentElementObj.attr('mac');
               var pin = deviceParentElementObj.attr('pin');
               var devName = deviceParentElementObj.attr('deviceName');
               $(this).removeClass('sel_checkbox').addClass('nor_checkbox');

               var mLFDInfo = new mLFDDeviceInfo();
               mLFDInfo.mDeviceIP = deviceIp;
               mLFDInfo.mDeviceId = deviceID;
               mLFDInfo.mDeviceName = devName;
               mLFDInfo.mTLSRequired = tlsReq;
               mLFDInfo.mMacAddr = macAddr;
               mLFDInfo.mPin = pin;
               mLFDInfo.mStatus = INITIALIZE;
               mLFDInfo.isCanceled = false;
               mLFDInfoArrayList.pop(mLFDInfo);
               if (mLFDInfoArrayList.length < 1) {
                   $('.network-footer>#newconection').addClass('icon-disabled');
                   $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').addClass('icon-disabled');
               }
               return false;
           });


    $("#listContainerId").on('tap', 'li>.cancel_checkbox', function() {
        if (isSyncingSend) {
            return;
        }
        $(this).addClass('icon-disabled');
        deviceID = $(this).parent('.auto-LFD-List').attr('id');

        // CANCEL INDIVISUAL SEND
        for (var index = 0; index < mLFDInfoArrayList.length; index++) {
            if (mLFDInfoArrayList[index].mDeviceId == deviceID) {
                var previousStatus = -1;
                mLFDInfoArrayList[index].isCanceled = true;
                if (mLFDInfoArrayList[index].mStatus == INITIALIZE) {
                    previousStatus = INITIALIZE;
                    mLFDInfoArrayList[index].mStatus = CANCEL;
                    isCanceled = true;
                    showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
                    if (previousStatus == INITIALIZE || !Utils.isIOSDvice()) {
                        setTimeout(function() {
                            isCanceled = false;
                            preUploadCancel(deviceID);
                        }, 500);
                    }
                } else {
                    isCanceled = true;
                    showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
                }

                if (previousStatus != INITIALIZE && Utils.isIOSDvice()) {
                    setTimeout(function() {
                        var successCallBack = function() {
                            setTimeout(function() {
                                isCanceled = false;
                                preUploadCancel(deviceID);
                                var mMaxIndex = mLFDInfoArrayList.length - 1;
                                updateGUIOnCancel(mMaxIndex, deviceID, CONNECTION_TYPE_SCHEDULE_UPLOAD);
                            }, 500);
                        };

                        var errorCallBack = function() {
                            console.log("error");
                        };

                        mUtilityManager.cancelButtonTappedInUI(successCallBack, errorCallBack);
                    }, 2000);
                }
                break;
            }
        }
    });



    $("#send_preBtnId").on('click', function() {
        if (isBackPressOn) {
            cancelCurrentSendPrev();
            return;
        } else {
            mProtocolManager.stopAutoDiscoveryService();
            window.location.href = "../schedule/Schedule.html?schedulePath=" + schedulePath + "&scheduleName=" + scheduleName + "&navigateFromSchedule=" + navigateFromSch + "&navigateFromTemplate=" + navigateFromTemp + "&category=" + category;
        }
    });



    // RESEND BUTTON CLICKED SCENARIO
    $('#resendBtnId').on('tap', function() {
        if ($(this).hasClass('icon-disabled')) {
            return false;
        }

        $('.network-footer-two').hide();
        $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);
        $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);        

        processButton();

        $('.network-footer>#newconection').text(langObj.Send.COM_SID_CANCEL);
        $('.network-footer').show();

        isBackPressOn = false;
        return false;
    });

    // SMALL CANCEL BUTTON NOW ( GO TO HOME)
    $('#cancelBtnId').on('click', function() {
        document.location.href = '../quickstart/QuickStart.html';

    });

    $('#Title>#LoadercontainerId').on('tap', function() {
        if ($(this).hasClass('icon-disabled') || isWiFiEnabled == false) {
            return false;
        }
        refreshList();
        // Re-adjust start send button
        $('.network-footer').show();
        $('.network-footer-two').hide();
        $('.network-footer>#newconection').addClass('icon-disabled');
    });

    $('.network-footer>#newconection').on('tap', function(e) {
    	console.log("Click $(this).hasClass('icon-disabled')"+$(this).hasClass('icon-disabled'));
        if($(this).hasClass('icon-disabled'))
    	{
    		return false;
    		e.stopPropagation();
    	}else{
    		processButton();
    	}
    });

    /*
     * Send Manual list delete handler*
     * Added by Pradeep on 9Mar
     */

    $('ul#list').on('tap', '.del_manual_ip', function(e) {
        e.stopPropagation();
        var thisVal = $(this);
        var mDeviceIP = $(this).parent().attr('ip');
        console.log("@@@@@ deviceip @@@@@ : " + mDeviceIP);
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Send.COM_TV_DELETE_THE_DEVICE_FROM_THE_LIST_YES_NO]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : "closeGenericPopUp"
        }, {
            "btntxt" : COM_SID_OK,
            "callback" : function() {
                thisVal.closest('li').remove();

                if (mDeviceIP != undefined) {
                    deleteDeviceFromDB(mDeviceIP);
                }
            }
        }]);
        genericPopUpObj.showPopUp();

    });

    //Ip Focus and blur handle here

    $('.iptext').focus(function(e) {
        $('.ip-wrapper').addClass('ip-focus');

        // type of device check
        if (deviceModel != undefined) {
            var temp;
            temp = deviceModel.slice(0, 5);
            deviceModel = temp;
        }
        // iPad3 is not working animation
        if (deviceModel == 'iPad3') {
            svgDoc[0].pauseAnimations();
            svgDoc[1].pauseAnimations();
            svgDoc[2].pauseAnimations();
            svgDoc[3].pauseAnimations();
        }

    }).blur(function(e) {
        $('.ip-wrapper').removeClass('ip-focus');
        if (deviceModel == 'iPad3') {
            svgDoc[0].unpauseAnimations();
            svgDoc[1].unpauseAnimations();
            svgDoc[2].unpauseAnimations();
            svgDoc[3].unpauseAnimations();
        }
    });

    $(document).on('input', '.iptext', function(e) {
        var specialChars = '*\"\\/?|<>+×÷=%??�¥₩@#$^&()\';!,`~{}[]?�○?�□?�♤?�♢?�☆?�°•¤《》�??�›₹';
        var AddsendIpValue = "";

        var name = $(this).val();
        for ( i = 0; i < specialChars.length; i++) {
            if (name.indexOf(specialChars[i]) > -1) {
                name = name.replace(specialChars[i], '');
            }
        }
        $(this).val(name);

        AddsendIpValue = $('#firmIpbox1').val().trim();
        console.log("AddsendIpValue in send: " + AddsendIpValue);
        if (AddsendIpValue == "" || AddsendIpValue == " ") {
            $('#updateenterId').addClass('icon-disabled');
        } else {
            $('#updateenterId').removeClass('icon-disabled');
        }

    });

    $(document).on('tap', '.helpBtnCls', function(e) {
        
        e.preventDefault();
        e.stopPropagation();
        
        if (category == "C") {
            HelpPopUp("CD_STEP13");
        } else {
            HelpPopUp("QS_STEP8");
        }
    });

    /*    Added by Pradeep
     *    Change ipbox to number or tel based on OS type
     *   This is used to trigger the relevant keyboard type
     */
    if (deviceType.toLowerCase() == 'ipad') {
        $('.iptext').attr('type', 'tel');
    } else {
        $('.iptext').attr('type', 'text');
    }

    if (category == 'C') {
        $('#tplContentHeader').hide();
    }

});

function processButton() {
	console.log("@processButton");
    if (isSyncingSend) {
            return;
    }
    isSyncingSend = true;
    addContentArr = [];
    templatePathArray = [];
    var CheckbtnTxt = $('.network-footer>#newconection').text().trim();
    if ($(this).hasClass('icon-disabled')) {
        return false;
    }
  
    if (CheckbtnTxt == langObj.Settings.COM_SID_CANCEL) {
        // CANCEL ALL SEND
        console.log("CANCEL ALL SEND");
        enableDisableDelIcon(true);
        isCanceled = true;
        showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
        for (var index = 0; index < mLFDInfoArrayList.length; index++) {
            mLFDInfoArrayList[index].isCanceled = true;
            $('li#' + mLFDInfoArrayList[index].mDeviceId).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('nor_checkbox');
            $('li#' + mLFDInfoArrayList[index].mDeviceId).find('.checkbox_settings').addClass('icon-disabled');

            if (Utils.isIOSDvice() && ((mLFDInfoArrayList[index].mStatus == DISCONNTED) || (mLFDInfoArrayList[index].mStatus == CONNECTED))) {
                cancelExcutionTask(index, CONNECTION_TYPE_SCHEDULE_UPLOAD);
            }
        }
         isSyncingSend = false;
    } else if (CheckbtnTxt == langObj.Send.COM_TV_SID_HOME) {
        document.location.href = '../quickstart/QuickStart.html';
    } else {// Send button clicked
    	enableDisableDelIcon(false);
        showAnimationLoader();
        showLoader('LoadercontainerId');
        $('.network-footer>#newconection').text(langObj.Send.COM_SID_CANCEL);
        $('.network-footer>#newconection').addClass('icon-disabled');
        isBackPressOn = true;
        $('#Title>#LoadercontainerId>.refresh').addClass('icon-disabled');
        $('.AddsignageCls').show();
        $('.AddsignageCls').addClass('icon-disabled');
        
        // Reset list
        mLFDInfoArrayList = new Array();
        var listItems = $("#list li");
        listItems.each(function(li) {
            var mDeviceId = $(this).attr('id');
            var mDeviceIP = $(this).attr('ip');
            var mTLSReq = $(this).attr('tls');
            var macAddr = $(this).attr('mac'); 
            var pin = $(this).attr('pin');
            var devName = $(this).attr('deviceName');
            if (isNull(devName)) {
                devName = $(this).find('div.manual_name div').first().text();
            }
            var liDeviceID = $('li#' + mDeviceId);
            var eleBoxSettings = liDeviceID.find('.checkbox_settings');
            if (eleBoxSettings.hasClass('sel_checkbox')){
                eleBoxSettings.removeClass('sel_checkbox').addClass('cancel_checkbox');
                liDeviceID.find('.function_icon').removeClass('err_icon');
        
                $('#' + mDeviceId).removeClass('send-failed');
                mDeviceIP = mDeviceIP.trim();
                /*mDeviceIP = mDeviceIP.split(".").map(function(i) {
                    return parseFloat(i);
                }).join(".");*/
                var mLFDInfo = new mLFDDeviceInfo();
                mLFDInfo.mDeviceIP = mDeviceIP;
                mLFDInfo.mDeviceId = mDeviceId;
                mLFDInfo.mDeviceName = devName;
                mLFDInfo.mTLSRequired = mTLSReq;
                mLFDInfo.mMacAddr = macAddr;
                mLFDInfo.mPin = pin;
                mLFDInfo.mStatus = INITIALIZE;
                mLFDInfo.isCanceled = false;
                mLFDInfo.mMetaInfo = "";
                mLFDInfoArrayList.push(mLFDInfo);                
            }

            if (eleBoxSettings.hasClass('nor_checkbox')){
                eleBoxSettings.addClass('icon-disabled');
            }
        });
        
        if (mLFDInfoArrayList.length > 0) {
            if (Utils.isIOSDvice() && (Utils.checkConnection() != 3)) {
                setTimeout(function() {
                    genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_FAILED_CONNECT_TO_NETWORK_INTERNET_CONNECTION_UNSTABLE]);
                }, 500);
            } else {
                try{
                    templatePathArray = [];
                    templatePathArray = JSON.parse(window.localStorage.getItem("templatePathList"));
                    subFolder = JSON.parse(window.localStorage.getItem("subFolder"));
                    templateIndex = 1;
                    addContentArr.push(templatePathArray[0]);
		    		    
		    uploadJsonLastIndex = globlePlayerType;/* RMD_MODEL = 1, RHE_MODEL = 2, STRETCH_MODEL = 3, TIZEN_MODEL = 4, TIZEN_S5 = 5, TIZEN_S6 = 6 */
                    uploadJsonCount = TIZEN_S6; /*Starting index 6 */
                    templateParser();
               }catch(e){
                       console.log("Parsing fail error found: "+e);
                       isSyncingSend = false;
                       loaderObj.hideLoader();
                       enableDisableDelIcon(true);
                       setTimeout(function() {
                        genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_UNABLE_TO_FIND_FILE_SCHEDULE]);
                    }, 500);
               }
            }
        }
    }
}

function initProgressBar(deviceID) {
    console.log("@initProgressBar :  " + deviceID);
    var progressBarDiv = $("<div>");
    progressBarDiv.attr('id', "slider" + deviceID + "");

    progressBarDiv.appendTo('#list>li#' + deviceID);
    $("#slider" + deviceID).css({
        "height" : Liheight + "px",
        "width" : 0 + "px",
        "position" : "absolute ",
        "left" : "0px ",
        "background" : "rgba(49, 150, 255,0.9)"
    });
}

function updateExportProgressBar(mDeviceId, progressVal) {
    console.log("@updateExportProgressBar: DeviceId: " + mDeviceId + " , ProgressVal: " + progressVal);
    $("#slider" + mDeviceId).css({
        'width' : progressVal + '%'
    });
}

function showDeviceListInNetwork(result) {
    console.log("@ showDeviceListInNetwork : ");
    $('#listContainerId').addClass('haslistCls');
    $('#list').addClass('addborderTop');
    $('.addNoDeviceMsgCls').hide();
    if (result == undefined) {
        refreshList();
        return;
    }
    try {
        isReady = true;
        var device_name = "";
        var device_ip = "";
        var device_storage_type = "";
        var total_space = "";
        var available_space = "";
        var listItem = "";
        var storageInfo = "";
        var connectStatus = "";
        var device_type = "";
        var firmware_version = "";
        var mac_address = "";
        var tls_required = "";
        var pin = "";

        $('#list > li.auto-LFD-List').remove();
        $('#list').html('');
        mDeviceListInfo = new Array();
        mLFDInfoArrayList = new Array();

        // Device Info list
        myDeviceInfoJson = {};
        myDeviceInfoArr = [];
        myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
        var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));

        // reset previous store device UI
        var listLen = myDeviceInfoJson != null ? myDeviceInfoJson.myDeviceInfoArrs.length : 0;
        if (listLen > 0) {
            for (var k = 0; k < listLen; k++) {
                var ip = myDeviceInfoJson.myDeviceInfoArrs[k].DeviceIP;
                var Status = myDeviceInfoJson.myDeviceInfoArrs[k].DeviceName;
                updateDeviceState(ip, Status, STATE_FAIL_CONNECTION);
            }
            getDeviceInfo();
        }

        for (var i = 0; i < result.length; i++) {

            device_name = result[i].device_name;
            device_ip = result[i].device_ip;
            device_type = result[i].device_type;
            connectStatus = result[i].connect_status;
            device_storage_type = result[i].storage_type;
            total_space = result[i].total_space;
            available_space = result[i].available_space;
            total_space = result[i].total_space;
            firmware_version = result[i].firmware_version;
            mac_address = result[i].mac_address;
            tls_required = result[i].tls_required;
            pin = "";
	    
            if(mac_address!=null && mac_address.length>0){
              pin = Utils.getMacPinValue(mac_address);
                }
            // DEVICE NAME
            if (device_name != null && device_name != undefined) {
                device_name = device_name.trim();
            }
            // DEVICE IP
            if (device_ip != null && device_ip != undefined) {
                device_ip = device_ip.trim();
            }

            console.log("Refresh: device_name: " + device_name + ",device_ip: " + device_ip + " ,connection_staus: " + connectStatus + " , device_type: " + device_type + ",storage_type: " + device_storage_type + "available_space: " + available_space + ", total_space: " + total_space + ", firmware_version: " + firmware_version);

            var deviceState = 1;
            var isAlreadyExist = false;
            // Device Info list
            myDeviceInfoJson = {};
            myDeviceInfoArr = [];
            myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
            var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
            listLen = myDeviceInfoJson != null ? myDeviceInfoJson.myDeviceInfoArrs.length : 0;
            if (listLen > 0) {
                for (var j = 0; j < listLen; j++) {
                    var dicoverIP = device_ip.trim();
                    var dbIP = myDeviceInfoJson.myDeviceInfoArrs[j].DeviceIP.trim();
                    console.log("Refresh: DB IP: " + dbIP + "  ,  dicoverIP: " + dicoverIP);
                    if (dicoverIP == dbIP) {
                        //alert("Device IP match: "+dicoverIP);

                        isAlreadyExist = true;
                        console.log("Refresh:  existed IP device_type: " + device_type);
                        if (device_type != undefined) {
                            device_type = device_type.trim();
                        }
                        var mPlayerId = Utils.getPlayerTypeWithModelCode(device_type);
                        mPlayerId = parseInt(mPlayerId);
                        console.log("Refresh: LFD player type: " + mPlayerId + " : Active Player Type: " + globlePlayerType);
                        //alert("Send: isAlreadyExist: Discovered PlayerId: "+mPlayerId+" , Active PlayerId: "+ globlePlayerType);
                        if (isValidPlayer(mPlayerId,globlePlayerType) && firmware_version != undefined && firmware_version != undefined && firmware_version.length > 0) {
                            //alert("Device IP match: "+"Supported");
                            // Supported
                            console.log("Refresh: Incase of manually supported");
                            updateDeviceFromDB(device_name, device_ip, connectStatus, device_storage_type, total_space, available_space, firmware_version, mPlayerId,STATE_SUPPORTED,mac_address,tls_required,pin);
                        } else if (isValidPlayer(mPlayerId,globlePlayerType)) {
                            // Update Required
                            //    alert("Device IP match: "+"Update Required");
                            console.log("Refresh: Incase manually Update Required");
                            updateDeviceFromDB(device_name, device_ip, connectStatus, device_storage_type, total_space, available_space, firmware_version, mPlayerId,STATE_UPDATE_REQ,mac_address,tls_required,pin);
                        } else {
                            // Not Supported
                            console.log("Refresh: Incase manually Not Supported");
                            var UnSupportedPType = Utils.getUnSupportedPlayerType();
                            UnSupportedPType = parseInt(UnSupportedPType);
                            //alert("Device IP match: "+"Not Supported");
                            updateDeviceFromDB(device_name, device_ip, connectStatus, device_storage_type, total_space, available_space, firmware_version, UnSupportedPType,STATE_UNSUPPORTED,mac_address,tls_required,pin);
                        }
                    }
                    if (isAlreadyExist == true) {
                        console.log("Refresh: *** already exist So, break from loop *** ");
                        isAlreadyExist = true;
                        break;
                    }
                }
            }
            var mLFDPlayerType = Utils.getPlayerTypeWithModelCode(device_type);
            if(globlePlayerType == STRETCH_MODEL)
            {
            	globlePlayerType = RHE_MODEL;
            }

         if(isAlreadyExist == false && isValidPlayer(mLFDPlayerType,globlePlayerType)){
             if (firmware_version!=undefined && firmware_version!=null && firmware_version.length > 0) {
                    if (total_space != undefined && total_space == '-1' || available_space == '-1') {
                        device_storage_type = parseInt(device_storage_type);
                        device_storage_type = Utils.getStorageType(device_storage_type);
                        storageInfo = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace('<<A>> (<<B>>/<<C>>)', '') + device_storage_type + " (" + langObj.Send.COM_BDP_SID_DEPTH_TWO_NETWORK_STATUS_NOT_CONNECTED + ")";
                          if(connectStatus == 2 || connectStatus == '2'){
                              listItem += '<li class="auto-LFD-List" id="' + i + '" ip="' + device_ip + '"  tls="' + tls_required + '"  mac="' + mac_address + ' " deviceName="' + device_name + '" pin="'+pin+'" style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo">' + storageInfo + '<span style="color:red;">'+ (langObj.Send.MIA_SID_20_LOCKED)+'</span>'+ '</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                          }else{
                        listItem += '<li class="auto-LFD-List" id="' + i + '" ip="' + device_ip + '" tls="' + tls_required + '"  mac="' + mac_address + '" deviceName="' + device_name + '" pin="'+pin+'" style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo">' + storageInfo + '</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                          }
                    } else {
                        total_space = parseInt(total_space);
                        total_space = Utils.formatBytes(total_space);
                        available_space = parseInt(available_space);
                        available_space = Utils.formatBytes(available_space);
                        device_storage_type = parseInt(device_storage_type);
                        device_storage_type = Utils.getStorageType(device_storage_type);
                        storageInfo = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace("<<A>>", device_storage_type).replace("<<B>>", available_space).replace("<<C>>", total_space);
                        if(connectStatus == 2 || connectStatus == '2'){
                            listItem += '<li class="auto-LFD-List" id="' + i + '" ip="' + device_ip + '" tls="' + tls_required + '"  mac="' + mac_address + '" deviceName="' + device_name + '" pin="'+pin+'" style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo">' + storageInfo + '<span style="color:red;">'+ (langObj.Send.MIA_SID_20_LOCKED) +'</span>'+ '</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                        }else{
                            listItem += '<li class="auto-LFD-List" id="' + i + '" ip="' + device_ip + '" tls="' + tls_required +'"  mac="' + mac_address + '" deviceName="' + device_name + '" pin="'+pin+'" style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo">' + storageInfo + '</div></div><div class="function_icon" ></div><div class="checkbox_settings nor_checkbox"></div></li>';
                        }
                    }
                } else {
                    storageInfo = langObj.Settings.MIS_SID_UPDATE_REQUIRED;
                    listItem += '<li class="auto-LFD-List UpdateRq" id="' + i + '" ip="' + device_ip + '" tls="' + tls_required +'"  mac="' + mac_address + '" deviceName="' + device_name + '" pin="'+pin+'" style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo" style="color:#eb6262;">' + storageInfo + '</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                }

                if (i == result.length - 1) {
                    $('#list>li:last').css({
                        'border-bottom' : 'solid #c7c7c7 1px'
                    });
                }
            }//isAlreadyExist
        }// for loop

        //////////////////// UPDATE DB STORAGE LIST ////////////////////
        setTimeout(function() {
            myDeviceInfoJson = {};
            myDeviceInfoArr = [];
            myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
            var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));

            addmanualListIndex = result.length - 1;
            listLen = myDeviceInfoJson != null ? myDeviceInfoJson.myDeviceInfoArrs.length : 0;
            if (listLen > 0) {
                for (var i = 0; i < listLen; i++) {
                    var curPin = Utils.getMacPinValue(myDeviceInfoJson.myDeviceInfoArrs[i].MacAddress);
                    var myDvcInfoDic = myDeviceInfoJson.myDeviceInfoArrs[i];
                    addManuallyDevice(STATE_REFRESHING, myDvcInfoDic.DeviceState, myDvcInfoDic.ConnectionStatus, myDvcInfoDic.DeviceIP, myDvcInfoDic.DeviceName, myDvcInfoDic.StorageType, myDvcInfoDic.TotalSpace, myDvcInfoDic.AvailableSpace, myDvcInfoDic.Version, myDvcInfoDic.PlayerType,myDvcInfoDic.MacAddress,myDvcInfoDic.TLSReq,curPin);
                }
            }
            $('#list').show();
            $('#list').append(listItem);
            $('.AddsignageCls').removeClass('icon-disabled');            

            $('.network-footer>#newconection').addClass('icon-disabled');
            hideLoader('LoadercontainerId');
            Liheight = $('#list >li').height();
            Liwidth = $('#list >li').width();

            if ($('#list>li').length < 1) {
                isReady = true;
                $('#list').removeClass('addborderTop');
                $('#listContainerId').removeClass('haslistCls');
                $('.addNoDeviceMsgCls').text(langObj.Settings.MIA_SID_NO_DEVICE_SEARCH_AGAIN);
                $('.addNoDeviceMsgCls').show();
            }

        }, 2000);
        ///////////////////// END //////////////////////////////////////

    }
    catch(e) {
        console.log("error: "+e);
        console.log("******* Error While Discovery: " + e);
        hideLoader('LoadercontainerId');
    }
    Liheight = $('#list >li').height();
    Liwidth = $('#list >li').width();
}


function clearProgressBar(mDeviceId) {
    $("#slider" + mDeviceId).html('');
    $("#slider" + mDeviceId).remove();
}

function uploadFailed(mDeviceId, mMaxIndex) {
    console.log("@uploadFailed");
    /*sending fail animation*/
    isSendingFail = true;
    $('#Connect_LFD').css('display', 'none');
    $('#Sending_complete').css('display', 'none');
    $('#' + mDeviceId).addClass('send-failed');
    $('li#' + mDeviceId).find('.function_icon').removeClass('del_icon').addClass('err_icon');    
    $('li#' + mDeviceId).find('.checkbox_settings').removeClass('cancel_checkbox').removeClass('dim_checkbox').addClass('nor_checkbox');
    mLFDInfoArrayList[mMaxIndex].mStatus = FAIL;
    mProtocolManager.stopConnectionService();
    //updateExportProgressBar(mDeviceId,0);
    clearProgressBar(mDeviceId);
}


// While Schedule upload completed
function uploadCompleteSuccess(mMaxIndex) {
	console.log("@uploadCompleteSuccess");
    /*sending success animation*/
    mProtocolManager.stopConnectionService();
    $('#Connect_LFD').css('display', 'none');
    $('#Sending_failure').css('display', 'none');
    mLFDInfoArrayList[mMaxIndex].mStatus = DONE;
    
    $('li#' + mLFDInfoArrayList[mMaxIndex].mDeviceId).find('.checkbox_settings').removeClass('cancel_checkbox').removeClass('dim_checkbox').addClass('com_icon');
    
    //updateExportProgressBar(mLFDInfoArrayList[mMaxIndex].mDeviceId,0);
    clearProgressBar(mLFDInfoArrayList[mMaxIndex].mDeviceId);
    //update status in DB
    updateInScheduleDB(true);
    
}

function updateInScheduleDB(status) {
    
    var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
    var currSchName = decodeURIComponent(scheduleName);
    $.each(myScheduleInfo.myScheduleInfoArrs, function(index, value) {

        if (currSchName == value.scheduleName) {
            var scheduleName = value.scheduleName;
            var scheduleFilePath = value.scheuleFilePath;
            var scheuleThumbNailPath = value.scheuleThumbNailPath;
            var scheduleId = value.scheduleId;
            updateScheduleFromDB(scheduleName, scheduleFilePath, scheuleThumbNailPath, status);

        }
    });

}

// All upload completed
function allUploadFinish() {
	console.log("@allUploadFinish");
    hideLoader('LoadercontainerId');
    mProtocolManager.stopConnectionService();
    mLFDInfoArrayList = new Array();
    var checkforcheckbox = new Array();
    var listItems = $("#list li");
    listItems.each(function(li) {
    	var mDeviceId = $(this).attr('id');
    	var storageInfoText = $('li#' + mDeviceId).find('.storageInfo').text();
    	var checkboxSettings = $('li#' + mDeviceId).find('.checkbox_settings');
        if (storageInfoText == langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE ||
        		storageInfoText == langObj.Settings.MIS_SID_NOT_SUPOORT ||
        		storageInfoText == langObj.Settings.MIS_SID_UPDATE_REQUIRED ||
        		storageInfoText.indexOf(langObj.Send.MIA_SID_20_LOCKED) != -1||
        		storageInfoText.indexOf(langObj.Send.COM_BDP_SID_DEPTH_TWO_NETWORK_STATUS_NOT_CONNECTED) != -1
        		){
        	    checkboxSettings.addClass('dim_checkbox');
        } else {
            if (checkboxSettings.hasClass('com_icon') == false ){
            	checkboxSettings.removeClass('cancel_checkbox').removeClass('icon-disabled').addClass('nor_checkbox');
            }
        }
    });
    
    $('.network-footer').hide();
    $('.network-footer-two').show();
    $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').addClass('icon-disabled');
    $('.network-footer>#newconection').addClass('icon-disabled');
    

    if (isSendingFail) {
        $('#TitletxtId').html(langObj.Send.COM_TV_SENDING_COMPLETE);
    } else {
        $('#TitletxtId').html(langObj.Send.MIA_SID_SENT_SUCCESSFULLY_KR_SENT);
    }
	enableDisableDelIcon(true);

    isBackPressOn = false;
    $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').addClass('icon-disabled');
    $('#Title>#LoadercontainerId>.refresh').removeClass('icon-disabled');
    $('.AddsignageCls').show();
    $('.AddsignageCls').removeClass('icon-disabled');
}

// Reset cancel GUI
function resetCancelUI(mCheckAllCancel) {
	console.log("@resetCancelUI");
    hideLoader('LoadercontainerId');
    isCanceled = false;
    var listItems = $("#list li");
    listItems.each(function(li) {
        var mDeviceId = $(this).attr('id');
        var checkBoxDiv = $('#list>li>.icon>.check_box>#' + mDeviceId + '.check');
        if ((checkBoxDiv.attr('src') != "../resource/img/ic_check_send_dim.png") && (checkBoxDiv.attr('src') == "../resource/img/ic_check_n.png" || checkBoxDiv.attr('src') == "../resource/img/ic_check_d.png")) {
            checkBoxDiv.attr('src', "../resource/img/ic_check_n.png");
            checkBoxDiv.removeClass('icon-disabled');
        }
    });

    if (mCheckAllCancel == 0) {
        mLFDInfoArrayList = new Array();
        $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);
        $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
        isBackPressOn = false;
    } else {
        $('.network-footer>#newconection').text(langObj.Send.COM_TV_SID_HOME);
    }
    $('#Title>#LoadercontainerId>.refresh').removeClass('icon-disabled');
    $('.network-footer>#newconection').addClass('icon-disabled');
    $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').addClass('icon-disabled');
    $('.AddsignageCls').show();
    $('.AddsignageCls').removeClass('icon-disabled');
    mProtocolManager.stopConnectionService();
    setTimeout(function(){
    	loaderObj.hideLoader();
    },8000);
   
}

// update upload cancel GUI
function uploadCancel(deviceID) {
	console.log("@ uploadCancel: "+deviceID);
    isCanceled = false;
    console.log("@update cancel : " + deviceID);    
    clearProgressBar(deviceID);
    $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox icon-disabled').addClass('nor_checkbox');
    if (mLFDInfoArrayList.length <= 1) {
        allUploadFinish();
    }
    console.log("finally cancelled called");
    hideLoader('LoadercontainerId');
    setTimeout(function(){
    	loaderObj.hideLoader();
    },8000);
}

// update upload cancel GUI
function preUploadCancel(deviceID) {
    console.log("@preUploadCancel");
    isCanceled = false;
    console.log("@update cancel : " + deviceID);
    if (mLFDInfoArrayList.length > 1) {
        $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('icon-disabled nor_checkbox');
    } else {
        allUploadFinish();
        $('li#' + deviceID).find('.checkbox_settings').addClass('nor_checkbox');
        $('#Title>#LoadercontainerId>.refresh').removeClass('icon-disabled');
       var doneStatus = titleGUIUpdateCancel();
       if(doneStatus == 1){
            $('#TitletxtId').html(langObj.Send.MIA_SID_SENT_SUCCESSFULLY_KR_SENT);
       }else{
            $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
        }

    }
    loaderObj.hideLoader();
}

function templateParser() {
    
    if (templateIndex < templatePathArray.length) {
        uploadTemplate(templatePathArray[templateIndex], subFolder);
    } else {
        //var Jsonobj = new Object();
        var Jsonobj = new Object();
        if(LOWER_PLAYER_TYPE_SUPPORT){
            Jsonobj.exportfile = {
                uploadFiles_S6 : addContentArr_S6,
                uploadFiles_S5 : addContentArr_S5,
                uploadFiles_S4 : addContentArr_S4,
                uploadFiles_S3 : addContentArr_S3,
                uploadFiles_E : addContentArr_E
            };
        }else{
            Jsonobj.exportfile = {
                uploadFiles : addContentArr
            };
        }
        var mMetaInfo = JSON.stringify(Jsonobj);
        $('#TitletxtId').empty();
        $('#TitletxtId').html(langObj.Send.MIA_SID_20_SENDING_IN_PROGRESS);
        
        // TO START PUBLISH CONTENT
        if (mLFDInfoArrayList.length > 0) {
            for(var i=0; i<mLFDInfoArrayList.length; i++){
               mLFDInfoArrayList[i].mMetaInfo = mMetaInfo;
            }
            if (checkingID != null) {
                $('li#' + checkingID).find('.storageInfo').html(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                checkingID = null;
            }
            isSendingFail = false;
            // Publish increasing order
            mLFDInfoArrayList.reverse();
            $('.network-footer>#newconection').text(langObj.Send.COM_SID_CANCEL);
            $('.network-footer>#newconection').removeClass('icon-disabled');
            mProtocolManager.initNetworkConnection(CONNECTION_TYPE_SCHEDULE_UPLOAD);
            isBackPressOn = true;
            $('#Title>#LoadercontainerId>.refresh').addClass('icon-disabled');
            $('.AddsignageCls').show();
            $('.AddsignageCls').addClass('icon-disabled');
        }
    }
       setTimeout(function(){
           // Complete sending initiated...
           isSyncingSend = false;
           console.log("********* Ready hide loader for sending ************");
           loaderObj.hideLoader();
        },1000);
}

function onBackkeyDown() {

    var el = document.getElementById("_coachmarkpopUpId");
    if (el != null && el.style.display == "block") {
        closeCoachmarkGenericPopUp();
        return;
    }

    if ( $('#Add_SinageTV_Close_Btn_ID').is(':visible') )
    {
        $('#Add_SinageTV_Close_Btn_ID').tap();
        return;
    }

    if (genericPopUpObj.isPopUpVisible()) {
         genericPopUpObj.hidePopUp();   
        return;
    }

    if (genericNumericKeyboard.isPinVerificationPageOpen()) {
        numericKeyboardButtonPressed("Cancel");
        return;
    }

    if (isBackPressOn) {
        cancelCurrentSendPrev();
        return;
    }

    if (isCanceled) {
        return;
    }

    mProtocolManager.stopAutoDiscoveryService();
    //document.location.href = '../quickstart/QuickStart.html';
    window.location.href = "../schedule/Schedule.html?schedulePath=" + schedulePath + "&scheduleName=" + scheduleName + "&navigateFromSchedule=" + navigateFromSch + "&navigateFromTemplate=" + navigateFromTemp + "&category=" + category;
}

function noDeviceFound() {

    myDeviceInfoJson = {};
    myDeviceInfoArr = [];
    myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
    var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
    $('#list').html('');
    addsendmanuallist = 0;
    //reset
    var arrLen = myDeviceInfoJson != null ? myDeviceInfoJson.myDeviceInfoArrs.length : 0;
    if (arrLen > 0) {
        for (var i = 0; i < arrLen; i++) {
            var myDvcInfoDic = myDeviceInfoJson.myDeviceInfoArrs[i];
            addManuallyDevice(STATE_REFRESHING, myDvcInfoDic.DeviceState, myDvcInfoDic.ConnectionStatus, myDvcInfoDic.DeviceIP, myDvcInfoDic.DeviceName, myDvcInfoDic.StorageType, myDvcInfoDic.TotalSpace, myDvcInfoDic.AvailableSpace, myDvcInfoDic.Version, myDvcInfoDic.PlayerType,myDvcInfoDic.MacAddress,myDvcInfoDic.TLSReq,"");
        }
    } else {
        isReady = true;
        $('#list').removeClass('addborderTop');
        $('#listContainerId').removeClass('haslistCls');
        $('.addNoDeviceMsgCls').text(langObj.Settings.MIA_SID_NO_DEVICE_SEARCH_AGAIN);
        $('.addNoDeviceMsgCls').show();
    }

    isReady = true;
    hideLoader('LoadercontainerId');
	if(isWiFiEnabled)
	{
		$('.AddsignageCls').removeClass('icon-disabled');
	}
	else
	{
		$('.AddsignageCls').addClass('icon-disabled');
	}
    $('#list').show();

}

function ValidIPEnter() {
    var AddIpValue = 0;
    AddIpValue = $('#ipbox1').val().trim();
    if (Utils.checkIP(AddIpValue) && AddIpValue != "...") {
        /*AddIpValue = AddIpValue.split(".").map(function(i) {
            return parseFloat(i);
        }).join(".");*/
	AddIpValue = Utils.removeZeros(AddIpValue);
        // checking Unique IP
        var isIPUnique = false;
        var listItems = $("#list li");
        listItems.each(function(li) {
            var mDeviceIP = $(this).attr('ip');
            mDeviceIP = mDeviceIP.trim();
            if (mDeviceIP == AddIpValue) {
                isIPUnique = true;
                return false;
            }
        });
        if (!isIPUnique) {
            if (checkingID != null) {
                $('#list>li#' + checkingID).find('.storageInfo').html(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                checkingID = null;
            }
            $('.iptext').val('');
            $('#view-send').show();
            $('#send_manually_add-ipID').hide();
            $('#send_manually_add-ip-panel').hide();
            addManuallyDevice(STATE_INIT, STATE_INIT, 'false', AddIpValue, AddIpValue, '', '', '', '', globlePlayerType,"",0,"");
        } else {
            setTimeout(function() {
                $('.AddsignageCls').show();
                $('.iptext').blur();
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Schedule.MIA_SID_ALREADY_EXISTS_LIST]);
            }, 500);
        }

    } else {
        //alert("AddIpValue"+AddIpValue);
        if (AddIpValue == "...") {
            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        } else if (AddIpValue != "") {
            $('.iptext').val('');
            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        }
        $('.iptext').val('');
        $('.AddsignageCls').hide();
        $('.iptext').blur();
        var AddsendIpValue = $('#ipbox1').val().trim();
        if (AddsendIpValue == "" || AddsendIpValue == " ") {
            $('#updateenterId').addClass('icon-disabled');
        } else {
            $('#updateenterId').removeClass('icon-disabled');
        }

    }
}

function updateWiFiState(wifiState) {
    if (wifiState == WIFI_ENABLED) {
        isWiFiEnabled = true;
        $('#Title>#LoadercontainerId').removeClass('icon-disabled');
        $('.AddsignageCls').show();
        $('.AddsignageCls').removeClass('icon-disabled');
        if (mLFDInfoArrayList.length > 0) {
            $('.network-footer>#newconection').removeClass('icon-disabled');
        } else {
            $('.network-footer>#newconection').addClass('icon-disabled');
        }
        if (isReady) {
            $('.network-footer-two').hide();
            $('.network-footer').show();
            $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);
            $('#list').show();
            $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
        }

    } else if (wifiState == WIFI_DISABLED) {
        isWiFiEnabled = false;
        isBackPressOn = false;
        //$('#list').hide();
        //$('#list').html('');
        $('.AddsignageCls').addClass('icon-disabled');
        mProtocolManager.stopAutoDiscoveryService();
        hideLoader('LoadercontainerId');
        
        $('.network-footer>#newconection').addClass('icon-disabled');
        $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);
        $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
        refreshList();
        setTimeout(function() {
            genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_FAILED_CONNECT_TO_NETWORK_INTERNET_CONNECTION_UNSTABLE]);
			$('#Title>#LoadercontainerId').addClass('icon-disabled');
        }, 500);
        //mProtocolManager.stopAutoDiscoveryService();
    }
}

function refreshList() {
    $('.addNoDeviceMsgCls').text('');
    $('.network-footer>#newconection').addClass('icon-disabled');
    $('.AddsignageCls').show();
    $('.AddsignageCls').addClass('icon-disabled');
    mProtocolManager.startDeviceDiscovery();
    showLoader('LoadercontainerId');
    $('#list').html('');
    //Remove only autmated LFD list
    $('#list > li.auto-LFD-List').remove();
    $('#TitletxtId').html(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE);
    $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);

    /*Play Connect_LFD animation when click the refresh button*/
    if ($("#Connect_LFD").css('display') == "none") {
        $("#ilPcTabletFadeIn")[0].beginElement();
        $('#Connect_LFD').css('display', 'block');
        $('#Sending_content').css('display', 'none');
        $('#Sending_complete').css('display', 'none');
        $('#Sending_failure').css('display', 'none');
    }
}

function failedToUpdateManualIp() {
    loaderObj.hideLoader();
    $('.AddsignageCls').show();
    $('.iptext').blur();
    mProtocolManager.stopConnectionService();
}

function cancelCurrentSend() {
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Send.MIA_SID_LEAVE_PAGE_DATA_STOPPED_PROCEDD]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_CANCEL,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : COM_SID_OK,
        "callback" : function() {
            // stop discovery service
            mProtocolManager.stopAutoDiscoveryService();
            // cancel all sending
            for (var index = 0; index < mLFDInfoArrayList.length; index++) {
                mLFDInfoArrayList[index].isCanceled = true;
            }
            mProtocolManager.stopConnectionService();
            setTimeout(function() {
                document.location.href = "../quickstart/QuickStart.html";
            }, 500);
        }
    }]);
    genericPopUpObj.showPopUp();

}

function cancelCurrentSendPrev() {
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Send.MIA_SID_LEAVE_PAGE_DATA_STOPPED_PROCEDD]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_CANCEL,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : COM_SID_OK,
        "callback" : function() {
            // stop discovery service
            mProtocolManager.stopAutoDiscoveryService();
            // cancel all sending
            for (var index = 0; index < mLFDInfoArrayList.length; index++) {
                mLFDInfoArrayList[index].isCanceled = true;
            }
            mProtocolManager.stopConnectionService();
            setTimeout(function() {
                window.location.href = "../schedule/Schedule.html?schedulePath=" + schedulePath + "&scheduleName=" + scheduleName + "&navigateFromSchedule=" + navigateFromSch + "&navigateFromTemplate=" + navigateFromTemp + "&category=" + category;
            }, 500);
        }
    }]);
    genericPopUpObj.showPopUp();
}

var manualDeviceId = "";
function addManuallyDevice(STATE, deviceState, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion, playerType,macAddr,tlsReq,pin) {

    switch(STATE) {
        case STATE_INIT:
            $('#listContainerId').addClass('haslistCls');
            $('#list').addClass('addborderTop');
            $('.addNoDeviceMsgCls').hide();
            addmanualListIndex++;
            manualDeviceId = addmanualListIndex;
            checkingID = manualDeviceId;
            //tls set according to player type
            var addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" tls="0" pin="" deviceName="' + device_name + '"  style="border-bottom:solid #c7c7c7 1px;"><div class="manual_name"><div>' + device_name + '</div><div class="storageInfo">' + langObj.Settings.COM_TV_SID_CHECKING_DOT_KR_KOR + '</div></div><div class="del_icon function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
            $('#list').prepend(addmanuallist);
            deviceListContainerRef = $('#list>li:first')

            $('.del_icon').authorActiveClass();
            $('.iptext').val('');
            $('.AddsignageCls').show();
            $('.network-footer>#newconection').text(langObj.Send.COM_COMMONCTRL_SEND);
            if (mLFDInfoArrayList.length == 0) {
                $('.network-footer>#newconection').addClass('icon-disabled');
            }
            insertDeviceInfo(device_name, AddIpValue, 'false', '', '', '', '', playerType, STATE_INIT,'','','',macAddr,tlsReq,pin);
            if (Utils.checkConnection() == 3) {
                //mProtocolManager.performIpVerification(AddIpValue);
                showAnimationLoader("");
                setTimeout(function(){
                mProtocolManager.performHandshaking(AddIpValue);
                },1000);
                checkingID = manualDeviceId;
            } else {
                setTimeout(function() {
                    $('li#' + manualDeviceId).find('.storageInfo').text(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                }, 3000);
            }
            break;

        case STATE_REFRESHING:
            $('#listContainerId').addClass('haslistCls');
            $('#list').addClass('addborderTop');
            deviceState = parseInt(deviceState);
            var imgSource = "";
            var deviceStorageStatus = "";
            //alert("Device Type: "+ globlePlayerType +" PlayerType: "+playerType+" deviceState: "+deviceState);
            if (playerType < globlePlayerType && deviceState != STATE_FAIL_CONNECTION && deviceState != STATE_INIT) {
                deviceStorageStatus = langObj.Settings.MIS_SID_NOT_SUPOORT;
            } else {
                deviceStorageStatus = getDeviceStorageInfo(STATE, deviceState, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion);
            }

            addmanualListIndex++;
            manualDeviceId = addmanualListIndex;

             if(connectionStatus == 2 || connectionStatus == '2'){
               deviceStorageStatus = deviceStorageStatus + "<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>";
             }

            var addmanuallist;
            if ( deviceState == STATE_SUPPORTED )
            {
                if(connectionStatus == 2 || connectionStatus == '2'){
                  addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '" style="border-bottom:solid #c7c7c7 1px;"><div class="manual_name"><div>' + device_name + '</div><div class="storageInfo">' + deviceStorageStatus + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                }else{
                 addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '"  mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '" style="border-bottom:solid #c7c7c7 1px;"><div class="manual_name"><div>' + device_name + '</div><div class="storageInfo">' + deviceStorageStatus + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings nor_checkbox"></div></li>';
                }
            }
            else
                addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '"  mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'" deviceName="' + device_name + '" style="border-bottom:solid #c7c7c7 1px;"><div class="manual_name"><div>' + device_name + '</div><div class="storageInfo">' + deviceStorageStatus + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';

            $('#list').prepend(addmanuallist);
            checkingID = null;
            break;

        case STATE_SUPPORTED:
            deviceState = parseInt(STATE_SUPPORTED);
            var deviceStorageStatus = getDeviceStorageInfo(STATE_SUPPORTED, STATE_SUPPORTED, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion);
           
            $('#list>li#' + manualDeviceId+' > .checkbox_settings').addClass("nor_checkbox").removeClass("dim_checkbox");
            $('#list>li#' + manualDeviceId).find('.manual_name > div').html(device_name);
            $('#list>li#' + manualDeviceId).find('.storageInfo').html(deviceStorageStatus);
                
            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, device_storage_type, total_space, available_space, mVersion, playerType, STATE_SUPPORTED,macAddr,tlsReq,pin);
            checkingID = null;
            break;

        case STATE_UNSUPPORTED:
            deviceState = parseInt(STATE_UNSUPPORTED);
            var deviceStorageStatus = getDeviceStorageInfo(STATE_UNSUPPORTED, STATE_UNSUPPORTED, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion);

            $('#list>li#' + manualDeviceId+' > .checkbox_settings').addClass("dim_checkbox").removeClass("nor_checkbox");
            $('#list>li#' + manualDeviceId).find('.manual_name > div').html(device_name);
            $('#list>li#' + manualDeviceId).find('.storageInfo').html(deviceStorageStatus);

            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, device_storage_type, total_space, available_space, mVersion, playerType, STATE_UNSUPPORTED,macAddr,tlsReq,pin);
            checkingID = null;
            break;

        case STATE_UPDATE_REQ:
            deviceState = parseInt(STATE_UPDATE_REQ);
            var deviceStorageStatus = getDeviceStorageInfo(STATE_UPDATE_REQ, STATE_UPDATE_REQ, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion);

            $('#list>li#' + manualDeviceId+' > .checkbox_settings').addClass("dim_checkbox").removeClass("nor_checkbox");
            $('#list>li#' + manualDeviceId).find('.manual_name > div').html(device_name);
            $('#list>li#' + manualDeviceId).find('.storageInfo').css({
                'color' : '#eb6262'
            });
            $('#list>li#' + manualDeviceId).find('.storageInfo').html(deviceStorageStatus);
            
            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, device_storage_type, total_space, available_space, mVersion, playerType, STATE_UPDATE_REQ,macAddr,tlsReq,pin);
            checkingID = null;
            break;

        case STATE_FAIL_CONNECTION:
            deviceState = parseInt(STATE_FAIL_CONNECTION);
            var deviceStorageStatus = getDeviceStorageInfo(STATE_FAIL_CONNECTION, STATE_FAIL_CONNECTION, connectionStatus, AddIpValue, device_name, playerType, device_storage_type, total_space, available_space, mVersion);

            $('#list>li#' + manualDeviceId+' > .checkbox_settings').addClass("dim_checkbox").removeClass("nor_checkbox");
            $('#list>li#' + manualDeviceId).find('.manual_name > div').html(device_name);

            if(connectionStatus == 2 || connectionStatus == '2'){
               deviceStorageStatus = "<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>";
            }
            $('#list>li#' + manualDeviceId).find('.storageInfo').html(deviceStorageStatus);

            
            mProtocolManager.stopConnectionService();
            checkingID = null;
            break;
    }
}


function getDeviceStorageInfo(STATE, deviceState, connectionStatus, AddIpValue, device_name, device_storage_type, total_space, available_space, mVersion) {
    switch(deviceState) {
        case STATE_INIT:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
        case STATE_SUPPORTED:
            if (mVersion != undefined && available_space.length > 0 && total_space.length > 0) {
                if (total_space == '-1' || available_space == '-1') {
                    //alert("total_space: "+total_space+" available_space: "+available_space);
                    device_storage_type = Utils.getStorageType(device_storage_type);
                    //device_storage_type = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace(" <<A>> (<<B>>/<<C>>)", "")+"("+langObj.Send.COM_BDP_SID_DEPTH_TWO_NETWORK_STATUS_NOT_CONNECTED+")";
                    device_storage_type = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace('<<A>> (<<B>>/<<C>>)', '') + langObj.Send.MIA_SID_EXTERNAL + " (" + langObj.Send.COM_BDP_SID_DEPTH_TWO_NETWORK_STATUS_NOT_CONNECTED + ")";
                } else {
                    total_space = parseInt(total_space);
                    total_space = Utils.formatBytes(total_space);
                    available_space = parseInt(available_space);
                    available_space = Utils.formatBytes(available_space);
                    device_storage_type = parseInt(device_storage_type);
                    device_storage_type = Utils.getStorageType(device_storage_type);
                    device_storage_type = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace("<<A>>", device_storage_type).replace("<<B>>", available_space).replace("<<C>>", total_space);
                    //alert("device_storage_type: "+device_storage_type);
                }
            } else {
                device_storage_type = langObj.Settings.MIS_SID_UPDATE_REQUIRED;
            }
            return device_storage_type;
        case STATE_UNSUPPORTED:
            return langObj.Settings.MIS_SID_NOT_SUPOORT;
        case STATE_UPDATE_REQ:
            return langObj.Settings.MIS_SID_UPDATE_REQUIRED;
        case STATE_FAIL_CONNECTION:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
    }
}

function ValidIPEnterUpdate() {

    var AddIpValue = 0;
    AddIpValue = $('#firmIpbox1').val().trim();
    AddIpValue = AddIpValue.trim();
    if (Utils.checkIP(AddIpValue) && AddIpValue != "...") {
        /*AddIpValue = AddIpValue.split(".").map(function(i) {
            return parseFloat(i);
        }).join(".");*/
        var isIPUnique = false;

        var listItems = $("#list li");
        listItems.each(function(li) {
            var mDeviceIP = $(this).attr('ip');
            mDeviceIP.trim();
            if (mDeviceIP == AddIpValue) {
                isIPUnique = true;
                return false;
            }
        });

        if (!isIPUnique) {
            
            if(checkingID != null){
               $('.list>li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
               checkingID = null;
            }

            $('.iptext').val('');
            $('#view-send').show();
            $('#send_manually_add-ipID').hide();
            $('#send_manually_add-ip-panel').hide();   
            addManuallyDevice(STATE_INIT,STATE_INIT,'false',AddIpValue, AddIpValue, '', '', '', '',globlePlayerType,"",0,"");
            
        } else {

            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Schedule.MIA_SID_ALREADY_EXISTS_LIST]);
            }, 500);
            $('.iptext').val('');
        }
    } else {
        if (AddIpValue == "...") {
            setTimeout(function() {
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        } else if (AddIpValue != "...") {
            setTimeout(function() {                
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_SID_IP_ADDRESS_INVALID_CHECK_ENTER]);
            }, 200);
        }
    }
    }
    
function isValidPlayer(playerId,activePlayer){
   if(playerId>=activePlayer){
   	     return true;
     }else{
   	    return false;
    }
}
function enableDisableDelIcon(flag){
	console.log("enableDisableDelIcon flag "+flag);
	if(flag==true){
		console.log("enableDisableDelIcon remove ");
		$('.del_icon').removeClass('icon-disabled');
	}else{
		console.log("enableDisableDelIcon add ");
		$('.del_icon').addClass('icon-disabled');
	}
}

function showPINVerficationPage(pinHeaderStr){
   $('#view-send').hide();
   $('#pin_verification_page_Id').show();
   $('#header-part2_addSignagea').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
   $('#pin_verification_panel').show();
   showGenericKeyboard(pinHeaderStr);
  // $('#pinbox1').focus();
  }

  function hidePINVerficationPage(){
     $('#view-send').show();
     $('#pin_verification_page_Id').hide();
     //$('#header-part2_addSignagea').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
     $('#pin_verification_panel').hide();
    // $('#pinbox1').focus();
    }
	
 function askToEnterCorrectPIN(ip,isManualCon,pinHeaderStr){
     $('#pin_verification_page_Id').attr('isManual',isManualCon);
     showPINVerficationPage(pinHeaderStr);
 }

function updateVerifyPINResult(result,resultType, deviceListContainerRef,pin,isManual){
       mProtocolManager.stopConnectionService();
       loaderObj.hideLoader();

        var mac = deviceListContainerRef.parent('.auto-LFD-List').attr('mac');
        if(mac == undefined){
          mac = deviceListContainerRef.attr('mac');
        }
		 if(isManual == 'true'){
           mac = result.split('>>>>')[6];
       }
         mProtocolManager.requestEncryption(deviceListContainerRef,isManual,mac,pin);
        if(isManual == 'true'){
             ip =  deviceListContainerRef.attr('ip');
             deviceListContainerRef.attr('tls',1);
             deviceListContainerRef.parent('.auto-LFD-List').attr('tls',1);
            // add device in list
            updateManuallyAddedIP(result,ip);
       }else{
          // SUCCESS VERIFICATION //
          console.log("result: "+result);
          deviceListContainerRef.removeClass('nor_checkbox').addClass('sel_checkbox');
          $('.network-footer>#newconection').removeClass('icon-disabled');
          $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').removeClass('icon-disabled');
      }
}

function updateEncryptedInfo(refId,isManual,pin){
    refId.attr('pin',pin); // new added
    refId.parent('.auto-LFD-List').attr('pin',pin);
    if(isManual == false){
      mLFDInfo.mPin = pin;
      mLFDInfoArrayList.push(mLFDInfo);
    }
}


function wrongPinGuiUpdate(result,resultType, deviceListContainerRef,pin,isManual){
        var ip =  deviceListContainerRef.attr('ip');
        if(ip == undefined){
         ip = deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
        }
         var pinHeaderStr;
         if(isManual == 'true'){
            pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_INVALID_ENTER_PIN_FOR_AGAIN.replace("<<A>>", ip));
         }
         else{
             pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_INVALID_ENTER_PIN_FOR_AGAIN.replace("<<A>>", deviceNameSend));
         }
        askToEnterCorrectPIN(ip, isManual, pinHeaderStr);
}

function doPinVerificationProcess(pinVal) {
        $('.pintext').blur();
         setTimeout(function(){

           var ip =  deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
           if(ip==undefined){
               ip =  deviceListContainerRef.attr('ip');
           }

           //var pinVal = $('#pinbox1').val().trim() + $('#pinbox2').val().trim() + $('#pinbox3').val().trim() + $('#pinbox4').val().trim();
           $('.pintext').val('');
           $('#view-send').show();
           $('#pin_verification_page_Id').hide();
           $('#pin_verification_panel').hide();
           pinVal = pinVal.trim();
           showAnimationLoader("");
           var isManual = $('#pin_verification_page_Id').attr('isManual');
           mProtocolManager.verifyPINInfo(ip,3,pinVal,deviceListContainerRef,isManual);
        },400);
}

function updatecheckBoxBlock(refID)
{
        var $parentLi = refID.parent();
        if(refID.hasClass('nor_checkbox')){
            refID.removeClass('nor_checkbox').addClass('dim_checkbox');
        }else if(refID.hasClass('sel_checkbox')){
        refID.removeClass('sel_checkbox').addClass('dim_checkbox');
        }
        $parentLi.find('.storageInfo').append("<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>");
}

function cancelPinPopUpButtonPressed()
{
    var ip =  $('#listContainerId>#list>li').first().attr('ip');
    var mac_addr = $('#listContainerId>#list>li').first().attr('mac');
    mProtocolManager.stopConnectionService();
    addManuallyDevice(STATE_FAIL_CONNECTION, STATE_FAIL_CONNECTION, '0', ip, ip, '', '', '', '', globlePlayerType,mac_addr,1,"");
}
/* Either incase pin wrong reset the list pin info*/
function updatePinInDeviceList(mMaxIndex)
{
        var mDeviceId = mLFDInfoArrayList[mMaxIndex].mDeviceId;
        var isPinEmpty = Utils.getMacPinValue(mLFDInfoArrayList[mMaxIndex].mMacAddr);
        if(isPinEmpty.length == 0){
           $('li#' + mDeviceId).attr('pin',"");
        }
}
function titleGUIUpdateCancel()
{
    var locFlag = 0;
    for (var index = 0; index < mLFDInfoArrayList.length; index++) {
        if(mLFDInfoArrayList[index].mStatus == DONE)
            {
                locFlag = 1;
                break;
            }
        }
    return locFlag;
}
