var DLiheight;
var DLiwidth;
var FontLiHeight;
var FontwiHeight;
var isDesignElement = false;
var EnglishFontID = "";
var mDownloadedEngFontPath = Utils.rootPath + "/Fonts/Downloads/english";
var mFontInfo = function() {
    this.mFontFileName = null;
    this.mFontFilePath = null;
    this.mFontFileType = null;
    this.mFontFileUrl = null;
};
var mDownloadedFontList = new Array();

//************* Font****************/
function createFontList() {
    isDesignElement = false;
    var fontLiItem = "";
    var fontLiItem_download = "";
    $('.ui-collapsible-inset .ui-collapsible-heading .ui-btn').css({
        "width" : "90%"
    });
    //
    var myFontElementsInfoJson = JSON.parse(sessionStorage.getItem("FontElements_INFO"));
    for (var i = 0; i < myFontElementsInfoJson.myFontElementsInfoArr.length; i++) {

        if (myFontElementsInfoJson.myFontElementsInfoArr[i].DesignElementsStatus == 1) {

            fontLiItem_download += '<li data-icon="false" id="DownloadedFont_' + myFontElementsInfoJson.myFontElementsInfoArr[i].id + '"  style="border-bottom:solid rgba(0,0,0,0.2) 1px;" url="' + R_SITE_BASE_URL + myFontElementsInfoJson.myFontElementsInfoArr[i].DesignElementsUrl + '" path="' + myFontElementsInfoJson.myFontElementsInfoArr[i].DesignElementsPath + '"><a class="ui-btn"><div class="font-list-li">English Fonts</div><div class="edit-section"><div class="editWrappper"><div class="Downloadfontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="Downloadfontlist-download  Downloadfontlist-tick" active-class="true"></div></div></div></a></li>';
            $('.font-list-downloadUl').html(fontLiItem_download);
            var deviceid = "DownloadedFont_" + myFontElementsInfoJson.myFontElementsInfoArr[i].id;
            EnglishFontID = deviceid;
            getDownloadedFontFileList(mDownloadedEngFontPath, deviceid);
            //createDownloadedFont(deviceid);
        } else {
            fontLiItem_download += '<li data-icon="false" id="DownloadedFont_' + myFontElementsInfoJson.myFontElementsInfoArr[i].id + '"  style="border-bottom:solid rgba(0,0,0,0.2) 1px;" url="' + R_SITE_BASE_URL + myFontElementsInfoJson.myFontElementsInfoArr[i].DesignElementsUrl + '" path="' + myFontElementsInfoJson.myFontElementsInfoArr[i].DesignElementsPath + '"><a class="ui-btn"><div class="font-list-li">English Fonts</div><div class="edit-section"><div class="editWrappper"><div class="Downloadfontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="Downloadfontlist-download" active-class="true"></div></div></div></a></li>';
            $('.font-list-downloadUl').html(fontLiItem_download);
            var deviceid = "DownloadedFont_" + myFontElementsInfoJson.myFontElementsInfoArr[i].id;
            EnglishFontID = deviceid;
        }
    }
    var isFontDownloaded = localStorage.getItem('isFontDeleted');
    if (isFontDownloaded != null && isFontDownloaded == 'false') {
        $('.font-list-downloadUl>li#' + EnglishFontID).children().children().children().find('.Downloadfontlist-download').removeClass('Downloadfontlist-tick');
    }
    FontLiHeight = $('.font-list-downloadUl >li').height();
    FontLiwidth = $('.font-list-downloadUl >li').width();
}

//************* Font End ****************/

//************* DESIGN ELEMENTS****************/
function createDesignElmList() {
    isDesignElement = true;
    var myDesignElementsInfoJson = JSON.parse(sessionStorage.getItem("DesignElements_INFO"));
    var DesignElmLi = "";
    for (var i = 0; i < myDesignElementsInfoJson.myDesignElementsInfoArr.length; i++) {
        if (myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsStatus == 1) {
            DesignElmLi += '<li data-icon="false" id="design_' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].id + '" url="' + R_SITE_BASE_URL + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsUrl + '" path="' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsPath + '"><a class="ui-btn"><div class="design-list-li textEllipsis">' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsName + '</div><div class="edit-section"><div class="designeditWrappper"><div class="designlist-error" active-class="true" style="visibility:hidden"></div><div class="designlist-download designlist-delete" active-class="true"></div></div></div></div></div></a></li>';
        } else {
            DesignElmLi += '<li data-icon="false" id="design_' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].id + '" url="' + R_SITE_BASE_URL + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsUrl + '" path="' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsPath + '"><a class="ui-btn"><div class="design-list-li textEllipsis">' + myDesignElementsInfoJson.myDesignElementsInfoArr[i].DesignElementsName + '</div><div class="edit-section"><div class="designeditWrappper"><div class="designlist-error" active-class="true" style="visibility:hidden"></div><div class="designlist-download" active-class="true"></div></div></div></div></div></a></li>';
        }
    }
    if(myDesignElementsInfoJson.myDesignElementsInfoArr.length>=4){
        $('.design-list li:last').addClass('ui-last-child');
    }
    
    $('.design-list').html(DesignElmLi);
    
    DLiheight = $('.design-list >li').height();
    DLiwidth = $('.design-list >li').width();
}

//************* ABOUT SOFTWARE ****************/
function createAboutSftElmList() {
    var aboutsftLi = "";
    for (var i = 0; i < 3; i++) {
        if (i == 0)
            aboutsftLi += '<li data-icon="false" id="abtSft' + i + '" ><a class="ui-btn"><div class="aboutsft-list-li textEllipsis">Open Source License</div><div class="edit-section"><div class="editWrappper"><div class="abtsft-edit" active-class="true" style="visibility:hidden;">Ver 1.0</div><div class="abtsft-arrow" active-class="true"></div></div></div></div></div></a></li>';
        if (i == 1)
            aboutsftLi += '<li data-icon="false" id="abtSft' + i + '" ><a class="ui-btn"><div class="aboutsft-list-li textEllipsis">Current Version</div><div class="edit-section"><div class="editWrappper"><div class="abtsft-edit" active-class="true">v' + SOFT_VER + '</div><div class="abtsft-download " active-class="true" style="visibility:hidden;"></div></div></div></div></div></a></li>';
        if (i == 2)
            aboutsftLi += '<li data-icon="false" id="abtSft' + i + '" ><a class="ui-btn"><div class="aboutsft-list-li textEllipsis">Latest Version</div><div class="edit-section"><div class="editWrappper"><div class="abtsft-edit" active-class="true">v' + Utils.getLatestVersion() + '</div><div class="abtsft-download" active-class="true" style="visibility:hidden;"></div></div></div></div></div></a></li>';
    }
    $('.aboutsft-list').html(aboutsftLi);
    $('.aboutsft-list li:last').addClass('ui-last-child');
}

function initProgressBarDE(deviceID) {
    $('<input>').appendTo('.design-list>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'height' : 0 + 'px',
                'position' : 'relative !important'
            });
            $('.ui-slider-track').css({
                "height" : DLiheight + 'px',
                'width' : DLiwidth + 'px',
                'position' : 'absolute'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions
            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");
    /*
     var i = 1;
     var interval = setInterval(function(){
     progressBar.setValue('#slider'+deviceID,i);
     if(i == 100) {
     clearInterval(interval);
     //progressBar.setValue('#slider'+deviceID,0);
     }
     i=i+25;
     },100);
     */
}

function initProgressBarFont(deviceID) {

    $('<input>').appendTo('.font-list-downloadUl>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'height' : 0 + 'px',
                'position' : 'relative !important'
            });
            $('.ui-slider-track').css({
                "height" : FontLiHeight + 'px',
                'width' : FontLiwidth + 'px',
                'position' : 'absolute'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions
            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");

}

$(function() {

    getDesignElementsInfo();
    //alert("panelID"+panelID);
    // ********************** FONT EVENTS ****************************

    $('#disclaimerID').on('click', function(e) {
        $('#Font-panel').hide();
        $('#font-disclaimer-panel').show();
        
        $('.custom-header').hide();
        $('.custom-font-disclaimer-header').show();
    });
    $('#disclaimer-back').on('click', function() {
        $('#font-disclaimer-panel').hide();
        $('#Font-panel').show();

    });
    $('#license-back').on('click', function() {
        $('#License-panel').hide();
        $('#Font-panel').show();
    });
    $('#openlicense-back').on('click', function() {
        $('#OpenSourceLicense-panel').hide();
        $('#AboutSoftware-panel').show();
    });

    $('.font-list-downloadUl').on('click', '.Downloadfontlist-download', function(e) {

        var currentLI = $(this);
        if ($(this).hasClass('Downloadfontlist-cross')) {
            loaderObj.showLoader({
                imgarr : ['../resource/img/ic_btn_loading_01.png', '../resource/img/ic_btn_loading_02.png', '../resource/img/ic_btn_loading_03.png', '../resource/img/ic_btn_loading_04.png'],
                'text' : 'Canceling...',
                'size' : 50,
                'interval' : 200,
                'color' : '#ffffff'
            });
            var deviceId = $(this).closest('li').attr('id');
            mProtocolManager.performCancelOperation(0, deviceId, CONNECTION_TYPE_RSITE_DOWNLOAD);
            return false;
        }
        if ($(this).hasClass('Downloadfontlist-tick')) {
            return false;
        }
        var mUrl = $(this).closest('li').attr('url');
        var mPath = $(this).closest('li').attr('path');
        var deviceId = $(this).closest('li').attr('id');
        $(this).addClass('Downloadfontlist-cross');
        initProgressBarFont(deviceId);
        mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
        isProgress = true;
        
        var fileType = langObj.Settings.MIA_SID_ENGLISH_FONTS;
        mProtocolManager.downloadRSiteDesignElements(fileType,mUrl, mPath, deviceId);
    });

    // ****************************** FONT EVENTS END *******************
    // Design element BG image download
    //********************** DESIGN ELEMENTS EVENTS *********************
    $('.design-list').on('click', '.designlist-download', function(e) {
        console.log("Design elements click to download");
        $(this).siblings('.designlist-error').css({
            'visibility' : 'hidden'
        });
        //alert( $(this).parent().children('.designlist-error').html());
        if ($(this).hasClass('AddDisable')) {
            return false;
        }
        // CANCEL DOWNLOAD
        if ($(this).hasClass('designlist-cross')) {
            loaderObj.showLoader({
                imgarr : ['../resource/img/ic_btn_loading_01.png', '../resource/img/ic_btn_loading_02.png', '../resource/img/ic_btn_loading_03.png', '../resource/img/ic_btn_loading_04.png'],
                'text' : 'Canceling...',
                'size' : 50,
                'interval' : 200,
                'color' : '#ffffff'
            });
            var deviceId = $(this).closest('li').attr('id');
            mProtocolManager.performCancelOperation(0, deviceId, CONNECTION_TYPE_RSITE_DOWNLOAD);
            return false;
        }

        // DELETE DOWNLOADED
        if ($(this).hasClass('designlist-delete')) {
            var currentLI = $(this);
            genericPopUpObj.createPopUp("Notification", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.delDesignElemId]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : popup_btnNo,
                "callback" : function() {
                    closeGenericPopUp();
                }
            }, {
                "btntxt" : popup_btnYes,
                "callback" : function() {
                    currentLI.removeClass('designlist-delete');
                    //$('.design-list li:last').addClass('ui-last-child');
                        var filePath = currentLI.closest('li').attr('path');
                    var deviceId = currentLI.closest('li').attr('id');
                    var id = deviceId.split('_');
                    updateDesignElementsFromDB(id[1], '0');
                    mProtocolManager.deleteRSiteElements(filePath, deviceId);
                }
            }]);
            genericPopUpObj.showPopUp();
            return false;
        }

        if ($(this).hasClass('designlist-done')) {
            return false;
        }

        var mUrl = $(this).closest('li').attr('url');
        var mPath = $(this).closest('li').attr('path');
        var deviceId = $(this).closest('li').attr('id');
        $(this).addClass('designlist-cross');
        initProgressBarDE(deviceId);
        var fileType = mUrl.substring(mUrl.lastIndexOf('/') + 1);
        mProtocolManager.downloadRSiteDesignElements(fileType,mUrl, mPath, deviceId);
        isProgress = true;
        $('.design-list>li').children().children().children().find('.designlist-download').not(this).addClass('AddDisable');
    });

    // Download software from market
    $('.aboutsft-list').on('click', '.abtsft-download', function(e) {
        console.log("About Software click to download Version");
        //alert("About Software click to download Version");
    });

    //About software licence
    $('.aboutsft-list').on('click', '.abtsft-arrow', function(e) {
        console.log("About Software click to open license");
        $('.inner-settings-page').hide();
        $('#OpenSourceLicense-panel').show();
        
        $('.custom-header').hide();
        $('.custom-license-header').show();
        
        //alert("About Software click to open license");
    });
});

function resetDesignElementUI() {
    var listItems = $(".design-list>li");
    listItems.each(function(li) {
        $('.design-list>li').children().children().children().find('.designlist-download').not(this).removeClass('AddDisable');
    });
}

function downloadFailed(deviceId) {
    //alert("downlad failed");
    if (isDesignElement) {
        $('.design-list>li#' + deviceId).children().children().children().find('.designlist-download').removeClass('designlist-cross');
        $('.design-list>li#' + deviceId).children().children().children().find('.designlist-error').css({
            'visibility' : 'visible'
        });
    } else {
        $('.font-list-downloadUl>li#' + deviceId).children().children().children().find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross');
        $('.font-list-downloadUl>li#' + deviceId).children().children().children().find('.Downloadfontlist-error').css({
            'visibility' : 'visible'
        });

    }
    isProgress = false;
    loaderObj.hideLoader();
    updateExportProgressBar(deviceId, 0);
    resetDesignElementUI();
}

function downloadSuccess(deviceId) {
    var fontLiItem = "";
    if (isDesignElement) {
        $('.design-list>li#' + deviceId).children().children().children().find('.designlist-download').removeClass('designlist-cross').addClass('designlist-tick');

        setTimeout(function() {
            $('.design-list>li#' + deviceId).children().children().children().find('.designlist-download').removeClass('designlist-tick').addClass('designlist-delete');
        }, 2000);
    } else {

        $('.font-list-downloadUl>li#' + deviceId).children().children().children().find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross').addClass('Downloadfontlist-tick');
        //getDownloadedFontFileList(mDownloadedEngFontPath);
    }

    updateExportProgressBar(deviceID, 0);
    resetDesignElementUI();
    loaderObj.showLoader({
        imgarr : ['../resource/img/ic_btn_loading_01.png', '../resource/img/ic_btn_loading_02.png', '../resource/img/ic_btn_loading_03.png', '../resource/img/ic_btn_loading_04.png'],
        'text' : 'Unzipping...',
        'size' : 50,
        'interval' : 200,
        'color' : '#ffffff'
    });
    var id = deviceId.split('_');
    updateDesignElementsFromDB(id[1], '1');
    isProgress = false;
}

function downloadCancel(deviceId) {
    updateExportProgressBar(deviceId, 0);
    resetDesignElementUI();
    $('.font-list-downloadUl>li#' + deviceId).children().children().children().find('.Downloadfontlist-download').removeClass('Downloadfontlist-cross');
    $('.design-list>li#' + deviceId).children().children().children().find('.designlist-download').removeClass('designlist-cross');
    isProgress = false;
}

function downloadUnzipped(deviceId) {
    if (isDesignElement == false) {
        localStorage.setItem('isFontDeleted', true);
        getDownloadedFontFileList(mDownloadedEngFontPath, deviceId);
    }
}

function createDownloadedFont(deviceId) {
    var fontLiItem = "";
    if (!isFontRendered) {
        loaderObj.showLoader({
            imgarr : ['../resource/img/ic_btn_loading_01.png', '../resource/img/ic_btn_loading_02.png', '../resource/img/ic_btn_loading_03.png', '../resource/img/ic_btn_loading_04.png'],
            'text' : 'Loading...',
            'size' : 50,
            'interval' : 200,
            'color' : '#ffffff'
        });
    }
    //show list here after download
    if ($('#fontlist-ul').length == 0) {
        var createUL = '<ul data-role="listview" id="fontlist-ul" class="font-list"></ul>';
        $('.font-list-downloadUl>li#' + deviceId).append(createUL);
    }
    $('#fontlist-ul').html('');

    console.log("mDownloadedFontList.length: " + mDownloadedFontList.length);
    for (var i = 0; i < mDownloadedFontList.length; i++) {
        var path = mDownloadedFontList[i].mFontFileUrl;
        path = path.replace('file://', "");
        console.log("Name: " + mDownloadedFontList[i].mFontFileName + " , URL: " + mDownloadedFontList[i].mFontFileUrl + ", Path: " + path);
        fontLiItem += '<li data-icon="false" id="DoFont_"' + i + '" path="' + mDownloadedFontList[i].mFontFilePath + '"><a class="ui-btn"><div class="font-list-li">' + mDownloadedFontList[i].mFontFileName + '</div><div class="edit-section"><div class="editWrappper"><div class="fontlist-edit" active-class="true" style="visibility:hidden;"></div><div class="fontlist-delete" active-class="true"></div></div></div></a></li>';

        //including font file and font family dynamically
        var special_font = document.createElement("style");
        special_font.type = "text/css";
        special_font.innerHTML = "@font-face {font-family: " + mDownloadedFontList[i].mFontFileName + ";  src: url(" + mDownloadedFontList[i].mFontFileUrl + ");}";
        document.getElementsByTagName('head')[0].appendChild(special_font);

    }
    $('.font-list').html(fontLiItem);
    $('.font-list li:first').addClass('BorderTopLi');

    var listItems = $(".font-list li");
    var i = 0;
    listItems.each(function(li) {
        $(this).children().find('.font-list-li').css({
            'font-family' : mDownloadedFontList[i].mFontFileName
        });
        i++;
    });
    if (!isFontRendered) {
        setTimeout(function() {
            loaderObj.hideLoader();
            isFontRendered = true;
        }, 2500);
    }

    $('.font-list-downloadUl>li#' + deviceId).css({
        "border-bottom" : "0px"
    });
    $('.font-list').on("click", ".fontlist-delete", function(event, ui) {
        var filePath = $(this).closest('li').attr('path');
        var currentLI = $(this);
        genericPopUpObj.createPopUp("Notification", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.deleteFontId]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : popup_btnNo,
            "callback" : function() {
                closeGenericPopUp();
            }
        }, {
            "btntxt" : popup_btnYes,
            "callback" : function() {
                //currentLI.removeClass('Downloadfontlist-delete');
                currentLI.closest('li').remove();
                $('.font-list-downloadUl>li#' + EnglishFontID).children().children().children().find('.Downloadfontlist-download').removeClass('Downloadfontlist-tick');
                localStorage.setItem('isFontDeleted', false);
                mProtocolManager.deleteRSiteElements(filePath, deviceId);
                $('.font-list li:first').addClass('addborderTop');
                console.log("length" + $('.font-list').length);
                if ($('.font-list').length <= 0) {
                    $('.font-list-downloadUl li:first').addClass('addborderTop');
                }
                getDownloadedFontFileList(mDownloadedEngFontPath, EnglishFontID);
            }
        }]);
        genericPopUpObj.showPopUp();
        return false;
        //to change icon to download if any font is deleted inside element
    });
    //font click events

}

function getDownloadedFontFileList(parentDir, deviceId) {
    mDownloadedFontList = new Array();
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
        fileSystem.root.getDirectory(parentDir, {
            create : false
        }, function(dirEntry) {
            var directoryReader = dirEntry.createReader();
            directoryReader.readEntries(function(entries) {
                console.log("Entries Count:" + entries.length);
                if (entries.length > 0) {
                    for (var i = 0; i < entries.length; i++) {
                        if (entries[i].isFile) {
                            var mFontFileInfo = new mFontInfo();
                            var fileNameWithEx = entries[i].name;
                            var fileExt = fileNameWithEx.substring(fileNameWithEx.lastIndexOf('.') + 1);
                            var fileName = fileNameWithEx.substring(0, fileNameWithEx.lastIndexOf('.'));
                            mFontFileInfo.mFontFilePath = entries[i].fullPath;
                            mFontFileInfo.mFontFileType = fileExt;
                            mFontFileInfo.mFontFileName = fileName;
                            mFontFileInfo.mFontFileUrl = entries[i].toURL();
                            mDownloadedFontList.push(mFontFileInfo);
                            console.log("FileName: " + mFontFileInfo.mFontFileName + " ,FileType: " + mFontFileInfo.mFontFileType + ", FilePath: " + mFontFileInfo.mFontFilePath);
                            // alert(mDownloadedFontList.length + "  FileName: "+mFontFileInfo.mFontFileName+" ,FileType: "+mFontFileInfo.mFontFileType+", FilePath: "+mFontFileInfo.mFontFilePath);
                        }
                    }
                    createDownloadedFont(deviceId);
                    if (mDownloadedFontList.length > 0) {
                        console.log(JSON.stringify(mDownloadedFontList));
                        localStorage.setItem('DownalodedFont_INFO', JSON.stringify(mDownloadedFontList));
                    } else {
                        localStorage.setItem('DownalodedFont_INFO', null);
                    }
                } // entries if end

            }, fail);
        }, fail);
    }, fail);

    function fail() {
        console.log("Failed to interator directory");
        //alert("Failed to interator directory");
    }

}

