/**
 * @filename Setting.js
 *
 *
 *   Modified rishu.yadav 17 feb adding back function
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */
$(document).ready(function() {
    
    //Dynamically Show version name after page loaded
    appset.initialize();
});
var progressBar = {
    setValue : function(id, value) {
        $(id).val(value);
        $(id).slider("refresh");
    }
};
var settingsPageType = 1;
var deviceListContainerRef;
var falgtoDonedisable=true;
var FlagToexpand=false;
var currentTime;
var addmanualListIndex = 0;
var addSendmanualListIndex = 0;
var start = "";
var end = "";
var startIpValuedate = "";
var endIpValuedate = "";
var addtimer = "";
var weekDays = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var loaderInt = null;
var deviceID;
var deviceIp;
var tlsReq;
var pin;
var mDeviceListInfo;
var panelID;
var Strtval = "";
var Endval = "";
var Date_value = "";
var Date_value_trim = "";
var lastdate = 31;
var Timer_Strtval = "";
var Timer_Endval = "";
var Timer_Value = "";
var Datearray = new Array();
var DayStr = "";
var OFFDayStr = "";
var Liheight;
var Liwidth;
var timerLiheight;
var timerLiwidth;
var StoreListLengthLimit = 0;
var isStoreDeleted = false;
var isProgress = false;
var isCheckingFWVersion = false;
var isReady = false;
var MAXTIMESTAMP = 32535109800000;
var point;
var flagtoshowspin = 0;
var ONtimervaluebeforeApply = "";
var ONtimervaluetoApply = "";
var OFFtimervaluebeforeApply = "";
var OFFtimervaluetoApply = "";
var DateValuetoApply = "";
var Onvalue = "On";
var Offvalue = "On";
var currentDate = "";
var mMetaInfo = "";
var finalvaluebeforesent;
var sendmonth = 0;
var flagtoFifteenDays = true;
var addId = 1;
var isCanceled = false;
var mTaskType = 0;
var isWiFiEnable = false;
var InputstarttimervalToHeader = "";
var InputendtimervalToHeader = "";
var InputvalToheader = "";
var alreadyEnteredHolidayFlag = false;
var isOnOffTimerIP = true;
var HolidayJsonObj = new Array();
var flagTofocusStart = true;
var flagTofocusEnd = true;
var passInputVal = "";
var FalgDoubletap = true;
var isFontRendered = false;
var DefaultStartTime = "";
var DefaultEndTime = "";
var storeWeekDayList = "";
var oldFirmwareVersion = "";
var launchFrmUpdate = false;
var checkingID = null;
var currentInputValue = 0;
var updateTimerHolidayDB = true;
var mLFDInfo;
var devicename = "";

var mLFDDeviceInfo = function() {
    this.mDeviceName = null;
    this.mDeviceId = null;
    this.mDeviceIP = null;
    this.mMetaInfo = null;
    this.mStatus = null;
    this.isCanceled = false;
    this.mProgressVal = 0;
    this.mTLSRequired = 0;
    this.mPin="";
    this.mMacAddr="";
};

var mLFDInfoArrayList = new Array();
var appset = {
    initialize : function() {
        this.bindEvents();
    },

    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);

    },

    onDeviceReady : function() {
        console.log("@ onDeviceReady settings page");
        document.addEventListener("backbutton", onBackkeyDown, false);
        appset.receivedEvent('deviceready');
        if (deviceType != "iPhone" && deviceType != "iPad") {
            Utils.registerKeyboardObserver();
        }
        isFontRendered = false;
        // checking software version from playstore
        var loc =window.location.href;
        var output  = loc.split('/').pop().split('.')[0];
        if(output == 'Settings'){
           //console.log("Called checkAndUpdateStatusOfDesignElements");
           var flag=checkAndUpdateStatusOfDesignElements();
           //console.log("Called getDesignElementsInfo");
           if(flag)
           {
            getDesignElementsInfo();
           }
           Utils.checkLatestVersion();
           setTimeout(function(){
             getDeviceInfo();
           },2000);
        }
        
		if(Utils.getLocalStorageValue('fontList') == null || Utils.getLocalStorageValue('fontList').length == 0){
            mUtilityManager.getAppResourceList(function(result){
            	    Utils.setLocalStorageValue('fontList',result); // Font
                     mUtilityManager.getAppResourceList(function(result){
                       Utils.setLocalStorageValue('BGList',result);  // BG
                        mUtilityManager.getAppResourceList(function(result){
                               Utils.setLocalStorageValue('FreeTemplateList',result); // Free Template
                              },function(message){
                                  console.log("Error: "+message);
                              },FREE_TEMPLATES_RES_ITEMS);
                      },function(message){
                            console.log("Error: "+message);
                      },BG_RES_ITEMS);
              },function(message){
                    console.log("Error: "+message);
              },FONT_RES_ITEMS);
           }
		
        var myTimerInfoJson = JSON.parse(localStorage.getItem("Timer_INFO"));
		var myTimerInfoArrObj;
        if(myTimerInfoJson == null)
		{
			setTimeout(function(){
				insertTimerInfo("OnTimer1", "F", "1", "1");
			},200);
		} else {
			if (myTimerInfoJson.myTimerInfoArr) {
				for (var i = 0; i < 14; i++) {
                    myTimerInfoArrObj = myTimerInfoJson.myTimerInfoArr[i];
   	        		var TimerName = myTimerInfoArrObj.TimerName;
					var IsOn = myTimerInfoArrObj.IsOn;
					var TimeVal = myTimerInfoArrObj.TimeVal;
					var WeekVal = myTimerInfoArrObj.WeekVal;
					var WeekArr = WeekVal.split(":");
					
					if(TimerName.substring(0,2) == "On")
					{
						var idx = TimerName.substring(7,8);
						if(IsOn == "T")
						{
					       	$('#onTimerIconCls_'+idx+'>img').removeClass('uncheck').addClass('check');
					        $('#onTimerIconCls_'+idx+'>img').attr('src', '../resource/img/btn_switch_bg_on.png');
							
							$('.timerContentCls'+idx+'>.ontimerContentCls>#SelectdaysId'+idx).removeClass('AddDisable');
							for(var j=0; j<7; j++)
							{
								$('.timerContentCls'+idx+'>.ontimerContentCls>#SelectdaysId'+idx+'>.day_'+WeekArr[j]).removeClass('floatLeftCls').addClass('floatLeftimgCls');	
							}
							
					       	var inputtext = $('#ipTextStart'+idx).closest('div.inputClass');
					       	inputtext.removeClass('AddDisable');
					       	$('#ipTextStart'+idx).val(TimeVal);
					       	
					       	var timer_setId = ".timer_set_" + idx;
							$(timer_setId).css("display", "block");
							//$(".timer_header_tap").collapsible("collapse");
						}
						else
						{
							$('#onTimerIconCls_'+idx+'>img').addClass('uncheck');
					        $('#onTimerIconCls_'+idx+'>img').attr('src', '../resource/img/btn_switch_bg_off.png');
					        $('.timerContentCls'+idx+'>.ontimerContentCls>#SelectdaysId'+idx).addClass('AddDisable');
					        for(var j=0; j<7; j++)
							{
								$('.timerContentCls'+idx+'>.ontimerContentCls>#SelectdaysId'+idx+'>.day_'+WeekArr[j]).addClass('floatLeftCls');	
							}
							var inputtext = $('#ipTextStart'+idx).closest('div.inputClass');
					       	inputtext.addClass('AddDisable');
						}
					}
					else if(TimerName.substring(0,3) == "Off")
					{
						var idx = TimerName.substring(8,9);
						if(IsOn == "T")
						{
							$('#offTimerIconCls_'+idx+'>img').removeClass('uncheck').addClass('check');
					        $('#offTimerIconCls_'+idx+'>img').attr('src', '../resource/img/btn_switch_bg_on.png');
							
							$('.timerContentCls'+idx+'>.offtimerContentCls>#OffSelectdaysId'+idx).removeClass('AddDisable');
							for(var j=0; j<7; j++)
							{
								$('.timerContentCls'+idx+'>.offtimerContentCls>#OffSelectdaysId'+idx+'>.day_'+WeekArr[j]).removeClass('floatLeftCls').addClass('floatLeftimgCls');	
							}
							
					       	var inputtext = $('#ipTextEnd'+idx).closest('div.inputEndClass');
					       	inputtext.removeClass('AddDisable');
					       	$('#ipTextEnd'+idx).val(TimeVal);
					       	
					       	var timer_setId = ".timer_set_" + idx;
							$(timer_setId).css("display", "block");
							//$(".timer_header_tap").collapsible("collapse");
						}
						else
						{
							$('#offTimerIconCls_'+idx+'>img').addClass('uncheck');
					        $('#offTimerIconCls_'+idx+'>img').attr('src', '../resource/img/btn_switch_bg_off.png');
					        $('.timerContentCls'+idx+'>.offtimerContentCls>#OffSelectdaysId'+idx).addClass('AddDisable');
					        for(var j=0; j<7; j++)
							{
								$('.timerContentCls'+idx+'>.offtimerContentCls>#OffSelectdaysId'+idx+'>.day_'+WeekArr[j]).addClass('floatLeftCls');	
							}
							var inputtext = $('#ipTextEnd'+idx).closest('div.inputEndClass');
					       	inputtext.addClass('AddDisable');
						}
					}
				}
			}
		}

	},

    // Update DOM on a Received Event
    receivedEvent : function(id) {

        console.log('Received Event: ' + id);
    },

    switchView : function() {
        if ($(this).hasClass('close')) {
            $('#view-setting').addClass('show');
            $('#view-home').removeClass('show');
        } else if ($(this).attr('id') == 'home-button') {
            $('#view-home').addClass('show');
            $('#view-setting').removeClass('show');
        }
    }
};

window.onload = function() {
    //yourJSCodeHERE
    $('.settings-panel').show();
    var SelectedModelName = Utils.getActivePlayerType();
    console.log("SelectedModelName here" + SelectedModelName);
    var trimStr = langObj.Settings.COM_TV_MODEL;
    //trimStr = trimStr.replace('<<A>>', Utils.getPlayerName(SelectedModelName));
    $('#Model-selection').text(trimStr);
    $('#power-cntrl').text(langObj.Settings.COM_TV_SID_ONOFF_TIMER);
    //$('#Firmware-update').text(langObj.Settings.COM_SOFTWARE_UPDATE);
    $('#Store').text(langObj.Settings.COM_STORE_M_SHOP);
    $('#Font').text(langObj.Settings.IDS_FONT_TEXT);
    $('#DesignElements').text(langObj.Settings.MIA_SID_DESIGN_ELEMENTS);
    $('#AboutSoftware').text(langObj.Settings.MIA_SID_ABOUT_SOFTWARE);
    
    if( sessionStorage.getItem('editStoreFromSettings') == 'true' )
    {
        $('.inner-settings-page').hide();
        $('#Store-panel').show();
    
        $('.tablet_ContentsCls').css({
            'left' : '0%',
        });
        
        $('.settings-panel').css({
            'left' : '-100%'
        });
        
        $('#headerTitle1').text(langObj.Settings.COM_STORE_M_SHOP);
        CreateStoreList();
        mTaskType = 0;
        isReady = false;
        
        sessionStorage.setItem("editStoreFromSettings", false);

    }

    if(sessionStorage.getItem('modelFromSettings') == 'true')
    {
        $('.inner-settings-page').hide();
        $('#Model-selection-panel').show();
    
        $('.tablet_ContentsCls').css({
            'left' : '0%',
        });
        
        $('.settings-panel').css({
            'left' : '-100%'
        });
        
        $('#headerTitle1').text(langObj.Settings.COM_TV_MODEL);
        createPlaylistModels_set();
        
        sessionStorage.setItem("modelFromSettings", false);
    }
    
    $('ul.settings-item> li').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault();
        
        $('.inner-settings-page').hide();
        
        panelID = $(this).attr('id');
        panelID = panelID.trim();
        
        $('#' + panelID + '-panel').show();
        
        $(".timer_header_tap").collapsible("collapse");
        
        if (panelID == "Model-selection") {
            $('#headerTitle1').text(langObj.Settings.COM_TV_MODEL);
            createPlaylistModels_set();
        } else if (panelID == "power-cntrl") {
            $('#timerLabeId').text(langObj.Settings.MIA_SID_MIX_TIMER.replace('<<A>>',""));
            $('#headerTitle1').text(langObj.Settings.COM_TV_SID_ONOFF_TIMER);
            if ( langObj.Settings.COM_TV_SID_ONOFF_TIMER.length > 20 && langObj.Settings.COM_TV_SID_ONOFF_TIMER.length <= 25)
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'17px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }
            else if ( langObj.Settings.COM_TV_SID_ONOFF_TIMER.length > 25 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'85%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'15px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'0%'});
            }
            
            if ( langObj.Settings.MIA_SID_SELECT_SIGNAGE_ON_OFF_TIMER.length > 100 )
            {
                $('.updatefooterTxt').css({'font-size':'15px'});
            }
            else
            {
                $('.updatefooterTxt').css({'font-size':'17px'});
            }
            
        } else if (panelID == "Firmware-update") {
            $('#headerTitle1').text(langObj.Settings.COM_SOFTWARE_UPDATE);
            mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
            if ( langObj.Settings.COM_SOFTWARE_UPDATE.length > 25 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'15px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }else if( langObj.Settings.COM_SOFTWARE_UPDATE.length > 20 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'17px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }
            if ( langObj.Settings.MIA_SID_SELELCT_SIGNAGE_UPDATE_SW_UPDATE_DEVICE.length > 100 )
            {
                $('.updatefooterTxt').css({'font-size':'15px'});
            }
            else
            {
                $('.updatefooterTxt').css({'font-size':'17px'});
            }
            
            createAboutSftElmList();

            mTaskType = CONNECTION_TYPE_FIRMWARE_UPGRADE;
            $('.list').html('');

            mProtocolManager.registerWiFiStateChangeReceiver();
            if (Utils.checkConnection() == CONNECTION_WIFI) {
                isReady = true;
                mProtocolManager.startDeviceDiscovery();
                showLoader('updatefooterIcon');
            } else {
                hideLoader('updatefooterIcon');
            }
           
        } else if (panelID == "Store") {
            $('#headerTitle1').text(langObj.Settings.COM_STORE_M_SHOP);
            $("#AddStoreBtnId").text("+ " + langObj.index.MIA_SID_ADD_STORE);
            
            if ( langObj.Settings.MIA_SID_CREATE_ADS_USING_STORE_NAME.length > 100 )
            {
                $('.updatefooterTxt').css({'font-size':'15px'});
            }
            else
            {
                $('.updatefooterTxt').css({'font-size':'17px'});
            }
    
            CreateStoreList();
            mTaskType = 0;
            isReady = false;
            mProtocolManager.stopAutoDiscoveryService();
        } else if (panelID == "Font") {
             mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
            $('#headerTitle1').text(langObj.Settings.IDS_FONT_TEXT);
            $('#headingTxtFontId').text(langObj.Settings.downloadfontId);
            createFontList();
        } else if (panelID == "DesignElements") {
             mTaskType = CONNECTION_TYPE_RSITE_DOWNLOAD;
            $('#headerTitle1').text(langObj.Settings.MIA_SID_DESIGN_ELEMENTS);
            if ( langObj.Settings.MIA_SID_DESIGN_ELEMENTS.length > 25 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'15px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }else if ( langObj.Settings.MIA_SID_DESIGN_ELEMENTS.length > 20 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'17px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }
            
            if ( langObj.Settings.MIA_SID_DOWN_MORE_DESIGN_TEMPLATE.length > 100 )
            {
                $('.updatefooterTxt').css({'font-size':'15px'});
            }
            else
            {
                $('.updatefooterTxt').css({'font-size':'17px'});
            }
            
            $('#designId').text(langObj.Settings.designFooterTxtId);
            createDesignElmList();
        } else if (panelID == "AboutSoftware") {
            $('#headerTitle1').text(langObj.Settings.MIA_SID_ABOUT_SOFTWARE);
            if ( langObj.Settings.MIA_SID_ABOUT_SOFTWARE.length > 25 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'15px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }else if (langObj.Settings.MIA_SID_ABOUT_SOFTWARE.length > 20 )
            {
                $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'17px'});
                $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'5%'});
            }
            $('#contntManagerId').text(langObj.Settings.contntManagerId);
            
            createAboutSftElmList();
        }
        
        $('.tablet_ContentsCls').animate({
            'left' : '0%'
        });
        
        $('.settings-panel').animate({
            'left' : '-100%'
        });
        
    }); 

    $('.back-btn').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault();
        
        if (isProgress || isFirmwareProgress) {
            cancelCurrentProcessOnBack();
            return;
        }

        mProtocolManager.stopAutoDiscoveryService();

        if ( $('#newconection_apply').is(':visible') )
        {
        	$(".timer_header_tap").collapsible("collapse");
        }
        
        if ( $('#StartsendbtnId').is(':visible') )
        {
            $('#power-cntrl-panel').show();
            $('#power-cntrl-panel-apply').hide();
            $('.Settinglist_Send').html('');
            $('.settings_manually_add').show();
            $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
            $('.AddsignageSendTvCls').hide();        

            return;
        }
        

        $('.settings-panel').animate(
            {
                'left' : '0%'
            },
            {
                complete: function()
                {
                    $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'70%'});
                    $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'19px'});
                    $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'15%'});
                }
            }
        );

        $('.tablet_ContentsCls').animate({
            'left' : '100%'
        });

    });
        

       $('.close-btn').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        
        window.location.href="../quickstart/QuickStart.html";
    });


    //Ip Focus and blur handle here

    $('.iptext').focus(function(e) {
        $('.ip-wrapper').addClass('ip-focus');
    }).blur(function(e) {
        $('.ip-wrapper').removeClass('ip-focus');
    });
    
    $('.holiday-arrow').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault(); 
        $(".timer_header_tap").collapsible("collapse");
        
        $("#settings_ContentsId").css("display", "none");
        $("#settings_holidaymgt").css("display", "block");
        
        if ( langObj.Settings.COM_IDS_TXT_HOLIDAY_MANAGEMENT.length > 25 )
            {
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part2 > .header-text').css({'font-size':'15px'});
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part3').css({'width':'5%'});
            }else if (langObj.Settings.MIA_SID_ABOUT_SOFTWARE.length > 20 )
            {
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part2').css({'width':'80%'});
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part2 > .header-text').css({'font-size':'17px'});
                $('.tablet_ContentsCls > .custom-holidaymgt-header > .header-part3').css({'width':'5%'});
            }

        $("#holidaymgt-panel").css("display", "block");
        
        
        var headerCnt = $('.holiday_block').find('.hoilday_header_tap').length;
		
        $('.holiday_block').find('.hoilday_header_tap').each(function() {
        	$('.holiday_block').find('.hoilday_header_tap').remove();
        });
        
	var myHolidayInfoJson = JSON.parse(localStorage.getItem("Holiday_INFO"));

	if (myHolidayInfoJson!=null && myHolidayInfoJson.myHolidayInfoArr) {
		addId = myHolidayInfoJson.myHolidayInfoArr.length;
		var maxIndex = 0;
		var myHolidayInfoArrObj;
		for (var i = 0; i < addId; i++) {
			myHolidayInfoArrObj = myHolidayInfoJson.myHolidayInfoArr[i];
			var holidayID = myHolidayInfoArrObj.IndexVal;
			var start = myHolidayInfoArrObj.StartDate;
			var end = myHolidayInfoArrObj.EndDate;

			if (maxIndex < holidayID) {
				maxIndex = holidayID;
			}

			ShowHolidayList(holidayID, start, end);
			$(".addUndoicon").tap();
		}
		addId = maxIndex + 1;
	}
    });

    $('#holidayMgntId').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault();
        $('.holiday-arrow').trigger('tap');        
    });


    $('#holidaymgtBack').on('tap', function(e) {
        e.stopPropagation();
        e.preventDefault(); 

        $("#settings_ContentsId").css("display", "block");
        $("#power-cntrl-panel-apply").css("display", "none");        
        $("#settings_holidaymgt").css("display", "none");
        $("#holidaymgt-panel").css("display", "none");
        
        if($('#holidayMgnttitleId').hasClass('AddDisable'))
        {
        	$(".addUndoicon").tap();	
        }
        
    });
    
    $('.ModelsListUl_set').on('click', '#changeModelTypeID', function(e) {
        document.location.href = "../index.html?WhereFrom=Model";
    });

};

// ========================== DOCUMENT READY ============================//
$(function() {

   $('.font-list-container_license').html(langObj.Settings.MIA_SID_LICENSE_OSD_MSG_FONT_1+"<br><br>"+langObj.Settings.MIA_SID_LICENSE_OSD_MSG_FONT_2);
  //************************Some Common Tap Events for All Modules in Settings****************************//
    $('.closebtnCls_each').on('tap', function(e) {
        if (isProgress || isFirmwareProgress) {
            cancelCurrentProcessOnBack();
            return;
        }

        document.location.href = "../quickstart/QuickStart.html";
        e.preventDefault();
        e.stopPropagation();
    });
    $(".panel-page").click(function() {
        if ($("#timePopUp").css("display") == "block") {
            $("#timePopUp").css("display", "none");
        }

    });
    
    $(".setting-pop").bind({
        popupbeforeposition : function() {
            $('.popup-overlay').show();
        },
        popupafterclose : function(event, ui) {
            $('.popup-overlay').hide();
        }
    });

    /*
    $(document).on('click', function(e) {
        console.log("click Inside document tap");
        var el = document.getElementById("popupID");
        if(el.style.display == 'block'){
            $('#ok-popup').click();
        }
        
        flagTofocusStart = true;
        flagTofocusEnd = true;
        DeleteEmptyHoliday();
      //  e.preventDefault();
        e.stopImmediatePropagation();
        
    });*/

    $('.Settinglist_Send').css({'height':'1000px'});
    setTimeout(function(){$('.Settinglist_Send').css({'height':''});}, 2000);
    var refreshIconWH = Math.round($(window).height()*0.071);
    $('#Loadercontainer_sendId').css({'width':refreshIconWH+'px !important', 'height':refreshIconWH+'px'});


    /*    Added by Pradeep
     *    Change ipbox to number or tel based on OS type
     *   This is used to trigger the relevant keyboard type
     */
    if (deviceType.toLowerCase() == 'ipad') {
        $('.iptext').attr('type', 'tel');
    } else {
        $('.iptext').attr('type', 'text');
    }

    $(document).on('input', '.iptext', function(e) {

        var specialChars = '*\"\\/?|<>+Ã—Ã·=%â‚¬Â£Â¥â‚©@#$^&()\';!,`~{}[]â–ªâ—‹â—�â–¡â– â™¤â™¡â™¢â™§â˜†âŠ™Â°â€¢Â¤ã€Šã€‹Â¡-â€¹â€ºâ‚¹';
        var AddsendIpValue = "";
        var addupdateIpvalue = "";
        var name = $(this).val();
        for ( i = 0; i < specialChars.length; i++) {
            if (name.indexOf(specialChars[i]) > -1) {
                name = name.replace(specialChars[i], '');
            }
        }
        currentInputValue = name;
        var ipBoxId;
        $(this).val(name);
        if($('#ipbox1').length>0){
        	AddsendIpValue = $('#ipbox1').val().trim();
        	ipBoxId = "ipbox";
        }
        if($('#firmIpbox1').length>0){
        	addupdateIpvalue = $('#firmIpbox1').val().trim();
        	ipBoxId = "firmIpbox";	
        }        
        
        if (AddsendIpValue == "" || AddsendIpValue == " ") {
            $('#sendenterId').addClass('AddDisable');
        } else {
            $('#sendenterId').removeClass('AddDisable');
        }
        if (addupdateIpvalue == "" || addupdateIpvalue == " ") {
            $('#updateenterId').addClass('AddDisable');
        } else {
            $('#updateenterId').removeClass('AddDisable');
        }

    });

    //**************************on/off Timer Event Listeners Start ***********************************************//

    $('input').blur(function() {
        //console.log("blurrrrrrrrrrrrrrrrrrrrhere");
        setTimeout(function(){$('#TimePicker_Time').remove();},50);
    });
    
    $(".inputStart").on('tap', function(event) {
        console.log("Input start");
        event.stopPropagation();
        event.preventDefault();
        var checkdisable = "";
        passInputVal = "";
        var IdVal = $(this).attr('id');
        var TrimIdVal = IdVal.replace('ipTextStart','');
        checkdisable = $(this).closest('div.inputClass').hasClass('AddDisable');
        //alert("checkdisable"+checkdisable);
        if (checkdisable == true) {
            $(this).blur();
            return false;
        } else {
            
            if($(this).closest('.inputBlock').find('.timePickerClass').length===0)
            {
                console.log("Input start if");
                $(this).focus();
                passInputVal = $(this).val();
                var InputVal = passInputVal.split(':');
                var ampmVal = "";
                var hourTwoVal = InputVal[0];
                var minTwoVal = InputVal[1];
                minTwoVal = minTwoVal.replace('am', '');
                minTwoVal = minTwoVal.replace('pm', '');
                ampmVal = InputVal[1].indexOf('am') > 0 ? "AM" : "PM";
                ampmVal=ampmVal.toLowerCase();
        
        
                
            $('#cancel-popup').text(langObj.Schedule.COM_SID_CANCEL);
            $("#ok-popup").text(langObj.Schedule.COM_SID_OK);
            
            
            //$('#popupID').show();
           /*
            $('.popup-body').append('<div id="timePicker"> </div>');
                       
                       var timepickerLayout =  '<div id="line_1" class="timepicker_Line"> </div>' +
                                           '<div id="line_2" class="timepicker_Line"> </div>' +
                                           '<div id="semi_1" class="timepicker_semi"> : </div>';
                                           
                       $('.popup-body').append(timepickerLayout);
                       $('.popup-header').text(langObj.Settings.COM_TV_SID_SET_TIME);
                       
                       var timeHeight = 150;
                   
                       if ( deviceType == 'iPhone' )
                       {
                           timeHeight = 140;
                       }
                       */
            createTimePickers(3);
            var setTime = passInputVal;
            var CurrentTimePicker = $('body').find('#TimePicker');
            CurrentTimePicker.timeSpinner(
                {
                   type: '3',
                   fontPadding : '0',
                   fontHeight: FonttimerValFrNote_5,
                   MinSecSuffix:true,
                   time3 : {
                                hour : getParseIntInDec(hourTwoVal),
                                min : getParseIntInDec(minTwoVal),
                                ampm : ampmVal
                            },
                    onTimeSet:function(val)
                    {
                        updateTime(TrimIdVal,val,"start");
                        
                        updateTimerDB("On", TrimIdVal, "T");
                           
                    }
                });
                            
            }
            
        
        }
        if (!checkdisable) {
            
            //$(".Timer_holidayContainerCls").scrollTo($(this), 500);
            
        }
    });

  
    $(".inputEnd").on('tap', function(event) {

        event.stopPropagation();
        event.preventDefault();
        var checkdisable = "";
        passInputVal = "";
        var IdVal = $(this).attr('id');
        var TrimIdVal = $(this).attr('id').replace('ipTextEnd', '');
        checkdisable = $(this).closest('div.inputEndClass').hasClass('AddDisable');
        if (checkdisable == true) {
            $(this).blur();
            return false;
        } else {
            if($(this).closest('.inputBlock').find('.timePickerClass').length===0)
            {
                $(this).focus();
                passInputVal = $(this).val();
                var InputVal = passInputVal.split(':');
                var ampmVal = "";
                var hourTwoVal = InputVal[0];
                var minTwoVal = InputVal[1];
                minTwoVal = minTwoVal.replace('am', '');
                minTwoVal = minTwoVal.replace('pm', '');
                ampmVal = InputVal[1].indexOf('am') > 0 ? "AM" : "PM";
                ampmVal=ampmVal.toLowerCase();

                //$('#cancel-popup').text(langObj.Schedule.COM_SID_CANCEL);
                $("#ok-popup").text(langObj.Schedule.COM_SID_OK);

              /*
                $('#popupID').show();
                              $('.popup-body').append('<div id="timePicker"> </div>');
              
                              var timepickerLayout =  '<div id="line_1" class="timepicker_Line"> </div>' +
                                                  '<div id="line_2" class="timepicker_Line"> </div>' +
                                                  '<div id="semi_1" class="timepicker_semi"> : </div>';
                                                  
                              $('.popup-body').append(timepickerLayout);
                              $('.popup-header').text(langObj.Settings.COM_TV_SID_SET_TIME);
                              
                              var timeHeight = 150;
                          
                              if ( deviceType == 'iPhone' )
                              {
                                  timeHeight = 140;
                              }
                              */
              
                var setTime = passInputVal;
                createTimePickers(3);
                var CurrentTimePicker = $('body').find('#TimePicker');
                CurrentTimePicker.timeSpinner(
                {
                    type: '3',
                    fontPadding :'0',
                    fontHeight: FonttimerValFrNote_5,
                    MinSecSuffix:true,
                    time3 : {
                                hour : getParseIntInDec(hourTwoVal),
                                min : getParseIntInDec(minTwoVal),
                                ampm : ampmVal
                            },

                    onTimeSet:function(val)
                    {
                        updateTime(TrimIdVal,val,"end");
                        
                        updateTimerDB("Off", TrimIdVal, "T");
                    }
                });    
                         
            }
        }
        if (!checkdisable) {
            //$(".Timer_holidayContainerCls").scrollTo($(this), 500);
        }

    });
    
    // OK button
    /*
    $('#ok-popup').on('tap', function(e){
        setTimeout ( function (){
            $('#popupID').hide();
            $('.popup-body').children().remove();
            
            $('.popup-btn').css(
                {
                    'background-color':'#e6e6e6',
                    'color':'#242424',
                }
            );
            
        },200);
        
        e.preventDefault();
        e.stopPropagation();
    });
    
    $('#cancel-popup').on('tap', function(e){
        e.preventDefault();
        e.stopPropagation();
        
        setTimeout ( function (){
            $('#popupID').hide();
            $('.popup-body').children().remove();
        },200);
    });*/
    
    // Popup close
    $(document).on('touchstart, tap',".headerClsTi", function(e) {    
        console.log('headerClsTi');
        e.stopPropagation();
        e.preventDefault();
    });
    
    $(document).on('touchstart',".TimePickerConCls", function(e) {  
        console.log('TimePickerConCls');
        e.stopPropagation();
        e.preventDefault();
    });
    $('.buttonClsTi,.bodyCls').off('touchstart');
    $(document).on('touchstart', ".buttonClsTi", function(e) {    
        e.stopPropagation();
        e.preventDefault();
        console.log('buttonClsTi');
        /*if( flagTofocusEnd == true  && ($('.inputEndDate').val() == "--/--") )
        {
            var d = new Date();
            var month = d.getMonth() + 1;
            if(month < 10)
            {
                month = '0'+month;
            }
            var date = d.getDate();
            if(date < 10)
            {
                date = '0'+date;
            }
            var start = $('.inputStartDate').val();
            $(".inputEndDate").val(start);
        }
        
        if($('.inputStartDate').val() == "--/--")
        {
            var d = new Date();
            var month = d.getMonth() + 1;
            if(month < 10)
            {
                month = '0'+month;
            }
            var date = d.getDate();
            if(date < 10)
            {
                date = '0'+date;
            }
           
            
            $(".inputStartDate").val(month+"/"+date);
        }*/
        if(($('.inputStartDate').val() != "--/--") && ($('.inputEndDate').val() != "--/--"))
        {
            $('.addDoneicon').removeClass('AddDisable');
        }
        $('.buttonClsTi').css(
            {
                'background-color':'#3196ff',
                'color':'#ffffff',
            }
        );
        
        setTimeout ( function (){
            closeTimePicker();
            $('.buttonClsTi').css(
                {
                    'background-color':'#e6e6e6',
                    'color':'#242424',
                }
            );
        },200);

    });
    
    
    
    //Auto scroll Timer

    $(".timer_header_tap").on("collapsibleexpand", function(event, ui) {
		if($('.bodyCls').length>0){
    		//If timer is already open then exit;
    		return false;
    	}
        console.log("*****************collapsible expand  tap  " + $(this).attr('id'));

        var id = $(this).attr('id');
        var timer_setId = ".timer_set_" + id;
        $(timer_setId).css("display", "none");
        var height_factor = 70;
        DeleteEmptyHoliday(true);
        if (id == '7') {
            height_factor = 73;
        }
        var $this = $(this);
        setTimeout(function() {
            $(".Timer_holidayContainerCls").scrollTo($this, 500);
        }, 100);
    });
          
    $(".timer_header_tap").on("collapsiblecollapse", function(event, ui) {
    	if($('.bodyCls').length>0){
    		//If timer is already open then exit;
    		return false;
    	}
        console.log("*****************collapsible collapse  tap  "+$(this).attr('id'));
        var getId = $(this).attr('id');
        var collapsed =  $('#'+getId).collapsible("option", "collapsed");
        var ontimeDays="";
        var offtimeDays="";
        var timer_setId = ".timer_set_" + getId;
        var timer_headerId = '#' + getId;
        //if(collapsed == false){
            $(timer_setId).css("display", "block");
            if ($(timer_headerId).find('.onTimerIconCls>img').hasClass('uncheck') && $(timer_headerId).find('.offTimerIconCls>img').hasClass('uncheck') )
            {
                $(timer_setId).css("display", "none");
                if($(timer_headerId).find('.onTimerIconCls>img').hasClass('uncheck'))
                {
	               var timerName = "OnTimer" + getId;
	               //updateTimerOffFromDB(timerName, 'F');
                }
                if($(timer_headerId).find('.offTimerIconCls>img').hasClass('uncheck'))
                {
                	var timerName = "OffTimer" + getId;
	                //updateTimerOffFromDB(timerName, 'F');
                }
            }
            else
            {
            
            ontimeDays = "";
            offtimeDays = "";
                
            if ($(timer_headerId).find('.onTimerIconCls>img').hasClass('check')) {
                $('.ontimer'+getId+'_Sun').show();
                $('.ontimer'+getId+'_Mon').show();
                $('.ontimer'+getId+'_Tue').show();
                $('.ontimer'+getId+'_Wed').show();
                $('.ontimer'+getId+'_Thu').show();
                $('.ontimer'+getId+'_Fri').show();
                $('.ontimer'+getId+'_Sat').show();
                $('.ontimer'+getId+'_Sun').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Mon').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Tue').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Wed').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Thu').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Fri').css({'color' : '#363638', 'opacity':'0.4'});
                $('.ontimer'+getId+'_Sat').css({'color' : '#363638', 'opacity':'0.4'});

                var ontimerTimeVal = "";
                var weekVal = "";

                $($(timer_headerId)).find('.SelectdaysCls>div.floatLeftimgCls').each(function() {
                    var tempar = new Array();
                    var temp;
                    temp = $(this).attr('class');
                    temp=temp.replace('floatLeftimgCls','');
                    tempar = temp.split("_");
                    
                    if(tempar == "day,1 ")
                    {
                          $('.ontimer'+getId+'_Sun').css({'color' : '#3196ff', 'opacity':'1'});
                          weekVal = weekVal + "1:";
                    }
                    else if(tempar == "day,2 ")
                    {
                        $('.ontimer'+getId+'_Mon').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "2:";
                    }
                    else if(tempar == "day,3 ")
                    {
                        $('.ontimer'+getId+'_Tue').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "3:";
                    }
                    else if(tempar == "day,4 ")
                    {
                        $('.ontimer'+getId+'_Wed').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "4:";
                    }
                    else if(tempar == "day,5 ")
                    {
                        $('.ontimer'+getId+'_Thu').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "5:";
                    }
                    else if(tempar == "day,6 ")
                    {
                        $('.ontimer'+getId+'_Fri').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "6:";
                    }
                    else if(tempar == "day,7 ")
                    {
                        $('.ontimer'+getId+'_Sat').css({'color' : '#3196ff', 'opacity':'1'});
                        weekVal = weekVal + "7:";
                    }
                    
                    $('.ontimer'+getId+'Icon').css({"display":"block", "opacity":"1"});
                    
                    ontimerTimeVal = $('#ipTextStart' + getId).val();
                    $('.ontimer' + getId + 'Time').text(ontimerTimeVal);
					
                    //update Timer DB
                    var timerName = "OnTimer" + getId;
                    //updateTimerFromDB(timerName, 'T', ontimerTimeVal, weekVal);
                    
                });
            } else {
                $('.ontimer'+getId+'Time').text("_");
                $('.ontimer'+getId+'_Sun').hide();
                $('.ontimer'+getId+'_Mon').hide();
                $('.ontimer'+getId+'_Tue').hide();
                $('.ontimer'+getId+'_Wed').hide();
                $('.ontimer'+getId+'_Thu').hide();
                $('.ontimer'+getId+'_Fri').hide();
                $('.ontimer'+getId+'_Sat').hide();
                
                $('.ontimer'+getId+'Icon').css("opacity", "0.2");
                
                var timerName = "OnTimer" + getId;
                //updateTimerOffFromDB(timerName, 'F');
            }
             
            if ($(timer_headerId).find('.offTimerIconCls>img').hasClass('check')) {
                $('.offtimer'+getId+'_Sun').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Mon').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Tue').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Wed').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Thu').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Fri').css({'color' : '#363638', 'opacity':'0.4'});
                $('.offtimer'+getId+'_Sat').css({'color' : '#363638', 'opacity':'0.4'});
                
                $('.offtimer'+getId+'_Sun').show();
                $('.offtimer'+getId+'_Mon').show();
                $('.offtimer'+getId+'_Tue').show();
                $('.offtimer'+getId+'_Wed').show();
                $('.offtimer'+getId+'_Thu').show();
                $('.offtimer'+getId+'_Fri').show();
                $('.offtimer'+getId+'_Sat').show();

                var offtimerTimeVal = "";
                var offWeekVal = "";
                $($(timer_headerId)).find('.OffSelectdaysCls>div.floatLeftimgCls').each(function() {
                    var tempar = new Array();
                    var temp;
                    temp = $(this).attr('class');
                    temp=temp.replace('floatLeftimgCls','');
                    tempar = temp.split("_");
                    
                    if(tempar == "day,1 ")
                    {
                          $('.offtimer'+getId+'_Sun').css({'color' : '#3196ff', 'opacity':'1'});
                          offWeekVal = offWeekVal + "1:";
                    }
                    else if(tempar == "day,2 ")
                    {
                        $('.offtimer'+getId+'_Mon').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "2:";
                    }
                    else if(tempar == "day,3 ")
                    {
                        $('.offtimer'+getId+'_Tue').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "3:";
                    }
                    else if(tempar == "day,4 ")
                    {
                        $('.offtimer'+getId+'_Wed').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "4:";
                    }
                    else if(tempar == "day,5 ")
                    {
                        $('.offtimer'+getId+'_Thu').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "5:";
                    }
                    else if(tempar == "day,6 ")
                    {
                        $('.offtimer'+getId+'_Fri').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "6:";
                    }
                    else if(tempar == "day,7 ")
                    {
                        $('.offtimer'+getId+'_Sat').css({'color' : '#3196ff', 'opacity':'1'});
                        offWeekVal = offWeekVal + "7:";
                    }

                    
                    $('.offtimer'+getId+'Icon').css({"display":"block", "opacity":"1"});
					
                    var offtimerTimeVal = $('#ipTextEnd' + getId).val();
                    $('.offtimer' + getId + 'Time').text(offtimerTimeVal);
					
                    //update Timer DB
                    var timerName = "OffTimer" + getId;
                    //updateTimerFromDB(timerName, 'T', offtimerTimeVal, offWeekVal);
                    
                });
               } else {
                    $('.offtimer'+getId+'Time').text("_");
                    $('.offtimer'+getId+'_Sun').hide();
                    $('.offtimer'+getId+'_Mon').hide();
                    $('.offtimer'+getId+'_Tue').hide();
                    $('.offtimer'+getId+'_Wed').hide();
                    $('.offtimer'+getId+'_Thu').hide();
                    $('.offtimer'+getId+'_Fri').hide();
                    $('.offtimer'+getId+'_Sat').hide();

                    $('.offtimer'+getId+'Icon').css("opacity", "0.2");
				
                    //update Timer DB
                    var timerName = "OffTimer" + getId;
                    //updateTimerOffFromDB(timerName, 'F');
                }
            }
        //}
     });
$(document).on('tap',".bodyCls ",function(e){ 
        if( $('#TimePicker').css('display') == 'block' ){
            console.log(' documnet' );
            e.stopPropagation();
            e.preventDefault();
            closeTimePicker();
            
			return false;
        }
        if(($('.inputStartDate').val() != "--/--") && ($('.inputEndDate').val() != "--/--"))
        {
            $('.addDoneicon').removeClass('AddDisable');
        }
    });

    $('.onTimerIconCls').on('tap', '.uncheck', function() {
        getDefaultStoreInfo();
        var getId = $(this).parent().attr('id');
        getId = getId.replace('onTimerIconCls_', '');
        var InputStartDiv = $('#ipTextStart'+getId);
        var InputEndDiv = "";
        InputEndDiv = $('#ipTextEnd'+getId).closest('.inputEndClass');
        end = "";
        var selectdays = "";
        var inputtext = "";
        selectdays = $('#SelectdaysId'+getId);
        inputtext = InputStartDiv.closest('div.inputClass');
        $(this).removeClass('uncheck');
        $(this).addClass('check');
        $(this).attr('src', '../resource/img/btn_switch_bg_on.png');
        selectdays.removeClass('AddDisable');
        inputtext.removeClass('AddDisable');  
        if (selectdays.find('.floatLeftimgCls').length <= 0) {
            for (var i = 0; i < storeWeekDayList.length; i++) {
                $('#SelectdaysId'+getId+'>.day_' + storeWeekDayList[i]).removeClass('floatLeftCls').addClass('floatLeftimgCls');
            }
        }
        if (InputStartDiv.val() == "") {
            //give default start time
            InputStartDiv.val(DefaultStartTime);
        }
        InputstarttimervalToHeader = InputStartDiv.val();
        if (InputEndDiv.hasClass('AddDisable')) {
            InputendtimervalToHeader = "";
        } else {
            InputendtimervalToHeader = $('#ipTextEnd' + getId).val();
        }
        if (InputstarttimervalToHeader != "" && InputendtimervalToHeader != "") {
            InputvalToheader = InputstarttimervalToHeader + " - " + InputendtimervalToHeader;
        } else {
            InputvalToheader = InputstarttimervalToHeader + " ~ " + InputendtimervalToHeader;
        }
        InputvalToheader=strToUpper(InputvalToheader);
        //$('#' + getId).find('.addtimerTxtCls').text(InputvalToheader);
        
        $('.ontimer'+getId+'Time').text(InputstarttimervalToHeader);

        enableApplynow();
        
        updateTimerDB("On", getId, "T");
        
    });

    $('.onTimerIconCls').on('tap', '.check', function() {

        var getId = $(this).parent().attr('id');
        getId = getId.replace('onTimerIconCls_', '');
        var InputEndDiv = "";
        InputEndDiv = $('#ipTextEnd' + getId).closest('.inputEndClass');
        var selectdays = "";
        var inputtext = "";
        selectdays = $('#SelectdaysId'+getId);
        inputtext = $('#ipTextStart'+getId);
        var inputtextDiv = $('#ipTextStart'+getId).closest('.inputClass');
        $(this).removeClass('check');
        $(this).addClass('uncheck');
        $(this).attr('src', '../resource/img/btn_switch_bg_off.png');
        selectdays.addClass('AddDisable');
        inputtextDiv.addClass('AddDisable');
        $("#spinDiv").remove();
        InputstarttimervalToHeader = "";
        if (!InputEndDiv.hasClass('AddDisable'))
       {
            InputendtimervalToHeader = $('#ipTextEnd'+getId).val();
        }
        InputvalToheader = InputstarttimervalToHeader+" ~ "+ InputendtimervalToHeader;
        
        if (InputvalToheader == " ~ ") {
            //$('#' + getId).find('.addtimerTxtCls').text("");
        } else {
             InputvalToheader=strToUpper(InputvalToheader);
            //$('#'+getId).find('.addtimerTxtCls').text(InputvalToheader);
        }
        $('.ontimer'+getId+'Time').text("");
        //$('.ontimer'+getId+'Day').text("");
        enableApplynow();
        
        updateTimerDB("On", getId, "F");
    });

    $('.offTimerIconCls').on('tap', '.check', function() {
        var getId = $(this).parent().attr('id');
        getId = getId.replace('offTimerIconCls_', '');
        var InputStartDiv = $('#onTimerIconCls'+getId).find('.inputStart');
        $(this).removeClass('check');
        $(this).addClass('uncheck');
        $(this).attr('src', '../resource/img/btn_switch_bg_off.png');
        var selectdays = "";
        var inputtext = "";
        selectdays = $('#OffSelectdaysId'+getId);
        inputtext = $('#ipTextEnd'+getId).closest('.inputEndClass');
        selectdays.addClass('AddDisable');
        inputtext.addClass('AddDisable');
        $("#spinDiv").remove();
        InputendtimervalToHeader = "";
        if ($('#onTimerIconCls'+getId+'>img').hasClass('check'))
        {
            InputstarttimervalToHeader = InputStartDiv.val();
        }
        InputvalToheader = InputstarttimervalToHeader + " ~ " + InputendtimervalToHeader;
        if (InputvalToheader == " ~ ") {
            //$('#' + getId).find('.addtimerTxtCls').text("");
        } else {
            InputvalToheader=strToUpper(InputvalToheader);
            //$('#' + getId).find('.addtimerTxtCls').text(InputvalToheader);
        }
        $('.offtimer'+getId+'Time').text("");
        //$('.offtimer'+getId+'Day').text("");
      enableApplynow();
      
        updateTimerDB("Off", getId, "F");
        
    });

    $('.offTimerIconCls').on('tap', '.uncheck', function() {
        getDefaultStoreInfo();
        var getId = $(this).parent().attr('id');
        getId = getId.replace('offTimerIconCls_', '');
        var InputStartDiv=$('#ipTextStart'+getId).closest('.inputStart');
        $(this).removeClass('uncheck');
        $(this).addClass('check');
        $(this).attr('src', '../resource/img/btn_switch_bg_on.png');
        var selectdays = "";
        var inputtext = "";
        var InputEndDiv = "";
        selectdays = $('#OffSelectdaysId'+getId);
        inputtext = $('#ipTextEnd'+getId).closest('.inputEndClass');
        InputEndDiv=$('#ipTextEnd'+getId);
        selectdays.removeClass('AddDisable');
        inputtext.removeClass('AddDisable');
        if (selectdays.find('.floatLeftimgCls').length <= 0) {
            for (var i = 0; i < storeWeekDayList.length; i++) {
               $('#OffSelectdaysId'+getId+'>.day_' + storeWeekDayList[i]).removeClass('floatLeftCls').addClass('floatLeftimgCls');
            }
        }
        if (InputEndDiv.val() == "") {
            //give default end time
            InputEndDiv.val(DefaultEndTime);
        }
        if ($('#onTimerIconCls_'+getId+'>img').hasClass('check'))
        {
            InputstarttimervalToHeader = InputStartDiv.val();
        } 
        else
         {
            InputstarttimervalToHeader = "";
        }
        InputendtimervalToHeader = InputEndDiv.val();

        if (InputstarttimervalToHeader != "" && InputendtimervalToHeader != "") {

            InputvalToheader = InputstarttimervalToHeader + " - " + InputendtimervalToHeader;
        }
        else 
        {
            InputvalToheader = InputstarttimervalToHeader + " ~ " + InputendtimervalToHeader;
        }
        InputvalToheader=strToUpper(InputvalToheader);
        //$('#' + getId).find('.addtimerTxtCls').text(InputvalToheader);
        $('.offtimer'+getId+'Time').text(InputendtimervalToHeader);
        enableApplynow();

        updateTimerDB("Off", getId, "T");
        
    });
    //select days
    $('.SelectdaysCls>div').on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
           var checkfordays = "";
           var currentDaysId="";
           currentDaysId=$(this).parent().attr('id');
           var TrimId=currentDaysId.replace('SelectdaysId','');
        if ($('#'+currentDaysId).hasClass('AddDisable') == true) {
            return false;
        }
         else{
            if ($(this).hasClass('floatLeftCls')) {
                $(this).removeClass('floatLeftCls').addClass('floatLeftimgCls');
            } 
            else if ($(this).hasClass('floatLeftimgCls')) {
                $(this).removeClass('floatLeftimgCls').addClass('floatLeftCls');
            }
                $('#'+currentDaysId).find('.floatLeftimgCls').each(function() {
                checkfordays += $(this).attr('id');
            });
            if (checkfordays == "") {
                var onTimeIconImageObj = $('#onTimerIconCls_'+TrimId).find('img');
                onTimeIconImageObj.removeClass('check');
                onTimeIconImageObj.addClass('uncheck');
                onTimeIconImageObj.attr('src', '../resource/img/btn_switch_bg_off.png');
                $('#SelectdaysId'+TrimId).addClass('AddDisable');
                $('#ipTextStart'+TrimId).closest('.inputClass').addClass('AddDisable');
            }
            updateTimerDB("On", TrimId, "T");
        }
    });

    //timer off select days
    $('.OffSelectdaysCls>div').on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        var checkfordays = "";
        var CurrentDaysId=$(this).parent().attr('id');
        var TrimId=CurrentDaysId.replace('OffSelectdaysId','');
        if ($('#'+CurrentDaysId).hasClass('AddDisable') == true) {
            return false;
        } else {
            if ($(this).hasClass('floatLeftCls') == true) {
                $(this).removeClass('floatLeftCls').addClass('floatLeftimgCls');
            } else if ($(this).hasClass('floatLeftimgCls') == true) {
                $(this).removeClass('floatLeftimgCls').addClass('floatLeftCls');
            }

            $('#'+CurrentDaysId).find('.floatLeftimgCls').each(function() {
                checkfordays += $(this).attr('id');
            });
            if (checkfordays == "") {
                var offTimerIconImageObj = $('#offTimerIconCls_'+TrimId).find('img');
                offTimerIconImageObj.removeClass('check');
                offTimerIconImageObj.addClass('uncheck');
                offTimerIconImageObj.attr('src', '../resource/img/btn_switch_bg_off.png ');
                $('#'+CurrentDaysId).addClass('AddDisable');
                $('#ipTextEnd'+TrimId).closest('div.inputEndClass').addClass('AddDisable');
                
            } else {

            }
            
        	updateTimerDB("Off", TrimId, "T");            
        }
    });
    
    

         
  //**************************on/off Timer Event Listeners End ***********************************************//
  //**************************Holiday Management Event Listeners Start ***********************************************//
    var set = $('.holiday_block');
    var addHoliday = "";
    $('#holidayMgnttitleId').on('touchstart', function(){
    	if(!$(this).hasClass('AddDisable')){
    		$(this).addClass('insideTxtfontCls-active');
    	}
    }).on('touchend', function(){
    	$(this).removeClass('insideTxtfontCls-active');
    });
    $('#holidayMgnttitleId').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        if($(this).hasClass('AddDisable'))
        {
            return false;
        }
        $('.holiday_block').scrollTop(0);
    	updateTimerHolidayDB = false;
        var ind = "";
        var addstartinput = "";
        var addendinput = "";
        var accolength = $('.hoilday_header_tap').length;
        addId++;
        if (FalgDoubletap) {
            FalgDoubletap = false;
            setTimeout(function() {
                if (alreadyEnteredHolidayFlag == false) {
                     falgtoDonedisable=true;
                     DeleteEmptyHoliday(false);
                    if (accolength < 20) {
                         var style = "width:100%;padding: 10px 0px 10px 0px; font-size:18px !important;";
                        addHoliday = '<div data-role="collapsible" data-iconpos="right"  class="hoilday_header_tap hoilday_header_tap' + addId + '"    id="hoilday_header_tapId' + addId + '" >' + ' <h3>' + '<div class="title_holiday">--/-- ~ --/--</div>' + '<div class="HolidayiconNtxtupdate"><div class="Checkboxtext">'+langObj.Settings.MIA_SID_MONTH_SLASH_DATE+'</div><div id="addDeleteiconId" class="addDeleteicon"></div> </div>' + '</h3>' + '  <div class="holidayContentCls' + addId + '">' + '<div class="inputBlock_holiday">' + '<div class="TimertxtId" style="margin-top: 0px;height:15%;" class="insideTxtfontCls">' + '<div class="HoltxtCls">'+ langObj.Settings.MIA_SID_START_FROM + '</div>'+'<div class="HoltxtToCls">'+langObj.Settings.COM_TO_DATE +'</div>' + '</div>' + '<div style="height:35%"><div style="float: left; width: 43%;" class="startholidayConcls' + addId + '">' + ' </div>' + '<div style="float: left; width: 13.5%;">' + '<div class="txtbtnCls">-</div>' + '</div>' + '<div style="float: left; width: 43%;" class="endholidayConcls' + addId + '">' + '</div></div>' + '<div id="btncontainer" style="margin-top:-15%;height:15%;width:100%;">' + '<div id="newconection_cancel" style="float:left;width:48%;height:100%;"><div id="addUndoiconId" style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline addUndoicon">' + langObj.Schedule.COM_SID_CANCEL + '</div></div>' + '<div id="newconection_save" style="float:right;width:48%;height:100%;"><div id="addDoneiconId"  style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline addDoneicon">' + langObj.Schedule.COM_BUTTON_SAVE + '</div></div>' + '</div>' + ' </div>' + '</div>' +  '</div>';
                        //addHoliday ='<div data-role="collapsible" data-iconpos="right"  class="hoilday_header_tap hoilday_header_tap' + addId + '"                         id="' + addId + '" >' + '<h3>'+'<div class="title_holiday">--/-- ~ --/--</div>' + '<div class="HolidayiconNtxtupdate"><div class="Checkboxtext">'+langObj.Settings.MIA_SID_MONTH_SLASH_DATE+'</div><div id="addDeleteiconId" class="addDeleteicon"></div></div>' +'</h3>'+ '<div class="holidayContentCls holidayContentCls' + addId + '">' + '<div class="inputBlock">' + '<div class="TimertxtId" style="margin-top: 0px;height:28%;" class="insideTxtfontCls">' + '<div class="HoltxtCls">'+ langObj.Settings.MIA_SID_START_FROM + '</div>'+'<div class="HoltxtToCls">'+langObj.Settings.COM_TO_DATE +'</div>' + '</div>' + '<div style="float: left; width: 43%;" class="startholidayConcls' + addId + '">' + ' </div>' + '<div style="float: left; width: 13.5%;">' + '<div class="txtbtnCls">-</div>' + '</div>' + '<div style="float: left; width: 43%;" class="endholidayConcls' + addId + '">' + '</div>' + '</div>' + '<div id="btncontainer" style="padding-top:3%;width:100%;">' + '<div id="addUndoiconId" style="float:left;width:38%;height:100%;"class="my-btn-footer ui-btn ui-btn-inline addUndoicon">' + langObj.Schedule.COM_SID_CANCEL + '</div>' + '<div id="addDoneiconId" style="float:right;width:38%;height:100%;" class="my-btn-footer ui-btn ui-btn-inline addDoneicon AddDisable">'+langObj.Schedule.COM_BUTTON_SAVE+ '</div></div>' + '</div>' + '</div>';
                        
                        $('.holiday_block').prepend(addHoliday).collapsibleset('refresh');

                        var collapsed = $(".hoilday_header_tap" + addId).collapsible("option", "collapsed");
                        $(".hoilday_header_tap" + addId).collapsible("option", "collapsed", false);
                        addstartinput = ' <input type="text"  class="calInput_date inputStartDate"  id="ipTextDateStart'+addId+'" value="--/--" name="ipText" maxlength="5"  readonly/>';
                        addendinput = '<input type="text"  class="calInput_date inputEndDate" id="ipTextDateEnd'+addId+'"  value="--/--" name="ipText" maxlength="5"  readonly/>';
                        $('.startholidayConcls' + addId).append(addstartinput);
                        $('.endholidayConcls' + addId).append(addendinput);
                        $('.startholidayConcls' + addId).trigger('create');
                        $('.endholidayConcls' + addId).trigger('create');
                        $('#addDeleteiconId').hide();
                        
                        $('.addDeleteicon').addClass('icon-disabled');
                    }
                    else
                    {
                        genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Settings.MIA_SID_SET_MAXIMUM_20HOLIDAYS]);

                    }
                }

                FalgDoubletap = true;
            }, 350);

        }

    });
    
    $(document).on('tap', '.addDeleteicon', function(e) {
        var currentholidayDeleteIcon = $(this);
        e.stopPropagation();
        e.preventDefault();
        console.log("addDeleteicon click");

        if ( currentholidayDeleteIcon.hasClass('icon-disabled') == true )
            return;
        
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.COM_TV_SID_DELETE_HOLIDAY_KR_MIA]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_TV_SID_NO,
            "callback" : "closeGenericPopUp"
        }, {
            "btntxt" : COM_TV_SID_YES,
            "callback" : function() {
            	var currentHolidayID = currentholidayDeleteIcon.closest('.hoilday_header_tap').attr('id');
            	currentHolidayID = currentHolidayID.substring(20);
            	deleteHolidayFromDB(currentHolidayID);
				
                currentholidayDeleteIcon.closest('.hoilday_header_tap').remove();
                enableApplynow();
            }
        }]);
        genericPopUpObj.showPopUp();

    });


    $(document).on('tap', '.addDoneicon', function(e) {
        
        var currentholidayAddIcon = $(this);
        if (!currentholidayAddIcon.hasClass('AddDisable'))
        {
            var currentholidayDoneIcon = $(this);
            e.stopPropagation();
            e.preventDefault();
            console.log("addDoneicon click");
            $('.addDeleteicon').removeClass('icon-disabled');
            
            $('.hoilday_header_tap>h3').show();
            $('.addDeleteicon').show(); 
                    
            FlagToexpand=false;
            $( ".hoilday_header_tap" ).collapsible( "enable" );
            if (!currentholidayDoneIcon.hasClass('AddDisable'))
            {
                var currentHolidayID = currentholidayDoneIcon.closest('.hoilday_header_tap').attr('id');
                currentHolidayID = currentHolidayID.replace('hoilday_header_tapId', '');
                var heret=$(this).closest('.HolidayiconNtxtupdate');
                flagtoFifteenDays=true;
                alreadyEnteredHolidayFlag=false;
                $('.hoilday_header_tap'+currentHolidayID+'>h3').hide();
                ShowPopupForInvalidCasesInHolidayEnd(currentHolidayID);
               
                console.log("flagtoFifteenDays"+flagtoFifteenDays+"alreadyEnteredHolidayFlag"+alreadyEnteredHolidayFlag);
             
                if (flagtoFifteenDays == true && alreadyEnteredHolidayFlag == false) {
                    falgtoDonedisable=false;
                                        
                    heret.find('.addUndoicon').hide();
                    heret.find('.addDoneicon').hide();
                    heret.find('.addDeleteicon').show();
                    if(isHolidayIdExistsInLocalSrotage(currentHolidayID))
                    {
                    	updateTimerHolidayDB=true;
                    } 
                    sendvalueToholidayHeader(currentHolidayID);
                    var collapsed = $(".hoilday_header_tap" + currentHolidayID).collapsible("option", "collapsed");
                    $(".hoilday_header_tap" + currentHolidayID).collapsible("option", "collapsed", true);
                    $('#holidayMgnttitleId').removeClass('AddDisable');    
                }    
            }
            else{
                return false;
            }
         }
    });
    
    $(document).on('tap', '.addUndoicon', function(e) {
        var currentholidayUndoIcon = $(this);
        e.stopPropagation();
        e.preventDefault();
        FlagToexpand=false;
        $( ".hoilday_header_tap" ).collapsible( "enable" );

        console.log("addUndoicon click");

        $('.addDeleteicon').removeClass('icon-disabled');

        if (!currentholidayUndoIcon.hasClass('AddDisable'))
        {
            var currentHolidayID = currentholidayUndoIcon.closest('.hoilday_header_tap').attr('id');
            currentHolidayID = currentHolidayID.replace('hoilday_header_tapId','');
            if($(".hoilday_header_tap" + currentHolidayID).find('.ui-collapsible-heading-toggle>.title_holiday').text()=="--/-- ~ --/--")
            {
                $('#ipTextDateStart' + currentHolidayID).val('--/--');
                $('#ipTextDateEnd' + currentHolidayID).val('--/--');
                $(".hoilday_header_tap" + currentHolidayID).remove();                
            }
            else{
                var StorePrevDate=$(".hoilday_header_tap" + currentHolidayID).find('.ui-collapsible-heading-toggle>.title_holiday').text();
                StorePrevDate=StorePrevDate.split(' ~');
                $('#ipTextDateStart' + currentHolidayID).val(StorePrevDate[0]);
                $('#ipTextDateEnd' + currentHolidayID).val(StorePrevDate[1]);
                falgtoDonedisable=false;
                 var collapsed = $(".hoilday_header_tap" + currentHolidayID).collapsible("option", "collapsed");
                $(".hoilday_header_tap" + currentHolidayID).collapsible("option", "collapsed", true);
                falgtoDonedisable=true;
                currentholidayUndoIcon.closest('.hoilday_header_tap').find('.addUndoicon').hide();
                currentholidayUndoIcon.closest('.hoilday_header_tap').find('.addDoneicon').hide();
                currentholidayUndoIcon.closest('.hoilday_header_tap').find('.addDeleteicon').show(); 
                $(".hoilday_header_tap" + currentHolidayID + ">h3").show();               
            }
              $('#holidayMgnttitleId').removeClass('AddDisable');
        }
        else{
            return false;
        }
    });


    $(document).on("collapsiblecollapse", ".hoilday_header_tap", function(event, ui) {
        event.preventDefault();
        event.stopPropagation();
        DeleteEmptyHoliday(true);
        
        var heret=$(this);
        if(FlagToexpand==true)
        {
            $(this).collapsible("option", "collapsed", false);
            return false;
        }
        if (!$(this).find('.addDoneicon').hasClass('AddDisable')) {            
            
            if (falgtoDonedisable == true) {
                console.log("collapsiblecollapse dont close first ");
                try
                {
                	$(this).collapsible("option", "collapsed", false);	
                }
                catch(ex)
                {
                	console.log("Not able to collapse, as item already deleted");
                }
                return false;
            }

        } else {
        
            if (falgtoDonedisable == true) {
                console.log("collapsiblecollapse dont close");
                try
                {
                	$(this).collapsible("option", "collapsed", false);	
                }
                catch(ex)
                {
                	console.log("Not able to collapse, as item already deleted");
                }
                
                return false;
            }

            $('#holidayMgnttitleId').removeClass('AddDisable');
        }
    });
    

    $(document).on("collapsibleexpand", ".hoilday_header_tap", function(event, ui) {

        var id = $(this).attr('id');
        id=id.replace('hoilday_header_tapId','');
        console.log("click collapsibleexpandFlagToexpand"+FlagToexpand);
        if(FlagToexpand==true)
        {
            return false;
        }
        FlagToexpand=true;
        $( ".hoilday_header_tap" ).collapsible( "disable" );
        console.log("collapsibleexpand excuting");
        //Collapse accordion if any is opened
        //$(".timer_header_tap").collapsible("collapse");
        $('#holidayMgnttitleId').addClass('AddDisable');
        
        $(".hoilday_header_tap" +id +">h3").hide();
        
        // code to fill latest value in input boxes while expanding
        var valForInput=$(".hoilday_header_tap" +id +">h3 .title_holiday").html();
        var ipArr=valForInput.split("~");
        $("#ipTextDateStart"+id).val($.trim(ipArr[0]));
        $("#ipTextDateEnd"+id).val($.trim(ipArr[1]));
        var currentholidayDoneIcon=$(this).find('.HolidayiconNtxtupdate');
        if($(this).find('.addDeleteicon').css('display')=="block")
        {
                   
            $(this).find('.addUndoicon').show();
            $(this).find('.addDoneicon').show();
            $(this).find('.addDoneicon').addClass('AddDisable');
            $(this).find('.addDeleteicon').hide(); 

        }
        falgtoDonedisable=true;
        $(".Timer_holidayContainerCls").scrollTo($(this), 500);
        
    });
    $(document).on('tap', '.inputStartDate', function(e) {
        
        e.stopPropagation();
        e.preventDefault();
        $(this).focus();
        var ths=$(this);
        callFocusInputStart(ths);
    });
    $(document).on('tap', '.inputEndDate', function(e) {
        
        e.stopPropagation();
        e.preventDefault();
        $(this).focus();
        var ths=$(this);
        callFocusInputEnd(ths);
    });
    
    
    
//**************************Holiday Management Event Listeners End ***********************************************//

//*************************Send On/Off timer Tap Events Start*****************************************************//
  $('ul#deviceListOnOffTimer').on('tap', '.del_icon', function(e) {
        if($(this).hasClass('icon-disabled')){
            return false;
        }
        e.stopPropagation();
        var thisVal = $(this);
        var mDeviceIP = $(this).closest('li.auto-LFD-List').attr('ip');
        
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.COM_TV_DELETE_THE_DEVICE_FROM_THE_LIST_YES_NO]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : "closeGenericPopUp"
        }, {
            "btntxt" : COM_SID_OK,
            "callback" : function() {
                deleteDeviceFromDB(mDeviceIP);
                thisVal.closest('li').remove();
            }
        }]);
        genericPopUpObj.showPopUp();
    });
    


    $('.Settinglist_Send').on('tap', 'li>.nor_checkbox', function(e) {
        e.stopPropagation();
        e.preventDefault();
        settingsPageType = 1;
        var $deviceObj = $(this).parent('.auto-LFD-List');
        deviceID = $deviceObj.attr('id');
        deviceIp = $deviceObj.attr('ip');
        devicename = $('#' + deviceID).attr('devicename');
        if ($deviceObj.attr('isaddedmanually') == "true") {
            devicename = $deviceObj.find('div.name div').first().text();
        }
        tlsReq = $deviceObj.attr('tls');
        pin = $deviceObj.attr('pin');
	    var devName = $deviceObj.attr('deviceName');
        var mac = $deviceObj.attr('mac');
        deviceListContainerRef = $(this);

        //if (Utils.checkConnection() == 3) {
         //   $('#StartsendbtnId').removeClass('icon-disabled');
       // }

        mLFDInfo = new mLFDDeviceInfo();
        mLFDInfo.mDeviceIP = deviceIp;
        mLFDInfo.mDeviceId = deviceID;
        mLFDInfo.mDeviceName = devName;
        mLFDInfo.mMetaInfo = mMetaInfo;
        mLFDInfo.mStatus = INITIALIZE;
        mLFDInfo.mTLSRequired = tlsReq;
        mLFDInfo.mPin = pin;
        mLFDInfo.mMacAddr = mac;


        if (tlsReq == '1' && pin.length == 0){
            $('#pin_verification_page_Id').attr('isManual', false);

            //var pinHeaderStr = 'Enter the PIN number for ' + deviceName + '. This process is required only when connecting to the target device for the first time.';
            var pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_ENTER_PIN_NUMBER_FOR.replace("<<A>>", devicename) + " " + langObj.Send.MIA_SID_20_PROCESS_REQUIRED_CONNECTING_TARGET_FIRST);
            askToEnterCorrectPIN(deviceIp, false, pinHeaderStr);
            //  $('#pinboxd').focus();
        } else {
            $(this).removeClass('nor_checkbox').addClass('sel_checkbox');
            $('.network-footer>#newconection').removeClass('icon-disabled');
            $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').removeClass('icon-disabled');
            mLFDInfoArrayList.push(mLFDInfo);
             if (mLFDInfoArrayList.length >0) {
                 $('#StartsendbtnId').removeClass('icon-disabled');
            }
          }
          return false;
     });


    // not required as of now
    /*$(document).on('tap', '.pintext', function(e) {
        //return; // remove this if edit on tap is required
        //e.preventDefault();
        var element = $(this);
        if (currPinBox == element.attr('id')) {
            return;
        }
        $('#' + currPinBox).removeClass('pintext-active');
        element.addClass('pintext-active');
        currPinBox = element.attr('id');
    });*/

        // ADD MANUALLY CLOSE BUTTON
         /*$('#Add_SinageTV_Close_Btn_ID').on('tap', function(e) {
                e.stopPropagation();
                e.preventDefault();

                // if something is foucused
                if( document.activeElement.tagName == "INPUT") {
                    $('.iptext').blur();
                    setTimeout(function(){
                        $('.iptext').val('');
                        $('#view-setting').show();
                        $('#settings_manually_add-ipID').hide();
                        $('#manually_add-ip-panel').hide();
                    },400);
                }else {
                    $('.iptext').val('');
                    $('#view-setting').show();
                    $('#settings_manually_add-ipID').hide();
                    $('#manually_add-ip-panel').hide();
                    }
                    });*/

    // PIN VERIFICATION CLOSE BUTTON
         $('#pin_verification_close_Id').on('tap', function(e) {
                     e.stopPropagation();
                     e.preventDefault();
                     try{
                                  mLFDInfo.mPin = "";
                                 }catch(e){}
                     deviceListContainerRef.parent('.auto-LFD-List').attr('id');
                     // if something is foucused
                     if( document.activeElement.tagName == "INPUT") {
                         //$('.pintext').blur();
                         setTimeout(function(){
                             closePinVerification();
                         },400);
                     }else {
                         closePinVerification();
                     }
                 });

                   // ADD MANUALLY DONE BUTTON
          /*$('#Add_SinageTV_Done_Btn_ID').on('tap', function(e) {
                  e.stopPropagation();
                  e.preventDefault();

                         // if something is foucused
                         if( document.activeElement.tagName == "INPUT") {
                             $('.iptext').blur();
                             setTimeout(function(){
                                 ValidIPEnterUpdate();
                             },400);
                         }else {
                             ValidIPEnterUpdate();
                         }
                });*/

  // PIN VERIFICATION DONE BUTTON
                  $('#pin_verification_done_Id').on('tap', function(e) {
                          e.stopPropagation();
                          e.preventDefault();
                          //$('.pintext').blur();
                          setTimeout(function(){
                            if(settingsPageType == 1){
                            var ip =  deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
                                    if(ip==undefined){
                                           ip =  deviceListContainerRef.attr('ip');
                                       }
                               }
                               else{
                               var ip =  thisVal.parent('.auto-LFD-List').attr('ip');
                                   if(ip==undefined){
                                          ip =  thisVal.attr('ip');
                                      }
                               }
                            var pinVal = $('#pinboxa').val().trim() + $('#pinboxb').val().trim() + $('#pinboxc').val().trim() + $('#pinboxd').val().trim();
                            $('.pintext').val('');
                            $('#view-setting').show();
                            $('#pin_verification_page_Id').hide();
                            $('#pin_verification_panel').hide();
                            pinVal = pinVal.trim();
                            showAnimationLoader("");
                            var isManual = $('#pin_verification_page_Id').attr('isManual');
                            mProtocolManager.verifyPINInfo(ip,settingsPageType,pinVal,deviceListContainerRef,isManual);
                         },400);
                     });


    $('.Settinglist_Send').on('tap', 'li>.sel_checkbox', function(e) {
        e.stopPropagation();
        var autoLfdListObj = $(this).parent('.auto-LFD-List');
        deviceID = autoLfdListObj.attr('id');
        deviceIp = autoLfdListObj.attr('ip');
        tlsReq = autoLfdListObj.attr('tls');
        pin = autoLfdListObj.attr('pin');
        var devName = autoLfdListObj.attr('deviceName');
        $(this).removeClass('sel_checkbox').addClass('nor_checkbox');

            mLFDInfo = new mLFDDeviceInfo();
            mLFDInfo.mDeviceIP = deviceIp;
            mLFDInfo.mDeviceId = deviceID;
            mLFDInfo.mDeviceName = devName;
            mLFDInfo.mMetaInfo = mMetaInfo;
            mLFDInfo.mStatus = INITIALIZE;
            mLFDInfo.mTLSRequired = tlsReq;
            mLFDInfo.mPin = pin;
            mLFDInfoArrayList.pop(mLFDInfo);
            if (mLFDInfoArrayList.length < 1) {
                $('#StartsendbtnId').addClass('icon-disabled');
            }
    });


    $('.Settinglist_Send').on('tap', 'li>.cancel_checkbox', function(e) {
        e.stopPropagation();
        var autoLfdListObj = $(this).parent('.auto-LFD-List');
        $(this).addClass('icon-disabled');
        autoLfdListObj.find('.storageInfo').html('');
        deviceID = autoLfdListObj.attr('id');

        // CANCEL INDIVISUAL SEND
        for (var index = 0; index < mLFDInfoArrayList.length; index++) {
            if (mLFDInfoArrayList[index].mDeviceId == deviceID) {
                mLFDInfoArrayList[index].isCanceled = true;
                isCanceled = true;

                if (mLFDInfoArrayList[index].mStatus == INITIALIZE)
                {
                    mLFDInfoArrayList[index].mStatus = CANCEL;
                    isCanceled = true;

                    showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
                    setTimeout(function() {
                        loaderObj.hideLoader();
                        isCanceled = false;
                        preonOffTimerCanceled(deviceID);
                    }, 1500);
                } else {
                    isCanceled = true;
                    showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
                }
                break;
            }
        }
    });


    
    $('#addSmartSignagebtn_sendId').on('tap', function(e) {

        if($('#AddsignageTvsendId').hasClass('AddDisableAddManual')){
            return false;
        }
        e.stopPropagation();
        $('#settings_ContentsId').hide();
        $('.custom-header').hide();
        $('#settings_manually_add-ipID').show();
        $('#manually_add-ip-panel').show();
        $('#header-part2_addSignagea').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
        $('#AddsignageTvId').hide();
        isOnOffTimerIP = true;
        $('#firmIpbox1').focus();
        return false;
    });

        
    // Refresh button for on-off timer device discovery list
    $('#Loadercontainer_sendId').on('tap', function() {
        if (isWiFiEnable) {
            if ($(this).hasClass('icon-disabled')) {
                return false;
            }
            $('.addNoDeviceMsgCls>.addNoDeviceMsgTxtCls').text('');
            mProtocolManager.startDeviceDiscovery();
            $('#StartsendbtnId').text(langObj.Settings.COM_COMMONCTRL_SEND);
            $('#StartsendbtnId').addClass();
            $('#StartsendbtnId').addClass('icon-disabled');
            $('.Settinglist_Send').html('');
            showLoader('Loadercontainer_sendId');
            $('.AddsignageSendTvCls').addClass('AddDisableAddManual');
            $('.AddsignageSendTvCls').show();
            $('.settings_manually_add').hide();
        }
    });

    // SEND On-Off Timer
    $('#StartsendbtnId').on('tap', function() {
        if ($(this).hasClass('icon-disabled')) {
            return false;
        }
        showLoader('Loadercontainer_sendId');
        $('#deviceListOnOffTimer  div.del_icon, #Loadercontainer_sendId').addClass('icon-disabled')
        var startSend = $(this).text();
        startSend = startSend.trim();
        if (startSend == langObj.Settings.COM_COMMONCTRL_SEND) {
            mTaskType = CONNECTION_TYPE_ON_OFF_TIMER_UPDATE;
            // Reset list
            mLFDInfoArrayList = new Array();
            var listItems = $("#deviceListOnOffTimer li");
            listItems.each(function(li) {
                var mDeviceId = $(this).attr('id');
                var mDeviceIP = $(this).attr('ip');
                var deviceName = $(this).attr('deviceName');
                var mtlsReq = $(this).attr('tls');
                var mpin = $(this).attr('pin');

                if ($('li#' + mDeviceId).find('.checkbox_settings').hasClass('sel_checkbox')){
                    $('li#' + mDeviceId).find('.checkbox_settings').removeClass('sel_checkbox').addClass('cancel_checkbox');

                    $('#' + mDeviceId).removeClass('send-failed');

                    mDeviceIP = mDeviceIP.trim();
                    /*mDeviceIP = mDeviceIP.split(".").map(function(i) {
                        return parseFloat(i);
                    }).join(".");*/
                    var mLFDInfo = new mLFDDeviceInfo();
                    mLFDInfo.mDeviceIP = mDeviceIP;
                    mLFDInfo.mDeviceName = deviceName;
                    mLFDInfo.mDeviceId = mDeviceId;
                    mLFDInfo.mStatus = INITIALIZE;
                    mLFDInfo.isCanceled = false;
                    mLFDInfo.mTLSRequired = mtlsReq;
                    mLFDInfo.mPin = mpin;
                    mLFDInfo.mMetaInfo = mMetaInfo;
                    mLFDInfoArrayList.push(mLFDInfo);

                    $('li#' + deviceID).find('.function_icon').removeClass('err_icon');
                    $('li#' + mDeviceId).find('.storageInfo').text(langObj.Send.COM_EBD_MOBSS_SENDING_KR_BLANK);
                    }

                if ($('li#' + mDeviceId).find('.checkbox_settings').hasClass('nor_checkbox')){
                    $('li#' + mDeviceId).find('.checkbox_settings').addClass('icon-disabled');
                }
            });

            var index = mLFDInfoArrayList.length;
            if (index > 0) {
                isProgress = true;
                mLFDInfoArrayList.reverse();
                var id = mLFDInfoArrayList[index - 1].mDeviceId;
                mProtocolManager.initNetworkConnection(CONNECTION_TYPE_ON_OFF_TIMER_UPDATE);
                $('#Loadercontainer_sendId>.refresh').addClass('icon-disabled');
                $('#StartsendbtnId').addClass('icon-disabled');
                $('.AddsignageTvCls').addClass('AddDisableAddManual');
                $('.AddsignageSendTvCls').addClass('AddDisableAddManual');
            } else {
                $('#StartsendbtnId').addClass('icon-disabled');
            }
        } else if (startSend == langObj.Settings.homeId) {
            mProtocolManager.stopAutoDiscoveryService();
            document.location.href = '../quickstart/QuickStart.html';
        }
    });

    
//*************************Send On/Off timer Tap Events***********************//


    //Apply now button
    $('.network-footer-apply>#newconection_apply').on('tap', function() {
        if ($('.network-footer-apply>#newconection_apply').hasClass('AddDisable')) {
            return false;
        }
        $(".timer_header_tap").collapsible("collapse");
        //reset list;
        mLFDInfoArrayList = new Array();
        var temponvalue = "";
        var temponoffvalue = "";
        var tempoffvalue = "";
        var tempoffoffvalue = "";
        ONtimervaluetoApply = "";
        OFFtimervaluetoApply = "";
        DateValuetoApply = "";
        $('#StartsendbtnId').addClass('icon-disabled');
        var indx = "";
        $('.Timer_block>.timer_header_tap').each(function() {
            id = $(this).attr('id');
            DayStr = "";
            OFFDayStr = "";
            if ($(this).find('.onTimerIconCls>img').hasClass('check')) {

                $(this).find('.SelectdaysCls>div.floatLeftimgCls').each(function() {
                    var tempar = new Array();
                    var temp;
                    temp = $(this).attr('class');
                    temp=temp.replace('floatLeftimgCls','');
                    tempar = temp.split("_");
                    DayStr += tempar[1] + ":";
                });
                DayStr = DayStr.slice(0, -1);
                //to remove last char from string
                Timer_Strtval = $(this).find('#ipTextStart' + id).val();
                Timer_Strtval = Timer_Strtval.replace("am", ";am");
                Timer_Strtval = Timer_Strtval.replace("pm", ";pm");

                if (ONtimervaluetoApply == "") {

                    ONtimervaluebeforeApply = "OnTimer" + id + ";" + Onvalue + ";" + DayStr + ";" + Timer_Strtval + ';' + '0x62;60';
                    temponvalue = "OnTimer" + id + ";" + "On;;" + ';' + '0x62;60';
                    if (ONtimervaluebeforeApply != temponvalue)
                    {
                        ONtimervaluetoApply += ONtimervaluebeforeApply;
                    }
                } else {
                    ONtimervaluebeforeApply = "OnTimer" + id + ";" + Onvalue + ";" + DayStr + ";" + Timer_Strtval + ';' + '0x62;60';
                    temponvalue = "OnTimer" + id + ";" + "On;;" + ';' + '0x62;60';
                    if (ONtimervaluebeforeApply != temponvalue)
                    {
                        ONtimervaluetoApply += '>>>>' + ONtimervaluebeforeApply;
                    }
                }

                ONtimervaluetoApply = ONtimervaluetoApply.trim();

            }//if end  for on timer
            //off timer seperation
            if ($(this).find('.offTimerIconCls>img').hasClass('check')) {

                $(this).find('.OffSelectdaysCls>div.floatLeftimgCls').each(function() {
                    var temoffpar = new Array();
                    var tempoff;
                    tempoff = $(this).attr('class');
                    tempoff=tempoff.replace('floatLeftimgCls','');
                    temoffpar = tempoff.split("_");
                    OFFDayStr += temoffpar[1] + ":";
                });
                OFFDayStr = OFFDayStr.slice(0, -1);
                //to remove last char from string
                Timer_Endval = $(this).find('#ipTextEnd' + id).val();

                Timer_Endval = Timer_Endval.replace("am", ";am");
                Timer_Endval = Timer_Endval.replace("pm", ";pm");
                if (OFFtimervaluetoApply == "") {
                    OFFtimervaluebeforeApply = "OffTimer" + id + ";" + Offvalue + ";" + OFFDayStr + ";" + Timer_Endval;
                    tempoffvalue = "OffTimer" + id + ";" + "On;;";
                    if (OFFtimervaluebeforeApply != tempoffvalue) {
                        OFFtimervaluetoApply += OFFtimervaluebeforeApply;
                    }
                } else {
                    OFFtimervaluebeforeApply = "OffTimer" + id + ";" + Offvalue + ";" + OFFDayStr + ";" + Timer_Endval;
                    tempoffvalue = "OffTimer" + id + ";" + "On;;";
                    if (OFFtimervaluebeforeApply != tempoffvalue) {

                        OFFtimervaluetoApply += '>>>>' + OFFtimervaluebeforeApply;
                    }
                }
                OFFtimervaluetoApply = OFFtimervaluetoApply.trim();

            }

        }); 
        //timer values end
        //Date values start
         DeleteEmptyHolidayApplyNow();
        $('.holiday_block>.hoilday_header_tap').each(function() {
            Date_value = "";
            var holidayId = $(this).attr('id');
            holidayId=holidayId.replace('hoilday_header_tapId','');
            Strtval = $(this).find('#ipTextDateStart' + holidayId).val();
            Endval = $(this).find('#ipTextDateEnd' + holidayId).val();
            if (Strtval != "--/--") {
                Date_value = Strtval;
            }
            if (Endval != "--/--") {
                Date_value = Endval;
            }
            if (Strtval != "--/--" || Endval != "--/--") {
                if (Strtval == "--/--") {
                    Date_value = Strtval + ":" + Endval;
                }
                if (Endval == "--/--") {
                    Date_value = Strtval + ":" + Endval;
                }
                if (Strtval != "--/--" && Endval != "--/--") {
                    Date_value = Strtval + ":" + Endval;
                }
            }
            
             checkForFifteenDays(Strtval, Endval);
            alreadyEnteredHoliday(holidayId);
            
            if (alreadyEnteredHolidayFlag == true) {
                            indx = holidayId;
                        }
            
            Date_value_trim = Date_value;
            Date_value_trim = Date_value_trim.replace('/', '');
            Date_value_trim = Date_value_trim.replace('/', '');
            Date_value_trim = Date_value_trim.trim();
            if (Date_value_trim != "") {
                DateValuetoApply += ";" + Date_value_trim;
            }
             
        });
        //holiday values end

        if (DateValuetoApply != "") {

            finalvaluebeforesent = 'SysTime;' + Utils.getCurrentSystemTime() + '>>>>' + ONtimervaluetoApply + '>>>>' + OFFtimervaluetoApply + '>>>>H' + DateValuetoApply;

        } else {

            if (OFFtimervaluetoApply != "") {

                finalvaluebeforesent = 'SysTime;' + Utils.getCurrentSystemTime() + '>>>>' + ONtimervaluetoApply + '>>>>' + OFFtimervaluetoApply;

            } else {

                finalvaluebeforesent = 'SysTime;' + Utils.getCurrentSystemTime() + '>>>>' + ONtimervaluetoApply;
            }

        }

        if (ONtimervaluetoApply == "" && OFFtimervaluetoApply == "" && DateValuetoApply == "") {

            finalvaluebeforesent = finalvaluebeforesent.replace('>>>>', '');
            finalvaluebeforesent = finalvaluebeforesent.replace('>>>>', '');
            finalvaluebeforesent = finalvaluebeforesent.replace('>>>>', '');

        }

        // mMetaInfo = 'SysTime;'+Utils.getCurrentSystemTime()+'>>>>'+ONtimervaluetoApply+'>>>>'+OFFtimervaluetoApply+'>>>>H'+DateValuetoApply;
        finalvaluebeforesent = finalvaluebeforesent.replace('>>>>>>>>', '>>>>');
        finalvaluebeforesent = finalvaluebeforesent.replace('>>>>>>>>', '>>>>');
        mMetaInfo = finalvaluebeforesent;
        mMetaInfo = mMetaInfo.replace(/\s+/g, '');
        var currenttime = Utils.getCurrentSystemTime();
        currenttime = "Sys Time;" + currenttime;
        currenttime = currenttime.replace(/\s+/g, '');
        if (mMetaInfo == currenttime) {
            genericOkPopUP("Type1", 'Notification', COM_SID_OK, ['No on or off timer or holiday selected.']);
        } else {
            setTimeout(function() {
                if (flagtoFifteenDays == true && alreadyEnteredHolidayFlag == false) {
                    $('#power-cntrl-panel').hide();
                    $('#power-cntrl-panel-apply').show();
                    $('.Settinglist_Send').html('');
                    $('.settings_manually_add').hide();
                    $('.AddsignageSendTvCls').addClass('AddDisableAddManual');
                    $('.AddsignageSendTvCls').show();
                  
                    mProtocolManager.startDeviceDiscovery();
                    showLoader('Loadercontainer_sendId');
                    isReady = true;

                } else if (alreadyEnteredHolidayFlag == true) {
                    if ($('#_genericPopUpId').css('display') == 'block') {

                    } else {
                        showalreadyEnteredPopUP(ind);
                        return false;
                    }
                }
            }, 550);
        }
        flagtoFifteenDays = true;
        alreadyEnteredHolidayFlag = false;
        loaderObj.hideLoader();
        mTaskType = CONNECTION_TYPE_ON_OFF_TIMER_UPDATE;
        mProtocolManager.registerWiFiStateChangeReceiver();
        $('#StartsendbtnId').addClass('icon-disabled');
      
    });
    //apply now end

});
//Ready closed

// =================== END OF DOCUMENT READY =====================================


function sendvalueToholidayHeader(addindex) {

    var tempAddindex = addindex;
    startIpValuedate = $(".holidayContentCls" + tempAddindex).children().eq(0).find('.inputStartDate').val();
    endIpValuedate = $(".holidayContentCls" + tempAddindex).children().eq(0).find('.inputEndDate').val();

    if (startIpValuedate != "" && endIpValuedate == "") {
        $(".hoilday_header_tap" + tempAddindex).find('.ui-collapsible-heading-toggle>.title_holiday').text(startIpValuedate + " ~ ");

    }
    if (endIpValuedate != "" && startIpValuedate == "") {
        $(".hoilday_header_tap" + tempAddindex).find('.ui-collapsible-heading-toggle>.title_holiday').text(endIpValuedate);

    }

    if (startIpValuedate != "" && endIpValuedate != "") {

        addHoliday = startIpValuedate + " ~ " + endIpValuedate;
        $(".hoilday_header_tap" + tempAddindex).find('.ui-collapsible-heading-toggle>.title_holiday').text(addHoliday);
        $(".hoilday_header_tap" + tempAddindex).find('.addDoneicon').removeClass('AddDisable');
        
        if(updateTimerHolidayDB == false)
        {
        	insertHolidayInfo(tempAddindex, startIpValuedate, endIpValuedate);
        	updateTimerHolidayDB = true;
        }
        else
        {
        	updateHolidayFromDB(tempAddindex, startIpValuedate, endIpValuedate);
        }

    }
    if (startIpValuedate == "" && endIpValuedate == "") {
        $(".hoilday_header_tap" + tempAddindex).find('.ui-collapsible-heading-toggle>.title_holiday').text("--/-- ~ --/--");
    }

}

function ShowHolidayList(addindex, startTime, endTime) {	
	
	var addId = addindex;
	var startIpValuedate = startTime;
	var endIpValuedate = endTime;
	
	var style = "width:100%;padding: 10px 0px 10px 0px; font-size:18px !important;";
	var addHoliday = '<div data-role="collapsible" data-iconpos="right"  class="hoilday_header_tap hoilday_header_tap' + addId + '"    id="hoilday_header_tapId' + addId + '" >' + ' <h3>' + '<div class="title_holiday">--/-- ~ --/--</div>' + '<div class="HolidayiconNtxtupdate"><div class="Checkboxtext">'+langObj.Settings.MIA_SID_MONTH_SLASH_DATE+'</div><div id="addDeleteiconId" class="addDeleteicon"></div> </div>' + '</h3>' + '  <div class="holidayContentCls' + addId + '">' + '<div class="inputBlock_holiday">' + '<div class="TimertxtId" style="margin-top: 0px;height:15%;" class="insideTxtfontCls">' + '<div class="HoltxtCls">'+ langObj.Settings.MIA_SID_START_FROM + '</div>'+'<div class="HoltxtToCls">'+langObj.Settings.COM_TO_DATE +'</div>' + '</div>' + '<div style="height:35%"><div style="float: left; width: 43%;" class="startholidayConcls' + addId + '">' + ' </div>' + '<div style="float: left; width: 13.5%;">' + '<div class="txtbtnCls">-</div>' + '</div>' + '<div style="float: left; width: 43%;" class="endholidayConcls' + addId + '">' + '</div></div>' + '<div id="btncontainer' + addId + '" style="margin-top:-3%;height:15%;width:100%;">' + '<div id="newconection_cancel" style="float:left;width:48%;height:100%;"><div id="addUndoiconId" style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline addUndoicon">' + langObj.Schedule.COM_SID_CANCEL + '</div></div>' + '<div id="newconection_save" style="float:right;width:48%;height:100%;"><div id="addDoneiconId"  style="' + style + '" class="my-btn-footer ui-btn ui-btn-inline addDoneicon">' + langObj.Schedule.COM_BUTTON_SAVE + '</div></div>' + '</div>' + ' </div>' + '</div>' +  '</div>';
    
	$('.holiday_block').prepend(addHoliday).collapsibleset('refresh');
	var collapsed = $(".hoilday_header_tap" + addId).collapsible("option", "collapsed");
	$(".hoilday_header_tap" + addId).collapsible("option", "collapsed", true);
	
	var addstartinput = "";
	var addendinput = "";
	addstartinput = '<input type="text"  class="calInput_date inputStartDate" id="ipTextDateStart' + addId + '" value="'+ startIpValuedate + '" name="ipText" maxlength="5"  readonly/>';
	addendinput = '<input type="text"  class="calInput_date inputEndDate" id="ipTextDateEnd' + addId + '"  value="'+endIpValuedate+'" name="ipText" maxlength="5"  readonly/>';
	$('.startholidayConcls' + addId).append(addstartinput);
	$('.endholidayConcls' + addId).append(addendinput);
	$('.startholidayConcls' + addId).trigger('create');
	$('.endholidayConcls' + addId).trigger('create');
	$('#addDeleteiconId').hide();
	$("#btncontainer").hide();
	
	if (startIpValuedate != "" && endIpValuedate == "") {
		$(".hoilday_header_tap" + addId).find('.ui-collapsible-heading-toggle>.title_holiday').text(startIpValuedate + " ~ ");
	}
	if (endIpValuedate != "" && startIpValuedate == "") {
		$(".hoilday_header_tap" + addId).find('.ui-collapsible-heading-toggle>.title_holiday').text(endIpValuedate);
	}
	if (startIpValuedate != "" && addId != "") {

		addHoliday = startIpValuedate + " ~ " + endIpValuedate;
		$(".hoilday_header_tap" + addId).find('.ui-collapsible-heading-toggle>.title_holiday').text(addHoliday);
		$(".hoilday_header_tap" + addId).find('.addDoneicon').removeClass('AddDisable');

	}
	if (startIpValuedate == "" && endIpValuedate == "") {
		$(".hoilday_header_tap" + addId).find('.ui-collapsible-heading-toggle>.title_holiday').text("--/-- ~ --/--");
	}
}

var lastIndex;
var lastTextBox;

function defaultToday() {

    var today = new Array();
    var gettoday = "";
    var todaydate = Utils.getCurrentSystemTime();
    todaydate = todaydate.replace(";", ":");
    today = todaydate.split(':');
    gettoday = today[1] + '/' + today[2];

    return gettoday;

}

function DeleteEmptyHoliday(flag) {
     alreadyEnteredHolidayFlag = false;
    if( $('.holiday_block').find('.hoilday_header_tap').length > 0)
     {
        //var findhere=$(".hoilday_header_tap" ).collapsible("option", "collapsed");
        $('.holiday_block>.hoilday_header_tap').each(function() {
            var holidayId = $(this).attr('id');
            holidayId=holidayId.replace('hoilday_header_tapId','');
            console.log("holidayIdholidayIdholidayIdholidayIdholidayId"+holidayId);
            var Strtval = $(this).find('#ipTextDateStart'+holidayId).val();
            var Endval = $(this).find('#ipTextDateEnd'+holidayId).val();
            console.log("Strtval"+Strtval+"Endval"+Endval);
            //if (Strtval == "--/--" && Endval == "--/--") {
              if ((flag && Strtval == "--/--" && Endval == "--/--") || (!flag && (( Strtval == "--/--" || Endval == "--/--")||!isHolidayIdExistsInLocalSrotage(holidayId))))
              {  
                $('.hoilday_header_tap' + holidayId).remove();
                $('#holidayMgnttitleId').removeClass('AddDisable');
                FlagToexpand=false;
                $( ".hoilday_header_tap" ).collapsible( "enable" );
                //console.log("click come to DeleteEmptyHoliday");
                
            }
             
        });

    }

}

function checkForFifteenDays(startIpValuedate, endIpValuedate) {

    flagtoFifteenDays = true;
    var temp_strt = startIpValuedate;
    var temp_end = endIpValuedate;
    var startarry = new Array();
    var endary = new Array();
    var diffmnth;
    var diffday;
    var findlastday = 0;
    var caldays = 0;
    var dayforanthrmnth = 0;

    startIpValuedate = temp_strt;
    endIpValuedate = temp_end;
    startarry = startIpValuedate.split("/");
    endary = endIpValuedate.split("/");

    diffmnth = endary[0] - startarry[0];
    //diff btw mnths
    //diff btn days
    sendmonth = startarry[0];
    var tempstrtday = 0;
    var tempendday = 0;
    tempstrtday = startarry[1];
    tempendday = endary[1];
    if (diffmnth == 0)//same mnth
    {

        diffday = endary[1] - startarry[1];
        if (diffday > 14) {
            flagtoFifteenDays = false;
        } else if (diffday <= 14 && diffday > 0) {
        } else if (diffday < 0) {
            flagtoFifteenDays = false;
        }

    } else if (diffmnth == 1)//diff mnth
    {

        findlastday = findlastdayofMonth(sendmonth);

        dayforanthrmnth = findlastday - tempstrtday;

        caldays = Number(dayforanthrmnth) + Number(tempendday);
        if (caldays > 14) {
            flagtoFifteenDays = false;
        } else if (caldays <=14) {
        }

    } else if (diffmnth > 1) {

        flagtoFifteenDays = false;
    } else if (diffmnth < 0) {
        if(sendmonth == 12 && diffmnth == -11)
        {
            findlastday = findlastdayofMonth(sendmonth);
            dayforanthrmnth = findlastday - tempstrtday;
            caldays = Number(dayforanthrmnth) + Number(tempendday);
            if (caldays > 14) 
            {
                flagtoFifteenDays = false;
            }
            else
            {
                flagtoFifteenDays = true;
            }    
        }
        else
        {
            flagtoFifteenDays = false;
        }
    }

}
// ======================== TO SHOW DISCOVERED DEVICE LIST =================================
function showDeviceListInNetwork(result) {

    $('.userpar').children('ul').addClass('addborderTop');
    $('.userpar').addClass('haslistCls');
    $('.addNoDeviceMsgCls').hide();
    try {
        console.log("@ showDeviceListInNetwork");
        isReady = true;
        
        // required variables
        var device_name = "";
        var device_ip = "";
        var connection_staus = "";
        var firmware_version = "";
        var device_type = "";
        var total_space = "";
        var available_space = "";
        var storage_type = "";
        var frmVersionChk = "";
        var mac_address = "";
        var tls_required = "";
        var pin = "";

        // list variables
        var listItem_Send = "";
        var listItem = "";
        $('.list').html('');
        $('.list').hide();
        $('.Settinglist_Send').hide();
        
               // Device Info list
        myDeviceInfoJson = {};
        myDeviceInfoArr = [];
        myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
        var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
        
        // reset previous store device UI
        if (myDeviceInfoJson != null && myDeviceInfoJson.myDeviceInfoArrs.length > 0) {
            for (var k = 0; k < myDeviceInfoJson.myDeviceInfoArrs.length; k++) {
               var ip = myDeviceInfoJson.myDeviceInfoArrs[k].DeviceIP;
               var Status = myDeviceInfoJson.myDeviceInfoArrs[k].DeviceName;
               updateDeviceState(ip, Status,STATE_FAIL_CONNECTION);
            } 
            getDeviceInfo();
        }
        
        
        mDeviceListInfo = new Array();
        for (var i = 0; i < result.length; i++) {
            device_name = result[i].device_name;
            device_ip = result[i].device_ip;
            connection_staus = result[i].connect_status;
            device_type = result[i].device_type;
            storage_type = result[i].storage_type;
            total_space = result[i].total_space;
            available_space = result[i].available_space;
            firmware_version = result[i].firmware_version;
            frmVersionChk = firmware_version;
            mac_address = result[i].mac_address;
            tls_required = result[i].tls_required;
            pin = "";
            if(mac_address!=null){
            if(mac_address.length>0){
              pin = Utils.getMacPinValue(mac_address);
                }
            }
            console.log("Refresh: device_name: "+device_name+"  ,  device_ip: "+device_ip+" ,connection_staus: "+connection_staus+" , device_type: "+device_type+",storage_type: "+storage_type+", total_space: "+total_space+", available_space: "+available_space+" ,firmware_version: "+firmware_version);
            var deviceState = 1;
            var isAlreadyExist = false;
            
            myDeviceInfoJson = {};
            myDeviceInfoArr = [];
            myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
            var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
            
            if (myDeviceInfoJson != null && myDeviceInfoJson.myDeviceInfoArrs.length > 0) {
                for (var j = 0; j < myDeviceInfoJson.myDeviceInfoArrs.length; j++) {
                    var dicoverIP = device_ip.trim();
                    var dbIP = myDeviceInfoJson.myDeviceInfoArrs[j].DeviceIP.trim();
                    console.log("Refresh: DB IP: "+dbIP+"  ,  dicoverIP: "+dicoverIP);
                    if (dicoverIP == dbIP) {
                          isAlreadyExist = true;
                           // setTimeout(function(){
                                console.log("Refresh:  existed IP device_type: "+device_type);
                                if(device_type!=undefined){
                                    device_type = device_type.trim();
                                }
                            
                                var mPlayerId = Utils.getPlayerTypeWithModelCode(device_type); 
                                console.log("Refresh: LFD player type: "+mPlayerId+" : Active Player Type: "+Utils.getActivePlayerType());
                                if (mPlayerId >= Utils.getActivePlayerType() && firmware_version != undefined && firmware_version != undefined){
                                    // Supported
                                    console.log("Refresh: Incase of manually supported");
                                    updateDeviceFromDB(device_name, device_ip, connection_staus, storage_type, total_space, available_space, firmware_version, mPlayerId,STATE_SUPPORTED,mac_address,tls_required,pin);
                                } else if(mPlayerId >= Utils.getActivePlayerType()) {
                                    // Update Required
                                    console.log("Refresh: Incase manually Update Required");
                                    updateDeviceFromDB(device_name, device_ip, connection_staus, storage_type, total_space, available_space, firmware_version,mPlayerId, STATE_UPDATE_REQ,mac_address,tls_required,pin);
                                }else{
                                    // Not Supported
                                    console.log("Refresh: Incase manually Not Supported");
                                    var unSupported = Utils.getUnSupportedPlayerType();
                                    updateDeviceFromDB(device_name, device_ip, connection_staus, '', '', '', '', unSupported,STATE_UNSUPPORTED,mac_address,tls_required,pin);
                                }
                                 console.log("Refresh: *** call device to get getDeviceInfo *** ");
                                 //sessionStorage.setItem("Device_INFO", "");
                                 ///getDeviceInfo();
                            // },1000);
                       }
                        if (isAlreadyExist == true) {
                            console.log("Refresh: *** already exist So, break from loop *** ");
                            isAlreadyExist = true;
                            break;
                        }
                }
            }

         var activePlayerType = Utils.getActivePlayerType();
         var mLFDPlayerType = Utils.getPlayerTypeWithModelCode(device_type); 
         if(activePlayerType == STRETCH_MODEL)
         {
             activePlayerType = RHE_MODEL;
         }
            
         if (isAlreadyExist == false && mLFDPlayerType >= activePlayerType) {
          // connection_staus = (connection_staus == 'false' || connection_staus == false)? langObj.Settings.MIA_SID_AVAILABLE : langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
           var isUpdateRq = false;
           var txtColor;
           var img_source;
           var tempClass;
           var lockMsg = "";
           
           if (firmware_version!=undefined && firmware_version!=null && firmware_version.length > 0) {
                firmware_version = langObj.Schedule.COM_EBD_SID_MIX_CURRENT_VERSION.replace('<<A>>',firmware_version);
                isUpdateRq = false;
                txtColor="rgba(63,63,66,0.6)";
                tempClass="";
                    img_source="../resource/img/ic_check_nor.png";
            }
            else {
                firmware_version = langObj.Settings.MIS_SID_UPDATE_REQUIRED;
                    img_source="../resource/img/ic_check_dim.png";
                isUpdateRq = true;
                tempClass="UpdateRq";
                txtColor="#eb6262";
            }

            if(connection_staus == 2 || connection_staus == '2'){
             lockMsg = '<span style="color:red;">'+ (langObj.Send.MIA_SID_20_LOCKED)+'</span>';
             checkboxType = "dim_checkbox";
            }

            if (panelID == "Firmware-update") {
                   listItem += '<li class="auto-LFD-List ' +tempClass+ '" id="frmw_' + i + '" ip="' + device_ip + '" tls="' + tls_required + '" mac="' + mac_address + '" pin="'+pin+'"  deviceName="' + device_name + '"><div class="name_fw"><div>' + device_name + '</div><div class="storageInfo" style="color:'+txtColor+'">' + firmware_version + lockMsg+ '</div></div><div class="function_icon"></div></li>';
            } else {
                if ( firmware_version == langObj.Settings.MIS_SID_UPDATE_REQUIRED )
                listItem_Send += '<li class="auto-LFD-List ' +tempClass+ '" id="tm' + i + '" ip="' + device_ip + '" tls="' + tls_required + '" mac="' + mac_address + '" pin="'+pin+'" deviceName="' + device_name + '"  style="border-bottom:solid #c7c7c7 1px;"><div class="manual_name"><div>' + device_name + '</div><div class="storageInfo" style="color:'+txtColor+'">' + firmware_version + lockMsg+'</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
              else{
                    if(lockMsg == "")
                listItem_Send += '<li class="auto-LFD-List ' +tempClass+ '" id="tm' + i + '" ip="' + device_ip + '" tls="' + tls_required + '" mac="' + mac_address + '" pin="'+pin+'" deviceName="' + device_name + '"  style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo" style="color:'+txtColor+'">'+lockMsg+ '</div></div><div class="function_icon" ></div><div class="checkbox_settings nor_checkbox"></div></li>';
                else
                listItem_Send += '<li class="auto-LFD-List ' +tempClass+ '" id="tm' + i + '" ip="' + device_ip + '" tls="' + tls_required + '" mac="' + mac_address + '" pin="'+pin+'" deviceName="' + device_name + '"  style="border-bottom:solid #c7c7c7 1px;"><div class="name"><div>' + device_name + '</div><div class="storageInfo" style="color:'+txtColor+'">'+lockMsg+ '</div></div><div class="function_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                }
             }
          }//already exist

        }//for loop

        
        //**********************  Firmware update initiate while selecting list item ******************//

        if (panelID != "" && panelID == "Firmware-update") {
            isOnOffTimerIP = false;
            mLFDInfoArrayList = new Array();
            mTaskType = CONNECTION_TYPE_FIRMWARE_UPGRADE;
            $('.list').append(listItem);

            addmanualListIndex = result.length - 1;
            Liheight = $('.list >li').height();
            Liwidth = $('.list >li').width();
        } else {
            if (panelID != "" && panelID == "power-cntrl") {
                mTaskType = CONNECTION_TYPE_ON_OFF_TIMER_UPDATE;
            }
            isOnOffTimerIP = true;
            $('.Settinglist_Send').append(listItem_Send);

            addSendmanualListIndex = result.length - 1;
            timerLiheight = $('.Settinglist_Send >li').height();
            timerLiwidth = $('.Settinglist_Send >li').width();
        }

        //////////////////// UPDATE DB STORAGE LIST ////////////////////
            setTimeout(function(){
        
                  myDeviceInfoJson = {};
                  myDeviceInfoArr = [];
                  myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
                  var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
                  if (myDeviceInfoJson != null && myDeviceInfoJson.myDeviceInfoArrs.length > 0) {
                    for (var i = 0; i < myDeviceInfoJson.myDeviceInfoArrs.length; i++) {
                        var curPin = Utils.getMacPinValue(myDeviceInfoJson.myDeviceInfoArrs[i].MacAddress);
                        addManuallyDevice(STATE_REFRESHING, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceState, myDeviceInfoJson.myDeviceInfoArrs[i].ConnectionStatus, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceIP, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceName, myDeviceInfoJson.myDeviceInfoArrs[i].StorageType, myDeviceInfoJson.myDeviceInfoArrs[i].TotalSpace, myDeviceInfoJson.myDeviceInfoArrs[i].AvailableSpace, myDeviceInfoJson.myDeviceInfoArrs[i].Version,myDeviceInfoJson.myDeviceInfoArrs[i].PlayerType,myDeviceInfoJson.myDeviceInfoArrs[i].MacAddress,myDeviceInfoJson.myDeviceInfoArrs[i].TLSReq,curPin);
                    }
                  } 
                
                $('.AddsignageTvCls').removeClass('AddDisableAddManual');
                $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
                $('.Settinglist_Send').show();
                $('.list').show();

                hideLoader('updatefooterIcon');
                hideLoader('Loadercontainer_sendId');
                timerLiheight = $('.Settinglist_Send >li').height();
                timerLiwidth = $('.Settinglist_Send >li').width();
                Liheight = $('.list >li').height();
                Liwidth = $('.list >li').width();

                console.log("**** $('.Settinglist_Send>li').length: "+$('.Settinglist_Send>li').length +" isOnOffTimerIP: "+isOnOffTimerIP);
                if(isOnOffTimerIP){
                    console.log(" $('.Settinglist_Send>li').length: "+$('.Settinglist_Send>li').length +" isOnOffTimerIP: "+isOnOffTimerIP);
                 if($('.Settinglist_Send>li').length < 1){
                     $('.Settinglist_Send').html('');
                    $('.userpar').removeClass('haslistCls');
                    $('.userpar').children('ul').removeClass('addborderTop');
                    $('.addNoDeviceMsgCls').show();
                    $('.addNoDeviceMsgCls>.addNoDeviceMsgTxtCls').text(langObj.Settings.MIA_SID_NO_DEVICE_SEARCH_AGAIN);
                 }
                }else{
                    console.log(" elsee $('.Settinglist_Send>li').length: "+$('.Settinglist_Send>li').length +" isOnOffTimerIP: "+isOnOffTimerIP);
                    if($('.list>li').length < 1){
                 $('.list').html('');
                    $('.userpar').removeClass('haslistCls');
                    $('.userpar').children('ul').removeClass('addborderTop');
                    $('.addNoDeviceMsgCls').show();
                    $('.addNoDeviceMsgCls>.addNoDeviceMsgTxtCls').text(langObj.Settings.MIA_SID_NO_DEVICE_SEARCH_AGAIN);
                 }
                }
            },2000);

        ///////////////////// END //////////////////////////////////////
     }
    catch(e) {
        //alert("error: " + e);
        hideLoader('Loadercontainer_sendId');
        hideLoader('updatefooterIcon');
    }
}


function noDeviceFound() {

    myDeviceInfoJson = {};
    myDeviceInfoArr = [];
    myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
    var myDeviceInfoJson = JSON.parse(sessionStorage.getItem("Device_INFO"));
    $('.Settinglist_Send').html('');
    $('.list').html('');
    addmanualListIndex = 0; //reset
    addsendmanuallist = 0; //reset
    if (myDeviceInfoJson != null && myDeviceInfoJson.myDeviceInfoArrs.length > 0) {
        for (var i = 0; i < myDeviceInfoJson.myDeviceInfoArrs.length; i++) {
             var curPin = Utils.getMacPinValue(myDeviceInfoJson.myDeviceInfoArrs[i].MacAddress);
             addManuallyDevice(STATE_REFRESHING, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceState, myDeviceInfoJson.myDeviceInfoArrs[i].ConnectionStatus, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceIP, myDeviceInfoJson.myDeviceInfoArrs[i].DeviceName, myDeviceInfoJson.myDeviceInfoArrs[i].StorageType, myDeviceInfoJson.myDeviceInfoArrs[i].TotalSpace, myDeviceInfoJson.myDeviceInfoArrs[i].AvailableSpace, myDeviceInfoJson.myDeviceInfoArrs[i].Version,myDeviceInfoJson.myDeviceInfoArrs[i].PlayerType,myDeviceInfoJson.myDeviceInfoArrs[i].MacAddress,myDeviceInfoJson.myDeviceInfoArrs[i].TLSReq,curPin);
        }
    } else {
        isReady = true;
        $('.userpar').removeClass('haslistCls');
        $('.userpar').children('ul').removeClass('addborderTop');
        $('.addNoDeviceMsgCls').show();
        $('.addNoDeviceMsgCls>.addNoDeviceMsgTxtCls').text(langObj.Settings.MIA_SID_NO_DEVICE_SEARCH_AGAIN);
    }
    $('.AddsignageTvCls').removeClass('AddDisableAddManual');
    $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
    $('.Settinglist_Send').show();
    $('.list').show();
    hideLoader('Loadercontainer_sendId');
    hideLoader('updatefooterIcon');
    mProtocolManager.stopAutoDiscoveryService();
    
}
/*
function showLoader(divID, path, size) {
    //Clear interval if already in action
    clearInterval(loaderInt);
    var i = 1;
    var vPath = window.location.toString().split("www")[0];
    if (path == undefined) {

        path = vPath + "www/";
    }
    if (size == undefined) {
        size = '45px';
    }

    loaderInt = setInterval(function() {
        if (i >= 12)
            i = 1;
        $('#' + divID).html('<img src="' + path + 'resource/img/loading/loading_' + i + '.png" style="height:100%;vertical-align:middle;" >').show();

        i++;

    }, 200);
}

function hideLoader(divID) {
    clearInterval(loaderInt);
    $('#' + divID).html('').hide();
    $('#' + divID).html('<img src="../resource/img/ic_refresh_n.png" class="refresh" style="height:100%;vertical-align:middle;" >').show();
}
*/

function initProgressBarTimer(deviceID) {
        console.log("initProgressBarinitProgressBarinitProgressBarinitProgressBarTimer"+deviceID);

    $('<input>').appendTo('.Settinglist_Send>li#' + deviceID).attr({
        'name' : 'slider',
        'id' : 'slider' + deviceID,
        'data-highlight' : 'true',
        'min' : '0',
        'max' : '100',
        'value' : '0',
        'type' : 'range',
        'disabled' : 'true'
    }).slider({
        create : function(event, ui) {
            $(this).parent().find('input').hide();
            $('.ui-slider').css({
                'position' : 'absolute !important'
                ,"z-index":"99999 !important"
                ,'top':'0px'
                ,'left':'0px'
            });
            $('.ui-slider-track').css({
                "height" : timerLiheight + 'px',
                'width' : timerLiwidth + 'px'
            });
            $(this).parent().find('input').css('margin-left', '-9999px');
            // Fix for some FF versions
            // $(this).parent().find('.ui-slider-track').css('margin', '0 15px 0 15px');
            $(this).parent().find('.ui-slider-handle').hide();
        }
    }).slider("refresh");

}

function showalreadyEnteredPopUP(ind) {

    var ind = ind;
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_HOLIDAY_ALREAY_ADDED]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_OK,
        "callback" : function() {

            //$('.hoilday_header_tap' + ind).remove();
            alreadyEnteredHolidayFlag = false;
            closeGenericPopUp();
            $('.hoilday_header_tap'+ind+'>h3').hide();
        }
    }]);
    genericPopUpObj.showPopUp();
}

function updateExportProgressBar(deviceID, progressVal) {
    console.log("@updateExportProgressBar: DeviceId: " + deviceID + " , ProgressVal: " + progressVal);
    progressBar.setValue('#slider' + deviceID, progressVal);
}


function firmwareUpdateProgressBar(deviceID, progressVal,progressInBytes) {
    console.log("@updateExportProgressBar: DeviceId: " + deviceID + " , ProgressVal: " + progressVal);
    progressVal = parseInt(progressVal);
    $('.list>li#' +deviceID).find('.storageInfo').text(langObj.Settings.COM_TV_SID_DOWNLOADING_DOT_KR_BLANKDOT + " ("+ progressInBytes +")");
    progressBar.setValue('#slider' + deviceID, progressVal);
}


function firmwareCopyProgressBar(deviceID, progressVal,progressInBytes) {
    console.log("@updateExportProgressBar: DeviceId: " + deviceID + " , ProgressVal: " + progressVal);
    progressVal = parseInt(progressVal);
    $('.list>li#' +deviceID).find('.storageInfo').text(langObj.Settings.MIA_SID_COPYING_DOT + " ("+ progressInBytes +")");
    progressBar.setValue('#slider' + deviceID, progressVal);
}

//fail - on off timer;
function onOffTimerUpdateFail(mMaxIndex, deviceID) {

    mLFDInfoArrayList[mMaxIndex].mStatus = FAIL;

    $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('nor_checkbox');
    $('li#' + deviceID).find('.checkbox_settings').removeClass('icon-disabled');

    $('li#' + deviceID).find('.function_icon').removeClass('del_icon').addClass('err_icon');
    $('li#' + deviceID).find('.function_icon').removeClass('icon-disabled');
    
    $('.Settinglist_Send>li#' + deviceID + '>.icon>.check_box').removeClass('showCheck');
    mProtocolManager.stopConnectionService();
 
    $('ul#deviceListOnOffTimer > li#' + deviceID).find('.storageInfo').text(langObj.Settings.COM_IDWS_MOIP_SKYPE_FAILED);
    $('#' + deviceID).addClass('send-failed');
    $('#deviceListOnOffTimer  div.del_icon, #Loadercontainer_sendId').removeClass('icon-disabled');
    updateExportProgressBar(deviceID, 0);
}

//complete for one - on off timer;
function onOffTimerUpdateSuccess(mMaxIndex, deviceID) {

    mLFDInfoArrayList[mMaxIndex].mStatus = DONE;
    setTimeout(function() {
        $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('com_icon');
        $('li#' + deviceID).find('.checkbox_settings').removeClass('icon-disabled');
    }, 400);

                       
    
    $('li#' + deviceID).find('.storageInfo').text(langObj.Settings.COM_SID_COMPLETE_COMPLETE);
        
    updateExportProgressBar(deviceID, 0);
}

// completed for all - - on off timer;
function onOffTimerUpdateCompleted() {
    $('#StartsendbtnId').addClass('icon-disabled');
    hideLoader('Loadercontainer_sendId');
    loaderObj.hideLoader();
    isProgress = false;
    $('.network-footer>#newconection_apply').removeClass('icon-disabled');
    $('#Title>#LoadercontainerId>.refresh').removeClass('icon-disabled');
    $('#Loadercontainer_sendId>.refresh').removeClass('icon-disabled');
    $('.AddsignageTvCls').removeClass('AddDisableAddManual');
    $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
    mLFDInfoArrayList = new Array();
    mProtocolManager.stopConnectionService();

    var checkforcheckbox = new Array();
    var listItems = $("#deviceListOnOffTimer li");
    listItems.each(function(li) {
        var mDeviceId = $(this).attr('id');
        if (($('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') != "../resource/img/ic_check_dim.png") && ($('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') == "../resource/img/ic_check_nor.png" || $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') == "../resource/img/ic_check_dim.png")) {
            $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src', "../resource/img/ic_check_nor.png");
            $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').removeClass('icon-disabled');
            checkforcheckbox.push(mDeviceId);
        }
    });
    $('#deviceListOnOffTimer  div.del_icon, #Loadercontainer_sendId').removeClass('icon-disabled');
    if (checkforcheckbox.length > 0) {
        //TODO
    
    } else {
    
        $('#StartsendbtnId').text(langObj.Settings.sendId);
        $('#StartsendbtnId').addClass('icon-disabled');
    }

}

function onOffTimerCanceled(deviceID) {

    isCanceled = false;


    $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('nor_checkbox');
    $('li#' + deviceID).find('.checkbox_settings').removeClass('icon-disabled');

    $('#deviceListOnOffTimer  div.del_icon, #Loadercontainer_sendId').removeClass('icon-disabled');
    mProtocolManager.stopConnectionService();
    updateExportProgressBar(deviceID, 0);
}

// update upload cancel GUI
function preonOffTimerCanceled(deviceID) {

    isCanceled = false;
    loaderObj.hideLoader();
    $('#deviceListOnOffTimer  div.del_icon, #Loadercontainer_sendId').removeClass('icon-disabled');
    if (mLFDInfoArrayList.length > 1) {
        $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('dim_checkbox');
        $('li#' + deviceID).find('.checkbox_settings').addClass('icon-disabled');
    } else {
        $('li#' + deviceID).find('.checkbox_settings').removeClass('cancel_checkbox').addClass('nor_checkbox');
        $('li#' + deviceID).find('.checkbox_settings').removeClass('icon-disabled');
    }
}

// Reset cancel GUI
function resetOnOffCancelUI(mCheckAllCancel) {

    isProgress = false;
    loaderObj.hideLoader();
    var listItems = $("#deviceListOnOffTimer li");
    listItems.each(function(li) {
        var mDeviceId = $(this).attr('id');
        if ((($('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') != "../resource/img/ic_check_dim.png")) && ($('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') == "../resource/img/ic_check_nor.png" || $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src') == "../resource/img/ic_check_dim.png")) {
            $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').attr('src', "../resource/img/ic_check_nor.png");
            $('#deviceListOnOffTimer>li>.icon>.check_box>#' + mDeviceId + '.check').removeClass('icon-disabled');
            updateExportProgressBar(mDeviceId, 0);
        }
    });
    $('#Loadercontainer_sendId').removeClass('icon-disabled');
    $('.AddsignageTvCls').removeClass('AddDisableAddManual');
    $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
    $('#Title>#LoadercontainerId>.refresh').removeClass('icon-disabled');
    if (mCheckAllCancel == 0) {

    } else {
        $('#StartsendbtnId').text(langObj.Settings.sendId);
        $('#StartsendbtnId').addClass('icon-disabled');
    }
    mProtocolManager.stopConnectionService();
    
}


function onBackkeyDown(e) {
    console.log("isProgress: " + isProgress + " ,isFirmwareProgress: " + isFirmwareProgress + " ,isCheckingFWVersion: " + isCheckingFWVersion);
    
    if( $('#TimePicker').css('display') == 'block' ) 
    {
         closeTimePicker();
        return;
    }

    if ( isCheckingFWVersion )
    {
        showAnimationLoader(langObj.Settings.MIA_SID_CANCELING_DOT);
        isCheckingFWVersion = false;
        try{
            mLFDInfoArrayList[0].isCanceled = true;
        }
        catch(e) {
            console.log(e);
        }

        try{
            cancelExcutionTask(0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
        }
        catch(e) {
            loaderObj.hideLoader();
            console.log(e);
        }

        closeGenericPopUp();
        isCheckingFWVersion = false;
        return;
    }

    if (genericPopUpObj.isPopUpVisible()) {
        if (alreadyEnteredHolidayFlag == false) {
            exitCounter = 0;                       
        }
        genericPopUpObj.hidePopUp();
        return;
    }

    if (genericNumericKeyboard.isPinVerificationPageOpen()) {
        numericKeyboardButtonPressed("Cancel");
        return;
    }

    if (isProgress || isFirmwareProgress) {
        cancelCurrentProcessOnBack();
        return;
    }

    if (isStoreDeleted) {
        closeGenericPopUp();
        isStoreDeleted = false;
        return;
    }

    if ( $('#popupID').is(':visible') )
    {
        $('#ok-popup').trigger('click');
        return;
    }

    if ( $('.back-btn').is(':visible') && $('.settings-panel').css('left') != "0px" )
    {
        $('.back-btn').trigger('tap');
        return;
    }
/*
     $('#Add_SinageTV_Close_Btn_ID').on('tap', function(e) {
            e.stopPropagation();
            e.preventDefault();

            // if something is foucused
            if( document.activeElement.tagName == "INPUT") {
                $('.iptext').blur();
                setTimeout(function(){
                    $('.iptext').val('');
                    $('#view-setting').show();
                    $('#settings_manually_add-ipID').hide();
                    $('#manually_add-ip-panel').hide();
                },400);
            }else {
                $('.iptext').val('');
                $('#view-setting').show();
                $('#settings_manually_add-ipID').hide();
                $('#manually_add-ip-panel').hide();
    }
                });

     $('#pin_verification_close_Id').on('tap', function(e) {
                 e.stopPropagation();
                 e.preventDefault();

                 // if something is foucused
                 if( document.activeElement.tagName == "INPUT") {
                     $('.iptext').blur();
                     setTimeout(function(){
                         $('.iptext').val('');
                         $('#view-setting').show();
                         $('#pin_verification_page_Id').hide();
                         $('#pin_verification_panel').hide();
                     },400);
                 }else {
                     $('.iptext').val('');
                     $('#view-setting').show();
                     $('#pin_verification_page_Id').hide();
                     $('#pin_verification_panel').hide();
                 }
             });

               // ADD MANUALLY DONE BUTTON
      $('#Add_SinageTV_Done_Btn_ID').on('tap', function(e) {
              e.stopPropagation();
              e.preventDefault();

                     // if something is foucused
                     if( document.activeElement.tagName == "INPUT") {
                         $('.iptext').blur();
                         setTimeout(function(){
                            // ValidIPEnterUpdate();
                         },400);
                     }else {
                        // ValidIPEnterUpdate();
                     }
            });

                    // PIN VERIFICATION DONE BUTTON
                  $('#pin_verification_done_Id').on('tap', function(e) {
                          e.stopPropagation();
                          e.preventDefault();
                          $('.pintext').blur();
                          setTimeout(function(){
                            var ip =  deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
                            var pinVal = $('#pinbox1').val().trim() + $('#pinbox2').val().trim() + $('#pinbox3').val().trim() + $('#pinbox4').val().trim();
                            $('.pintext').val('');
                            $('#view-setting').show();
                            $('#pin_verification_page_Id').hide();
                            $('#pin_verification_panel').hide();
                            pinVal = pinVal.trim();
                            showAnimationLoader('Verifying...');
                            mProtocolManager.verifyTLSPINInfo(ip,pinVal,deviceListContainerRef);
                         },400);
                     });
*/
    if ( $('#opensourcelicenseBack').is(':visible') )
    {
        $('#opensourcelicenseBack').trigger('click');
        return;
    }

    if ( $('#holidaymgtBack').is(':visible') )
    {
        $('#holidaymgtBack').trigger('tap');
        return;
    }
    
    if ( $('#fontlicenseBack').is(':visible') )
    {
        $('#fontlicenseBack').trigger('click');
        return;
    }

    e.preventDefault();
    if ($.mobile.activePage.is('#Initial_setup1')) {
        onBackConfirmDialog(e);
    } else if ($.mobile.activePage.is('#QuickStartPage')) {

        if ($('#view-home').is(':visible')) {
            exitCounter = 0;
            $('#view-home >.closeBtn').trigger('tap');
        } else if (isTutOpen) {
            $('#Exit_tutorial_btn').trigger('tap');
        } else {
            if ($('#_genericPopUpId').css('display') == 'block') {
                exitCounter = 0;
                closeGenericPopUp();
                e.preventDefault();
                e.stopPropagation();
            } else {
                onBackConfirmDialog(e);
            }

        }

    } else if ($.mobile.activePage.is('#view-setting')) {
        mProtocolManager.stopAutoDiscoveryService();
        document.location.href = '../quickstart/QuickStart.html';
    }
}

function onBackConfirmDialog(e) {

    if (exitCounter == 0) {
        Utils.showToast(langObj.index.COM_MIA_SID_PRESS_AGAIN_TO_EXIT_THIS_APPLICATION);
        exitCounter++;
    } else {
        navigator.app.exitApp();
    }
}

function onConfirm(button) {
    if (button == 2) {//If User selected No, then we just do nothing
        return;
    } else {
        navigator.app.exitApp();
        // Otherwise we quit the app.
    }
}


function updateWiFiState(wifiState) {

    if (mTaskType == CONNECTION_TYPE_ON_OFF_TIMER_UPDATE) {
        // OnOff Timer
        if (wifiState == WIFI_ENABLED) {

            isWiFiEnable = true;
            $('.Settinglist_Send').html('');
            $('.Settinglist_Send').show();
            $('.settings_manually_add').hide();
            $('.AddsignageSendTvCls').show();
            mLFDInfoArrayList = new Array();
            if (!isReady) {
                $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
            } else {
                $('.AddsignageSendTvCls').addClass('AddDisableAddManual');
            }
            $('#Loadercontainer_sendId').removeClass('icon-disabled');
            if (mLFDInfoArrayList.length > 0) {
                $('#StartsendbtnId').removeClass('icon-disabled');
            }
        } else if (wifiState == WIFI_DISABLED) {

            isWiFiEnable = false;
            isReady = false;
            $('.Settinglist_Send').html('');
            mProtocolManager.stopAutoDiscoveryService();
            loaderObj.hideLoader();
            $('.AddsignageSendTvCls').addClass('AddDisableAddManual');
            $('#Loadercontainer_sendId').addClass('icon-disabled');
            $('#StartsendbtnId').addClass('icon-disabled');
            setTimeout(function() {
                hideLoader('Loadercontainer_sendId');
                genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Send.MIA_FAILED_CONNECT_TO_NETWORK_INTERNET_CONNECTION_UNSTABLE]);
            }, 1000);
            isProgress = false;
        }
    } 
    else if (mTaskType == CONNECTION_TYPE_FIRMWARE_UPGRADE) { 
        if (wifiState == WIFI_ENABLED) {
            isWiFiEnable = true;
            $('.list').show();
            $('.AddsignageTvCls_open').hide();
            $('#AddsignageTvId').show();
            $('#updatefooterIcon').removeClass('icon-disabled');
            if (!isReady) {
                $('.AddsignageTvCls').removeClass('AddDisableAddManual');
            } else {
                $('.AddsignageTvCls').addClass('AddDisableAddManual');
            }
        } else if (wifiState == WIFI_DISABLED) {
            hideLoader('updatefooterIcon');
            isWiFiEnable = false;
            isReady = false;
            loaderObj.hideLoader();
            mProtocolManager.stopAutoDiscoveryService();
            $('.AddsignageTvCls').addClass('AddDisableAddManual');
            $('#updatefooterIcon').addClass('icon-disabled');
            
            var showWifiSetUpPopUp = true;
            
            if ((Utils.checkConnection() == CONNECTION_NONE) && (showWifiSetUpPopUp)) {
                genericPopUpObj.createPopUp("Notification", "Type1","Wi-Fi");
                genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_DEVICE_NOT_CONNECTED_NETWORK + " " + langObj.Settings.MIA_SID_FEATURE_REQUIRES_INTERNET_CONNECTION]);
                genericPopUpObj.addFooterBtns([{
                    "btntxt" : langObj.Settings.MIA_SID_SET_UP_WI_FI,
                    "callback" : function() {
                        closeGenericPopUp();
                        mUtilityManager.openWiFiSettings();
                    }
                }, {
                    "btntxt" : COM_SID_OK,
                    "callback" : function() {
                        closeGenericPopUp();
                    }
                }]);
                genericPopUpObj.showPopUp(); 
            }
            // Incase of wifi off while firmware download

            console.log("isProgress : " + isProgress + " isFirmwareProgress : " + isFirmwareProgress );
            try{
                if (isProgress || isFirmwareProgress) {
                    mLFDInfoArrayList[0].isCanceled = true;

                    console.log("updateWiFiState deviceID : " + deviceID);
                    
                    $('.list>li#' + deviceID).find('.storageInfo').text(oldFirmwareVersion);
                    $('.list>li#' + deviceID).find('.function_icon').removeClass('cancel_checkbox').addClass('err_icon');
                    $('.list>li#' + deviceID).find('.function_icon').removeClass('icon-disabled');
                    $('.list>li#' + deviceID).addClass('send-failed');

                    cancelExcutionTask(0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
                    closeGenericPopUp();

                    setTimeout(function() {
                        genericOkPopUP("Type1", 'Notification', COM_SID_OK, [langObj.Settings.MIA_SID_UNABLE_DOWNLOAD_UPDATE_FILE + " " + langObj.Settings.MIA_SID_WIFI_TURNED_OFF]);
                    }, 500);                    
                }
            } catch(e) {
                console.log(e);
            }
            isProgress = false;
            }
       } else  if (mTaskType == CONNECTION_TYPE_RSITE_DOWNLOAD) {
        try{
             if (wifiState == WIFI_DISABLED) {
                 isProgress = false;
                 loaderObj.hideLoader();
                 resetDesignElementUI();
                 updateExportProgressBar(curDeviceID, 0);
                }
          }catch(e) { 
              console.log("@updateExportProgressBar: "+e);
          }
     }
}

function ConvertTimeStamp(InputDate) {
    var Currentyear;
    var TimeStampValue;
    var InputDate;
    var todaydate = Utils.getCurrentSystemTime();
    todaydate = todaydate.split(':');
    Currentyear = todaydate[0];

    InputDate = InputDate;
    //InputDate=InputDate.replace(".","/");
    InputDate = InputDate + "/" + Currentyear;
    TimeStampValue = new Date(InputDate).getTime();
    return TimeStampValue;
}


// ========================== get iOS Version added by Sailender Singh on 13/03/2015

function iOSversion() {
    if (/iP(hone|od|ad)/.test(navigator.platform)) {
        var v = (navigator.appVersion).match(/OS (\d+)_(\d+)_?(\d+)?/);
        var ver = [getParseIntInDec(v[1]), getParseIntInDec(v[2]), getParseIntInDec(v[3] || 0)];
        return ver;
    }
}
// for encode and decode string  k.chainani
function encodeData(s) {
    return encodeURIComponent(s).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29");
}

function decodeData(s) {
    try {
        return decodeURIComponent(s.replace(/\%2D/g, "-").replace(/\%5F/g, "_").replace(/\%2E/g, ".").replace(/\%21/g, "!").replace(/\%7E/g, "~").replace(/\%2A/g, "*").replace(/\%27/g, "'").replace(/\%28/g, "(").replace(/\%29/g, ")"));
    } catch (e) {
    }
    return "";
}

function alreadyEnteredHoliday(lastIndex) {
    var addindex = lastIndex;
    if ($('#ipTextDateStart' + addindex).val() != "--/--") {
        var CurStrttimestamp = ConvertTimeStamp($('#ipTextDateStart' + addindex).val());
    }
    if ($('#ipTextDateEnd' + addindex).val() != "--/--") {
        var CurEndtimestamp = ConvertTimeStamp($('#ipTextDateEnd' + addindex).val());
    }
    $('.holiday_block').find('.hoilday_header_tap').each(function() {
        if (addindex != $(this).attr('id').replace('hoilday_header_tapId','').trim()) {
            if ($(this).find('.title_holiday').text() != "--/-- ~ --/--" && $(this).find('.title_holiday').text().indexOf('--/--') < 0) {
                var takeeacheaderval = $(this).find('.title_holiday').text();
                takeeacheaderval = takeeacheaderval.split(' ~ ');
                var EachStartTimestampVal = ConvertTimeStamp(takeeacheaderval[0]);
                var EachEndTimestampVal = ConvertTimeStamp(takeeacheaderval[1]);
                if (CurStrttimestamp <= EachEndTimestampVal && EachEndTimestampVal <= CurEndtimestamp) {
                    alreadyEnteredHolidayFlag = true;
                }
                if (CurStrttimestamp <= EachStartTimestampVal && EachStartTimestampVal <= CurEndtimestamp) {
                    alreadyEnteredHolidayFlag = true;
                }

            }

        }

    });

}

function callFocusInputStart(val) {
    flagTofocusStart = true;
    flagTofocusEnd = false;
    var thisval = val;
    var Idval=thisval.attr('id');
    var inputstartId = Idval;
    inputstartId = inputstartId.replace('ipTextDateStart', '');
    var currentVal = $('#'+Idval).val(); 
    var dayTwoVal="";
    var monTwoVal="";
    if (currentVal != "--/--") {    
        currentVal = currentVal.split('/');
        //month
        dayTwoVal = currentVal[1];
        dayTwoVal = getParseIntInDec(dayTwoVal);
        dayTwoVal = dayTwoVal < 10 ? ("0" + dayTwoVal) : dayTwoVal;
        monTwoVal = currentVal[0];
        monTwoVal = getParseIntInDec(monTwoVal);
        monTwoVal = monTwoVal < 10 ? ("0" + monTwoVal) : monTwoVal;
    }
    else{
        console.log("currentVal"+currentVal);
        var d = new Date();
        monTwoVal = d.getMonth() + 1;
        if(monTwoVal < 10)
        {
            monTwoVal = '0' + monTwoVal;
        }
        dayTwoVal = d.getDate();
        if(dayTwoVal < 10)
        {
            dayTwoVal = '0' + dayTwoVal;
        }
    }
    // Holiday startDate
    if($('#'+Idval).closest('.inputBlock').find('.timePickerClass').length==0)
    {
        $('#cancel-popup').text(langObj.Schedule.COM_SID_CANCEL);
        $("#ok-popup").text(langObj.Schedule.COM_SID_OK);
        $("#"+Idval).val(monTwoVal+"/"+dayTwoVal);
        createTimePickers(4);
        var CurrentDatePicker = $('body').find('#TimePicker');
        CurrentDatePicker.timeSpinner(
        {
            type : '4',
            fontHeight: FonttimerValFrNote_5,
            fontPadding:'0',
            time4 : {
                month : getParseIntInDec(monTwoVal),
                day : getParseIntInDec(dayTwoVal),
            },
            onTimeSet : function(val) {
                updateDate(inputstartId, val, "start");
            }
        });
        $(".Timer_holidayContainerCls").scrollTo(val, 500, false);
    }
    enableApplynow();
}
function CloseNOpenTimePicker(Val,ID){
    var currentVal = Val;
    var dayTwoVal = "";
    var monTwoVal = "";
    if (currentVal != "--/--") {
        currentVal = currentVal.split('/');
        //month
        dayTwoVal = currentVal[1];
        dayTwoVal = getParseIntInDec(dayTwoVal);
        dayTwoVal = dayTwoVal < 10 ? ("0" + dayTwoVal) : dayTwoVal;
        monTwoVal = currentVal[0];
        monTwoVal = getParseIntInDec(monTwoVal);
        monTwoVal = monTwoVal < 10 ? ("0" + monTwoVal) : monTwoVal;
    } else {
        console.log("currentVal" + currentVal);
        dayTwoVal = "01";
        monTwoVal = "01";
    }
}

function ShowPopupForInvalidCasesInHolidayStart(lastIndex)
{
    alreadyEnteredHolidayFlag = false;
    flagtoFifteenDays = true;
    //var thisval = val;
    var inputstartId = "ipTextDateStart"+lastIndex;
    var tempStartval = "";
    var inputendId="ipTextDateEnd"+lastIndex;
    //var triminputstartId = inputstartId.replace('ipTextDateStart', '');
    var triminputstartId=lastIndex;
    var tempendedval = "";
    tempStartval = $('#' + inputstartId).val();
    //add end date value if end is empty
    if ($(".holidayContentCls" + triminputstartId).children().eq(0).find('.inputEndDate').val().trim() == "--/--") {
        $(".holidayContentCls" + triminputstartId).children().eq(0).find('.inputEndDate').val(tempStartval);
        sendvalueToholidayHeader(triminputstartId);
    }
    tempendedval = $(".holidayContentCls" + triminputstartId).children().eq(0).find('.inputEndDate').val();
    if (tempStartval != "--/--" && tempendedval != "--/--") {
        checkForFifteenDays(tempStartval, tempendedval);
    }
    if (flagtoFifteenDays == false) {
             $('.hoilday_header_tap'+triminputstartId+'>h3').hide();
            genericPopUpObj.createPopUp("Check", "Type1");
            genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_HOLIDYA_PERIOD_NOT_EXCCED]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_SID_OK,
                "callback" : function() {
                        
                var addFifteenDays = addFifteenDaysToStartDate(tempStartval);
                $('#ipTextDateEnd' + triminputstartId).val(addFifteenDays);
                sendvalueToholidayHeader(triminputstartId); 
                closeGenericPopUp();
                $('.hoilday_header_tap'+triminputstartId+'>h3').hide();
                
               // CloseNOpenTimePicker($('#' + inputstartId).val(),inputstartId);
                }
            }]);
            genericPopUpObj.showPopUp(); 
    }
    if ($('#' + inputstartId).val().trim() != "--/--") {
        alreadyEnteredHoliday(triminputstartId);
    }
    if (alreadyEnteredHolidayFlag == true) {
    	$('#' + inputendId).val('--/--');
    	$('#' + inputstartId).val('--/--');
    	$('.hoilday_header_tap'+triminputstartId+' .addDoneicon').addClass('AddDisable');
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_HOLIDAY_ALREAY_ADDED]);
        genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_OK,
        "callback" : function() {

            //$('.hoilday_header_tap' + ind).remove();
            alreadyEnteredHolidayFlag = false;
            closeGenericPopUp();
            $('.hoilday_header_tap'+triminputstartId+'>h3').hide();

        }
    }]);
        genericPopUpObj.showPopUp();
    }
         enableApplynow();
}

function callFocusInputEnd(val) 
{
    flagTofocusStart = false;
    flagTofocusEnd = true;
    var thisval = val;
    var IdVal=thisval.attr('id');
    var inputendId = IdVal;
    inputendId = inputendId.replace('ipTextDateEnd', '');
    var currentVal = $('#'+IdVal).val();
    var dayTwoVal="";
    var monTwoVal="";
    if (currentVal != "--/--") {
        currentVal = currentVal.split('/');
        //month
        dayTwoVal = currentVal[1];
        dayTwoVal = getParseIntInDec(dayTwoVal);
        dayTwoVal = dayTwoVal < 10 ? ("0" + dayTwoVal) : dayTwoVal;
        monTwoVal = currentVal[0];
        monTwoVal = getParseIntInDec(monTwoVal);
        monTwoVal = monTwoVal < 10 ? ("0" + monTwoVal) : monTwoVal;
    }
    else{
       console.log("currentVal"+currentVal);
       var inputstartId = "ipTextDateStart" +inputendId;
       var currentStartVal = $('#'+inputstartId).val();
       console.log("startDate : " + currentStartVal);
       if(currentStartVal == "--/--")
       {
          var d = new Date();
          monTwoVal = d.getMonth() + 1;
          if(monTwoVal < 10)
          {
            monTwoVal = '0' + monTwoVal;
          }
          dayTwoVal = d.getDate();
          if(dayTwoVal < 10)
          {
            dayTwoVal = '0' + dayTwoVal;
          }
          $('#'+inputstartId).val(monTwoVal+"/"+dayTwoVal);
       }
       else
       {
       	currentStartVal = currentStartVal.split('/');
        //month
        dayTwoVal = currentStartVal[1];
        dayTwoVal = getParseIntInDec(dayTwoVal);
        dayTwoVal = dayTwoVal < 10 ? ("0" + dayTwoVal) : dayTwoVal;
        monTwoVal = currentStartVal[0];
        monTwoVal = getParseIntInDec(monTwoVal);
        monTwoVal = monTwoVal < 10 ? ("0" + monTwoVal) : monTwoVal;
       }
    }
    // Holiday End
    if($('#'+IdVal).closest('.inputBlock').find('.timePickerClass').length==0)
    {
        $('#cancel-popup').text(langObj.Schedule.COM_SID_CANCEL);
        $("#ok-popup").text(langObj.Schedule.COM_SID_OK);
        $("#"+IdVal).val(monTwoVal+"/"+dayTwoVal);
        $(".hoilday_header_tap" + inputendId).find('.addDoneicon').removeClass('AddDisable');
        createTimePickers(4);
        var CurrentDatePicker = $('body').find('#TimePicker');
        CurrentDatePicker.timeSpinner(
        {
            type : '4',
            fontHeight: FonttimerValFrNote_5,
            fontPadding:'0',
            time4 : {
                month : getParseIntInDec(monTwoVal),
                day : getParseIntInDec(dayTwoVal),
            },
            onTimeSet : function(val) {
                updateDate(inputendId, val, "end");
            }
        });
            
         $(".Timer_holidayContainerCls").scrollTo(val, 500, false);  
        
    }
    enableApplynow();
                    
            $('#cancel-popup').on('click', function(e){
                setTimeout ( function (){
                    $('#popupID').hide();
                    $('.popup-body').children().remove();
                },200);
            }); 
                $('#ok-popup').on('click', function(){
                    
                    // month : getParseIntInDec(monTwoVal),
                       // day : getParseIntInDec(dayTwoVal),

                    setTimeout ( function (){
                        $('#popupID').hide();
                        $('.popup-body').children().remove();
                    },200);
                });


}

function ShowPopupForInvalidCasesInHolidayEnd(lastIndex){
    falgtoDonedisable=true;
    flagtoFifteenDays = true;
    alreadyEnteredHolidayFlag = false;
    /*var thisval = val;*/
    /*var inputendId = thisval.id;*/
    var inputendId="ipTextDateEnd"+lastIndex;
    /*var triminputendId = inputendId.replace('ipTextDateEnd', '');*/
    var triminputendId=lastIndex;
    var tempEndval = "";
    tempEndval = $('#' + inputendId).val();
    var tempStrted_val = "";
    tempStrted_val = $(".holidayContentCls" + triminputendId).children().eq(0).find('.inputStartDate').val();
    
    if ($('#' + inputendId).val().trim() != "--/--") {
        alreadyEnteredHoliday(triminputendId);
        checkForFifteenDays(tempStrted_val, tempEndval);
        $('.hoilday_header_tap'+triminputendId+'>h3').show();
    }
    if (alreadyEnteredHolidayFlag == true) {
        $('.hoilday_header_tap'+triminputendId+'>h3').hide();
        //$('#holidayMgnttitleId').removeClass('AddDisable');
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_HOLIDAY_ALREAY_ADDED]);
        genericPopUpObj.addFooterBtns([{
        "btntxt" : COM_SID_OK,
        "callback" : function() {

            //$('.hoilday_header_tap' + ind).remove();
            alreadyEnteredHolidayFlag = false;
            closeGenericPopUp();
            //$('.hoilday_header_tap'+triminputendId+'>h3').hide();

        }
    }]);
        genericPopUpObj.showPopUp();
    }
    /*
    if (tempEndval != "--/--" && tempStrted_val != "--/--") {
            checkForFifteenDays(tempStrted_val, tempEndval);
        }*/
    
    else if (flagtoFifteenDays == false) {
        $('.hoilday_header_tap'+triminputendId+'>h3').hide();
        genericPopUpObj.createPopUp("Check", "Type1");
        genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_HOLIDYA_PERIOD_NOT_EXCCED]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_OK,
            "callback" : function() {
               var addFifteenDays=addFifteenDaysToStartDate($('#ipTextDateStart' + triminputendId).val());
                $('#' + inputendId).val(addFifteenDays);
                //sendvalueToholidayHeader(triminputendId);
                closeGenericPopUp();
                
                $('.hoilday_header_tap'+triminputendId+'>h3').hide();
                //callFocusInputEnd(tempEndval);
                //CloseNOpenTimePicker($('#' + inputendId).val(),inputendId);
            }
        }]);
        genericPopUpObj.showPopUp(); 
    }
    
     enableApplynow();
}

var manualDeviceId = "";
function addManuallyDevice(STATE, deviceState, connectionStatus, AddIpValue, device_name, storage_type, total_space, available_space, mVersion,playerType,macAddr,tlsReq,pin) {

    switch(STATE) {
        case STATE_INIT:
            $('.userpar').addClass('haslistCls');
            $('.addNoDeviceMsgCls').hide();
            $('.userpar').children('ul').addClass('addborderTop');
            if (isOnOffTimerIP) {
                addSendmanualListIndex++;
                manualDeviceId = 'tm' + addSendmanualListIndex;
                var addsendmanuallist = '<li class="auto-LFD-List"  id="' + manualDeviceId + '" ip="' + AddIpValue + '" tls="0" pin="" deviceName="' + AddIpValue + '" isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_text manual_name"><div>' + AddIpValue + '</div><div class="storageInfo">' + langObj.Settings.COM_TV_SID_CHECKING_DOT_KR_KOR + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                $('.Settinglist_Send').prepend(addsendmanuallist);
                deviceListContainerRef = $('.Settinglist_Send>li:first')
                $('.iptext').val('');
                $('.settings_manually_add').hide();
                $('.AddsignageSendTvCls').show();
            } else {
                // Firmware upgrade
                addmanualListIndex++;
                manualDeviceId = 'frmw_' + addmanualListIndex;
                var addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" tls="0" pin="" deviceName="' + AddIpValue + '"  isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_fw"><div>' + AddIpValue + '</div><div class="storageInfo">' + langObj.Settings.COM_TV_SID_CHECKING_DOT_KR_KOR + '</div></div><div class="function_icon del_icon" ></div></li>';
                $('.list').prepend(addmanuallist);
                deviceListContainerRef = $('.list>li:first');
                $('.iptext').val('');
                $('.AddsignageTvCls_open >.AddsignageTvCls_openContent').find('#manual_ip').val('');
                $('.AddsignageTvCls_open').hide();
                $('#AddsignageTvId').show();
            }
            var playerType = Utils.getActivePlayerType();
            insertDeviceInfo(device_name, AddIpValue, 'false', '', '', '', '', playerType,STATE_INIT,'','','',macAddr,tlsReq,pin);
            if (Utils.checkConnection() == CONNECTION_WIFI) {
                //mProtocolManager.performIpVerification(AddIpValue);
                showAnimationLoader("");
                setTimeout(function(){
                   mProtocolManager.performHandshaking(AddIpValue);
                },1000);
                checkingID = manualDeviceId;
            } else {
               setTimeout(function(){
                    if (isOnOffTimerIP) {
                        $('ul#deviceListOnOffTimer > li#' + manualDeviceId).find('.storageInfo').text(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                        $('ul#deviceListOnOffTimer > li#' + manualDeviceId).find('.check').attr('src', '../resource/img/ic_check_dim.png');
                    } else {
                        $('.list>li#' + manualDeviceId).find('.storageInfo').text(langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                    }
               },3000);
            }
            break;

        case STATE_REFRESHING:
            $('.userpar').addClass('haslistCls');
            $('.Settinglist_Send').addClass('addborderTop');
            deviceState = parseInt(deviceState);
            if (isOnOffTimerIP) {
                addSendmanualListIndex++;
                manualDeviceId = 'tm' + addSendmanualListIndex;
                var onOffDeviceState = "";
                var imgSource = "";
                if(playerType < Utils.getActivePlayerType() && deviceState != STATE_FAIL_CONNECTION && deviceState != STATE_INIT){
                    onOffDeviceState = langObj.Settings.MIS_SID_NOT_SUPOORT;
                }else{
                    onOffDeviceState = getOnOffTimerDeviceState(deviceState);
                }
                if(connectionStatus == 2 || connectionStatus == '2'){
                  onOffDeviceState = "<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>";
                }
                var addsendmanuallist;
                if ( deviceState == STATE_SUPPORTED )
                {
                    if(connectionStatus == 2 || connectionStatus == '2'){
                        addsendmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '"  isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_text name"><div>' + device_name + '</div><div class="storageInfo">' + onOffDeviceState + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';
                    }else{
                        addsendmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '"  isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_text name"><div>' + device_name + '</div><div class="storageInfo">' + onOffDeviceState + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings nor_checkbox"></div></li>';
                    }
                }
                 else
                     addsendmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '"  isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_text manual_name"><div>' + device_name + '</div><div class="storageInfo">' + onOffDeviceState + '</div></div><div class="function_icon del_icon" ></div><div class="checkbox_settings dim_checkbox"></div></li>';

                $('.Settinglist_Send').prepend(addsendmanuallist);
            } else {
                // Firmware upgrade
                addmanualListIndex++;
                manualDeviceId = 'frmw_' + addmanualListIndex;
                var frmUpgrade = "";
                if(playerType < Utils.getActivePlayerType() && deviceState != STATE_FAIL_CONNECTION && deviceState != STATE_INIT){
                   frmUpgrade = langObj.Settings.MIS_SID_NOT_SUPOORT;
                }else{
                   frmUpgrade = getFirmwareUpgradeDeviceState(deviceState, mVersion);
                }
                    if(connectionStatus == 2 || connectionStatus == '2'){
                       frmUpgrade = "<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>";
                     }
                var addmanuallist = '<li class="auto-LFD-List" id="' + manualDeviceId + '" ip="' + AddIpValue + '" mac = "'+macAddr+'" tls="'+tlsReq+'" pin="'+pin+'"  deviceName="' + device_name + '" isAddedManually = "true" style="border-bottom:solid #c7c7c7 1px;"><div class="name_fw"><div>' + device_name + '</div><div class="storageInfo">' + frmUpgrade + '</div></div><div class="function_icon del_icon" ></div></li>';

                $('.list').prepend(addmanuallist);
            }
            
            break;
        case STATE_SUPPORTED:
            if (isOnOffTimerIP) {
                $('li#' + manualDeviceId).find('.name_text').removeClass('manual_name').addClass('name');
                $('li#' + manualDeviceId).find('.name_text > div').html(device_name);
                $('li#' + manualDeviceId).find('.storageInfo').html('');
                $('li#' + manualDeviceId).find('.checkbox_settings').removeClass('dim_checkbox').addClass('nor_checkbox');
            } else {
                var currrentVersion = langObj.Schedule.COM_EBD_SID_MIX_CURRENT_VERSION.replace('<<A>>', mVersion);
                $('.list>li#' + manualDeviceId).find('.name > div').html(device_name);
                $('.list>li#' + manualDeviceId).find('.storageInfo').html(currrentVersion);
            }
            checkingID = null;
            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, storage_type, total_space, available_space, mVersion,playerType, STATE_SUPPORTED,macAddr,tlsReq,pin);
            break;

        case STATE_UNSUPPORTED:
            if (isOnOffTimerIP) {
                $('li#' + manualDeviceId).find('.manual_name > div').html(device_name);
                $('li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIS_SID_NOT_SUPOORT);
            } else {
                $('.list>li#' + manualDeviceId).find('.name > div').html(device_name);
                $('.list>li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIS_SID_NOT_SUPOORT);
            }
            checkingID = null;
            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, storage_type, total_space, available_space, mVersion,playerType, STATE_UNSUPPORTED,macAddr,tlsReq,pin);
            break;

        case STATE_UPDATE_REQ:
            if (isOnOffTimerIP) {
                $('li#' + manualDeviceId).find('.manual_name > div').html(device_name);
                $('li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIS_SID_UPDATE_REQUIRED);
            } else {
                $('.list>li#' + manualDeviceId).find('.name > div').html(device_name);
                $('.list>li#' + manualDeviceId).find('.storageInfo').html(langObj.Settings.MIS_SID_UPDATE_REQUIRED);
            }
            checkingID = null;
            mProtocolManager.stopConnectionService();
            updateDeviceFromDB(device_name, AddIpValue, connectionStatus, storage_type, total_space, available_space, mVersion, playerType,STATE_UPDATE_REQ,macAddr,tlsReq,pin);
            break;

        case STATE_FAIL_CONNECTION:
                    var lockedStatus = (langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE);
                    if(connectionStatus == 2 || connectionStatus == '2'){
                           lockedStatus = "<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) + "</span>";
                        }
            if (isOnOffTimerIP) {
                $('li#' + manualDeviceId).find('.manual_name > div').html(device_name);
                $('li#' + manualDeviceId).find('.storageInfo').html(lockedStatus);
            } else {
                $('.list>li#' + manualDeviceId).find('.name > div').html(device_name);
                $('.list>li#' + manualDeviceId).find('.storageInfo').html(lockedStatus);
            }
            checkingID = null;
            mProtocolManager.stopConnectionService();
            break;
        default:
            console.log("unknown case found");
    }
}

function getFirmwareUpgradeDeviceState(deviceState, mVersion) {
    switch(deviceState) {
        case STATE_INIT:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
        case  STATE_SUPPORTED:
            var currrentVersion = langObj.Schedule.COM_EBD_SID_MIX_CURRENT_VERSION.replace('<<A>>', mVersion);
            return currrentVersion;
        case STATE_UNSUPPORTED:
            return langObj.Settings.MIS_SID_NOT_SUPOORT;
        case STATE_UPDATE_REQ:
            return langObj.Settings.MIS_SID_UPDATE_REQUIRED;
        case STATE_FAIL_CONNECTION:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
        default:
            return '';
    }
}

function getOnOffTimerDeviceState(deviceState) {
    switch(deviceState) {
        case STATE_INIT:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
        case  STATE_SUPPORTED:
            return '';
        case STATE_UNSUPPORTED:
            return langObj.Settings.MIS_SID_NOT_SUPOORT;
        case STATE_UPDATE_REQ:
            return langObj.Settings.MIS_SID_UPDATE_REQUIRED;
        case STATE_FAIL_CONNECTION:
            return langObj.Settings.MIA_SID_CURRENTLY_UNAVAILABLE;
            default: '';
    }
}

function getOnOffTimerDeviceIconState(deviceState) {
    switch(deviceState) {
        case STATE_INIT:
            return 'ic_check_dim.png';
        case  STATE_SUPPORTED:
            return 'ic_check_nor.png';
        case STATE_UNSUPPORTED:
            return 'ic_check_dim.png';
        case STATE_UPDATE_REQ:
            return 'ic_check_dim.png';
        case STATE_FAIL_CONNECTION:
            return 'ic_check_dim.png';
        default:
            return '';
    }
}

function failedToUpdateManualIp() {
    if (isOnOffTimerIP) {
        // On Off timer
        loaderObj.hideLoader();
        $('.AddsignageSendTvCls').hide();
        $('.settings_manually_add').show();
        $('.iptext').blur();
        mProtocolManager.stopConnectionService();
    } else {
        // Firmware
        loaderObj.hideLoader();
        $('.AddsignageTvCls_open').hide();
        $('#AddsignageTvId').show();
        $('.iptext').blur();
        mProtocolManager.stopConnectionService();
    }
}
function getDefaultStoreInfo(){
    var myStoreInfoJson=Utils.getActiveStoreInfo();
        storeWeekDayList=myStoreInfoJson.StoreOpenDay.split("||");
    var startTimeEndTimeArray=myStoreInfoJson.StoreOpenTime.split("||");
     //DefaultStartTime=startTimeEndTimeArray[0].split('-')[0];
     //DefaultEndTime=startTimeEndTimeArray[0].split('-')[1];
     //changed according to Requirement
     DefaultStartTime="12:00 am";
     DefaultEndTime="12:00 am";
    for (var i=0;i<storeWeekDayList.length;i++)
    {
        storeWeekDayList[i]=storeWeekDayList[i].replace("sun","1");
        storeWeekDayList[i]=storeWeekDayList[i].replace("mon","2");
        storeWeekDayList[i]=storeWeekDayList[i].replace("tue","3");
        storeWeekDayList[i]=storeWeekDayList[i].replace("wed","4");
        storeWeekDayList[i]=storeWeekDayList[i].replace("thu","5");
        storeWeekDayList[i]=storeWeekDayList[i].replace("fri","6");
        storeWeekDayList[i]=storeWeekDayList[i].replace("sat","7");
    }
}
/**
 *Call this method while switching to other screen
 */
function cancelCurrentProcessOnBack() {
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_LEAVE_PAGE_DATA_STOPPED_PROCEDD]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_SID_CANCEL,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : langObj.Schedule.COM_SID_OK,
        "callback" : function() {
            isProgress = false;

            console.log("mTaskType: " + mTaskType );             
            if (mTaskType == CONNECTION_TYPE_FIRMWARE_UPGRADE) {
                mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
            } else if (mTaskType == CONNECTION_TYPE_ON_OFF_TIMER_UPDATE) {
                mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_ON_OFF_TIMER_UPDATE);
            } else if (mTaskType == CONNECTION_TYPE_RSITE_DOWNLOAD) {
                mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_RSITE_DOWNLOAD);
            }

            if ( $('#StartsendbtnId').is(':visible') )
            {
                $('#power-cntrl-panel').show();
                $('#power-cntrl-panel-apply').hide();
                $('.Settinglist_Send').html('');
                $('.settings_manually_add').show();
                $('.AddsignageSendTvCls').removeClass('AddDisableAddManual');
                $('.AddsignageSendTvCls').hide();        

                return;
            }
            

            $('.settings-panel').animate(
                {
                    'left' : '0%'
                },
                {
                    complete: function()
                    {
                        $('.tablet_ContentsCls > .custom-header > .header-part2').css({'width':'70%'});
                        $('.tablet_ContentsCls > .custom-header > .header-part2 > .header-text').css({'font-size':'19px'});
                        $('.tablet_ContentsCls > .custom-header > .header-part3').css({'width':'15%'});
                    }
                }
            );

            $('.tablet_ContentsCls').animate({
                'left' : '100%'
            });

        }
    }]);
    genericPopUpObj.showPopUp();
}

function cancelCurrentProcess(thisVal) {
    genericPopUpObj.createPopUp("Check", "Type1");
    genericPopUpObj.appendHTMLData([langObj.Settings.MIA_SID_LEAVE_PAGE_DATA_STOPPED_PROCEDD]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_SID_CANCEL,
        "callback" : function() {
            closeGenericPopUp();
        }
    }, {
        "btntxt" : langObj.Schedule.COM_SID_OK,
        "callback" : function() {
            isProgress = false;
            try {
                if (mTaskType == CONNECTION_TYPE_FIRMWARE_UPGRADE) {
                    mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_FIRMWARE_UPGRADE);
                } else if (mTaskType == CONNECTION_TYPE_ON_OFF_TIMER_UPDATE) {
                    mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_ON_OFF_TIMER_UPDATE);
                } else if (mTaskType == CONNECTION_TYPE_RSITE_DOWNLOAD) {
                    mProtocolManager.performCancelOperation(0, 0, CONNECTION_TYPE_RSITE_DOWNLOAD);
                }
            } catch(e) {
            }
            thisVal.trigger('tap');
        }
    }]);
    genericPopUpObj.showPopUp();
}

function addFifteenDaysToStartDate(startval){
        var inputstartval=startval;
        var EndDateVal="";
        var takeDate = new Date();
        takeDate.setMonth((getParseIntInDec(inputstartval.split('/')[0])-1));
        takeDate.setDate(getParseIntInDec(inputstartval.split('/')[1]));
        takeDate.setDate(takeDate.getDate() + 14);
         var  month_value = takeDate.getMonth();
        var day_value = takeDate.getDate();
        month_value=getParseIntInDec(month_value)+1;
        month_value=month_value<10?"0"+month_value:month_value;
        day_value=day_value<10?"0"+day_value:day_value;
         EndDateVal=month_value+"/"+day_value;
        console.log("currentPlusFifteen_date"+takeDate+"month_value"+month_value+"day_value"+day_value+"EndDateVal"+EndDateVal);
        return EndDateVal;
}
function strToUpper (str) {
    
    return String(str).toUpperCase();
}

function createPlaylistModels_set()
{
    $('.ModelsListUl_set').html('');
    var ModelListLiItem="";
    var SelectedName=Utils.getActivePlayerType();
    SelectedName=Utils.getPlayerName(SelectedName);
    var i = 1;
    var activeLi = "active-li-model";
    var modelSeries = addSeriesToModel(SelectedName);
    ModelListLiItem += '<li class="ModelListLiItemCls_set" id="Model_set'+i+'"  name="'+SelectedName+'"><div class="ModelListLiContent_set '+activeLi+'" >'+modelSeries+'<div></li>';
    i++;
    var changeModelOSD = langObj.Settings.MIA_SID_CHANGE_MODEL_TYPE;
    ModelListLiItem += '<li class="ModelListLiItemCls_set model-arrow" id="changeModelTypeID"  name="'+"Change Model Type"+'" ><div class="ModelListLiContent_set_2 MIA_SID_CHANGE_MODEL_TYPE" >'+changeModelOSD+'</div></li>';
   
    $('.ModelsListUl_set').append(ModelListLiItem);
    //apply border-top for the first li
    $('#Model_set1').find('.ModelListLiContent_set').css({'border-top':'solid rgba(29, 29, 31,0.2) 1px'});

}
function addSeriesToModel(ModelName)
{
    var PlayerNameSeries="";                
    
    switch(ModelName) {
        case langObj.index.MIA_SID_STANDARD_MODEL:
            PlayerNameSeries = "MagicInfo Player E";
            break;
        case langObj.index.MIA_SID_PREMIUM_MODEL:
            PlayerNameSeries = "MagicInfo Player S3 / 16:9";
            break;
        case langObj.index.MIA_SID_TIZEN:
            PlayerNameSeries = "MagicInfo Player S4";
            break;
        case "stretchmodel":
            PlayerNameSeries = "MagicInfo Player S3 / 32:9";
            break;
        case langObj.index.MIA_SID_S5:
            PlayerNameSeries = "MagicInfo Player S5";
            break;
        case langObj.index.MIA_SID_S6:
            PlayerNameSeries = "MagicInfo Player S6";
            break;
        default:
            break;
    }
    return PlayerNameSeries;

}
function OpenSoftwareUpdate(){
          
    mProtocolManager.registerWiFiStateChangeReceiver();
    isReady = true;
    mProtocolManager.startDeviceDiscovery();
    showLoader('updatefooterIcon');
    if (Utils.checkConnection() == CONNECTION_WIFI) 
    {
        isReady = true;
        mProtocolManager.startDeviceDiscovery();
        showLoader('updatefooterIcon');
    } else {
        hideLoader('updatefooterIcon');
    }
}
function enableApplynow(){
    var Strtval="";
    var Endval="";
    var flagToenable=false;
    var value="";
            $('.holiday_block>.hoilday_header_tap').each(function() {
             var holidayId = $(this).attr('id');
             holidayId=holidayId.replace('hoilday_header_tapId','');
             Strtval = $('#ipTextDateStart' + holidayId).val();
             Endval = $('#ipTextDateEnd' + holidayId).val();
            if(Strtval!="--/--" || Endval!='--/--'){
                  value=Strtval+Endval;
            }
            });
            
            if($('.Timer_block>.timer_header_tap').find('.onTimerIconCls>img.check').length>0 || $('.Timer_block>.timer_header_tap').find('.offTimerIconCls>img.check').length>0 ||value!="")
            {
                if($('.network-footer-apply>#newconection_apply').hasClass('AddDisable')){
                     $('.network-footer-apply>#newconection_apply').removeClass('AddDisable');
                }
            }
            else if($('.Timer_block>.timer_header_tap').find('.onTimerIconCls>img.check').length<=0 &&  $('.Timer_block>.timer_header_tap').find('.offTimerIconCls>img.check').length<=0 &&value==""){
                     $('.network-footer-apply>#newconection_apply').addClass('AddDisable');
            }
            
}
//============================ END ==================================
function UpdateValuesForStartNEndHoliday(index)
{
    var tempEndval = "";
    tempEndval = $('#ipTextDateEnd' + index).val();
    var tempStartval = "";
    tempStartval = $('#ipTextDateStart' + index).val();
    //add end date value if end is empty
    if (tempEndval == "--/--") 
    {
        $('#ipTextDateEnd' + index).val(tempStartval);
    }
    //add end date value if start is empty
    if (tempStartval == "--/--")
     {
        $('#ipTextDateStart' + index).val(tempEndval);
    }
}
function DeleteEmptyHolidayApplyNow()
{
    if ($('.holiday_block').find('.hoilday_header_tap').length > 0)
     {
        $('.holiday_block>.hoilday_header_tap').each(function() {
            var holidayId = $(this).attr('id');
            holidayId=holidayId.replace('hoilday_header_tapId','');
            if($(".hoilday_header_tap" + holidayId).find('.ui-collapsible-heading-toggle>.title_holiday').text()=="--/-- ~ --/--")
            {
                $(".hoilday_header_tap" + holidayId).remove();
                $('#holidayMgnttitleId').removeClass('AddDisable');
                FlagToexpand=false;

            }

        });

    }

}
function enableScrollOnWindow(){
    setTimeout(function() {
            $('body').append("<div style='height:1500px;width:90%;position:absolute;border:solid 1px;' id='demo'></div>");
            setTimeout(function() {
                $('#demo').delay(100).remove();
            }, 100);

        }, 150);
}
function setOnOffTimerTimeLabel(){
    $('.Timer_block>.timer_header_tap').each(function() {
        id = $(this).attr('id');
        DayStr = "";
        OFFDayStr = "";
        if ($(this).find('.offTimerIconCls>img').hasClass('check')) {
            $(this).find('.OffSelectdaysCls>div.floatLeftimgCls').each(function() {
                var temoffpar = new Array();
                var tempoff;
                tempoff = $(this).attr('class');
                tempoff = tempoff.replace('floatLeftimgCls', '');
                temoffpar = tempoff.split("_");
                OFFDayStr += temoffpar[1] + ":";
            });
            OFFDayStr = OFFDayStr.slice(0, -1);
            //to remove last char from string
        }
    });

    if (InputvalToheader == " ~ ") {
        //$('#' + getId).find('.addtimerTxtCls').text("");
        $('.ontimer' + getId + 'Time').text("");
        $('.offtimer' + getId + 'Time').text("");
    } else {
        InputvalToheader = strToUpper(InputvalToheader);
        //$('#' + getId).find('.addtimerTxtCls').text(InputvalToheader);
        $('.ontimer' + getId + 'Time').text(InputstarttimervalToHeader);
        $('.offtimer' + getId + 'Time').text(InputendtimervalToHeader);
    }
}

function setTimerInsertCnt(cnt)
{
	if(cnt == 1)
		insertTimerInfo("OnTimer2", "F", "1", "1");
	else if(cnt == 2)
		insertTimerInfo("OnTimer3", "F", "1", "1");
	else if(cnt == 3)
		insertTimerInfo("OnTimer4", "F", "1", "1");
	else if(cnt == 4)
		insertTimerInfo("OnTimer5", "F", "1", "1");
	else if(cnt == 5)
		insertTimerInfo("OnTimer6", "F", "1", "1");
	else if(cnt == 6)
		insertTimerInfo("OnTimer7", "F", "1", "1");
	else if(cnt == 7)
		insertTimerInfo("OffTimer1", "F", "1", "1");
	else if(cnt == 8)
		insertTimerInfo("OffTimer2", "F", "1", "1");
	else if(cnt == 9)
		insertTimerInfo("OffTimer3", "F", "1", "1");
	else if(cnt == 10)
		insertTimerInfo("OffTimer4", "F", "1", "1");
	else if(cnt == 11)
		insertTimerInfo("OffTimer5", "F", "1", "1");
	else if(cnt == 12)
		insertTimerInfo("OffTimer6", "F", "1", "1");
	else if(cnt == 13)
		insertTimerInfo("OffTimer7", "F", "1", "1");
	else if(cnt == 14)
		console.log("Timer DB Complete");

}

function updateTimerDB(onoff, number, type)
{
	var i = number;
	if(onoff == "On")
	{
		var timerName = 'OnTimer'+i;
		
		if(type == "F")
		{
			updateTimerOffFromDB(timerName, 'F');
		}
		else
		{
			var weekVal = "";
			$('#SelectdaysId'+i+'>div.floatLeftimgCls').each(function() {
                var tempar = new Array();
                var temp;
                temp = $(this).attr('class');
                temp=temp.replace('floatLeftimgCls','');
                tempar = temp.split("_");
                weekVal += tempar[1] + ":";
            });
            
            if(weekVal == "")
            {
            	updateTimerOffFromDB(timerName, 'F');
            }
            else
            {
	            var timeVal = $('#ipTextStart' + i).val();
				updateTimerFromDB(timerName, 'T', timeVal, weekVal);
            }
		}
	}
	else if(onoff == "Off")
	{
		var timerName = 'OffTimer'+i;
		
		if(type == "F")
		{
			updateTimerOffFromDB(timerName, 'F');
		}
		else
		{
			var weekVal = "";
			$('#OffSelectdaysId'+i+'>div.floatLeftimgCls').each(function() {
                var tempar = new Array();
                var temp;
                temp = $(this).attr('class');
                temp=temp.replace('floatLeftimgCls','');
                temp=temp.replace(' ','');
                tempar = temp.split("_");
                weekVal += tempar[1] + ":";
            });
			
			if(weekVal == "")
			{
				updateTimerOffFromDB(timerName, 'F');
			}
			else
			{
	            var timeVal = $('#ipTextEnd' + i).val();
				updateTimerFromDB(timerName, 'T', timeVal, weekVal);
			}
		}
	}
}
function isHolidayIdExistsInLocalSrotage(holidayId)
{
	 var myHolidayInfoJson = JSON.parse(localStorage.getItem("Holiday_INFO"));		
		if (myHolidayInfoJson!=null && myHolidayInfoJson.myHolidayInfoArr) {
			var arrLen = myHolidayInfoJson.myHolidayInfoArr.length;
			var holidayID = 0;
			for (var i = 0; i < arrLen; i++) {
				holidayID = myHolidayInfoJson.myHolidayInfoArr[i].IndexVal;
				if(holidayId==holidayID)
				{
					return true;
					break;
				}
			}
		}
		return false;
}

function showPINVerficationPage(pinHeaderStr) {
    $('#view-setting').hide();
    $('#pin_verification_page_Id').show();
    $('#header-part2_addSignagea').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
    $('#pin_verification_panel').show();
    showGenericKeyboard(pinHeaderStr); // show Pin Verification Page
}

function hidePINVerficationPage(){
     $('#view-setting').show();
     $('#pin_verification_page_Id').hide();
     //$('#header-part2_addSignagea').autoFontSize({ maxFontPixels: 18,minFontPixels:12});
     $('#pin_verification_panel').hide();
    // $('#pinbox1').focus();
    }

function askToEnterCorrectPIN(ip, isManualCon, pinHeaderStr){
     $('#pin_verification_page_Id').attr('isManual', isManualCon);
     showPINVerficationPage(pinHeaderStr);
 }

function updateVerifyPINResult(result, resultType,deviceListContainerRef,pin,isManual){
   mProtocolManager.stopConnectionService();
   loaderObj.hideLoader()
   var mac = deviceListContainerRef.parent('.auto-LFD-List').attr('mac');
   if(mac == undefined){
     mac = deviceListContainerRef.attr('mac');
   }
    if(isManual == 'true'){
           mac = result.split('>>>>')[6];
       }
   mProtocolManager.requestEncryption(deviceListContainerRef,isManual,mac,pin);

        if(resultType == 1){  //ON OFF Timer
          // SUCCESS VERIFICATION //
              if(isManual == 'true'){
               ip =  deviceListContainerRef.attr('ip');
               deviceListContainerRef.attr('tls',1);
               deviceListContainerRef.parent('.auto-LFD-List').attr('tls',1);
              updateManuallyAddedIP(result,ip);
          //mProtocolManager.performIpVerification(ip);
         }else{
              console.log("result: "+result);
              $('#StartsendbtnId').removeClass('icon-disabled');
              deviceListContainerRef.removeClass('nor_checkbox').addClass('sel_checkbox');
              $('.network-footer>#newconection').removeClass('icon-disabled');
              $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').removeClass('icon-disabled');
              if (mLFDInfoArrayList.length >0) {
               $('#StartsendbtnId').removeClass('icon-disabled');
              }
         }
     }else if(resultType == 2){ //FIRMWARE
           // SUCCESS VERIFICATION //
           console.log("result: "+result);

            if(isManual == 'true'){
                ip =  deviceListContainerRef.attr('ip');
                deviceListContainerRef.attr('tls',1);
                deviceListContainerRef.parent('.auto-LFD-List').attr('tls',1);
                // add device in list
                 updateManuallyAddedIP(result,ip);
            }else{

           $('.network-footer>#newconection').removeClass('icon-disabled');
           $('.network-footer-two>#btncontainer>#newconection_resend>#resendBtnId').removeClass('icon-disabled');

           $('.AddsignageTvCls').addClass('AddDisableAddManual');
           $('#updatefooterIcon').addClass('icon-disabled');
           mProtocolManager.initNetworkConnection(CONNECTION_TYPE_FIRMWARE_UPGRADE);
           oldFirmwareVersion = $('.list>li#' +deviceID).find('.storageInfo').text();
           setTimeout(function() {
               showFirmwareCancelPopup();
           }, 500);
           }
       }
}

function updateEncryptedInfo(refId,isManual,pin){
    refId.attr('pin',pin);
    refId.parent('.auto-LFD-List').attr('pin',pin);
    if(isManual == false){
      mLFDInfo.mPin = pin;
      mLFDInfoArrayList.push(mLFDInfo);
    }
}

function wrongPinGuiUpdate(result,resultType, deviceListContainerRef,pin,isManual){
        var ip =  deviceListContainerRef.attr('ip');
        if(ip == undefined){
         ip = deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
        }
         var pinHeaderStr;
         if(isManual == 'true'){
            pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_INVALID_ENTER_PIN_FOR_AGAIN.replace("<<A>>", ip));
         }
         else{
             pinHeaderStr = (langObj.Send.MIA_SID_20_MIX_INVALID_ENTER_PIN_FOR_AGAIN.replace("<<A>>", devicename));
         }
        askToEnterCorrectPIN(ip, isManual, pinHeaderStr);
}

function doPinVerificationProcess(pinVal) {
    setTimeout(function(){
        if (settingsPageType == 1) {
            var ip =  deviceListContainerRef.parent('.auto-LFD-List').attr('ip');
            if (ip == undefined) {
                ip =  deviceListContainerRef.attr('ip');
            }
        } else {
            var ip =  thisVal.parent('.auto-LFD-List').attr('ip');
            if (ip == undefined) {
                ip =  thisVal.attr('ip');
            }
        }
        $('.pintext').val('');
        $('#view-setting').show();
        $('#pin_verification_page_Id').hide();
        $('#pin_verification_panel').hide();
        pinVal = pinVal.trim();
        showAnimationLoader("");
        var isManual = $('#pin_verification_page_Id').attr('isManual');
        mProtocolManager.verifyPINInfo(ip ,settingsPageType, pinVal, deviceListContainerRef, isManual);
    }, 400);
}

function updatecheckBoxBlock(refID)
{
        var $parentLi = refID.parent();
        if(refID.hasClass('nor_checkbox')){
            refID.removeClass('nor_checkbox').addClass('dim_checkbox');
        }else if(refID.hasClass('sel_checkbox')){
        refID.removeClass('sel_checkbox').addClass('dim_checkbox');
                           }
        $parentLi.find('.storageInfo').append("<span style='color:red;'>"+ (langObj.Send.MIA_SID_20_LOCKED) +"</span>");

        console.log("updatecheckBoxBlock: "+refID.html());
}

function cancelPinPopUpButtonPressed()
{
    if (deviceListContainerRef.attr('isaddedmanually') != 'true') {
        return;
    }
    var listObj = $('li.auto-LFD-List');
    var mac_addr = null;
    var deviceIP = deviceListContainerRef.attr('ip');
    listObj.each(function() {
        var thisIP = $(this).attr('ip');
        if (deviceIP == thisIP) {
            mac_addr = $(this).attr('mac');
            return false;
        }
    });
    mProtocolManager.stopConnectionService();
    addManuallyDevice(STATE_FAIL_CONNECTION, STATE_FAIL_CONNECTION, '0', deviceIP, deviceIP, '', '', '', '', Utils.getActivePlayerType(),mac_addr,1,"");
}
/* Either incase pin wrong reset the list pin info*/
function updatePinInDeviceList(mMaxIndex)
{
         if(settingsPageType == 1){
         var deviceID = mLFDInfoArrayList[mMaxIndex].mDeviceId;
        var isPinEmpty = Utils.getMacPinValue(mLFDInfoArrayList[mMaxIndex].mMacAddr);
        if(isPinEmpty.length == 0){
           $('li#' + deviceID).attr('pin',"");
            }
        }
}
function checkAndUpdateStatusOfDesignElements()
{
    var designElmStatus=Utils.getSessionStorageValue("downloadStatus");
    var flag=true;
    if(designElmStatus=="")
    {
        var designElementPath=[{path:'.ETabletAuthor/BG/bg_custom/bg_classic/actual',id:2}
                            ,{path:'.ETabletAuthor/BG/bg_custom/bg_modern/actual',id:3}
                            ,{path:'.ETabletAuthor/BG/bg_custom/bg_vintage/actual',id:4}
                            ,{path:WEATHER_IMG_PATH,id:5}
                            ,{path:'.ETabletAuthor/FreeTemplates/Download',id:1}]
        var length=designElementPath.length;
        var designObj;
        var promises=[];
        for(var i=0;i<length;i++)
        {
            designObj=designElementPath[i];
            promises.push(getNewPromise(designObj.path,designObj.id));
        }
        Promise.all(promises).then(function(results) {
                                getDesignElementsInfo();
                                //console.log("--x--In Promise::"+JSON.stringify(results));
                             }).catch(function(error) {
                               getDesignElementsInfo();
                              // console.log("--x--In Promise::"+error);
                             });
        Utils.setSessionStorageValue("downloadStatus","true");
        flag=false;
    }
    return flag;
}
function getNewPromise(path,id)
{
    return new Promise(function(resolve,reject){
        getDesignElementList(path,function(fileList,designElmId){
            if(fileList.length==0)
            {
              updateDesignElementsStatusWithId(designElmId, '0');
            }
            resolve({id:designElmId,length:fileList.length});
        },id);
    });
}
function getDesignElementList(folderPath, funCallBack,id)
{
    var callBackFetchList = funCallBack;
    var folderPath = folderPath;
    var listArray=[];
    function gotDS1(fileSystem) {
        entry = fileSystem.root.toURL();
        rootPath = fileSystem.root.toURL();
        entry = folderPath;
        this.filesys = fileSystem;
        fileSystem.root.getDirectory(entry, {
            create : true,
            exclusive : false
        }, onGetDirectoryWin1, onGetDirectoryFail1);
    };
    function fail1(error) {
        callBackFetchList([],id);
    }
    function onGetDirectoryWin1(directoryEntry) {
        var directoryReader = directoryEntry.createReader();
        directoryReader.readEntries(gotDirectoryEntry1, fail1);
    }
    function gotDirectoryEntry1(entries) {
        for (var i = 0; i < entries.length; ++i) {
            listArray.push(entries[i].name);
            break; // remove it if want to fetch whole list, currently only need to check if there is something in folder
        }
        callBackFetchList(listArray,id);
    }
    function onGetDirectoryFail1(directoryEntry) {
        callBackFetchList([],id);
    }
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotDS1, fail1);
};
function closePinVerification(){
     $('.pintext').val('');
     $('#view-setting').show();
     $('#pin_verification_page_Id').hide();
     $('#pin_verification_panel').hide();
}
