var db;
var dbCreated = false;

var mTimerName = "";
var mTimerIsOn = "";
var mTimerTimeVal = "";
var mTimerWeekVal = "";

var mHolidayIndex = "";
var mHolidayStartDate = "";
var mHolidayEndDate = "";

var Timer_DB_TAB = "TimerDB:: ";
var myTimerInfoJson = {};
var myTimerInfoArr = [];
myTimerInfoJson.myTimerInfoArr = myTimerInfoArr;

var timerInsertCnt = 0;

var Holiday_DB_TAB = "HolidayDB:: ";
var myHolidayInfoJson = {};
var myHolidayInfoArr = [];
myHolidayInfoJson.myHolidayInfoArr = myHolidayInfoArr;

/***
 * To insert Holiday info in DB
 *
 * @param
 * 
 *		mHolidayIndex -> 1 (order)
 * 		mHolidayStartDate -> 0714
 * 		mHolidayEndDate -> 0718
 */
function insertHolidayInfo(mHolidayIndex, mHolidayStartDate, mHolidayEndDate) {
	console.log(Holiday_DB_TAB + "@insertHolidayInfo "+mHolidayIndex + ", " + mHolidayStartDate + ", " + mHolidayEndDate);
	//alert(Holiday_DB_TAB + "@insertHolidayInfo "+mHolidayIndex + ", " + mHolidayStartDate + ", " + mHolidayEndDate);
	this.mHolidayIndex = mHolidayIndex;
	this.mHolidayStartDate = mHolidayStartDate;
	this.mHolidayEndDate = mHolidayEndDate;
	
	db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);
	console.log(Holiday_DB_TAB + "@insertHolidayDB: DB Open Successfully...");
	db.transaction(populateHolidayDB, HolidayDBError);
}


/***
 * To insert Timer info in DB
 *
 * @param
 * 		mTimerName -> OnTimer1
 * 		mIsOn -> T/F
 * 		mTimerTimeVal -> 12:00am
 * 		mTimerWeekVal -> 2: 4: 6
 */
function insertTimerInfo(mTimerName, mIsOn, mTimerTimeVal, mTimerWeekVal) {
	console.log(Timer_DB_TAB + "@insertTimerInfo " +  mTimerName + ", " + mIsOn +", " + mTimerTimeVal + ", " + mTimerWeekVal);
	
	this.mTimerName = mTimerName;
	this.mTimerIsOn = mIsOn;
	this.mTimerTimeVal = mTimerTimeVal;
	this.mTimerWeekVal = mTimerWeekVal;

	db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	console.log(Timer_DB_TAB + "@insertTimerDB: DB Open Successfully...");
	db.transaction(populateTimerDB, TimerDBError);
}

/**
 * To get the Holiday information list
 */
function saveHolidayInfo() {
	console.log(Holiday_DB_TAB + "@saveHolidayInfo");
	db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);
	//alert("open db success");
	db.transaction(readHolidayDB, HolidayDBError, populateHolidayDBOnSuccess);
}

/**
 * To get the Timer information list
 */
function saveTimerInfo() {
	console.log(Timer_DB_TAB + "@saveTimerInfo");
	db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	db.transaction(readTimerDB, TimerDBError, populateTimerDBOnSuccess);
}

/**
 * To deleteTimerFromDB according to specified attribute
 * @param DeviceName
 */
function deleteHolidayFromDB(IndexVal) {
	console.log(Holiday_DB_TAB + "@deleteHolidayFromDB");
	var db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
        var sql = "DELETE FROM tbl_Holiday WHERE tbl_Holiday.IndexVal = '" + IndexVal + "'";
        console.log("@@@@@@ sql query: "+sql);
		tx.executeSql(sql);
		console.log(Holiday_DB_TAB + " Delete one item success" + IndexVal);
	});
	sessionStorage.setItem("Holiday_INFO", "");
	saveHolidayInfo();
}

/**
 * To deleteTimerFromDB according to specified attribute
 * @param DeviceName
 */
function deleteTimerFromDB(TimerName) {
	console.log(Timer_DB_TAB + "@deleteTimerFromDB");
	var db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
        var sql = "DELETE FROM tbl_Timer WHERE tbl_Timer.TimerName = '" + TimerName + "'";
        console.log("@@@@@@ sql query: "+sql);
		tx.executeSql(sql);
		console.log(Timer_DB_TAB + " Delete one item success" + TimerName);
	});
	sessionStorage.setItem("Timer_INFO", "");
	saveTimerInfo();
}

/**
 * 
 *update Holiday list DB as wll as  update saveHolidayInfo() in session
 *
 * @param Holiday StartDate
 * 
 * Need to update
 */
function updateHolidayFromDB(id, StartDate, EndDate) {
	console.log(Holiday_DB_TAB + "@@@@@@@ updateHolidayFromDB @@@@@@@@@:  ");
	var db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);

	var whr = "WHERE tbl_Holiday.IndexVal = '"+id+"'";
	var sql = "UPDATE tbl_Holiday SET " + " StartDate='" + StartDate + "'," + "EndDate='" + EndDate + "' " + whr;
	
	console.log(Holiday_DB_TAB + sql);
	
	db.transaction(function(tx) {
		tx.executeSql(sql);
		console.log(Holiday_DB_TAB + " Updated one item successfully:  "+id +" , StartDate: "+StartDate+" , EndDate: "+EndDate);
		sessionStorage.setItem("Holiday_INFO", "");
		console.log(Holiday_DB_TAB + " Reseting updated Holiday: "+id+" , StartDate: "+StartDate+" , EndDate: "+EndDate);
	    saveHolidayInfo();
	});
}

/**
 * 
 *update Timer list DB as wll as  update saveTimerInfo() in session
 *
 * @param Timer
 * 
 * Need to update
 */
function updateTimerFromDB(timerName, isOn, timeVal, weekVal) {
	console.log(Timer_DB_TAB + "@@@@@@@ updateTimerFromDB @@@@@@@@@:  ");
	var db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	var whr = "WHERE tbl_Timer.TimerName = '" + timerName + "'";
	var sql = "UPDATE tbl_Timer SET " + " IsOn='" + isOn + "'," + "TimeVal='" + timeVal + "'," + "WeekVal='" + weekVal + "' " + whr;
	console.log(Timer_DB_TAB + sql);
	
	db.transaction(function(tx) {
		tx.executeSql(sql);
		console.log(Timer_DB_TAB + " Updated one item successfully:  "+timerName +" , TimeVal: "+timeVal+" , WeekVal: "+weekVal);
		sessionStorage.setItem("Timer_INFO", "");
		console.log(Timer_DB_TAB + " Reseting updated TimerName: "+timerName+" , TimeVal: "+timeVal+" , WeekVal: "+weekVal);
	    saveTimerInfo();
	});
}

function updateTimerOffFromDB(timerName, isOn) {
	console.log(Timer_DB_TAB + "@@@@@@@ updateTimerOffFromDB @@@@@@@@@:  ");
	var db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	var whr = "WHERE tbl_Timer.TimerName = '" + timerName + "'";
	var sql = "UPDATE tbl_Timer SET " + " IsOn='" + isOn + "' " + whr;
	console.log(Timer_DB_TAB + sql);
	
	db.transaction(function(tx) {
		tx.executeSql(sql);
		console.log(Timer_DB_TAB + " Updated one item successfully:  "+timerName +" , isOn: "+isOn);
		sessionStorage.setItem("Timer_INFO", "");
		console.log(Timer_DB_TAB + " Reseting updated TimerName: "+timerName +" , isOn: "+isOn);
	    saveTimerInfo();
	});
}

function populateHolidayDB(tx) {
	console.log(Holiday_DB_TAB + "@saveHolidayInfo populateHolidayDB for Insert Operation");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Holiday ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "IndexVal INT(5), " + "StartDate VARCHAR(50), " + "EndDate VARCHAR(50))";
	
	console.log(Holiday_DB_TAB + sql);
	tx.executeSql(sql);
	tx.executeSql("INSERT INTO tbl_Holiday (IndexVal, StartDate, EndDate) VALUES (" + 
	"'" + mHolidayIndex + "'"  + "," + 
	"'" + mHolidayStartDate + "'" + "," + 
	"'" + mHolidayEndDate + "'" + ")");
	
	console.log(Holiday_DB_TAB + "Inserted one item success");
	
	localStorage.setItem("Holiday_INFO", "");
	saveHolidayInfo();
	
}

function populateTimerDB(tx) {
	console.log(Timer_DB_TAB + "@saveTimerInfo populateTimerDB for Insert Operation");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Timer ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "TimerName VARCHAR(256), " + "IsOn VARCHAR(50), " + "TimeVal VARCHAR(50), " + "WeekVal VARCHAR(50))";
	console.log(Timer_DB_TAB + sql);
	tx.executeSql(sql);
	tx.executeSql("INSERT INTO tbl_Timer (TimerName, IsOn, TimeVal, WeekVal) VALUES ("
	+ "'" + mTimerName + "'"  + ","
	+ "'" + mTimerIsOn + "'"  + "," 
	+ "'" + mTimerTimeVal + "'" + ","
	+ "'" + mTimerWeekVal + "'" + ")");
	
	console.log(Timer_DB_TAB + "Inserted one item success");
	localStorage.setItem("Timer_INFO", "");
	saveTimerInfo();
	
}

/**
 * To populate readHolidayDB
 * @param tx
 */
function readHolidayDB(tx) {
	console.log(Holiday_DB_TAB + "@readHolidayDB");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Holiday ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "IndexVal INT(5), " + "StartDate VARCHAR(50), " + "EndDate VARCHAR(50))";
	console.log(Holiday_DB_TAB + "SqlQuery: " + sql);
	tx.executeSql(sql);
	console.log("readHolidayDB : execute read success");
}

function HolidayDBError(tx, error) {
	//console.log("Database Error: " + tx);
	console.log(Holiday_DB_TAB + "@transaction_error");
}

function HolidayDBErrorOnSuccess(tx, error) {
	//console.log("Database Error: " + tx);
	console.log(Holiday_DB_TAB + "HolidayDBErrorOnSuccess @transaction_error");
}


function populateHolidayDBOnSuccess() {
	console.log(Holiday_DB_TAB + "@populateDB_success");
	//alert(Holiday_DB_TAB + "@populateDB_success");
	db.transaction(excuteHolidayQuery, HolidayDBErrorOnSuccess);
}

/**
 * To populate readTimerDB
 * @param tx
 */
function readTimerDB(tx) {
	console.log(Timer_DB_TAB + "@readTimerDB");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Timer ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "TimerName VARCHAR(256), " + "IsOn VARCHAR(50), " + "TimeVal VARCHAR(50), " + "WeekVal VARCHAR(50))";
	console.log(Timer_DB_TAB + "SqlQuery: " + sql);
	tx.executeSql(sql);
	console.log("readTimerDB: execute read success");
}

function TimerDBError(tx, error) {
	console.log("Database Error: " + error);
	console.log(Timer_DB_TAB + "@transaction_error");
}

function TimerDBErrorOnSuccess(tx, error) {
	//console.log("Database Error: " + tx);
	console.log(Timer_DB_TAB + "TimerDBErrorOnSuccess @transaction_error");
}

function populateTimerDBOnSuccess() {
	console.log(Timer_DB_TAB + "@populateDB_success");
	db.transaction(excuteTimerQuery, TimerDBErrorOnSuccess);
}

/**
 * To excute Holiday query for fetching db list
 * @param tx
 */
function excuteHolidayQuery(tx) {
	console.log(Holiday_DB_TAB + "@excuteHolidayQuery");
	//var sql = "select * from  tbl_Holiday group by Holiday order by id desc"; // order by �� �����ؾ���
	var sql = "select * from  tbl_Holiday order by StartDate desc";
	console.log(Holiday_DB_TAB + "@excuteQuery: " + sql);
	tx.executeSql(sql, [], fetchHolidayItemList);
}

/**
 * To excute Timer query for fetching db list
 * @param tx
 */
function excuteTimerQuery(tx) {
	console.log(Timer_DB_TAB + "@excuteTimerQuery");
	var sql = "select * from  tbl_Timer";
	console.log(Timer_DB_TAB + "@excuteQuery: " + sql);
	tx.executeSql(sql, [], fetchTimerItemList);
}

/**
 * To show list of Holiday item list
 * here user can populate using html components
 */
function fetchHolidayItemList(tx, results) {
	//alert("@fetchHolidayItemList");
	myHolidayInfoJson = {};
	myHolidayInfoArr = [];
	myHolidayInfoJson.myHolidayInfoArr = myHolidayInfoArr;
	var len = results.rows.length;
	//alert("Holiday DB Length: "+len);
    console.log("Holiday DB Length: "+len);
	for (var i = 0; i < len; i++) {
		var myHolidayRows = results.rows.item(i);
		var myHolidayInfo = {};
		
		myHolidayInfo.IndexVal = myHolidayRows.IndexVal;
		myHolidayInfo.StartDate = myHolidayRows.StartDate;
		myHolidayInfo.EndDate = myHolidayRows.EndDate;
		myHolidayInfoJson.myHolidayInfoArr.push(myHolidayInfo);
	}
	createHolidaySessionJsonList();
}

function createHolidaySessionJsonList() {
	//sessionStorage.setItem("Holiday_INFO", JSON.stringify(myHolidayInfoJson));
	//alert(""+JSON.stringify(myHolidayInfoJson));
	console.log(JSON.stringify(myHolidayInfoJson));
	localStorage.setItem("Holiday_INFO", JSON.stringify(myHolidayInfoJson));
}

/**
 * To show list of Timer item list
 * here user can populate using html components
 */
function fetchTimerItemList(tx, results) {
	myTimerInfoJson = {};
	myTimerInfoArr = [];
	myTimerInfoJson.myTimerInfoArr = myTimerInfoArr;
	var len = results.rows.length;
	timerInsertCnt = len;
    console.log("Timer DB Length: "+len);
	for (var i = 0; i < len; i++) {
		var myTimerRows = results.rows.item(i);
		var myTimerInfo = {};
		
		myTimerInfo.TimerName = myTimerRows.TimerName;
		myTimerInfo.IsOn = myTimerRows.IsOn;
		myTimerInfo.TimeVal = myTimerRows.TimeVal;
		myTimerInfo.WeekVal = myTimerRows.WeekVal;
		myTimerInfoJson.myTimerInfoArr.push(myTimerInfo);
	}
	createTimerSessionJsonList();
}

function createTimerSessionJsonList() {
	//sessionStorage.setItem("Timer_INFO", JSON.stringify(myTimerInfoJson));
	console.log(JSON.stringify(myTimerInfoJson));
	localStorage.setItem("Timer_INFO", JSON.stringify(myTimerInfoJson));
	setTimerInsertCnt(timerInsertCnt);
}

function checkHolidayRecord() {
	var sql = "select id from tbl_Holiday order by StartDate asc";
	var db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
		tx.executeSql(sql, [], dropHolidayTable);
	});
}

function dropHolidayTable(tx, results) {
	if (results.rows.length == 0) {
		var db = window.openDatabase("HolidayDB", "1.0", "MagicInfo", 200000);
		db.transaction(function(tx) {
			tx.executeSql("DROP TABLE  tbl_Holiday");
			console.log(Holiday_DB_TAB + " Updated one item success");
			projectCounter = 0;
		});
	}
}

function checkTimerRecord() {
	var sql = "select id from tbl_Timer order by TimerName asc";
	var db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
		tx.executeSql(sql, [], dropTimerTable);
	});
}

function dropTimerTable(tx, results) {
	if (results.rows.length == 0) {
		var db = window.openDatabase("TimerDB", "1.0", "MagicInfo", 200000);
		db.transaction(function(tx) {
			tx.executeSql("DROP TABLE  tbl_Timer");
			console.log(Timer_DB_TAB + " Updated one item success");
			projectCounter = 0;
		});
	}
}
