var InputSourceUI = function(){
    
};
var StickersUI = function(){
    
};
var BackgroundUI = function(){
    
};
var WidgetUI = function(){
    
};
var ShapeUI = function(){
    
};
var inptSrcUIObj = new InputSourceUI();
var stickersUIObj = new StickersUI();
var backgroundUIObj = new BackgroundUI();
var widgetUIObj = new WidgetUI();
var shapeUIObj = new ShapeUI();
var doneBtn;
var textSource;
var inpSrcSelcted = null;
var step1Region = REGION_OTHERS;
InputSourceUI.prototype.createInpSrcGUIStep1 = function($this){ 
    var inpSrcContainer1 = $('<div>').attr("id", "inpSrcContainer1").css({
        "height":"100%",        
        "background-color" : "#181818"
    }).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");
    
    var inpSrcArea1 = $('<div>').attr("id", "inpSrcArea1").css({    
        "height":"100%",
        "width":"100%"  
    }).addClass("inpSrcAreaCls"); 
    
    var headerHeight = window.innerHeight * 0.078;
    var textSize = headerHeight * 0.50;
    
    var inpSrcHeader1 = $('<div>').attr("id", "inpSrcHeader1").css({        
          "position":"relative",
    }).addClass("custom-header");   
    textSource = $('<div>').attr("id", "textSource").css({
    	"background-color" : "#dedede"
    }).addClass("header-part2");
    
    var cancelBtn = $('<div>').attr("id", "cancelBtn").css({    	
    	"background-image": "url('../resource/img/btn_title_close_n.png')"        
    }).addClass("header-part1 inpSrcHeaderBtn");
    doneBtn =  $('<div>').attr("id", "doneBtn").css({       
        "background-image": "url('../resource/img/btn_title_done_n.png')"
    }).addClass("header-part3 inpSrcHeaderBtn");
    
    inpSrcHeader1.append(cancelBtn);
    inpSrcHeader1.append(textSource);
    inpSrcHeader1.append(doneBtn);
    
    inpSrcContainer1.append(inpSrcHeader1);
    inpSrcContainer1.append(inpSrcArea1);    
    
    cancelBtn.on("tap", function(e) {
        //inpSrcContainer1.hide();
        $('#inpSrcContainer1').removeClass('animateContentMenu');
        resetDropDown();
        resetCheckIpSrc();
        //inpSrcSelcted = null;
        return false;
    });
    doneBtn.on("tap", function(e) {
        var selSrc=getSelectedSourceID();
       // inpSrcContainer1.hide();
       $('#inpSrcContainer1').removeClass('animateContentMenu');
        resetDropDown();
		deleteIpSrcObj(); 
	        $("#tplGalleyDropArea div.drpAreaIpSrcCls").remove();
	        showGuideMsg();
		if(selSrc!=-1){
			sourceTapHandler(inpSrcSelcted);
		}        	                        
        return false;
    });
    
    $("#templatePage").append(inpSrcContainer1);
    if(currModel==RMD_MODEL){
    	inptSrcUIObj.setInprSrcSelDrpDwnGui();	
    }else{
    	textSource.html(langObj.template.COM_SID_SOURCE);
    }        
    inptSrcUIObj.setSourceMenuGuiHandler(inpSrcArea1);
    addTapOnIpSrc();
};
function getSelectedSourceID()
{
  var srcID=-1;
  $("#inpSrcContainer1").find(".checkImgClass").each(function(){
      if($(this).css("visibility")=="visible")
      {
          srcID=$(this).parent().attr("id");
      }
  });   
  return srcID;
}
function resetDropDown(){
	var customArrowDiv = $(".customArrowDiv");
    var listDownUiMainDiv = $(".listDownUiMainDiv");
	customArrowDiv.removeClass('tplMenuUpArrowIcon');
    listDownUiMainDiv.hide();
    customArrowDiv.addClass('tplMenuDownArrowIcon');
}
function resetCheckIpSrc(){
	$(".checkImgClass").css({
         "visibility" : "hidden"
    });
}
InputSourceUI.prototype.createInpSrcGUIStep2 = function($this){
    var inpSrcContainer2 = $('<div>').attr("id", "inpSrcContainer2").css({
        "background-color" : "#181818",
        "display":"block !important"
    }).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");   
    
    var inpSrcArea = $('<div>').attr("id", "inpSrcArea").css({          
    	"background-color": "#181818"    
    }).addClass("inpSrcTabContentCls inpSrcAreaCls");    
    
    var headerHeight = window.innerHeight * 0.458 * .165;
    var textSize = headerHeight * 0.40;
    var inpSrcHeader = $('<div>').attr("id", "inpSrcHeader").css({      
        "font-family" : "NotoSans-Regular",
        "font-size" : textSize + "px"
       /* "padding-left":"4%"*/  
    }).addClass("inpSrcMainHeaderCls");
    inpSrcHeader.addClass("vAlignmiddle");
    
    inpSrcContainer2.append(inpSrcHeader);
    inpSrcContainer2.append(inpSrcArea);    
    
    $("#templatePage").append(inpSrcContainer2);
    if(currModel==RMD_MODEL){
    	inptSrcUIObj.setInprSrcSelDrpDwnGui();	
    }else{
    	inpSrcHeader.css('padding-left','4%');
    	inpSrcHeader.html(langObj.template.COM_SID_SOURCE);
    }       
    inptSrcUIObj.setSourceMenuGuiHandler(inpSrcArea);
    $(document).off('tap', 'div.sourceMenuDiv');// remove tap
};
InputSourceUI.prototype.setSourceMenuGuiHandler = function(inpSrcArea){
    var scrollingHeight = window.innerHeight;
    var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);
    var leftMargin = getParseIntInDec(scrollingWidth * 0.037);
    
    var fontSize = window.innerWidth * 0.03;
    var divC = "#6c9acf";
    var rootPath = '../resource/img/';
    var clFlag = false;   
    var sourceArray;    
    if(currModel != RMD_MODEL)
    {
        sourceArray = [{
            path : rootPath + 'ss_icon_source_tv.png',
            id : sourceType.TV,
            dText : tvTxt
        }, {
            path : rootPath + 'ss_icon_source_hdmi.png',
            id : sourceType.HDMI1,
            dText : hdmi1Txt
        }, {
            path : rootPath + 'ss_icon_source_hdmi.png',
            id : sourceType.HDMI2,
            dText : hdmi2Txt
        }, {
            path : rootPath + 'ss_icon_source_hdmi.png',
            id : sourceType.HDMI3,
            dText : hdmi3Txt
        }, {
            path : rootPath + 'ss_icon_source_av.png',
            id : sourceType.AV,
            dText : avTxt
        }, {
            path : rootPath + 'ss_icon_source_rgb.png',
            id : sourceType.RGB,
            dText : pcTxt
        }, {
            path : rootPath + 'ss_icon_source_dp.png',
            id : sourceType.DP,
            dText : dpTxt
        }, {
            path : rootPath + 'ss_icon_source_component.png',
            id : sourceType.COMPONENT,
            dText : compTxt
        }, {
            path : rootPath + 'ss_icon_source_dvi.png',
            id : sourceType.DVI,
            dText : dviTxt
        }];
    }else{
        sourceArray = [{
            path : rootPath + 'ss_icon_source_tv.png',
            id : sourceType.TV,
            dText : tvTxt
        }, {
            path : rootPath + 'ss_icon_source_hdmi.png',
            id : sourceType.HDMI1,
            dText : hdmi1Txt
        }, {
            path : rootPath + 'ss_icon_source_hdmi.png',
            id : sourceType.HDMI2,
            dText : hdmi2Txt
        }, {
            path : rootPath + 'ss_icon_source_av.png',
            id : sourceType.AV,
            dText : avTxt
        }];
       	if(currRegion == REGION_OTHERS){
            sourceArray[4] = {
                path : rootPath + 'ss_icon_source_rgb.png',
                id : sourceType.RGB,
                dText : pcTxt
            };
       	}else{
            sourceArray[4] = {
                path : rootPath + 'ss_icon_source_hdmi.png',
                id : sourceType.HDMI3,
                dText : hdmi3Txt
            };     
        }
    }
    var sourceMenuScrollAreaId;
    if(Utils.currStep == STEP_ONE){
    	$('#sourceMenuScrollArea1').remove();
    	sourceMenuScrollAreaId = "sourceMenuScrollArea1";	    
    }else{
   		$('#sourceMenuScrollArea2').remove();
   		sourceMenuScrollAreaId = "sourceMenuScrollArea2";	   
    }
    var sourceMenuScrollArea = $('<div>').attr({"id": sourceMenuScrollAreaId,"class":"tmpltSubDataCls"}).css({
	        "height" : '93%',
	        "width" : scrollingWidth + 'px',
	        "padding-top" : '4%',
	        "padding-bottom" : '2%',
	        "margin-left" : leftMargin + 'px',
	        "margin-right" : leftMargin + 'px'
	    });
    
    var midSourceArr = new Array;
    for (var counter = 0; counter < sourceArray.length; counter = counter + 1) {        
            var midSource = 1 +(counter-1)*3;
            midSourceArr.push(midSource);   
    }
    for (var counter = 0; counter < sourceArray.length; counter = counter + 1) {
        var checkImg = $('<img src="../resource/img/ss_icon_check.png" class="checkImgClass">').css({
            "height" : "51%",
            "width" : "68%",
            "top" : "30%",
            "left" : "21%",
            "position" : "absolute",
            "z-index" : "99",
            "visibility" : "hidden"
        });
       /* if((Utils.currStep == STEP_ONE) && (sourceArray[counter].id == getInputSourceTypeFrmArray())){
            checkImg.css({
                "visibility" : "visible"
            });         
        }*/      
       
        if (clFlag) {
            divC = "#66c2b8";
            clFlag = false;
        } else {
            divC = "#6c9acf";
            clFlag = true;
        }
        
        var sourceRtLeftMargin = 0;        
        
        if($.inArray(counter,midSourceArr) > -1){
            sourceRtLeftMargin = Math.round(scrollingWidth * 0.024);            
        }
        
        var sourceBottomMargin = Math.round(scrollingWidth * 0.024);        
        var sourceDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',
            "float" : "left",
            "margin-left" : sourceRtLeftMargin + 'px',
            "margin-right" : sourceRtLeftMargin + 'px',
            "margin-bottom" : sourceBottomMargin + 'px',
            "background-color" : divC,
            //"border" : "solid green 3px"
        }).attr("sourceId", sourceArray[counter].id).addClass("sourceMenuDiv");
        
        if(Utils.currStep == STEP_TWO){
            sourceDiv1.addClass("drag_sourceMenuDiv");   
        }else{
            sourceDiv1.removeClass("drag_sourceMenuDiv"); 
        }
        var iconDiv = $('<div>').attr("id", sourceArray[counter].id).css({
            "height" : sourceDivWidth * 0.38 + 'px',
            "width" : sourceDivWidth * 0.50 + 'px',
            "margin" : "auto",
            "margin-top" : sourceDivWidth * 0.18 + 'px',
            "background-image" : "url('" + sourceArray[counter].path + "')",
            "position":"relative"
        }).addClass('inptSrcIconCls');            
        var iconDivText = $('<div class="drpAraIpTxtCls">').css({            
            "width" : sourceDivWidth + 'px',
            "margin-top" : sourceDivWidth * 0.09 + 'px',            
            "font-size" : fontSize + 'px'                        
        }).html(sourceArray[counter].dText);
        iconDiv.append(checkImg);
        
        sourceDiv1.append(iconDiv);
        sourceDiv1.append(iconDivText);
        sourceMenuScrollArea.append(sourceDiv1);
    }
    inpSrcArea.append(sourceMenuScrollArea);
    if(Utils.currStep == STEP_ONE && inpSrcSelcted!=null){
	    	var id=inpSrcSelcted.children(0).attr('id');
	    	if($("#" + id).length>0)
	    	{  	$("#" + id).find("img").css({
	                "visibility" : "visible"
	            });
	         }
	         else
	         {
	         	inpSrcSelcted=null;
	         }	   
		}
};       
    
function addTapOnIpSrc(){    
    if(ipSrcObj!=null)
    {
    	//first remove all checked images
       resetCheckIpSrc();
       $("#" + ipSrcObj.orgImgPath).find("img").css({
                "visibility" : "visible"
            }); 
    }
    $(document).off('tap', 'div.sourceMenuDiv');
    $(document).on("tap", 'div.sourceMenuDiv', function(event) {
        if ($(this).find("img").css('visibility') != 'hidden') {
            //uncheck the source and remove from dropped area
            $(this).find("img").css({
                "visibility" : "hidden"
            });
            inpSrcSelcted = null;
            //remove source from array
            /*deleteIpSrcObj(); 
            $("#tplGalleyDropArea div.drpAreaIpSrcCls").remove();
            showGuideMsg();*/           
            return false;
        }
        if (getSelectedSourceID()!=-1 || (galleryContentSel.getSelectedVideoCount() == 1)) {                        
            Utils.showToast(langObj.template.MIA_SID_SELECT_EITHER_ON_INPUT_VIDEO + " "+langObj.template.MIA_SID_SOURCE_TYPE_NOT_SUPPORT_NOT_DISPROPERLY); 
            return false;
        } else {                        
        	$(this).find('img').css({
	        	"visibility" : "visible"
	        }); 
	        inpSrcSelcted  = $(this);                 
            //sourceTapHandler(this);
        }
        event.preventDefault();
        return false;
    });
}
function sourceTapHandler(currObj) {
    $('.tplDropAreaText').hide();
   /* $(currObj).find('img').css({
        "visibility" : "visible"
    });*/   
    var srcID = $(currObj).children(0).attr('id');
    showTostForIpSrc(srcID); 
    var inputSrPath = getIpSrcIconPath(srcID);
    ipSrcObj={
        type : "inputsource",
        imgPath : inputSrPath,
        thumbPath : inputSrPath,
        orgImgPath : srcID,
        fileName : getIpSrcName(srcID),
        orgW : 160,
        orgH : 90,
        duration : 0,
        bgColor : $(currObj).css("background-color")
    };
    tplUIObj.updateDropArea();
    srcCounter=1;
    mUiHandler.setSourceCounter(srcCounter);   
};

InputSourceUI.prototype.createInpSrcRegionDiv = function(region, country, height, fontSize){
	var inpSrcRegionDiv = $('<div>').css({
        "height" : height + 'px',
        "width" : "100%",       
        "font-size" : fontSize + "px"           
    }).attr('country',region).html(country).addClass("vAlignmiddle hAligncenter");
        
    return inpSrcRegionDiv;
};

// select input source drop down
InputSourceUI.prototype.setInprSrcSelDrpDwnGui = function($this){   
    var pageHeight = window.innerHeight;
    var pageWidth = window.innerWidth;
    var srcHeader;
    if(Utils.currStep == STEP_ONE){
    	srcHeader = $("#textSource");	
    }else{
    	srcHeader = $("#inpSrcHeader");
    }
    var headerHeight = srcHeader.height();  
    var headerWidth = srcHeader.width();
    
    var dropDownWidth = headerWidth;//getParseIntInDec(headerWidth * 70 * 0.01);
    var dropDownliHeight = getParseIntInDec(pageHeight * 7 * 0.01);  
    var fontSize  = headerHeight * 0.40;
    
    var customdropDownDiv = $('<div>').attr("id", "customdropDownDiv").css({
        "id" : "customdropDownDiv",
        "height" : headerHeight + 'px',
        "width" : dropDownWidth + 'px',    
        //"margin" : "auto",
        "background-color" : "#dedede",
      //  "border-bottom": "solid 1px #c7c7c7",
       // "border":"solid yellow 2px"       
    }).addClass("hAligncenter vAlignmiddle");
    var customdropDownTextDiv = $('<div>').attr("class", "customdropDownTextDiv").css({
        "class" : "customdropDownTextDiv",
        "height" : '100%',
       // "width" : "50%",       
       // "margin-left" : "2%",
        "color" : "#525257",              
        "font-family" : "NotoSans-Regular",
        "font-size" : fontSize + "px",
        //"border":"solid red 2px",
       // "float" : "left",          
    }).html(langObj.template.COM_SID_COUNTRY_OTHERS);
    customdropDownTextDiv.addClass("vAlignmiddle");
    var customArrowDiv = $('<div>').attr("class", "customArrowDiv").css({
        "class" : "customArrowDiv",
        "height" : '100%',
        "width" : 0.06*pageWidth+"px",
        /*"margin-left" : "33%",        
        "float" : "left",*/          
      //  "border":"solid green 2px"      
    }).addClass('tplMenuDownArrowIcon vAlignmiddle');    
    var listDownUiMainDiv = $('<div>').attr("class", "listDownUiMainDiv").css({
        "class":"listDownUiMainDiv",
        "height" : pageHeight * 0.01 * 38 + 'px',
        "width" : "100%",
        "left":"0px",
        "z-index" : "9999999999",
        //"margin":"auto",
        "margin-top" : headerHeight+"px",
        "display" : "none",
        "position" : "absolute",  
        "background-color" : "#dedede", 
      //  "border":"solid blue 1px"    
    }).addClass('tplListDropDown ');   
    
    var inputSrcOthers = inptSrcUIObj.createInpSrcRegionDiv(REGION_OTHERS, langObj.template.COM_SID_COUNTRY_OTHERS, dropDownliHeight, fontSize);
    var inputSrcUS = inptSrcUIObj.createInpSrcRegionDiv(REGION_US, langObj.template.COM_SID_UNITED_STATES, dropDownliHeight, fontSize);
    var inputSrcCanada = inptSrcUIObj.createInpSrcRegionDiv(REGION_CANADA, langObj.template.COM_SID_COUNTRY_CANADA, dropDownliHeight, fontSize);
    var inputSrcMexico = inptSrcUIObj.createInpSrcRegionDiv(REGION_MEXICO, langObj.template.COM_TV_SID_COUNTRY_MEXICO, dropDownliHeight, fontSize);
    var inputSrcKorea = inptSrcUIObj.createInpSrcRegionDiv(REGION_KOREA, langObj.template.COM_TV_SID_KOREA, dropDownliHeight, fontSize);
      
    listDownUiMainDiv.append(inputSrcOthers).append(inputSrcUS).append(inputSrcCanada).append(inputSrcMexico).append(inputSrcKorea);   
    
    customdropDownDiv.append(customArrowDiv).append(customdropDownTextDiv).append(listDownUiMainDiv);
       
    srcHeader.append(customdropDownDiv);
        
    customdropDownTextDiv.html(getIpSrcRegLang(currRegion));
    
    customArrowDiv.on("tap", function(e) {
    	e.preventDefault();
    	e.stopPropagation();    	
        toggleTplMenuDrpDwn();
        return false;
    });
    customdropDownTextDiv.on("tap",function(e){     
    	e.preventDefault(); 
    	e.stopPropagation();
        customArrowDiv.trigger("tap");
        return false;
    }); 
   
    $(".tplListDropDown").off("tap").on("tap", 'div',function(event) {    	
    	event.preventDefault();
    	event.stopPropagation();
    	if(currModel==RMD_MODEL)
    	{  	
        	if($(this).attr('country') != currRegion){        		
     	   		clickInpSrcDropDown($(this).attr('country'),$(this).html());
        	} 	     	   
        }  
        toggleTplMenuDrpDwn();
        return false;
    });
    function toggleTplMenuDrpDwn() {
        var customArrowDiv = $(".customArrowDiv");
        var listDownUiMainDiv = $(".listDownUiMainDiv");
        //console.log("Toggle after TAP "+customArrowDiv.hasClass('tplMenuDownArrowIcon'));
        if (customArrowDiv.hasClass('tplMenuDownArrowIcon')) {
            customArrowDiv.removeClass('tplMenuDownArrowIcon');
            listDownUiMainDiv.show();
            customArrowDiv.addClass('tplMenuUpArrowIcon');
        } else {
            customArrowDiv.removeClass('tplMenuUpArrowIcon');
            listDownUiMainDiv.hide();
            customArrowDiv.addClass('tplMenuDownArrowIcon');
        }
    };
};
function getIpSrcRegLang(regEnglish){	
	var regionLocale = langObj.template.COM_SID_COUNTRY_OTHERS;
    switch(regEnglish)
    {
        case REGION_US:
            regionLocale = langObj.template.COM_SID_UNITED_STATES;
        break;
        case REGION_CANADA:
            regionLocale = langObj.template.COM_SID_COUNTRY_CANADA;
        break;
        case REGION_MEXICO:
            regionLocale = langObj.template.COM_TV_SID_COUNTRY_MEXICO;
        break;      
        case REGION_KOREA:
            regionLocale = langObj.template.COM_TV_SID_KOREA;
        break;
        default:
            regionLocale = langObj.template.COM_SID_COUNTRY_OTHERS;
        break;
    }
    return regionLocale;
}
StickersUI.prototype.setStickerMenuGuiHandler = function(stickersList){
    var scrollingHeight = window.innerHeight;
    var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);  
    var leftMargin = getParseIntInDec(scrollingWidth * 0.037);
    
    var stickerContainer = $('<div>').attr("id", "stickerContainer").css({
        "background-color" : "#181818",
    }).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");   
    
    var stickerArea = $('<div>').attr("id", "stickerArea").css({            
    	"background-color": "#181818"         
    }).addClass("inpSrcTabContentCls"); 
    
    var headerHeight = window.innerHeight * 0.458 * .165;
    var textSize = headerHeight * 0.40;
    
    var stickerHeader = $('<div>').attr("id", "stickerHeader").css({
        "font-family" : "NotoSans-Regular",
        "font-size" : textSize + "px",
        "padding-left":"4%"
    }).addClass("inpSrcMainHeaderCls").html(langObj.template.COM_STICKERS);
    stickerHeader.addClass("vAlignmiddle");
    
    stickerContainer.append(stickerHeader);
    stickerContainer.append(stickerArea);    
    
    $("#templatePage").append(stickerContainer);    
    
    $('#stickerMenuScrollArea').remove();
    var stickerMenuScrollArea = $('<div>').attr({"id":"stickerMenuScrollArea","class":"tmpltSubDataCls"}).css({
        "height" : '93%',
        "width" : scrollingWidth + 'px',
        "padding-top" : '4%',
        "padding-bottom" : '2%',
        "margin-left" : leftMargin + 'px',
        "margin-right" : leftMargin + 'px'
    });
    
    var midStickerArr = new Array;
    for (var counter = 0; counter < stickersList.length; counter = counter + 1) {       
        var midSticker = 1 +(counter-1)*3;
        midStickerArr.push(midSticker); 
    }
  
    for (var counter = 0; counter < stickersList.length; counter = counter + 1) {       
       
        var stkrRtLeftMargin = 0;        
        
        if($.inArray(counter,midStickerArr) > -1){
            stkrRtLeftMargin = Math.round(scrollingWidth * 0.024);          
        }        
        var stkrBottomMargin = Math.round(scrollingWidth * 0.024);    
        
        var stickerDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',            
            "float" : "left",
            "margin-left" : stkrRtLeftMargin + 'px',
            "margin-right" : stkrRtLeftMargin + 'px',
            "margin-bottom" : stkrBottomMargin + 'px',
            "background-image" : "url('" + stickersList[counter].path + "')",            
            "background-color" : "#4F4F52"
        }).addClass("stickerMenuDiv inptSrcIconCls").attr({"stickerName": stickersList[counter].name,"stickerXmlStr":stickersList[counter].XmlText});                
        
        stickerMenuScrollArea.append(stickerDiv1);
    } 
    stickerArea.append(stickerMenuScrollArea);
    //  refreshScreen();
};
    
StickersUI.prototype.getStickerList = function(){
    var rootStickerPath = '../resource/img/sticker/thumb/';
    var stickers = [];
    $.ajax({
        type : "GET",
        url : "../resource/XML/stickers.xml",
        dataType : "xml",
        async : false,
        success : function(xml) {

            var xmlObj = $(xml).find("stickers");
            xmlObj.find("sticker").each(function() {
                	var imagename = $(this).find("image").text();
                	var stickerXmlStr = "";
                	if(imagename[8] == 't')
                    {	
                    	stickerXmlStr = $(this)[0].outerHTML;
                    }
                    stickers.push({
                        name : imagename,
                        path : rootStickerPath + $(this).find("thumb").text(),
                        XmlText: stickerXmlStr
                    });
            });
            stickersUIObj.setStickerMenuGuiHandler(stickers);
        },
        error : function(jqXHR, textStatus, errorThrown) {

        }
    });
};
BackgroundUI.prototype.setBackgroundMenuGuiHandler = function(backgroundList){
    

    var scrollingHeight = window.innerHeight;
    var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);  
    var leftMargin = getParseIntInDec(scrollingWidth * 0.0263);
    var backgroundDiv1;
    var isAddedBckImage="";
    var userAddedImage=false;   
     $('#backgroundMenuScrollArea').remove();
    var bckMenuScrollArea = $('<div>').attr({"id":"backgroundMenuScrollArea","class":"tmpltSubDataCls"}).css({
        "height" : '95%',
        "width" : scrollingWidth + 'px',
        "padding-top" : '4%',
        "padding-bottom" : '2%',
        "margin-left" : leftMargin + 'px',
        "margin-right" : leftMargin + 'px'
    });
   
    for (var counter = 0; counter <=backgroundList.length; counter = counter + 1) {     
         
         var root = Utils.getSystemRootPath() + '.ETabletAuthor/BG/';
         var isDraggable="";
         var stkrRtLeftMargin = Math.round(scrollingWidth * 0.0106);          
         var stkrBottomMargin = Math.round(scrollingWidth * 0.0212);
         var visible="block";
            if(counter== backgroundList.length )
            {
               if( backgroundList.length >= 100) 
               {
                 visible="none";  
               }
               
                backgroundDiv1=$('<div id="addBckgroundImageBtn" >').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',            
            "float" : "left",
            "margin-left" : stkrRtLeftMargin + 'px',
            "margin-right" : stkrRtLeftMargin + 'px',
            "margin-bottom" : stkrBottomMargin + 'px',
            "display":visible
          
             });
              backgroundUIObj.setBackgroundADDBtnEvents(backgroundDiv1);
              
            }else{
	          	var imageType=backgroundList[counter].typeUserDefined;
	          	userAddedImage=false;
	          	isDraggable="";
	          	switch(imageType)
	          	{
	          		case BG_ORIGINAL :
	          						{	
						            root += "bg_original/";     
						            break;
						           }
				    case BG_GALLERY :
				    				{
						          	root += "bg_gallery/";
						            userAddedImage=true;
						            isDraggable="isbckImgdrag";  
						            break;
						           }
	                case BG_CLASSIC :
	                				{
						          	 root += "bg_custom/bg_classic/";							         
						            break;
						            }
			        case BG_MODERN :
			        				{
						           root += "bg_custom/bg_modern/";	           					   
						            break;
						           }
					case BG_VINTAGE :
									{
						            root += "bg_custom/bg_vintage/";	           						
						            break;
						           }
				    default:
				  			 break;		            	            
					            
          	}
            
             var actualPath=root+"actual/"+backgroundList[counter].path;
             if(templateObj.bgImage == actualPath)
             {
                isAddedBckImage="bckImgSelected";
             }
             else{
                isAddedBckImage="";
             }      
             backgroundDiv1 = $('<div>').css({
	            "height" : sourceDivWidth + 'px',
	            "width" : sourceDivWidth + 'px',            
	            "float" : "left",
	            "margin-left" : stkrRtLeftMargin + 'px',
	            "margin-right" : stkrRtLeftMargin + 'px',
	            "margin-bottom" : stkrBottomMargin + 'px',
	            "background-image" : "url('"+root+"thumb/"+ backgroundList[counter].path + "')", 
	            "background-color" : "#e9e9e9",
	            " box-shadow" : "inset 0px 0px 0px 1px #bcbcbc"
           	}).addClass("bckImageCls " +isDraggable + " "+ isAddedBckImage).attr({
	            "bgActualPath":actualPath,
	            "userAddedImage":userAddedImage});
	         backgroundUIObj.setBackgroundImageEvents(backgroundDiv1);
         }
         bckMenuScrollArea.append(backgroundDiv1); 
    } 
    $("#backgrndMenuTab2_ContentId").append(bckMenuScrollArea);
    $("#addBckgroundImageBtn").authorActiveClass();
    
};
BackgroundUI.prototype.getBackGroundList = function(){
     var backgroundLst = [];
        for (var i = 0; i < backgroundCustomLst.length; ++i) {
            backgroundLst.push({

                path : backgroundCustomLst[i].path,
                typeUserDefined : backgroundCustomLst[i].typeUserDefined
            });

        }
      
        galleryContentSel.getFileList('.ETabletAuthor/BG/bg_original/thumb', function() {
        
            for (var i = 0; i < arrBGList.length; ++i) {
                if (arrBGList[i] != "") {
                    backgroundLst.push({

                        path : arrBGList[i],
                        typeUserDefined : 'bg_orginal'
                    });
                }

            }
          
           galleryContentSel.getFileList('.ETabletAuthor/BG/bg_gallery/thumb', function() {
                for (var i = 0; i < arrBGList.length; ++i) {
                    if (arrBGList[i] != "") {
                        backgroundLst.push({

                            path : arrBGList[i],
                            typeUserDefined : 'bg_gallery'
                        });
                    }
                }
             
               backgroundUIObj.setBackgroundMenuGuiHandler(backgroundLst);
            });
           
            backgroundUIObj.setBackgroundMenuGuiHandler(backgroundLst);
        });

};

BackgroundUI.prototype.openBgGallery = function() {
    console.log("addBackgroundImageToContainer");
   
        try {

            galleryContentSel.addBgGallery(true, GALLERY_STEP_BG, function() {
              
                if (arrBckImgList != null || arrBckImgList != "") {
               
                 $.each(arrBckImgList, function(index, result) {
                     var fileName=result["fileName"];
                     
                     backgroundUIObj.addBackgroundImageToContainer(fileName,'bg_gallery');
                });
                   
                }
               
            });
        } catch(err) {
            console.log("addBgGallery failed");
        } 

    
}; 
BackgroundUI.prototype.setBackgroundImageEvents = function(bckImgObj){
 
  bckImgObj.on("tap",function(e){
             //e.preventDefault();
            // e.stopPropagation();
             $(".bckImageCls").removeClass("bckImgSelected");
             if($(this).hasClass("bckImageCls"))
             {
                $(this).addClass("bckImgSelected");     
             }
             var bgImgPath = $(this).attr("bgActualPath");
             if(UNDO_REDO_ALLOWED){
            	 templateObj.createUndoRedoDataFrTmpltBg("",bgImgPath, false);
             }             
             templateObj.isEdited = true;
             templateObj.setBGofTemplate("", bgImgPath);
             
           }).on("taphold",function(e){
           	tapHoldOnBgFlag = true;
             e.preventDefault();
             e.stopPropagation();
                   if( bckImgObj.hasClass("isbckImgdrag"))
                        {               
                         $("#bckGrndrecycleDivID").show();
                         $(this).addClass("dragEnabled");
                         $("#backgroundMenuScrollArea").css("overflow-y","hidden");
                         $(".addBckgroundImageBtnCls").hide();
                        }
                  $(".bckImageCls").removeClass("bckImgSelected");
                 if($(this).hasClass("bckImageCls"))
                 {
                    $(this).addClass("bckImgSelected");     
                 }
               
                
              });
};
BackgroundUI.prototype.addBackgroundImageToContainer= function(fileName,typeUserDefined){

    var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);
    var root = Utils.getSystemRootPath() + '.ETabletAuthor/BG/bg_gallery/';
    var stkrRtLeftMargin = Math.round(scrollingWidth * 0.0106);
    var stkrBottomMargin = Math.round(scrollingWidth * 0.0212);
    var actualPath = root + "actual/" + fileName;
    var addBtn=$("#addBckgroundImageBtn");

     var backgroundDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',            
            "float" : "left",
            "margin-left" : stkrRtLeftMargin + 'px',
            "margin-right" : stkrRtLeftMargin + 'px',
            "margin-bottom" : stkrBottomMargin + 'px',
            "background-image" : "url('"+root+"thumb/"+ fileName + "')", 
            "background-color" : "#e9e9e9",
            " box-shadow" : "inset 0px 0px 0px 1px #bcbcbc"
           }).addClass("bckImageCls isbckImgdrag" ).attr({
            "bgActualPath":actualPath,
            "userAddedImage":"true"});
         $(".addBckgroundImageBtnCls").remove();
         $("#backgroundMenuScrollArea").append(backgroundDiv1);
         $("#backgroundMenuScrollArea").append(addBtn);
         backgroundUIObj.setBackgroundImageEvents(backgroundDiv1);
         backgroundUIObj.setBackgroundADDBtnEvents(addBtn);
         hideShowADDBckBtn();
            
    
};
BackgroundUI.prototype.setBackgroundADDBtnEvents = function(bckaddBtn){
    bckaddBtn.addClass("addBckgroundImageBtnCls")
             .on("tap",function(){
                 backgroundUIObj.openBgGallery();
              });
     $('.addBckgroundImageBtnCls').authorActiveClass();          
};
BackgroundUI.prototype.getBackGroundContentSize= function(){
    var size= $(".bckImageCls").length;
    return size;
};
WidgetUI.prototype.setWidgetMenuGuiHandler = function(type){
	
	var scrollingHeight = window.innerHeight;
	var scrollingWidth = window.innerWidth;
	var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);
	var leftMargin = getParseIntInDec(scrollingWidth * 0.037);
	var hdrH = Math.round(innerHeight * 0.0758);
	var arwHW = Math.round(hdrH * 0.30);
	var arwMr = Math.round(scrollingWidth * 0.01);
	var dataH = Math.round(scrollingHeight * 0.3815);
	var txtFontSize = Math.round(hdrH * 0.40);

	var widgetContainer = $('<div>').attr("id", "widgetContainer").css({
		"background-color" : "#181818",
	}).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");
	var wdgtDrpdwn = ' <div class="wdgt-drpdwn">' 
	+ ' <table class="listHdrTblCls" cellpadding="0" cellspacing="0" border="0" style="width:100%;">' + '   <tr>' 
	+ '    <td align="middle" valign="top">' 
	+ '        <div class="catDDArowDwnCls" id="wdgtDDArwId" active-class="true"></div> ' 
	+ '        <div id="wdgtDDTxtId" class="wdgtDDTxtCls COM_SID_ALL " value="ALL" active-class="true">'+langObj.template.COM_SID_ALL+'</div>' 
	+ '       </td>' + '    </tr>' 
	+ '   </table>' 
	+ '  <div id="wdgtDdParDivId">' 
	+ '  <div class="wdgtDDOptCls" value="ALL"  active-class="true">' + langObj.template.COM_SID_ALL + '</div>' 
	+ '  <div class="wdgtDDOptCls" value="W"  active-class="true">' + langObj.template.IDS_WEB_KR_WEB + '</div>' 
	+ '  <div class="wdgtDDOptCls" value="R" active-class="true">' + langObj.template.IDS_RSS_XML + '</div>' 
	+ '  <div class="wdgtDDOptCls" value="F" active-class="true">' + langObj.template.MIA_SID_FORECAST + '</div>' 
	+ '  <div class="wdgtDDOptCls" value="C" active-class="true">' + langObj.template.COM_TV_SID_CLOCK_KR_LFD + '</div>' 
	+ '  </div>' 
	+ '</div> ';

	var widgetArea = $('<div>').attr("id", "widgetArea").css({
		"background-color" : "#181818"
	}).addClass("inpSrcTabContentCls");

	var headerHeight = window.innerHeight * 0.458 * .165;
	var textSize = headerHeight * 0.50;

	var widgetHeader = $('<div>').attr("id", "widgetHeader").css({
		"font-family" : "NotoSans-Regular",
		"font-size" : textSize + "px"
	}).addClass("inpSrcMainHeaderCls").html(wdgtDrpdwn);
	widgetHeader.addClass("vAlignmiddle");

	widgetContainer.append(widgetHeader);
	widgetContainer.append(widgetArea);

	$("#templatePage").append(widgetContainer);
	$(".wdgt-drpdwn").css({
		'width' : scrollingWidth + 'px',
		'height' : hdrH + 'px'
	});
	$("#wdgtDDArwId").css({
		'width' : arwHW + 'px',
		'height' : arwHW + 'px',
		'margin-right' : arwMr + 'px',
		'margin-top' : Math.round((hdrH - arwHW) / 2) + 'px'
	});
	$(".wdgtDDTxtCls").css({
		'font-size' : txtFontSize + 'px',
		'line-height' : hdrH + 'px'
	});
	$("#wdgtDdParDivId").css({
		'width' : innerWidth + 'px',
		'height' : (dataH - 1) + 'px',
		'top' : hdrH + 'px',
		'left' : '0px'
	});
	var ddOption = $("#wdgtDdParDivId").children().length;
	var optionHeight = Math.round($("#wdgtDdParDivId").height() / ddOption);
	$(".wdgtDDOptCls").css({
		'height' : optionHeight + 'px',
		'line-height' : optionHeight + 'px',
		'font-size' : Math.round(optionHeight * .43) + 'px'
	});

	$('#widgetMenuScrollArea').remove();
    var widgetMenuScrollArea = $('<div>').attr({"id":"widgetMenuScrollArea","class":"tmpltSubDataCls"}).css({
		"height" : '93%',
		"width" : scrollingWidth + 'px',
		"padding-top" : '4%',
		"padding-bottom" : '2%',
		"margin-left" : leftMargin + 'px',
		"margin-right" : leftMargin + 'px'
	});
	
	widgetArea.append(widgetMenuScrollArea);
	widgetUIObj.filterByWidgetType(type);
	widgetUIObj.registerEvents(); 

};
ShapeUI.prototype.setShapeMenuGuiHandler=function(){
	
	var scrollingHeight = window.innerHeight;
	var scrollingWidth = window.innerWidth;
	var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);
	var leftMargin = getParseIntInDec(scrollingWidth * 0.037);
	var hdrH = Math.round(innerHeight * 0.0758);
	var dataH = Math.round(scrollingHeight * 0.3815);
    var sourceRtLeftMargin = Math.round(scrollingWidth * 0.0106);
    var sourceBottomMargin = Math.round(scrollingWidth * 0.0212);
    var fontSize = window.innerWidth * 0.03;
    var divC = "#454547";
	var shapeContainer = $('<div>').attr("id", "shapeContainer").css({
		"background-color" : "#181818",
	}).addClass("TemplateMainMenuCls stopPropagationCls MainMenuCls");

	var shapeArea = $('<div>').attr("id", "shapeArea").css({
		"background-color" : "#181818"
	}).addClass("inpSrcTabContentCls");

	var headerHeight = window.innerHeight * 0.458 * .165;
	var textSize = headerHeight * 0.40;

	var shapeHeader = $('<div>').attr("id", "shapeHeader").css({
		"font-family" : "NotoSans-Regular",
		"font-size" : textSize + "px",
		"padding-left": "4%"
	}).addClass("inpSrcMainHeaderCls shapesId").html(langObj.template.COM_EBD_CONTENTSLIB_SHAPES);
	shapeContainer.append(shapeHeader);
   shapeHeader.addClass("vAlignmiddle");

	shapeContainer.append(shapeArea);
	$("#templatePage").append(shapeContainer);
	$("#shapeDdParDivId").css({
		'width' : innerWidth + 'px',
		'height' : (dataH - 1) + 'px',
		'top' : hdrH + 'px',
		'left' : '0px'
	});
	var ddOption = $("#shapeDdParDivId").children().length;
	var optionHeight = Math.round($("#shapeDdParDivId").height() / ddOption);
	$(".shapeDDOptCls").css({
		'height' : optionHeight + 'px',
		'line-height' : optionHeight + 'px',
		'font-size' : Math.round(optionHeight * .43) + 'px'
	});

	$('#shapeMenuScrollArea').remove();
    var shapeMenuScrollArea = $('<div>').attr({"id":"shapeMenuScrollArea","class":"tmpltSubDataCls"}).css({
		"height" : '93%',
		"width" : scrollingWidth + 'px',
		"padding-top" : '4%',
		"padding-bottom" : '2%',
		"margin-left" : leftMargin + 'px',
		"margin-right" : leftMargin + 'px'
	});
	
	shapeArea.append(shapeMenuScrollArea);
    $("#shapeMenuScrollArea").html("");
   for (var counter = 0; counter < shapeInfo.shapeList.length; counter = counter + 1) {
   
   		 var checkImg = $('<img src="../resource/img/ss_icon_check.png" class="checkImgClass">').css({
            "height" : "51%",
            "width" : "68%",
            "top" : "30%",
            "left" : "21%",
            "position" : "absolute",
            "z-index" : "99",
            "visibility" : "hidden"
        });
     
        var sourceDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',
            "float" : "left",
            "margin-left" : sourceRtLeftMargin + 'px',
            "margin-right" : sourceRtLeftMargin + 'px',
            "margin-bottom" : sourceBottomMargin + 'px',
            "background-color" : divC,
            "background-image" : "url('../resource/img/shapes/" + shapeInfo.shapeList[counter].bg + ".png')",
            "position":"relative",
			"background-size":"100%"
               }).attr("shape-id", shapeInfo.shapeList[counter].type).addClass("shapeMenuDiv"); 
    	var iconDivText = $('<div class="drpAraIpTxtCls">').css({            
            "width" : sourceDivWidth + 'px',
            "margin-top" : sourceDivWidth * 0.09 + 'px',            
            "font-size" : fontSize + 'px',
            "position":"absolute",
            "text-align":"center",
            "bottom":"14%"                     
        });//.html(shapeInfo.shapeList[counter].name);
        sourceDiv1.append(iconDivText);

        $("#shapeMenuScrollArea").append(sourceDiv1);

    }      
};

WidgetUI.prototype.registerEvents=function(){
	
	$('.wdgtDDOptCls[value="ALL"]').addClass("wdgtDDOptCls-active");
    $("#wdgtDDArwId,#wdgtDDTxtId").off("tap").on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        if ($("#wdgtDDArwId").hasClass("catDDArowDwnCls")) {
            $("#wdgtDDArwId").removeClass("catDDArowDwnCls").addClass("catDDArowUpCls");
            $("#wdgtDdParDivId").show();
        } else {
            $("#wdgtDDArwId").removeClass("catDDArowUpCls").addClass("catDDArowDwnCls");
            $("#wdgtDdParDivId").hide();
        }
        return false;
    });
   
    $(".wdgtDDOptCls").off("tap").on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        var cateogry = $(this).attr("value");
        $("#wdgtDDTxtId").attr("value", cateogry);
        $("#wdgtDDTxtId").html($(this).html());
        $('.wdgtDDOptCls').removeClass("wdgtDDOptCls-active");
        $('.wdgtDDOptCls[value="' + cateogry + '"]').addClass("wdgtDDOptCls-active");
    
         widgetUIObj.filterByWidgetType(cateogry);
        $("#wdgtDDArwId").trigger("tap");
        return false;
    });

};
WidgetUI.prototype.filterByWidgetType=function(type)
{
	var scrollingWidth = window.innerWidth;
    var sourceDivWidth = getParseIntInDec(scrollingWidth * 0.294);
    var sourceRtLeftMargin = Math.round(scrollingWidth * 0.0106);
    var sourceBottomMargin = Math.round(scrollingWidth * 0.0212);
    var fontSize = window.innerWidth * 0.03;
    var divC = "#454547";
    var widgetItem;
    $("#widgetMenuScrollArea").html("");
   for (var counter = 0; counter < widgetInfo.widgetList.length; counter = counter + 1) {

   widgetItem = widgetInfo.widgetList[counter];
   if(widgetItem.type == widgetInfo.MEDIARSS && !Utils.isHighEndModel(templateObj.modelType)){
       continue;
   }
      
    var widgetType="";
 
    if(widgetItem.type==widgetInfo.WEB)
    {
    	widgetType="W";
    }else if(widgetItem.type==widgetInfo.RSS || widgetItem.type==widgetInfo.MEDIARSS )
    {
    	widgetType="R";
    }
    else if(widgetItem.type==widgetInfo.WEATHER_TODAY || widgetItem.type==widgetInfo.WEATHER_WEEK || widgetItem.type==widgetInfo.WEATHER_HOUR)
    {
    	widgetType="F";
    }
    else 
    {
    	widgetType="C";
    }
    if(type=="ALL" || type==widgetType)
   {
   		 var checkImg = $('<img src="../resource/img/ss_icon_check.png" class="checkImgClass">').css({
            "height" : "51%",
            "width" : "68%",
            "top" : "30%",
            "left" : "21%",
            "position" : "absolute",
            "z-index" : "99",
            "visibility" : "hidden"
        });
     
        var sourceDiv1 = $('<div>').css({
            "height" : sourceDivWidth + 'px',
            "width" : sourceDivWidth + 'px',
            "float" : "left",
            "margin-left" : sourceRtLeftMargin + 'px',
            "margin-right" : sourceRtLeftMargin + 'px',
            "margin-bottom" : sourceBottomMargin + 'px',
            "background-color" : divC,
            "background-image" : "url('../resource/img/widget/" + widgetItem.bg + ".png')",
            "position":"relative",
			"background-size":"100%"
               }).attr("widget-id", widgetItem.type).addClass("widgetMenuDiv");
    	var iconDivText = $('<div class="drpAraIpTxtCls">').css({            
            "width" : sourceDivWidth + 'px',
            "margin-top" : sourceDivWidth * 0.09 + 'px',            
            "font-size" : fontSize + 'px',
            "position":"absolute",
            "text-align":"center",
            "bottom":"14%"                     
        }).html(widgetItem.name);
        sourceDiv1.append(iconDivText);
        	
    }
        $("#widgetMenuScrollArea").append(sourceDiv1);

    }      
};



	 
