/**
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
var isLoaded = false;
var arrPath = [];
var imageURLs = [];
var jsonContentObj = [];
var currObjTemplate;
var contentInfoJson;
var callbackDesignTemplate;
var elementNo = 1;
var translateYCor = 0;
var deltaRotation = 0;
var isAnimNeeded = false;
var arrDeg = [10, -5, -9, -20, 24, -15, 30, -7, -33];
var arrCord = [[0.5, 0.5], [0.85, 0.5], [0.5, 0.15], [0.15, 0.15], [0.15, 0.5], [0.5, 0.85], [0.85, 0.15], [0.15, 0.85], [0.85, 0.85]];
var arrSelectedContent = [];
var folderPath;
var callBackFetchList;
var arrContentList = [];
var categoryGType = ""; 
var srcCounter = 0;
var play_Shuffle = null;
var isClassigBG = false;
var isModernBG = false;
var isVintageBG = false;
var arrBGList = [];
var arrBckImgList=[];
var backgroundCustomLst = [];
var isMax=false;
var galleryContentSel = {
    // Application Constructor
    initialize : function() {
        this.bindEvents();
    },
    // Bind Event Listeners       
    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    onDeviceReady : function() {

    	document.addEventListener("backbutton", onBackkeyDown, false);
        tplUIObj.updateOrientation(orientationMode);
		if(templateRenderer.lfdPath != null && templateRenderer.lfdPath != ''){
			templateRenderer.initialize(false);
		}
        Utils.registerKeyboardObserver();  
	    deleteOuterSpenFolderContents();      
        galleryContentSel.getBgList();
                
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {

        }, function(evt) {
            console.log("NOT ABLE TO GET SYTEM ROOT PATH");
        });       
        
        registerActivityStatus();
        
    },
    // Update DOM on a Received Event
    receivedEvent : function(id) {
       
        console.log('Received Event: ' + id);
    },


getBgList:function() {

    backgroundCustomLst = [];
    galleryContentSel.getFileList('.ETabletAuthor/BG/bg_custom/bg_classic/actual', function() {
       
		  galleryContentSel.addBackgroundCutomLst("bg_classic");
        galleryContentSel.getFileList('.ETabletAuthor/BG/bg_custom/bg_modern/actual', function() {
           
		    galleryContentSel.addBackgroundCutomLst("bg_modern");
            galleryContentSel.getFileList('.ETabletAuthor/BG/bg_custom/bg_vintage/actual', function() {
            	
            	 galleryContentSel.addBackgroundCutomLst("bg_vintage");
               
            });

        });

    });

},
setImgCount:function()
{   
    $("#countId").html(galleryContentSel.getSelectedImgCount());
},
addBackgroundCutomLst:function(imageType){
	
	 for (var i = 0; i < arrBGList.length; ++i) {
                    if (arrBGList[i] != "") {
                        backgroundCustomLst.push({

                            path : arrBGList[i],
                            typeUserDefined : imageType
                        });
                    }
                }
},

DragDrop:function() {

    var error = function(message) {
    };
    var success = function(message) {
    };
    mUiHandler.DragDrop(success, error);
},

addSelection:function(flagSelect, path) {

    var error = function(message) {
    };
    var success = function(message) {
    };
    mUiHandler.addSelection(flagSelect, path, success, error);

},

addGallery:function(flagShow,galleryStep,iMode) {     
    var error = function(message) {        
       if(message=="CLOSE")
       {
           Utils.isGalleryOpen=false;	       
       }        
    };
    var success = function(contentInfo) {
        if(galleryStep==STEP_TWO)
        {
            galleryContentSel.addCntntTOFrames(contentInfo);
        }
        else
        {
            Utils.isGalleryOpen=false;
            jsonContentObj=contentInfo;
            tplUIObj.updateDropArea();
            //galleryContentSel.addContntFromGallery(contentInfo);
        }        
    };

    mUiHandler.addGallery(flagShow, galleryStep,jsonContentObj, success, error,iMode);
},
addIpSourceToDropArea:function()
{   
    if(ipSrcObj!=null)
    {         
        $('.tplDropAreaText').hide();
        $("#tplGalleyDropArea div.drpAreaIpSrcCls").remove();
        drawSource(ipSrcObj.bgColor, ipSrcObj.orgImgPath); 
    }    
},
getSmallThumbDim:function(iWidth,iHeight)
{
    var aspectRatio=0;
    var aspctToken=W_EQ_H;    
    var wH=window.innerHeight;
    var wW=window.innerWidth;    
    var calW,CalH;
    var wPer,hPer;
    //log.debug("--x-- iWidth:"+iWidth+",iHeight:"+iHeight+",wH:"+wH+",wW:"+wW);
    if(iWidth>iHeight)
    {
      aspectRatio= iWidth/iHeight;
      aspctToken=W_GT_H;
    }
    else if(iWidth<iHeight)
    {
       aspectRatio= iHeight/iWidth;
       aspctToken=W_LT_H; 
    }
    else
    {
        aspectRatio=1;
        aspctToken=W_EQ_H;
    }
    aspectRatio=parseFloat(aspectRatio).toFixed(2);
    //log.debug("--x--aspectRatio: "+ aspectRatio);
    if(aspectRatio>=1.00 && aspectRatio<1.10)
    {
        wPer=0.198;
        hPer=0.198;              
    }
    else if(aspectRatio>=1.10 && aspectRatio<=1.60)
    {
        wPer=0.2364;
        hPer=0.130;        
    }
    else if(aspectRatio>=1.61)
    {
        wPer=0.2785;
        hPer=0.1464;        
    }
   
    if(aspctToken==W_LT_H)
    {
        calH=Math.round(wH*hPer);
        calW=Math.round(calH/aspectRatio);  
    }
    else
    {        
        calW=Math.round(wW*wPer);
        calH=Math.round(calW/aspectRatio);
    }
    return {w:calW,h:calH};
},
addContntFromGallery:function(contentInfo)
{
    jsonContentObj=[];
    $(".drpAreaImgCls").remove();
    var ipSrcCount=0;     
    if(contentInfo.length==0)
    {            
        if(ipSrcObj==null)
        {
            $('.tplDropAreaText').show();
        }
        else
        {            
            $('.tplDropAreaText').hide();
        }
        return;
    }
    if(ipSrcObj!=null)
    {
        ipSrcCount=1;
    }        
    var uniqueId,actualPath,thumbPath,mWidth,counter=0;
    var mHeight,item;
    var iteration,finlTmbHW;        
    $('.tplDropAreaText').hide();
    var wWidth = window.innerWidth;
    var wHeight = window.innerHeight; 
            
    $.each(contentInfo, function(index, result) {
        uniqueId = result["uniqueId"];
        actualPath = Utils.encodeThumbPath(result["actualPath"]);            
        thumbPath = Utils.encodeThumbPath(result["thumbPath"]);       
        mWidth = getParseIntInDec(result["width"]);
        mHeight = getParseIntInDec(result["height"]);
        $('#tplGalleyDropArea').append('<img class="drpAreaImgCls" id="' + uniqueId + '" src="' + thumbPath + '"/>');
        item = {};
        item["actualPath"] = result["actualPath"];
        item["thumbPath"] = result["thumbPath"];
        item["imgPath"] = "";
        item["uniqueId"] = uniqueId;
        item["fileType"] = result["fileType"];
        item["width"] = mWidth;
        item["height"] = mHeight;
        item["fileName"] = result["fileName"];
        item["duration"] = result["duration"];
        jsonContentObj.push(item);
        finlTmbHW=galleryContentSel.getSmallThumbDim(mWidth,mHeight);                               
        counter = jsonContentObj.length - 1+ipSrcCount;            
        iteration = Math.round(counter / 9);
        counter = counter % 9;
        galleryContentSel.setAnimFrDrpAraElm({id:uniqueId,cntr:counter,w:finlTmbHW.w,h:finlTmbHW.h});       
        counter += iteration;
        counter = counter % 9;
        galleryContentSel.setStylFrDrpAreaElm(uniqueId,arrDeg[counter]);  
        galleryContentSel.setImgCount();      
    });
},
addCntntTOFrames:function(contentInfo)
{       
    var xCord=contentInfo["xCordinate"];;
    var yCord=contentInfo["yCordinate"];
    var elmObj=galleryContentSel.getElmObjFromJson(contentInfo,false);
    templateObj.addElementInFrame(elmObj, xCord, yCord,false); 
},
getElmObjFromJson:function(json,isEncode)
{    
    var elmObj = {
        type : json["fileType"],
        imgPath : isEncode ? Utils.encodeThumbPath(json["imgPath"]):json["imgPath"],
        thumbPath : json["thumbPath"],
        orgImgPath : json["actualPath"],
        fileName : json["fileName"],
        orgW : getParseIntInDec(json["width"]),
        orgH : getParseIntInDec(json["height"]),
		duration : Math.floor((Utils.isIOSDvice() ? json["duration"] : json["duration"]/1000)),
        imgPathOrgW:getParseIntInDec(json["imgPathWidth"]),
        imgPathOrgH:getParseIntInDec(json["imgPathHeight"])
    };
    return elmObj;
},
addBgGallery:function(flagShow,galleryStep,callBackToTemplate){
    var error = function(message) {
    };
    var success = function(contentInfo) {
        arrBckImgList=[];
        if (contentInfo == "addGallerySuccess") {
           
            return;
        } else {
            var isValidContent = contentInfo["isValidContent"];
            if (isValidContent == false || isValidContent == "false") {
                var errMsg = contentInfo["errMsg"];
                Utils.showToast(errMsg);              
                return false;
            }

        }
    	    Utils.isGalleryOpen=false;            
            arrBckImgList=contentInfo;
            callBackToTemplate.apply();
        
    }; 
    mUiHandler.addGallery(flagShow, galleryStep,null, success, error,DEFAULT_VALUE);   
},
createThumbnail:function(callBack){
   
    callbackDesignTemplate = callBack;
    loaderObj.showLoader(); 
    arrSelectedContent=[];
    arrSelectedContent=jsonContentObj;        
    var error = function(message) {
    };
    var success = function(contentInfo) {

        contentInfoJson = contentInfo;
        loaderObj.hideLoader();
        callbackDesignTemplate.apply();
    };
    
    setTimeout(function(){
        if (Utils.isIOSDvice() && (jsonContentObj == "" || jsonContentObj == "undefined")) {
            success([]);
        } else {
            mUiHandler.createCopyThumbnail(jsonContentObj,success, error);
        }
    },200);
    
},

capturePhoto:function() {
    // Take picture using device camera and retrieve image as base64-encoded string
    navigator.camera.getPicture(onPhotoURISuccess, onFail, {
        quality : 50,
        destinationType : Camera.DestinationType.FILE_URI,
        allowEdit : false,
        saveToPhotoAlbum : true,
        correctOrientation : true
    });
    
},

onPhotoURISuccess:function(imageURI) {
},

onFail:function(message) {
},

contentValidation:function(categoryType){

    var msg="";
    var selectedContent = jsonContentObj.length;
    if (categoryType == Category.PROMOTION && selectedContent < 1) {
        msg = MIA_SID_SELECT_1_IMAGE_PROMOTION;        

    } else if (categoryType == Category.SLIDESHOW && selectedContent < 2) {
        msg = MIA_SID_SELECT_LEASE_2_IMG_SLIDSHOW;       
    }    
    return msg;
    
},
getSelectedVideoCount:function()
{
	var vdoCounter = 0;
	$.each(jsonContentObj, function(index, result) {
        if (result["fileType"] == "video") {            
            vdoCounter++;
        }
    });
  return vdoCounter;
},

getSelectedImgCount:function()
{
    var imgCounter = 0;
    $.each(jsonContentObj, function(index, result) {
        if (result["fileType"] == "image") {
            //Remove from array
            imgCounter++;
        }
    });
  return imgCounter;
},
delDropAreaItem:function(id)
{
    $("#" + id).remove();
    var indexDelete;
    if (id.lastIndexOf('_sourcedrp') > 0) {                                        
        $(".sourceMenuDiv").find('img').css({
            "visibility" : "hidden"
        });                    
        deleteIpSrcObj();    
    } else {
        $.each(jsonContentObj, function(index, result) {
            if (result["uniqueId"] == id) {                            
                indexDelete = index;                            
            }
        });        
        jsonContentObj.splice(indexDelete, 1); 
          galleryContentSel.setImgCount();                                       
    }
    showGuideMsg(); 
},
setAnimFrDrpAraElm:function(objProp)
{
    var cWidth = $("#tplGalleyDropArea").width();
    var cHeight = $("#tplGalleyDropArea").height();
    var elmObj=$("#"+objProp.id);  
    elmObj.css({              
        'width' : objProp.w + 'px',
        'height' : objProp.h + 'px'
    });
    elmObj.animate({
        'left' : (arrCord[objProp.cntr][0] * cWidth - (objProp.w / 2)) + 'px',
        'top' : (arrCord[objProp.cntr][1] * cHeight - (objProp.h / 2)) + 'px'
    }, 900);  
},
setStylFrDrpAreaElm:function(elmId,deg)
{
    try
    {
        var elmObj=$("#"+elmId);         
        elmObj.css({
            '-webkit-transform' : 'rotate(' + deg + 'deg)'
        });
        elmObj.draggable({
          stop: function() {                      
            var id=$(this).attr("id");
            var cWidth = $("#tplGalleyDropArea").width();
            var cHeight = $("#tplGalleyDropArea").height();
            var dpOffSet = $("#tplGalleyDropArea").offset();
            var eleObj=$("#"+id); 
            var elmW=eleObj.width();
            var elmH=eleObj.height();
            var elmOffSet=eleObj.offset();
            var elmX=elmOffSet.left+(elmW/2);
            var elmY=elmOffSet.top+(elmH/2);
            //log.debug("elmX: "+ elmX+",elmY:"+elmY+",dpOffSet.left:"+dpOffSet.left);
            if(elmX<dpOffSet.left || elmX>(dpOffSet.left+cWidth)
               || elmY<dpOffSet.top || elmY>(dpOffSet.top+cHeight))
           {
               galleryContentSel.delDropAreaItem(id);
           }                    
          }           
        });           
    }
    catch(ex)
    {
        log.debug("Error: "+ex.message,"setStylFrDrpAreaElm");
    }   
},

getFileList:function(folderPath,funCallBack){
    
    arrBGList=[];
    callBackFetchList=funCallBack;
    folderPath=folderPath;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotDS1, fail1);

    function gotDS1(fileSystem) {
        entry = fileSystem.root.toURL();
        rootPath = fileSystem.root.toURL();

        entry = folderPath;

        this.filesys = fileSystem;
        fileSystem.root.getDirectory(entry, {
            create : true,
            exclusive : false
        }, onGetDirectoryWin1, onGetDirectoryFail1);
    }

    function fail1(error) {
    }

    function onGetDirectoryWin1(directoryEntry) {
        var directoryReader = directoryEntry.createReader();
        directoryReader.readEntries(gotDirectoryEntry1, fail1);
    }

    function onGetDirectoryFail1(directoryEntry) {
    }

    function gotDirectoryEntry1(entries) {

        for (var i = 0; i < entries.length; ++i) {
            //var myObject = new Object();
            //myObject.name = entries[i].name;
            //myObject.path = entries[i].fullPath;
            arrBGList.push(entries[i].name);
        }

        callBackFetchList.apply();

        }
    
},

ShuffleSound:function() {
    var resource = getPhoneGapPath() + 'resource/audio/Shuffle.wav';
    play_Shuffle = new Media(resource,
    // success callback
    function() {
        console.log("ShuffleSound():Audio Success");
    },
    // error callback
    function(err) {
        console.log("ShuffleSound():Audio Error: " + err);
    });

},

getPhoneGapPath:function() {
    var path = window.location.pathname;
    path = path.substr( 0, path.length - 22 );
    return path;
},

deleteFile:function(strPath,funCall){
    
    callBackFetchList=funCall;
    if(strPath.indexOf(Utils.getSystemRootPath())==0 && !Utils.isIOSDvice()){
    	strPath=strPath.replace(Utils.getSystemRootPath(),"");
    }
    var relativeFilePath = strPath;
    if (deviceType == "iPad" || deviceType == "iPhone") {
        relativeFilePath = relativeFilePath.split("Documents/")[1];
    }

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
        fileSystem.root.getFile(relativeFilePath, {
            create : false
        }, function(fileEntry) {
            fileEntry.remove(function(file) {
                callBackFetchList.apply(this, [true]);
                console.log("File removed!");
            }, function() {
                callBackFetchList.apply(this, [false]);
                console.log("error deleting the file " + error.code);
            });
        }, function() {
            callBackFetchList.apply(this, [false]);
            console.log("file does not exist");
        });
    }, function(evt) {
        callBackFetchList.apply(this, [false]);
        console.log(evt.target.error.code);
    });

}
};


function registerActivityStatus(){
    
    if(deviceType == "iPhone" || deviceType == "iPad"){
            return;
      }     
    var success = function(result){
        if(result == ON_RESUME){
            setTimeout(function(){
               console.log("on resume ");
               $('#templatePage').css({'visibility':'visible'});
               $('#shuffleBtnArea').css({'visibility':'visible'});               
               $('#tpl_shuffleBtnId').css({'visibility':'visible'});
               if(Utils.getActivePlayerType()!=RMD_MODEL)
               {
                    $('#shuffleAudioBtnId').css({'visibility':'visible'});    
               }
               
            }, 100);
        }else if(result == ON_PAUSE){
            console.log("on pause");
            $('#templatePage').css({'visibility':'hidden'});
            $('#shuffleBtnArea').css({'visibility':'hidden'});
            $('#shuffleAudioBtnId').css({'visibility':'hidden'});
            $('#tpl_shuffleBtnId').css({'visibility':'hidden'});
        }
    };
    var error = function(message){
    	 console.log("on Error: "+message);
    };
    console.log("Requesting Activity status");
    mUtilityManager.registerActivityStatus(success,error);
}

function onBackkeyDown(){
	if( $('#TimePicker').css('display') == 'block' ) 
    {
        closeTimePicker();
        return;
    }
    if(weatherImgsDownloading)
    {
		return;    	
    }
	var el = document.getElementById("_coachmarkpopUpId");
	if (el != null && el.style.display == "block") {
		closeCoachmarkGenericPopUp();
		return;
	}
	
	 if(Utils.isGalleryOpen){
	 	 mUiHandler.hideGallery();
	 	 Utils.isGalleryOpen = false;
	 	 return;
	 }else if(Utils.isHandwritingOpen){
	     return;
	 /*}else if($('.MainMenuCls').css("display") == 'block'){
	     //TODO: sravani
	     return;*/
	 }else if(!handleMenuOnBack()){
			return false;
	}else if(Utils.getUrlVars()["category"]=='C'){
		gotoQuickStartPage();
	 }else{
	   switch(Utils.currStep) {
            case STEP_ONE:
            	gotoQuickStartPage();
                break;
            case STEP_TWO:
                if (templateObj!=null && templateObj.isEdited == true ) {
                    tplUIObj.exitFromTmplt(EXITFLAG_PREV_CLICK);
                } 
                else {
                    tplUIObj.rndrStepOne();
                    
                    $('#tmpltPrevBtnId').hide();
                 } 
                 $('#stepId_1').removeClass('step-past').addClass('step1-on');                  
             break;
            default:
                break;
        }
     }
      return;
 }
 
