var DEFAULT_VALUE=-1;
var LEFT_SIDE = 1;
var TOP_SIDE = 2;
var BOTTOM_SIDE = 3;
var RIGHT_SIDE = 4;
var DIRECTION_VERTICAL = 5;
var FIXED_LAYOUT = 6;
var FREE_LAYOUT = 7;
var BLANK_LAYOUT = 8;
var VERTICAL = 9;
var HORIZONTAL = 10;
var DIRECTION_HORIZONTAL = 11;
var MAIN_FRAME_ELM_YCP=12;
var MAIN_FRAME_ELM_CP=14;
var INNER_FRAME_CP=15;
var MAIN_FRAME_ELM=17;
var IMAGE=18;
var INPUT_SOURCE=19;
var GROUP=20;
var TEXT=21;
var STICKER=22;
var SWAP_FRAME=23;
var VIDEO = 24;
var CENTER_SIDE = 25;
var TABLE_CP = 26;
var HANDWRITING=27;
var MN_FRM_ELM_ROT=28;
var MENUBOARD=29;
var EMPTY=30;
var MNFRM_ROT_ELMCP=31;
var BLANK_INNER_FRAME_CP=32;
var BLANK_INNER_FRAME=33;
var DECO_IMAGE=34;
var BLK_FRM_ROT_CP=35;
var PPT=36;
var PDF=39;
var AUDIO=37;
var TABLE_TEXT=38;
var FRAME_ROTATION=39;
var MULTISELECT=40;
var GROUP_DIV_DRAG=41;
var GROUP_DIV_CP_DRAG=42;
var GROUP_DIV_ROT_DRAG=43;
var GROUP_ELEMENTS=44;
var LANDSCAPE = 1000;
var PORTRAIT = 9999;
var SNAP_VALUE = 45;
var FRAME_ID_PREFIX="tplFrameId_";
var MIN_FRAME_W_PERC = 5;
var MIN_FRAME_H_PERC = 5;
var ANGLE_DIFF = 0;
var TABLE_SEPARATOR_W = 2;
var TABLE_TEXT_MIN_W = 50;
var TABLE_MAX_COL_COUNT = 3;
var TABLE_PRICE_COL_DISTANCE=20;
var TABLE_MAX_ROW_COUNT=10;
var W_GT_H=201;
var W_LT_H=202;
var W_EQ_H=203;
var W_6tn9n_H=204;
var W_N6tn9n_H=205;
var INITZINDEX=99999;
var MAX_COVER_DIV_Z_INDEX=999999;
var MIN_INNER_FRAME_ZINDEX=100;
var MIN_COVER_FRAME_ZINDEX=9999;
var BORDER_WIDTH = 2;
var COVERIDSHADOW="0px 0px 0px "+BORDER_WIDTH+"px";
var CPoint_HW=19;
var ROTATE_HANDLER_HW = 40;
var MAX_MAIN_FRAME_ELEMENTS = 40;
var MAX_INPUT_SRC_FRAMES = 1;
var MAX_VIDEO_FRAMES = 2;
var MAX_IMG_IN_FRAME=100;
var MAX_VDO_IN_FRAME=10;
var MAX_MEDIA_ITEMS=2;
var MAX_DSGN_ELM_PORT_WTH_IPSRC=2;
var STANDARD_VIDEO_HEIGHT=1080;
var VIDEO_LIMIT={W:1920,H:1920,RW:1920,RH:1080};
var MAGNET_RANGE_FOR_MOVE = 5;
var MAGNET_RANGE_FOR_RESIZE = 3;
var MAGNET_RANGE_FOR_ATTACHED = 1;
var MAX_HEAVY_ELM_CNT = 10;
var MIN_HW_MAIN_FRM_ELM=5;
var highLghtTime=1000;
// adding offset of group
var GROUP_OFFSET = 5;
const TXT_DIRECTION_LEFT = 1;
const TXT_DIRECTION_RIGHT = 2;
const TXT_DIRECTION_TOP = 3;
const TXT_DIRECTION_BOTTOM = 4;
const TXT_ALIGN_RIGHT = "right";
const TXT_ALIGN_LEFT = "left";
const TXT_ALIGN_DOWN = "down";
const TXT_ALIGN_UP = "up";
var TAPHOLDTIME = 500;
var cpRotationAngle=[-45,0,45,90,-45,0,45,90];

var constForTmpl = {
	SHUFFLE : "shuffle",
	SHOWAUDIOLIST : "showaudlst",
	SHIFTFORMENU : "shiftformenu",
	SHIFTFORTEXT : "shiftfortxt",
	SHOWMAINFRAME : "showmainframe",
	KEYBOARDCLOSE : "keybclose",
	HIDEITEMLIST : "hideitmlist",
	SHOW_SEL_FRAME : "showselfrm",
	OUTSIDETAP : "outsidetap",
	RNDR_FRAME_THUMB : "rndrframethumb",
	CLOSE_TXT_EDIT : "closetxtedit",
	SHOW_HIDE_FRAME_CTRLS : "showhideframecntrls",
	RESET_ZOOM_ON_CROP : "resetzooomandboxsoncrop",
	SHOW_HIDE_ELEMENT_CONTROLS : "showhideelementctrls",
	ACTV_FRAME_IPSRC_ID : "actvFrameSrcId",
	ARRANGE_LAYER_ELM_CNT : "arrangeLayerElmCount",
	SHOULD_ENBL_TXT_SLD:"shouldenabletxtSlide",
	IS_HEAVY_ELM_LMIT_XCD:"HeavyElementLimitExceeded"
};

// Undo Redo Operations
var UndoRedo = {
	ADD : 1,
 	DELETE : 2,
	REPLACE : 3,
	ARRANGE : 4,
	DRAG : 5,
	RESIZE : 6,
	TEXT_EDIT : 7,
	WEATHER_EDIT : 8,
	ADD_INNERFRAME_ELEMENT : 9,	
	DEL_INNERFRAME_ELEMENT : 10,
	ADD_BLANKFRAME:11,
	DEL_BLANKFRAME:12,
	REPLACE_INNERFRAME_ELEMENT : 13,
	DEL_FRAME: 14,
	ARRANGE_INNERFRAME_ELEMENT: 15,
	RESIZE_FRAME: 16,	
	SWP_FRM:17,
	EDIT_FRAME:18,
	RESIZE_BLANKFRAME:19,
	DRAG_BLANKFRAME:20,
	ARRANGE_BLANKFRAME:21,	
	ROTATE_INNERFRAME_ELEMENT:22,
	ROTATE_MAINFRAME_ELEMENT:23,
	CROP:24,
	ADD_AUDIO:25,
	DEL_AUDIO:26,
	REPLACE_AUDIO:27,
	TEMPLATE_BG:28,
	IMG_OPACITY:29,
	HW_UPDATE:30,
	SHAPES_EDIT:31,
	CROP_SHAPES:32,
	SHAPES_BG:33,
	RSS_WEB_URL:34,
	ZOOM_TEMPLATE:35,
	INPUT_SRC:36,
	MULTI_SEL_ROT:37,
	MULTI_SEL_RESIZE:38,
	MULTI_SEL_DEL:39,
	MENU_TABLE:40,
	ADD_ROW:41,
	DEL_ROW:42,
	ADD_COL:43,
	DEL_COL:44,
	MENU_TBL_SEP:45,
	MEDIA_RSS_RELOAD_DUR:46,
	MUTE_AUDIO:47
}; 
var TStickerCopyDir = {
NONE:333,
DOWN:444,
RIGHT:555,
UP:666,
LEFT:777
};
var TEXT_STICKER_LAYER_HTML = "Text_Sticker_Layer";