var TemplateUtils={
isColorPicker:{isInit:false,isLoaded:false},
rgbDataColorPicker:{red:0,green:0,blue:0},
zoomVisibleArea:{top:0,left:0,width:0,height:0,right:0,bottom:0},
zoomNonVisibleArea:{top:0,left:0,right:0,bottom:0},
zoomLeftTopOffset:{left:0,top:0}
};
var playerType = Utils.getActivePlayerType();
var colorTypeAttr = 'color';
var categoryTmplt = Utils.getUrlVars()["category"];
TemplateUtils.getCurrentTimeInMiliSeconds=function()
{
    return (new Date()).getTime();
};
TemplateUtils.getRotationAngle=function(cx, cy, ex, ey)
{	
	var dy = ey - cy;
	var dx = ex - cx;
	var radians = Math.atan2(dy, dx);	
	var theta = (radians * (180 / Math.PI) * -1) + 180;
	 return theta;		
};
TemplateUtils.isShape = function(shapeType){
	shapeType = getParseIntInDec(shapeType);
	if(!isNaN(shapeType) && (shapeType>=400 && shapeType<500)){
		return true;
	}else{
		return false;
	}
};
TemplateUtils.isArrangeWidgets = function(elmType){
	elmType = getParseIntInDec(elmType);
	if(!isNaN(elmType) && (elmType>=52 && elmType<=61)){
		return true;
	}
	return false;
};
TemplateUtils.isMiddleLayerElement=function(elmType)
{
	if(TemplateUtils.isShape(elmType) || TemplateUtils.isArrangeWidgets(elmType))
	{
		return true;
	}
	return false;
};
TemplateUtils.isTopLayerElement=function(elmType)
{
	if(elmType==STICKER || elmType==TEXT || elmType==HANDWRITING)
	{
		return true;
	}
	return false;
};

/*
 ------ -------------- --------------  COLOR PICKER  -------------- -------------- -------------- -------------- -------------- --------
 */
TemplateUtils.initiateColorPicker=function(colorTypeUsed)
{
    var zoomVisArea = TemplateUtils.zoomVisibleArea;
    colorTypeAttr = colorTypeUsed;
    $(".colorPickerRemoveClass").remove();
    templateObj.shiftTemplateForTxtEdit(DOWN);
    $("#TemplateEditMenuId").hide();
    // DIV APPENDED AND CANVAS ON BODY OF TEMPLATE
    $("body").append('<div id="_colorPickerMainDivId" class="colorPickerMainDivCls colorPickerRemoveClass" ></div>'
                     +'<div id="_colorPickerFrameDivId" class="colorPickerFrameDivCls colorPickerRemoveClass" ></div>'
                     +'<div id="_colorPickerSelectorDivId" class="colorPickerSelectorDivCls colorPickerRemoveClass" ></div>'
                     +'<canvas id="colorPickerCanvas" class="colorPickerRemoveClass" style="display:none;"></canvas>');
    
    var colorPickerWidth = getParseIntInDec($("#_colorPickerSelectorDivId").css("width"));
    var colorPickerHeight = getParseIntInDec($("#_colorPickerSelectorDivId").css("height"));
    var canvs = document.getElementById("colorPickerCanvas");
    var cntxt = canvs.getContext('2d');
    TemplateUtils.registerEvents(cntxt,colorPickerHeight,colorPickerWidth);
    setTimeout(function(){
        var zoomOffsetColorPicker = $("#"+templateObj.mainFrame.id).offset();
        var afterZoomFrameWidth = templateObj.mainFrame.w * templateObj.mainFrame.scale;
        var afterZoomFrameHeight = templateObj.mainFrame.h * templateObj.mainFrame.scale ;
        TemplateUtils.visibleAreaCalculation(colorPickerHeight,colorPickerWidth,zoomOffsetColorPicker,afterZoomFrameWidth,afterZoomFrameHeight);
        var imagePath = Utils.getSystemRootPath() + SaveTemplate.myTemplatePath +  "colorPickerImage.PNG";
        TemplateUtils.saveColorPickerSnapshot(imagePath,TemplateUtils.zoomLeftTopOffset,zoomVisArea.width,zoomVisArea.height);
   },10);
};

TemplateUtils.previewColorPicker = function(color, eventType)
{
    var activeFrame=templateObj.getActiveFrame();
    var selElmId,selElmType;
    var isElmTypeMainFrame=this.isElementTypeMainFrame(activeFrame.id);
    if(isElmTypeMainFrame)
    {
        selElmId=activeFrame.id+"-elm_"+activeFrame.activeEleIndex+"_0";
        selElmType=getParseIntInDec($("#ElmCover-"+selElmId).attr("type"));
    }
    else if(activeFrame.table!=null)
    {
        selElmId=$(".tmplTxtDivSelCls").attr("id");
        selElmType=TEXT;
    }
    var elmObj = templateObj.getTextObjectFromId(selElmId);
    if(elmObj!=null && elmObj!=undefined)
    {
        if(TemplateUtils.isShape(selElmType))
        {
            if(eventType == "ON_LOAD" || eventType == "TOUCH_END")
            {
               templateObj.applyShapeColorProperties(elmObj,selElmId,selElmType,colorTypeAttr,color);
            }
        }
        else
        {
            // case for digital clock, text, menuboard
            var alpha=0;
            if(colorTypeAttr=="background-color")
            {
                alpha=elmObj.bgAlpha;
            }
            else if(colorTypeAttr=="text_shadow_color")
            {
                alpha=elmObj.shdwOpc;
            }
            else if (colorTypeAttr=="text_stroke_color")
            {
                alpha=elmObj.strkOpc;
            }
            if(alpha==0)
            {
                alpha=100;
            }
            color=getRGBColorInRGBA(color,alpha);
            if(activeFrame.table!=null)
            {
                templateObj.handleTableTextEdit(selElmId,selElmType,colorTypeAttr,color, eventType, false)
            }
            else if(templateObj.isTxtTypeElm(selElmType))
            {
                templateObj.applyTextProperties(selElmId,selElmType, colorTypeAttr, color, false);
                templateObj.updateTextObj(elmObj, selElmType, colorTypeAttr, color, selElmId, eventType);
            }
        }
    }
    else
    {
        if(UNDO_REDO_ALLOWED)
        {
            if(eventType == 'TOUCH_END'){
                templateObj.createUndoRedoDataFrTmpltBg(color,"", true);
            }
            else if(eventType == 'TOUCH_START')
            {
                templateObj.prevBgColorFrUndo = templateObj.bgColor;
            }
        }
        templateObj.setBGofTemplate(color, "");
        templateObj.isEdited = true;
    }
};
TemplateUtils.setColorPickerValueToElement = function(col)
{
    log.debug("setColorPickerValueToElement called");
    var rgbPicker = "rgb("+col.red+","+col.green+","+col.blue+")";
    $.setColorFromPicker(rgbPicker);
};
TemplateUtils.restoreTemplateStateForColorPicker=function()
{
    $(".colorPickerRemoveClass").remove();
    $("#TemplateEditMenuId").show();
    templateObj.shiftTemplateForTxtEdit(UP);
};
TemplateUtils.saveColorPickerSnapshot=function(folderPath,offSet,w,h)
{
    log.debug("saveColorPickerSnapshot called1");
    var offSetUpdated = {left:0,top:0};
    offSetUpdated.left = offSet.left;
    offSetUpdated.top = offSet.top + 25;
    imageType = "TemplateImage";
    return cordova.exec(function (result) {
                        TemplateUtils.drawImageOnCanvas(folderPath,offSet,w,h);
                        }, function () {
                            TemplateUtils.restoreTemplateStateForColorPicker();
                        },
                        "Canvas2ImagePlugin",
                        "captureScreenShot",
                        [folderPath, imageType,offSet.left,offSet.top+25,w,h]);
    
};
TemplateUtils.drawImageOnCanvas=function(folderPath,offSet,w,h)
{
	log.debug("drawImageOnCanvas called1");
    var fldrPath = folderPath + ".PNG?t="+TemplateUtils.getCurrentTimeInMiliSeconds();
    var img = new Image();
    var canvs = document.getElementById("colorPickerCanvas");
    var cntxt = canvs.getContext('2d');
    var colorPickerWidth = getParseIntInDec($("#_colorPickerSelectorDivId").css("width"));
    var colorPickerHeight = getParseIntInDec($("#_colorPickerSelectorDivId").css("height"));
    canvs.height = h;
    canvs.width = w;
    img.onload = function(){
    	log.debug("on image load  called","colorPicker");
        cntxt.drawImage(img,0,0,w,h);
        TemplateUtils.rgbDataColorPicker = TemplateUtils.getColorFromCanvas(cntxt,(TemplateUtils.zoomVisibleArea.width)/2,(TemplateUtils.zoomVisibleArea.height)/2,colorPickerWidth,colorPickerHeight);
        TemplateUtils.showColorPickerPreview(TemplateUtils.rgbDataColorPicker, "ON_LOAD");
        Utils.showToast(langObj.template.MIA_SID_20_DRAG_TO_CHOOSE_COLOR_TAP_CONFIRM);
        $(".colorPickerRemoveClass").show();        
    };
    img.src = fldrPath;
};

TemplateUtils.showColorPickerPreview=function(colorObj,eventType)
{
    var rgcolor = "rgb("+colorObj.red+","+colorObj.green+","+colorObj.blue+")";
    //TemplateUtils.changePickerBorderColor(colorObj);
    TemplateUtils.previewColorPicker(rgcolor,eventType);
}
TemplateUtils.getColorFromCanvas=function(context,x,y,width,height)
{
    var fx=x+(width/2);
    var fy=y+(height/2);
    var canvasWidth=context.canvas.width;
    var canvasHeight=context.canvas.height;
    log.debug("Initial :fx:"+fx+",fy:"+fy+",canvasWidth:"+canvasWidth+",canvasHeight:"+canvasHeight,"getColorFromCanvas");

    if(fx<0)
    {
        fx=0;
    }
    if(fy<0)
    {
        fy=0;
    }
    if(fx>canvasWidth)
    {
      fx=canvasWidth-1;
    }
    if(fy>canvasHeight)
    {
      fy=canvasHeight-1;
    }

    log.debug("After update, fx:"+fx+",fy:"+fy+",canvasWidth:"+canvasWidth+",canvasHeight:"+canvasHeight,"getColorFromCanvas");
    var p = context.getImageData(fx, fy, 1, 1).data;
    // if((zoomVisArea.top - currY - colorPickerHeight/2  == 0)
    $("#_colorPickerSelectorDivId").css({
                                        'background-color':"rgb("+p[0]+","+p[1]+","+p[2]+")"
                                        });
    return {red:p[0],green:p[1],blue:p[2]};
};

TemplateUtils.changePickerBorderColor=function(colour)
{
    if(colour.red > 250 && colour.green >250 && colour.blue > 250)
    {
        $("#_colorPickerSelectorDivId").css({
        'border':"2px solid black"
        });
    }
    else
    {
        $("#_colorPickerSelectorDivId").css({
        'border':"2px solid white"
        });
    }
};
TemplateUtils.registerEvents=function(context,colorPH,colorPW)
{
    var zoomVisArea = TemplateUtils.zoomVisibleArea;
    $("#_colorPickerMainDivId,#_colorPickerFrameDivId,#_colorPickerSelectorDivId").off("tap").on("tap", function(e){
                                              e.preventDefault();
                                              e.stopPropagation();
                                              TemplateUtils.setColorPickerValueToElement(TemplateUtils.rgbDataColorPicker);
                                              TemplateUtils.restoreTemplateStateForColorPicker();
                                              return false;
                                              });
    /*$("#_colorPickerFrameDivId").off("tap").on("tap", function(e){
                                               e.preventDefault();
                                               e.stopPropagation();
                                               TemplateUtils.setColorPickerValueToElement(TemplateUtils.rgbDataColorPicker);
                                               return false;
                                               });
    $("#_colorPickerSelectorDivId").off("tap").on("tap", function(e){
                                                  TemplateUtils.setColorPickerValueToElement(TemplateUtils.rgbDataColorPicker);
                                                  return false;
                                                  });*/
    $("#_colorPickerSelectorDivId").off("touchstart").on("touchstart", function(e){
                                                        TemplateUtils.showColorPickerPreview(TemplateUtils.rgbDataColorPicker, "TOUCH_START");
                                                      });
    $("#_colorPickerSelectorDivId").off("touchmove").on("touchmove",function(e){
                                                        let cX = e.originalEvent.changedTouches[0].clientX;
                                                        let cY = e.originalEvent.changedTouches[0].clientY;
                                                        
                                                        if((zoomVisArea.top - cY - colorPH/2 -1)<0 && (WIN_INNER_H - zoomVisArea.bottom - cY - colorPH/2 +1) >=0)
                                                        {
                                                        $("#_colorPickerSelectorDivId").css({'top':cY+'px'});
                                                        }
                                                        
                                                        if((zoomVisArea.left - cX - colorPW/2 -1) <0 && (WIN_INNER_W - zoomVisArea.right - cX - colorPW/2 + 1) >=0)
                                                        {
                                                        $("#_colorPickerSelectorDivId").css({'left':cX+'px'});
                                                        }
                                                        TemplateUtils.rgbDataColorPicker = TemplateUtils.getColorFromCanvas(context,cX-zoomVisArea.left,cY-zoomVisArea.top,colorPW,colorPH);
                                                        if (Utils.isHighEndModel(playerType))
                                                        {
                                                            TemplateUtils.showColorPickerPreview(TemplateUtils.rgbDataColorPicker, "TOUCH_MOVE");
                                                        }
                                                        log.debug("currX outside is ::"+cX+" currY="+cY);
                                                        });
    
    $("#_colorPickerSelectorDivId").off("touchend").on("touchend",function(e){
                                                           TemplateUtils.showColorPickerPreview(TemplateUtils.rgbDataColorPicker, "TOUCH_END");
                                                     });
    
    
};

TemplateUtils.visibleAreaCalculation=function(colorPH,colorPW,zoomOffset,afterZoomFW,afterZoomFH)
{
    var zoomNonVis = TemplateUtils.zoomNonVisibleArea;
    var zoomVisArea = TemplateUtils.zoomVisibleArea;
    zoomNonVis.left = 0;
    zoomNonVis.bottom = 0;
    if(categoryTmplt == "C")
    {
        zoomNonVis.top = getParseIntInDec($(".custom-header").css("height"));
    }
    else if(categoryTmplt == "P")
    {
        zoomNonVis.top = getParseIntInDec($(".custom-header").css("height")) + getParseIntInDec($(".stepHeaderCls").css("height"));
    }
    zoomNonVis.right = 0;
    
    zoomVisArea.left = (zoomOffset.left < zoomNonVis.left) ? zoomNonVis.left : zoomOffset.left;
    zoomVisArea.top = (zoomOffset.top < zoomNonVis.top) ? zoomNonVis.top : zoomOffset.top;
    zoomVisArea.right = (zoomOffset.left + afterZoomFW < WIN_INNER_W) ? WIN_INNER_W - zoomOffset.left - afterZoomFW: 0;
    zoomVisArea.bottom = (zoomOffset.top + afterZoomFH < WIN_INNER_H - zoomNonVis.bottom) ? WIN_INNER_H - zoomOffset.top - afterZoomFH: zoomNonVis.bottom;
    zoomVisArea.height = WIN_INNER_H - zoomVisArea.bottom - zoomVisArea.top;
    zoomVisArea.width = WIN_INNER_W - zoomVisArea.right - zoomVisArea.left;
    TemplateUtils.zoomLeftTopOffset.left = zoomVisArea.left;
    TemplateUtils.zoomLeftTopOffset.top = zoomVisArea.top;
    
    
    $("#_colorPickerMainDivId").css({
                                    'width':WIN_INNER_W+"px",
                                    'height':WIN_INNER_H+"px",
                                    'overflow':"hidden"
                                    });
    
    $("#_colorPickerFrameDivId").css({
                                     'top':zoomVisArea.top+"px",
                                     'left':zoomVisArea.left+"px",
                                     'width':zoomVisArea.width+"px",
                                     'height':zoomVisArea.height+"px"
                                     });
    
    $("#_colorPickerSelectorDivId").css({
                                        'top':(zoomVisArea.top + WIN_INNER_H - zoomVisArea.bottom-colorPH)/2+"px",
                                        'left':(zoomVisArea.left + WIN_INNER_W - zoomVisArea.right-colorPW)/2+"px"
                                        });
};
//function to check if the id is for main frame or not.
TemplateUtils.isElementTypeMainFrame = function(elmId)
{
    return (elmId.indexOf("_Main") != -1);
};
//function to check if the id is for group or not.
TemplateUtils.isElementTypeGroup = function(elmId)
{
    return (elmId.indexOf("grp_") != -1);
};
TemplateUtils.getElementIndexFromID=function(elmID)
{
	if(TemplateUtils.isElementTypeMainFrame(elmID))
	{
		return TemplateUtils.getIndexOfMainFrameElementFromID(elmID);
	}
	else
	{
		return TemplateUtils.getIndexOfInnerFrameFromID(elmID);
	}
};
TemplateUtils.getIndexOfMainFrameElementFromID=function(elmID)
{
	return getParseIntInDec(elmID.split("-elm_")[1].split("_")[0]);
};
TemplateUtils.getIndexOfInnerFrameFromID=function(elmID)
{
	return getParseIntInDec(elmID.split("-elm_")[0].replace(FRAME_ID_PREFIX,""));
};
TemplateUtils.hideCntrPointOfActiveFrameForCropping= function()
{
    templateObj.hideCtrlPtsForFrameID(templateObj.getActiveFrame().id,true);
};
TemplateUtils.getElementIdFromCntrlPntId= function(cntrlPointId)
{
	return cntrlPointId.substr(0,cntrlPointId.indexOf("-CP_"));
};
TemplateUtils.getMainFrameElmIdFromCoverId=function(coverId)
{
    return coverId.replace("ElmCover-","");
};
TemplateUtils.getInnerFrameIdFromCoverId=function(coverId)
{
    return coverId.replace("frameCover-","");
};
TemplateUtils.getElementIdFromCoverId=function(coverId)
{
    coverId=this.getMainFrameElmIdFromCoverId(coverId);
    return this.getInnerFrameIdFromCoverId(coverId);
};
TemplateUtils.createBoundingRectangle=function(obj){
	var new_obj = {
    	x: obj.x,
    	y: obj.y,
    	w: obj.w,
    	h: obj.h,
    	rotation: obj.rotation
    };
    
	if(obj.rotation == 0)
		return new_obj;
		
    var utilR = new RotationUtil();
    var center = utilR.getCenter(obj);
    var left_top = utilR.doTransformation(center, obj, obj.rotation, 1 );

    var past_right_top = {
        x:obj.x + obj.w,
        y: obj.y
    };
    var past_left_bottom = {
        x:obj.x ,
        y: obj.y + obj.h
    };
    var past_right_bottom = {
        x:obj.x + obj.w,
        y: obj.y + obj.h
    };

    var right_top = utilR.doTransformation(center, past_right_top, obj.rotation, 1);
    var left_bottom = utilR.doTransformation(center, past_left_bottom, obj.rotation, 1);
    var right_bottom = utilR.doTransformation(center, past_right_bottom, obj.rotation, 1);
    var up = Math.min( Math.min(left_top.y , left_bottom.y ) , Math.min(right_top.y , right_bottom.y ));
    var down = Math.max( Math.max(left_top.y , left_bottom.y ) , Math.max(right_top.y , right_bottom.y ));
    var left = Math.min( Math.min(left_top.x , left_bottom.x ) , Math.min(right_top.x , right_bottom.x ));
    var right = Math.max( Math.max(left_top.x , left_bottom.x ) , Math.max(right_top.x , right_bottom.x ));
    
    new_obj = {
    	x: left,
    	y: up,
    	w: right-left,
    	h: down - up,
    	rotation:0
    };
    return new_obj;
};
TemplateUtils.convertAngleMoreThan360=function(deg){
	if(deg < 0)
	{
		deg = deg + 360;
	}
	else if(deg > 0)
	{
		deg = deg % 360;
	}
	return deg;
};
TemplateUtils.getDigitalClockJsonData=function(){
    digClkLangJSONObj=null;

    $.ajax({
        type: "GET",
        url: "../resource/JSON/CCRSSDatesMultilingualInfo.json",
        dataType: "json",
        async:true,
        success: function(json) {
            digClkLangJSONObj=json;
            console.log(" && digClkLangJSONObj - > "+ JSON.stringify(digClkLangJSONObj));
        },
        error:function(jqXHR, textStatus, errorThrown)
        {
            console.log(textStatus + " :: "+ errorThrown,"getDigitalClockJsonData");
        }
    });
};
TemplateUtils.processDigClkJSONFillData=function(langIndex, format, timeInfo){
    var lang = digitalClockLanguage[langIndex].id;

    var digClockDayTimeArr = digClkLangJSONObj.rssdates;
    var sunday, index=0, format;
    var hr, min, sec, ampm, day;

    hr = timeInfo.substring(0, timeInfo.indexOf(':'));
    min = timeInfo.substring(timeInfo.indexOf(':')+1 , timeInfo.indexOf(':')+3);

    switch(format){
        case digiClokType.HM12_AMPM:
            ampm = timeInfo.substring(timeInfo.indexOf(" ") + 1);
            timeInfo = digClockDayTimeArr[lang][ampm].replace("<<A>>",hr+":"+min);
        break;
        case digiClokType.HM12_AMPM_DOW:
            ampm = timeInfo.substring(timeInfo.indexOf(" ") + 1, timeInfo.lastIndexOf(" "));
            day = timeInfo.substring(timeInfo.lastIndexOf(" ") + 1).toLowerCase();
            timeInfo = digClockDayTimeArr[lang][ampm].replace("<<A>>",hr+":"+min) + " " + digClockDayTimeArr[lang][day];
        break;
        case digiClokType.HM24_DOW:
            day = timeInfo.substring(timeInfo.lastIndexOf(" ") + 1).toLowerCase();
            timeInfo = hr + ":" + min + " " + digClockDayTimeArr[lang][day];
        break;
        case digiClokType.HMS24_DOW:
            sec = timeInfo.substring(timeInfo.lastIndexOf(':')+1 , timeInfo.lastIndexOf(':')+3);
            day = timeInfo.substring(timeInfo.lastIndexOf(" ") + 1).toLowerCase();
            timeInfo = hr + ":" + min + ":" + sec + " " + digClockDayTimeArr[lang][day];
        break;
        default:
        break;
    }
    return timeInfo;
};
TemplateUtils.shiftValue=function(pValue)
{
	pValue=pValue>>1;
	return pValue<<1;
};

/*Method to check if the element is inside the mainframe or not. It takes care of the rotation*/
TemplateUtils.isElmInsideMainFrame=function(currObj)
{
	var curElm = currObj.mainFrameSelElmObj;
	var rotatedPointsArr = utilR.getClkwisTranforRotatedPointsArrOfElmnt(curElm);
	var mainFrameObj = currObj.mainFrame;
	var i,mainFrameDummyObj ={x:mainFrameObj.x,y:mainFrameObj.y,w:mainFrameObj.w,h:mainFrameObj.h,rotation:mainFrameObj.rotation};
	for(i=0;i<4;i++)
	{
		rotatedPointsArr[i].x+=mainFrameObj.x;
		rotatedPointsArr[i].y+=mainFrameObj.y;
		if(!utilR.pointInsideRectWithOutScale(mainFrameDummyObj,rotatedPointsArr[i]))
		{
			return false;
		}

    }
    return true;
};

/*Method to check if an element exist in canvas or not*/
TemplateUtils.isElementExistInDOM = function(elementId)
{
	return($("#" + elementId).length > 0);
};
/*Function to set rgb color and opacity for element from rgba color, user need to send element property name along with element object*/
TemplateUtils.setColorandAlphaForElement=function(elmObj,val,colorPropertyName,alphaPropertyName)
{
    if(val)
    {
        if(val.indexOf("rgba(")!=-1)
        {
            val=val.replace("rgba(","").replace(")","").split(",");
            elmObj[colorPropertyName]='rgb('+val[0]+','+val[1]+','+val[2]+')';
            elmObj[alphaPropertyName]=opctyToPrsntNvisVrsa(val[3]);
        }
        else
        {
            elmObj[colorPropertyName]=val;
        }
    }
};
/*Function to create rgba color from element object, user need tp pass color and alpha propery name*/
TemplateUtils.getRgbaForElementObject=function(elmObj,colorPropertyName,alphaPropertyName)
{
	var color = elmObj[colorPropertyName];
	var alpha = elmObj[alphaPropertyName];
	var val;
	val = color.replace("rgb(","").replace(")","").split(",");
	if(alpha == undefined || alpha == ""){
		alpha = 0;
	}
	alpha = opctyToPrsntNvisVrsa(alpha, true);
	return ('rgba('+val[0]+','+val[1]+','+val[2]+','+alpha+')');
};
TemplateUtils.getValueBtwn0to100=function(val)
{
    val=getParseIntInDec(val);
    if(isNaN(val))
    {
        val=0;
    }
    else if(val>100)
    {
        val=100;
    }
    return val;
};