/**
 * @filename UploadTemplate.js
 *
 * Modified by p.menaria 16-02-2015
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

var LFDFilePathAfterRoot;
var contentsFolderpath;
var sdcardFullPath;
var ContentObj;
var templateFlag;
var pathToWriteLFD;
var uploadContentFileId="";
var BGImageFilePath = "";
var playerToCreateJson = TIZEN_MODEL;
var plyrExt = EXT_TIZEN;
var LFD_EXT = ".LFD";

function uploadTemplate(LFDfilePathWithFileId,pathToSaveLFD){
    if(LOWER_PLAYER_TYPE_SUPPORT){
	    resetUploadTemplateVariables();
	}else{
        playerToCreateJson = Utils.getActivePlayerType();
	}
	console.log("<--- uploadTemplate1 "+LFDfilePathWithFileId + "pathToSaveLFD"+pathToSaveLFD);
	if(LFDfilePathWithFileId.indexOf(".ETabletAuthor/RHE")< 0 && LFDfilePathWithFileId.indexOf(".ETabletAuthor/RMD") <0 
		&& LFDfilePathWithFileId.indexOf(".ETabletAuthor/TIZEN")<0)
	{		
		LFDfilePathWithFileId=LFDfilePathWithFileId.replace(".ETabletAuthor",".ETabletAuthor/RHE");
	}	
	var lfdUploadPathArr=new Array();
	lfdUploadPathArr = LFDfilePathWithFileId.split("|");
	console.log("uploadTemplate"+lfdUploadPathArr[2].indexOf(".ETabletAuthor/RHE")+" lfdUploadPathArr[2]"+ lfdUploadPathArr[2]);
	
	console.log("<--- uploadTemplate2"+lfdUploadPathArr[2]);
	uploadContentFileId=lfdUploadPathArr[0]+"|"+lfdUploadPathArr[1]+"|";
	/*if(Utils.isIOSDvice()){
	       var LFDfilePath = lfdUploadPathArr[lfdUploadPathArr.length-1].replace("/private","");
	}else{*/
		var LFDfilePath = lfdUploadPathArr[lfdUploadPathArr.length-1];
		
	//}
	var LFDFileName = LFDfilePath.substring(LFDfilePath.lastIndexOf('/')+1);
	
	LFDFileName = modifyLfdFileNameAccToPlayer(LFDFileName);
	//LFDfilePath = modifyLfdFilePathAccToPlayer(LFDfilePath, LFDFileName);
		
	console.log("<--- uploadTemplate8 LFDFileName "+ LFDFileName+" LFDfilePath " + LFDfilePath);
	
	if(pathToSaveLFD != ""){
		pathToWriteLFD = pathToSaveLFD + LFDFileName;
	}
	
	templateFlag = UPLOAD_TEMPLATE;
	//UPLOAD LFD IMAGE
    
    addContentArr.push(LFDfilePathWithFileId.replace('file://', "") +".PNG");
	
	readLFDFileToUpload(LFDfilePath);
}
function resetUploadTemplateVariables(){
	uploadContentFileId="";
	BGImageFilePath = "";
	var temp = addContentArr[0];
	addContentArr = [];
	addContentArr[0] = temp;
	
	console.log("uploadtemplate reset addContentArr "+ addContentArr);
	playerToCreateJson = uploadJsonCount;
	switch(uploadJsonCount){
		case 1:
            plyrExt = EXT_RMD;
	    break;
		case 2:
			plyrExt = EXT_RHE;
		break;
		case 3:
			plyrExt = EXT_STRETCH;
		break;
		case 4:
            plyrExt = EXT_TIZEN;
        break;
        case 5:
            plyrExt = EXT_TIZEN_S5;
        break;
		case 6:
			plyrExt = EXT_TIZEN_S6;
		break;
		default:
		break;
    }
}
function modifyLfdFileNameAccToPlayer(name){	
    if(LOWER_PLAYER_TYPE_SUPPORT){
        // add player extension at end of lfd file name
        name = name.replace(LFD_EXT,"") + plyrExt + LFD_EXT;
    }
	console.log("uploadTemplate name "+name);
	return name;
}
/*function modifyLfdFilePathAccToPlayer(path,name){	
	path = path.substring(0, path.lastIndexOf('/') + 1) + name;
	console.log("uploadTemplate path "+path);
	return path;
}*/
function readLFDFileToUpload(LFDfilePath){
		
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
 	function (fileSystem) {
 		sdcardFullPath = fileSystem.root.toURL().replace("file://",""); 	
 		addContentArr.push(uploadContentFileId + sdcardFullPath + pathToWriteLFD);
        if (Utils.isIOSDvice()) {
            LFDFilePathAfterRoot = LFDfilePath.replace(sdcardFullPath,"");
        }else{
 		LFDFilePathAfterRoot = LFDfilePath.replace(sdcardFullPath,"");
        }
		contentsFolderpath = LFDfilePath.slice(0,LFDfilePath.lastIndexOf("/"));			
    	fileSystem.root.getFile(LFDFilePathAfterRoot, null, gotUploadLFDEntry, failUploadLFDEntry);
	},
	failUploadLFDEntry);	
}
function gotUploadLFDEntry(fileEntry){
    fileEntry.file(gotLFDFileToUpload, failUploadLFDEntry);
}
function gotLFDFileToUpload(file){
    readUploadLFDAsText(file);
}
function readUploadLFDAsText(file) {
    var reader = new FileReader();
    reader.onloadend = function(evt) {                
		ContentObj = Content.init(evt.target.result);
		createUploadArray();   		
    };
    reader.readAsText(file);
}
function failUploadLFDEntry(evt) {
    console.log(evt.target.error.code);
}

//Get file name from path
function retrieveFileName(path) {
	var temp;
	if(path!=undefined && path!=""){
		temp = path.substring(path.lastIndexOf('/') + 1);
    	return temp;
	}else{
		return path;
	}	
}

function createUploadArray(){
	var groupCount = ContentObj.Page[1].Group.length;
	var activePlayerType = Utils.getActivePlayerType();
	//rearrange group array to keep all videos assuming that the frame with video with sound is on top	
	if(!Utils.isHighEndModel(activePlayerType))
	{
	  	if(ContentObj.Page[1].Group[0].Video.length > 0 && ContentObj.Page[1].Group[0].Video[0].MovieMute == "False"){
	  		tempGrp = ContentObj.Page[1].Group[0];
	  		
	  		for(var j = 0; j < groupCount ; j++){
	  			if(j == groupCount-1){
	  				ContentObj.Page[1].Group[j] = tempGrp;  				
	  			}else if(ContentObj.Page[1].Group[j+1].Video.length > 0 || ContentObj.Page[1].Group[j+1].InputSource.length > 0){
	  				ContentObj.Page[1].Group[j] = tempGrp;
	  				break;
	  			}else{
	  				ContentObj.Page[1].Group[j] = ContentObj.Page[1].Group[j+1];
	  			} 
	 		}	  		
	  	}else if(ContentObj.Page[1].Group[0].InputSource.length > 0 && ContentObj.Page[1].Group[0].InputSource[0].Sound == 1){
	  		tempGrp = ContentObj.Page[1].Group[0];
	  		
	  		for(var k = 0; k < groupCount ; k++){
	  			if(k == groupCount-1){
	  				ContentObj.Page[1].Group[k] = tempGrp;  				
	  			}else if(ContentObj.Page[1].Group[k+1].Video.length > 0 || ContentObj.Page[1].Group[k+1].InputSource.length > 0){
	  				ContentObj.Page[1].Group[k] = tempGrp;
	  				break;
	  			}else{
	  				ContentObj.Page[1].Group[k] = ContentObj.Page[1].Group[k+1];
	  			} 
	 		}	  		
	  	}   	
	
	}
    var absoluteFilePath = "";
    //UPLOAD IMAGE FILES
    for(var i =0; i<groupCount; i++){
    	var grpObj = ContentObj.Page[1].Group[i];
    	var imageCount = grpObj.Image.length;
    	var videoCount = grpObj.Video.length;
    	var textCount = grpObj.Text.length;
    	var stickerCount = grpObj.Sticker.length;
    	var pptCount = grpObj.Office.length;
    	var pdfCount = grpObj.Pdf.length;
    	var soundCount = grpObj.Sound.length;
    	var shapeCount = grpObj.Shapes.length;
    	var analogClockCount = grpObj.AnalogClock.length;
    	var imgObj; 
		for(var j =0; j<imageCount; j++){
        	var croppedImagePath = "";        	
			imgObj = grpObj.Image[j];
            absoluteFilePath = imgObj.OriginalPath;            
            if(imgObj.IsMutable == "true"){//Normal Image
				if(playerToCreateJson !=RMD_MODEL){
					recalculateSizeBeforeUpload(imgObj);	
				}				
				
				if (Utils.isIOSDvice()) {
		            if(playerToCreateJson ==RMD_MODEL && (imgObj.Rotation != 0 || imgObj.ClipLeft!=0 || imgObj.ClipRight!=0 || imgObj.ClipTop!=0 || imgObj.ClipBottom!=0) ){
		            	croppedImagePath = imgObj.CroppedImagePath;
		            	imgObj.FilePath = croppedImagePath;
			            imgObj.NT14_FilePath = croppedImagePath;
			            absoluteFilePath = contentsFolderpath + "/ImageOp/"+ croppedImagePath; // Rotated and cropepd image will be placed in respective ImageOp folder
	               	}
				} else{
	                imgObj.FilePath = retrieveFileName(absoluteFilePath) ;
		                if(playerToCreateJson ==RMD_MODEL && (imgObj.Rotation != 0 || imgObj.ClipLeft!=0 || imgObj.ClipRight!=0 || imgObj.ClipTop!=0 || imgObj.ClipBottom!=0) ){
			               	croppedImagePath = imgObj.CroppedImagePath;
			               	imgObj.FilePath = croppedImagePath;
			            	imgObj.NT14_FilePath = croppedImagePath;			            	
			                absoluteFilePath = contentsFolderpath + "/ImageOp/" + croppedImagePath; // Rotated and cropepd image will be placed in respective ImageOp folder
	                }
            	}
            }else{// DECO_IMAGE
            	console.log("Deco image upload absoluteFilePath = "+absoluteFilePath);
            	if(absoluteFilePath.indexOf("FreeTemplates/Embedded") != -1){ // If Deco image path contains FreeTemplates/Embedded it should be taken from contents folder path
            		absoluteFilePath = contentsFolderpath + "/" +retrieveFileName(absoluteFilePath);
            	}
            	var orientation = getTemplateOrientation(retrieveFileName(contentsFolderpath) + LFD_EXT);			
            	if(playerToCreateJson == RMD_MODEL && orientation == "portrait" && absoluteFilePath.indexOf("/Spen/")!=-1){
            		absoluteFilePath = contentsFolderpath + "/ImageOp/"+ retrieveFileName(absoluteFilePath);
            	}
            }
            //Check for duplicate files            
            absoluteFilePath = renameDuplicateFiles(absoluteFilePath,imgObj.FilePath);
            if(playerToCreateJson ==RMD_MODEL){
            	imgObj.NT14_FilePath = imgObj.FilePath;
            }            
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		absoluteFilePath = "";
		
		//UPLOAD VIDEO FILES
		var vidObj; 
		for(var j=0; j<videoCount; j++){
			vidObj = grpObj.Video[j];
			absoluteFilePath = vidObj.OriginalPath;
			if (Utils.isIOSDvice()) {
                vidObj.FilePath = vidObj.FileName;
            } else{
                vidObj.FilePath = retrieveFileName(absoluteFilePath);
            }
            //Check for duplicate files            
            absoluteFilePath = renameDuplicateFiles(absoluteFilePath,vidObj.FilePath);
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		
		absoluteFilePath = "";
		
		//UPLOAD Shapes FILES
		var shapeObj; 
		for(var j=0; j<shapeCount; j++){
			shapeObj = grpObj.Shapes[j];
			absoluteFilePath = shapeObj.OriginalImage;
			absoluteFilePath = renameDuplicateFiles(absoluteFilePath,shapeObj.ImageFilePath);
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		
		
		absoluteFilePath = "";
		//UPLOAD TEXT FILES
		var contTxtObj;
		for(var j=0; j<textCount; j++){	
			contTxtObj = grpObj.Text[j];
			var fontFilePath = contTxtObj.TextFontFile;
			contTxtObj.TextFontFile = retrieveFileName(fontFilePath);
			if(Utils.isHighEndModel(playerToCreateJson))
			{
				if(fontFilePath!=undefined && fontFilePath!="" && addContentArr.indexOf(uploadContentFileId + fontFilePath)==-1)
				{
					addContentArr.push(uploadContentFileId + fontFilePath);	
				}
				contTxtObj.TextImage = "";
				contTxtObj.TextImageFile = "";	
			}
			else
			{
				if(contTxtObj.TextDirection==0){											
					if(playerToCreateJson == RMD_MODEL && contTxtObj.NT14_TextImage!=""){	   
						absoluteFilePath = contentsFolderpath+"/ImageOp/"+ contTxtObj.NT14_TextImage;
					}else{
						absoluteFilePath = contentsFolderpath+"/"+ contTxtObj.TextImage;
					}			
					if(absoluteFilePath!=undefined && absoluteFilePath!=""){
						addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
					}
					
				}else{				
					contTxtObj.TextImage = "";
					contTxtObj.TextImageFile = "";				
					if(playerToCreateJson ==RMD_MODEL){	   
						 contTxtObj.NT14_TextImage="";
						 contTxtObj.NT14_TextImageFile = "";
					}
				}
			}
			if(contTxtObj != null){
                contTxtObj.TextHTML =  getTextHtml(contTxtObj);
            }
		}
		
		absoluteFilePath = "";
		//UPLOAD STICKER FILES
		var stkrObj;
		for(var j=0; j<stickerCount; j++){	
			stkrObj = grpObj.Sticker[j];
			if(stkrObj.OriginalPath.indexOf("/Spen/") == -1){
				absoluteFilePath = contentsFolderpath+"/"+retrieveFileName(stkrObj.EndStateBitmap);
			}else{
				absoluteFilePath = stkrObj.OriginalPath;
			}			
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		absoluteFilePath = "";
		//UPLOAD PPT FILES
		for(var j=0; j<pptCount; j++){	
			absoluteFilePath = grpObj.Office[j].OriginalPath;	
			 //Check for duplicate files            
            absoluteFilePath = renameDuplicateFiles(absoluteFilePath, absoluteFilePath);		
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		absoluteFilePath = "";
		//UPLOAD PDF FILES
		for(var j=0; j<pdfCount; j++){	
			absoluteFilePath = grpObj.Pdf[j].OriginalPath;			
			//Check for duplicate files            
            absoluteFilePath = renameDuplicateFiles(absoluteFilePath, absoluteFilePath);		
			if(absoluteFilePath!=undefined && absoluteFilePath!=""){
				addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
			}
		}
		absoluteFilePath = "";
		//UPLOAD SOUND FILES
		for(var j=0; j<soundCount; j++){	
			absoluteFilePath = grpObj.Sound[j].OriginalPath;			
			var soundFileName = grpObj.Sound[j].FilePath;
			if(absoluteFilePath!=undefined && absoluteFilePath != ""){
			    if(Utils.isIOSDvice()){
             		addContentArr.push(uploadContentFileId + absoluteFilePath +"|"+soundFileName);
	            }else{
	            	addContentArr.push(uploadContentFileId + absoluteFilePath.replace('file://', ""));
	            }
			}
		}
		//UPLOAD ANALOG CLOCK FILES
		var analogClkObj;
		for(var j=0; j<analogClockCount; j++){	
			analogClkObj = grpObj.AnalogClock[j];
			var backImg = analogClkObj.ClockBackImage;
			var hrImg = analogClkObj.ClockHourImage;
			var minImg = analogClkObj.ClockMinuteImage;
			var secImg = analogClkObj.ClockSecondImage;
			if(backImg!=undefined && backImg!=""){
				addContentArr.push(uploadContentFileId + contentsFolderpath+"/"+ backImg);
			}
			if(hrImg!=undefined && hrImg!=""){
				addContentArr.push(uploadContentFileId + contentsFolderpath+"/"+ hrImg);
			}
			if(minImg!=undefined && minImg!=""){
				addContentArr.push(uploadContentFileId + contentsFolderpath+"/"+ minImg);
			}
			if(secImg!=undefined && secImg!=""){
				addContentArr.push(uploadContentFileId + contentsFolderpath+"/"+ secImg);
			}
		}
	}
	//UPLOAD BACKGROUND FILE
	BGImageFilePath = ContentObj.Page[1].BGImageOriginalPath;
	if(BGImageFilePath == undefined || BGImageFilePath == ""){
		BGImageFilePath = ContentObj.Page[0].BGImageOriginalPath; //If BG image not found in page[1] tag search in page[0]
	}
	if(BGImageFilePath!=undefined && BGImageFilePath != ""){
		
		if(playerToCreateJson ==RMD_MODEL){
			var orientation = getTemplateOrientation(retrieveFileName(contentsFolderpath) + LFD_EXT);			
			if(orientation == "portrait"){ // For Portrait type RMD Template
				BGImageFilePath = contentsFolderpath+"/ImageOp/"+ retrieveFileName(BGImageFilePath);
			}
		}	
		// If bg image path contains FreeTemplates/Embedded it should be taken from contents folder path	
    	if(BGImageFilePath.indexOf("FreeTemplates/Embedded") != -1){ 
    		BGImageFilePath = contentsFolderpath + "/" +retrieveFileName(BGImageFilePath);
    	}
		addContentArr.push(uploadContentFileId + BGImageFilePath.replace('file://', ""));	
	}
	//UPLOAD BACKGROUND MUSIC FILE
	/*var BGMusicFileFullPath = ContentObj.BGMusicFileFullPath;	
	if(BGMusicFileFullPath!=undefined && BGMusicFileFullPath != "" && ContentObj.SelectedAudioVideo=="AUDIO"){
		if(ContentObj.SelectedAudioVideo == "AUDIO" || ContentObj.AudioMute == "false")
        {
            if(Utils.isIOSDvice()){
                addContentArr.push(uploadContentFileId + BGMusicFileFullPath +"|"+ContentObj.BGMusicFilePath);
            }else{
                addContentArr.push(uploadContentFileId + BGMusicFileFullPath.replace('file://', ""));
            }
		}	
	}*/	
	console.log("addContentArr "+addContentArr);	
    if(LOWER_PLAYER_TYPE_SUPPORT){
        switch(uploadJsonCount){
            case 1:
                addContentToCorrespondingPlayerArr(addContentArr_E);
            break;
            case 2:
                addContentToCorrespondingPlayerArr(addContentArr_S3);
            break;
            case 3:
                addContentToCorrespondingPlayerArr(addContentArr_S3);
            break;
            case 4:
                addContentToCorrespondingPlayerArr(addContentArr_S4);
            break;
            case 5:
                addContentToCorrespondingPlayerArr(addContentArr_S5);
            break;
            case 6:
                addContentToCorrespondingPlayerArr(addContentArr_S6);
            break;
            default:
            break;
        }
    }
	LfdContent.sendContent(ContentObj,null); //save data to LFD file
}
function addContentToCorrespondingPlayerArr(playrArr){
    var arrLen = addContentArr.length;
    for(var i=0; i<arrLen; i++){
        if($.inArray(addContentArr[i], playrArr) == -1){
            playrArr.push(addContentArr[i]);
        }
    }
}
function getTemplateOrientation(templateName){
	var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
	var templateLength = templateInfo.myTemplateInfoArrs.length;
	for (var i=0; i<templateLength; i++) {
		if(templateInfo.myTemplateInfoArrs[i].templateName == templateName){			
			return templateInfo.myTemplateInfoArrs[i].orientationType;
		}
	}
}
function renameDuplicateFiles(absoluteFilePath1,contObjFilePath){
	if(absoluteFilePath1==undefined || absoluteFilePath1==""  || contObjFilePath==undefined || contObjFilePath=="" ){
		return "";
	}
    var fileName = contObjFilePath;//retrieveFileName(absoluteFilePath1);
    var fileExt = fileName.substring(fileName.lastIndexOf('.'));
    if(fileName!="" && addContentArr.indexOf(uploadContentFileId + absoluteFilePath1)!=-1){            	
    	var randomNo = Math.floor((Math.random() * 1000) + 1);
    	fileName = fileName.replace(fileExt,"") + "_" + randomNo +fileExt;    	
    	contObjFilePath = fileName;    	
    	absoluteFilePath1 = absoluteFilePath1+"|"+fileName;
    }
    return absoluteFilePath1;
}
function recalculateSizeBeforeUpload(contImageObj){
	var rotation = contImageObj.Rotation;
	if (rotation == 90 || rotation == 270) {
	    var tmpVal = contImageObj.Width;
	    
	    contImageObj.Width = parseInt(contImageObj.Height);
	    contImageObj.Height = parseInt(tmpVal);
	    
	    var w = parseInt(contImageObj.Width);
	    var h = parseInt(contImageObj.Height);
	    var x = parseInt(contImageObj.PositionX);
	    var y = parseInt(contImageObj.PositionY);
	    
	    var diffRatio = (w - h) / 2;
	    contImageObj.PositionX  = x - diffRatio;
	    contImageObj.PositionY  = y + diffRatio;	    
	}
}
function getTextHtml(tmpTxtObj){
    var privateKey = "#VX#VEY#VXXR#";
	var text = $.trim(tmpTxtObj.TextValue.replace(/&nbsp;/ig,""));
	text=Utils.replaceLastBrOfText(text);
	var textLines=text.split("<br>");
	var txtArrLen=textLines.length;
	var finalTextStr='';
	var tempStr = '',hexFirstPart,hex,i;
	for(i=0;i<txtArrLen;i++)
	{
		if(i==0){
			tempStr = textLines[i];
		}else{
		    hexFirstPart  = Number(textLines[i].charCodeAt(0)).toString(16);
			if(hexFirstPart != "a"){
			    hex = Utils.ascii_to_hexa(textLines[i], privateKey);
				tempStr = Utils.hex_to_ascii("0D"+ privateKey+"0A"+ privateKey + hex, privateKey);
				if(hex=="")
				{
				    tempStr = tempStr.substr(0,2);
				}
			}else{
				tempStr = textLines[i];
			}
		}
		finalTextStr = finalTextStr + '<p align="'+ setHorVerAlignFrmContentToTemp(tmpTxtObj.TextHAlign, true) +'">'+ tempStr;
	}
	finalTextStr = '<font face="'+tmpTxtObj.Textface+'" color="'+ changeToRgb(tmpTxtObj.TextColor) +'" size="'+ tmpTxtObj.TextFontSize+'">'+finalTextStr+'</font>';

	return finalTextStr;
}
/*Will change "255;0;255" to "rgb(255,0,255)"*/
function changeToRgb(bgColor){
	if(bgColor == undefined || bgColor == ""){
		return bgColor;
	}
	bgColor = bgColor.replace(/;/g, ",");
	bgColor = "rgb("+bgColor+")";
	return bgColor;
};
function setHorVerAlignFrmContentToTemp(alignId,isHor)
{
	var retStr="";
	if(isHor)
	{
		retStr = "left";
		if(alignId == 1){
			retStr = "center";
		}else if(alignId == 2){
			retStr = "right";
		}
	}
	else
	{
		retStr = "top";
		if(alignId == 1){
			retStr = "middle";
		}else if(alignId == 2){
			retStr = "bottom";
		}
	}
	return retStr;
}