function Shapes_Array()
{
	Name: null;
	typeName:null;
	MotionPathPoints:null;
	Layer:null;
	PinnedPointNameList:null;
	GlobalElement:false;
	PositionX: null;
	PositionY: null;
	Width: null;
	Height: null;
	ConfigName: null;
	IsVisible:null;
	GlobalDisplayPriority:null;
	GlobalPlayPolicy:null;
	DurationPolicy:null;
	Start:null;
	Duration:null;
	RepeatPeriod:null;
	RepeatEnd:null;
	InterpolationType:null;
	EventEnable:null;
	EffectInName:null;
	EffectInDuration:null;
	EffectInDirection:null;
	EffectInRepeatPolicy:null;
	EffectInRepeatPeriod:null;
	EffectInRepeatCount:null;
	EffectOutName:null;
	EffectOutDuration:null;
	EffectOutDirection:null;
	AuthorAreaFix:null;
	AuthorPreView:null;
	DesignCanvasVisible:null;
	//FigureRoundRatio:null;
    LineColor:null;
    FigureStrokeOpacity:null;
    FigureStrokeWidth:null;
    FigureStrokePattern:null;
    FillColor:null;
    FigureGrFillMode:null;
    FigureGrLineDirection:null;
    OrginalWidth:null;
    FigureGrPathDirection:null;
    OriginalHeight:null;
    FigureGrStartColor:null;
    FigureGrEndColor:null;
    ClipLeft:null;
    ClipRight:null;
    ClipTop:null;
    ClipBottom:null;
    FillOpacity:null;
    FillRange:null;
    OffsetLeft:null;
    OffsetRight:null;
    OffsetTop:null;
    OffsetBottom:null;
    ImageFilePath:null;
    ImageRatio:0;
    Reflection:null;
    Rotation:null;
    FillRange:null;
    ImageFilePath:null;
    thumbPath:null;
    OriginalImage:null;
    scale:null;
    thumbOrgW:null;
	thumbOrgH:null;
}


function addSpecificParaToShape(shapeArr,type)
{
	log.debug("FunctionIn: addSpecificParaToShape "+" shapeArr: "+ shapeArr + " type: "+ type);
	switch(type)
	{
		case shapeInfo.RECT:
			shapeArr.FigureRoundRatio=null;
		break;
		case shapeInfo.PARLGRM:
		case shapeInfo.TRPZOID:
			shapeArr.Slope=null;
		break;
		case shapeInfo.FRAME:
			shapeArr.FrameWidth=null;
		break;
		case shapeInfo.TRI:
			shapeArr.ApexRatio=null;
		break;
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:
			shapeArr.elementName=null;
			shapeArr.ArrowHeadLength=null;
			shapeArr.ArrowBodyWidth=null;
		break;
		case shapeInfo.FOLDEDCOR:
			shapeArr.FoldedRatio=null;
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:
			shapeArr.StartWidth=null;
			shapeArr.elementName=null;
		break;
		case shapeInfo.PENTGN:
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:
			shapeArr.elementName=null;
			shapeArr.PolygonWidth=null;
		break;
		case shapeInfo.LINE:
			shapeArr.BendingType=null;
		break;
		case shapeInfo.DONUT:
			shapeArr.DonutWidth=null;
		break;
		case shapeInfo.CROSS:
			shapeArr.BarWidth=null;
		break;
		case shapeInfo.SUN:
			shapeArr.EllipseSize=null;
		break;
		case shapeInfo.ARC:
			shapeArr.StartAngle=null;
			shapeArr.EndAngle=null;
		break;
		case shapeInfo.WAVE:
			shapeArr.CurvedRatio=null;
			shapeArr.elementName=null;
			shapeArr.HorizontalSlope=null;
		break;
		case shapeInfo.LEFTBRACE:
		case shapeInfo.RIGHTBRACE:
			shapeArr.VertexPosition=null;
			shapeArr.RoundCornerRatio=null;
			shapeArr.elementName=null;
		break;
		case shapeInfo.RECTCAL:
            shapeArr.HandleRatio_X = null;
            shapeArr.HandleRatio_Y = null;
            shapeArr.RectX1 = null;
            shapeArr.RectY1 = null;
            shapeArr.RectX2 = null;
            shapeArr.RectY2 = null;
            shapeArr.RoundedCorner = null;
        break;
		default:
		break;
		
	}
	log.debug("FunctionOut: addSpecificParaToShape");
}


function fillSpecificParaToShapeContObj(type,contShapesObj,tmpShapesObj)
{
	log.debug("FunctionIn: fillSpecificParaToShapeContObj "+" type: "+ type + " contShapesObj: "+ contShapesObj + " tmpShapesObj: "+ tmpShapesObj);
	switch(type)
	{
		case shapeInfo.RECT:
			contShapesObj.FigureRoundRatio=tmpShapesObj.FigureRoundRatio;
		break;
		case shapeInfo.PARLGRM:
		case shapeInfo.TRPZOID:
			contShapesObj.Slope=tmpShapesObj.Slope;
		break;
		case shapeInfo.FRAME:
			contShapesObj.FrameWidth=tmpShapesObj.FrameWidth;
		break;
		case shapeInfo.TRI:
			contShapesObj.ApexRatio=tmpShapesObj.ApexRatio;
		break;
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:
			contShapesObj.elementName=tmpShapesObj.elementName;
			contShapesObj.ArrowHeadLength=tmpShapesObj.ylowPts[0].x;
			contShapesObj.ArrowBodyWidth=tmpShapesObj.ylowPts[0].y;
		break;
		case shapeInfo.FOLDEDCOR:
			contShapesObj.FoldedRatio=tmpShapesObj.FoldedRatio;
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:
			contShapesObj.StartWidth=tmpShapesObj.StartWidth;
			contShapesObj.elementName=tmpShapesObj.elementName;
		break;
		case shapeInfo.PENTGN:
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:
			contShapesObj.elementName=tmpShapesObj.elementName;
			contShapesObj.PolygonWidth=tmpShapesObj.PolygonWidth;
		break;
		case shapeInfo.LINE:
			contShapesObj.BendingType=tmpShapesObj.BendingType;
		break;
		case shapeInfo.DONUT:
			contShapesObj.DonutWidth=tmpShapesObj.DonutWidth;
		break;
		case shapeInfo.CROSS:
			contShapesObj.BarWidth=tmpShapesObj.BarWidth;
		break;
		case shapeInfo.SUN:
			contShapesObj.EllipseSize=tmpShapesObj.EllipseSize;
		break;
		case shapeInfo.ARC:
			contShapesObj.EndAngle=tmpShapesObj.EndAngle;
			contShapesObj.StartAngle=tmpShapesObj.StartAngle;
		break;
		case shapeInfo.WAVE:
			contShapesObj.CurvedRatio=tmpShapesObj.CurvedRatio;
			contShapesObj.elementName=tmpShapesObj.elementName;
			contShapesObj.HorizontalSlope=tmpShapesObj.HorizontalSlope;
		break;
		case shapeInfo.LEFTBRACE:
		case shapeInfo.RIGHTBRACE:
			contShapesObj.VertexPosition=tmpShapesObj.VertexPosition;
			contShapesObj.RoundCornerRatio=tmpShapesObj.RoundCornerRatio;
			contShapesObj.elementName=tmpShapesObj.elementName;
		break;
		case shapeInfo.RECTCAL:
		    if (tmpShapesObj.CalloutPoint != null && tmpShapesObj.CalloutPoint != undefined) {
		        contShapesObj.HandleRatio_X = tmpShapesObj.CalloutPoint.x;
                contShapesObj.HandleRatio_Y = tmpShapesObj.CalloutPoint.y;
                contShapesObj.RectX1 = tmpShapesObj.InnerRect.x;
                contShapesObj.RectY1 = tmpShapesObj.InnerRect.y;
                contShapesObj.RectX2 = tmpShapesObj.InnerRect.w; // convert to exact
                contShapesObj.RectY2 = tmpShapesObj.InnerRect.h; // pixels while uploading template
                contShapesObj.RoundedCorner = tmpShapesObj.FigureRoundRatio;
                contShapesObj.CalloutDirection = tmpShapesObj.CalloutPoint.direction;
		    } else {
		        contShapesObj.CalloutPoint.x = tmpShapesObj.HandleRatio_X;
                contShapesObj.CalloutPoint.y = tmpShapesObj.HandleRatio_Y;
                contShapesObj.InnerRect.x = tmpShapesObj.RectX1;
                contShapesObj.InnerRect.y = tmpShapesObj.RectY1;
                contShapesObj.InnerRect.w = tmpShapesObj.RectX2;
                contShapesObj.InnerRect.h = tmpShapesObj.RectY2;
                contShapesObj.FigureRoundRatio = tmpShapesObj.RoundedCorner;
                contShapesObj.CalloutPoint.direction = tmpShapesObj.CalloutDirection;
		    }
		break;
		default:
		break;
		
	}
	log.debug("FunctionOut: fillSpecificParaToShapeContObj");
		
}
function fillSpecificParaToShapeTemObj(type,contShapesObj,tmpShapesObj)
{
	log.debug("FunctionIn: fillSpecificParaToShapeTemObj "+" type: "+ type + " contShapesObj: "+ contShapesObj + " tmpShapesObj: "+ tmpShapesObj);
	switch(type)
	{
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:
			tmpShapesObj.elementName=parseInt(contShapesObj.elementName,10);
			tmpShapesObj.ylowPts[0].x=contShapesObj.ArrowHeadLength;
			tmpShapesObj.ylowPts[0].y=contShapesObj.ArrowBodyWidth;
		break;
		default:
		break;
		
	}
	log.debug("FunctionOut: fillSpecificParaToShapeTemObj");		
}
function addSpecificParaToContFromLFD (type,contShapeObj,contentElmObj)
{
	log.debug("FunctionIn: addSpecificParaToContFromLFD "+" type: "+ type + " contShapeObj: "+ contShapeObj + " contentElmObj: "+ contentElmObj );	
	switch(type)
	{
		case shapeInfo.RECT:
			contShapeObj.FigureRoundRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureRoundRatio'));
		break;
		case shapeInfo.PARLGRM:
		case shapeInfo.TRPZOID:
			contShapeObj.Slope = Utils.getCdataKeyFrameValue(contentElmObj.find('Slope'));
		break;
		case shapeInfo.FRAME:
			contShapeObj.FrameWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('FrameWidth'));
		break;
		case shapeInfo.TRI:
			contShapeObj.ApexRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('ApexRatio'));
		break;
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:
			contShapeObj.elementName = Utils.getCdataKeyFrameValue(contentElmObj.find('ArrowType'));
			contShapeObj.ArrowHeadLength = Utils.getCdataKeyFrameValue(contentElmObj.find('ArrowHeadLength'));
			contShapeObj.ArrowBodyWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('ArrowBodyWidth'));
		break;
		case shapeInfo.FOLDEDCOR:
			contShapeObj.FoldedRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('FoldedRatio'));
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:
			contShapeObj.StartWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('StartWidth'));
			contShapeObj.elementName = Utils.getCdataKeyFrameValue(contentElmObj.find('elementName'));
		break;
		case shapeInfo.PENTGN:
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:
			contShapeObj.elementName = Utils.getCdataKeyFrameValue(contentElmObj.find('elementName'));
			contShapeObj.PolygonWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('PolygonWidth'));
			
		break;
		case shapeInfo.LINE:
			contShapeObj.BendingType = Utils.getCdataKeyFrameValue(contentElmObj.find('BendingType'));
		break;
		case shapeInfo.DONUT:
			contShapeObj.DonutWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('DonutWidth'));
		break;
		case shapeInfo.CROSS:
			contShapeObj.BarWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('BarWidth'));
		break;
		case shapeInfo.SUN:
			contShapeObj.EllipseSize = Utils.getCdataKeyFrameValue(contentElmObj.find('EllipseSize'));
		break;
		case shapeInfo.ARC:
			contShapeObj.StartAngle = Utils.getCdataKeyFrameValue(contentElmObj.find('StartAngle'));
			contShapeObj.EndAngle = Utils.getCdataKeyFrameValue(contentElmObj.find('EndAngle'));
		break;
		case shapeInfo.WAVE:
			contShapeObj.CurvedRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('CurvedRatio'));
			contShapeObj.elementName = Utils.getCdataKeyFrameValue(contentElmObj.find('elementName'));
			contShapeObj.HorizontalSlope = Utils.getCdataKeyFrameValue(contentElmObj.find('HorizontalSlope'));
		break;
		case shapeInfo.LEFTBRACE:
		case shapeInfo.RIGHTBRACE:
			contShapeObj.VertexPosition = Utils.getCdataKeyFrameValue(contentElmObj.find('VertexPosition'));
			contShapeObj.elementName = Utils.getCdataKeyFrameValue(contentElmObj.find('elementName'));
			contShapeObj.RoundCornerRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('RoundCornerRatio'));
		break;
		case shapeInfo.RECTCAL:
            contShapeObj.HandleRatio_X = Utils.getCdataKeyFrameValue(contentElmObj.find('HandleRatio_X'));
            contShapeObj.HandleRatio_Y = Utils.getCdataKeyFrameValue(contentElmObj.find('HandleRatio_Y'));
            contShapeObj.RectX1 = Utils.getCdataKeyFrameValue(contentElmObj.find('RectX1'));
            contShapeObj.RectY1 = Utils.getCdataKeyFrameValue(contentElmObj.find('RectY1'));
            contShapeObj.RectX2 = Utils.getCdataKeyFrameValue(contentElmObj.find('RectX2'));
            contShapeObj.RectY2 = Utils.getCdataKeyFrameValue(contentElmObj.find('RectY2'));
            contShapeObj.RoundedCorner = Utils.getCdataKeyFrameValue(contentElmObj.find('RoundedCorner'));
            contShapeObj.CalloutDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('CalloutDirection'));
        break;
		default:
		break;
		
	}
	log.debug("FunctionOut: addSpecificParaToContFromLFD");	
}
function addSpecificParaToLFDfromCont (type,Element,LFDObject,ShapesPropertiesObj)
{
	log.debug("FunctionIn: addSpecificParaToLFDfromCont "+" type: "+ type + " Element: "+ Element + " LFDObject: "+ LFDObject + " ShapesPropertiesObj: "+ ShapesPropertiesObj);
	switch(type)
	{
		case shapeInfo.RECT:
			var FigureRoundRatio = LFD.addNode(LFDObject,'FigureRoundRatio', false, ShapesPropertiesObj.FigureRoundRatio, true, 'type', 'Number', 'time', '0');
			Element.appendChild(FigureRoundRatio);
		break;
		case shapeInfo.PARLGRM:
		case shapeInfo.TRPZOID:
			var Slope = LFD.addNode(LFDObject,'Slope', false, ShapesPropertiesObj.Slope, true, 'type', 'Number', 'time', '0');
			Element.appendChild(Slope);
		break;
		case shapeInfo.FRAME:
			var FrameWidth = LFD.addNode(LFDObject,'FrameWidth', false, ShapesPropertiesObj.FrameWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(FrameWidth);
		break;
		case shapeInfo.TRI:
			var ApexRatio = LFD.addNode(LFDObject,'ApexRatio', false, ShapesPropertiesObj.ApexRatio, true, 'type', 'Number', 'time', '0');
			Element.appendChild(ApexRatio);
		break;
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:
			var elementName = LFD.addNode(LFDObject,'ArrowType', false, ShapesPropertiesObj.elementName, true, 'type', 'List', 'time', '0');
			Element.appendChild(elementName);
			var ArrowHeadLength = LFD.addNode(LFDObject,'ArrowHeadLength', false, ShapesPropertiesObj.ArrowHeadLength, true, 'type', 'Number', 'time', '0');
			Element.appendChild(ArrowHeadLength);
			var ArrowBodyWidth = LFD.addNode(LFDObject,'ArrowBodyWidth', false, ShapesPropertiesObj.ArrowBodyWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(ArrowBodyWidth);
		break;
		case shapeInfo.FOLDEDCOR:
			var FoldedRatio = LFD.addNode(LFDObject,'FoldedRatio', false, ShapesPropertiesObj.FoldedRatio, true, 'type', 'Number', 'time', '0');
			Element.appendChild(FoldedRatio);
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:
			var StartWidth = LFD.addNode(LFDObject,'StartWidth', false, ShapesPropertiesObj.StartWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(StartWidth);
			var elementName = LFD.addNode(LFDObject,'elementName', false, ShapesPropertiesObj.elementName, true, 'type', 'List', 'time', '0');
			Element.appendChild(elementName);
		break;
		case shapeInfo.PENTGN:
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:
			var elementName = LFD.addNode(LFDObject,'elementName', false, ShapesPropertiesObj.elementName, true, 'type', 'List', 'time', '0');
			Element.appendChild(elementName);
			var PolygonWidth = LFD.addNode(LFDObject,'PolygonWidth', false, ShapesPropertiesObj.PolygonWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(PolygonWidth);
		break;
		case shapeInfo.LINE:
			var BendingType = LFD.addNode(LFDObject,'BendingType', false, ShapesPropertiesObj.BendingType, true, 'type', 'List', 'time', '0');
			Element.appendChild(BendingType);
			// no idea of what is pointliststring ... taken X,Y and X+width,Y+Height
			var pointlistString = "("+ShapesPropertiesObj.PositionX +","+ShapesPropertiesObj.PositionY 
									+")("+(ShapesPropertiesObj.PositionX+ShapesPropertiesObj.Width)+","+(ShapesPropertiesObj.PositionY+ShapesPropertiesObj.Height)+")";
			var PointList = LFD.addNode(LFDObject,'PointList', true, pointlistString, true, 'type', 'MultilineString', 'time', '0');
			Element.appendChild(PointList);
			
		break;
		case shapeInfo.DONUT:
			var DonutWidth = LFD.addNode(LFDObject,'DonutWidth', false, ShapesPropertiesObj.DonutWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(DonutWidth);
		break;
		case shapeInfo.CROSS:
			var BarWidth = LFD.addNode(LFDObject,'BarWidth', false, ShapesPropertiesObj.BarWidth, true, 'type', 'Number', 'time', '0');
			Element.appendChild(BarWidth);
		break;
		case shapeInfo.SUN:
			var EllipseSize = LFD.addNode(LFDObject,'EllipseSize', false, ShapesPropertiesObj.EllipseSize, true, 'type', 'Number', 'time', '0');
			Element.appendChild(EllipseSize);
		break;
		case shapeInfo.ARC:
		    var startAngle = getParseIntInDec(ShapesPropertiesObj.StartAngle);
		    var endAngle = getParseIntInDec(ShapesPropertiesObj.EndAngle);
		    if(templateFlag == UPLOAD_TEMPLATE) {
                if (startAngle < 0) {
                    startAngle += 360;
                }
                if (endAngle < 0) {
                    endAngle += 360;
                }
		    }
			var StartAngle = LFD.addNode(LFDObject,'StartAngle', false, startAngle, true, 'type', 'Number', 'time', '0');
			Element.appendChild(StartAngle);
			var EndAngle = LFD.addNode(LFDObject,'EndAngle', false, endAngle, true, 'type', 'Number', 'time', '0');
			Element.appendChild(EndAngle);
		break;
		case shapeInfo.WAVE:
			var CurvedRatio = LFD.addNode(LFDObject,'CurvedRatio', false, ShapesPropertiesObj.CurvedRatio, true, 'type', 'Number', 'time', '0');
			Element.appendChild(CurvedRatio);
			var elementName = LFD.addNode(LFDObject,'elementName', false, ShapesPropertiesObj.elementName, true, 'type', 'List', 'time', '0');
			Element.appendChild(elementName);
			var HorizontalSlope = LFD.addNode(LFDObject,'HorizontalSlope', false, ShapesPropertiesObj.HorizontalSlope, true, 'type', 'Number', 'time', '0');
			Element.appendChild(HorizontalSlope);
			
		break;
		case shapeInfo.LEFTBRACE:
		case shapeInfo.RIGHTBRACE:
			var VertexPosition = LFD.addNode(LFDObject,'VertexPosition', false, ShapesPropertiesObj.VertexPosition, true, 'type', 'Number', 'time', '0');
			Element.appendChild(VertexPosition);
			var elementName = LFD.addNode(LFDObject,'elementName', false, ShapesPropertiesObj.elementName, true, 'type', 'List', 'time', '0');
			Element.appendChild(elementName);
			var RoundCornerRatio = LFD.addNode(LFDObject,'RoundCornerRatio', false, ShapesPropertiesObj.RoundCornerRatio, true, 'type', 'Number', 'time', '0');
			Element.appendChild(RoundCornerRatio);
		break;
		case shapeInfo.RECTCAL:
		    var HandleRatio_X = LFD.addNode(LFDObject,'HandleRatio_X', false, ShapesPropertiesObj.HandleRatio_X, true, 'type', 'Number', 'time', '0');
            Element.appendChild(HandleRatio_X);
            var HandleRatio_Y = LFD.addNode(LFDObject,'HandleRatio_Y', false, ShapesPropertiesObj.HandleRatio_Y, true, 'type', 'Number', 'time', '0');
            Element.appendChild(HandleRatio_Y);

            var rectX1 = getParseIntInDec(ShapesPropertiesObj.RectX1);
            var rectY1 = getParseIntInDec(ShapesPropertiesObj.RectY1);
            var rectX2 = getParseIntInDec(ShapesPropertiesObj.RectX2);
            var rectY2 = getParseIntInDec(ShapesPropertiesObj.RectY2);

            if (templateFlag == UPLOAD_TEMPLATE) {
                rectX2 = rectX1 + (rectX2);
                rectY2 = rectY1 + (rectY2);
            } else {
                var CalloutDirection = LFD.addNode(LFDObject,'CalloutDirection', false, ShapesPropertiesObj.CalloutDirection, true, 'type', 'Number', 'time', '0');
                Element.appendChild(CalloutDirection);
            }

            var RectX1 = LFD.addNode(LFDObject,'RectX1', false, rectX1, true, 'type', 'Number', 'time', '0');
            Element.appendChild(RectX1);
            var RectY1 = LFD.addNode(LFDObject,'RectY1', false, rectY1, true, 'type', 'Number', 'time', '0');
            Element.appendChild(RectY1);
            var RectX2 = LFD.addNode(LFDObject,'RectX2', false, rectX2, true, 'type', 'Number', 'time', '0');
            Element.appendChild(RectX2);
            var RectY2 = LFD.addNode(LFDObject,'RectY2', false, rectY2, true, 'type', 'Number', 'time', '0');
            Element.appendChild(RectY2);
            var RoundedCorner = LFD.addNode(LFDObject,'RoundedCorner', false, ShapesPropertiesObj.RoundedCorner, true, 'type', 'Number', 'time', '0');
            Element.appendChild(RoundedCorner);
		break;
		default:
		break;
		
	}
	log.debug("FunctionOut: addSpecificParaToLFDfromCont");
}

function getShapeTypeOfSameCategory(LFDtype,elementName)
{
	log.debug("FunctionIn: getShapeTypeOfSameCategory "+" LFDtype: "+ LFDtype + " elementName: "+ elementName);
	if(elementName == undefined || isNaN(elementName))
	{
		log.debug("FunctionOut: getShapeTypeOfSameCategory");
		return parseInt(LFDShapeTypeTemplateShapeTypeMapping[LFDtype],10);
	}
	else
	{
		var categoryString = (LFDShapeTypeTemplateShapeTypeMapping[LFDtype]).toString();
		if(categoryString.indexOf('-') == -1)
		{
			return parseInt(categoryString,10);
		}
		var categoryListType = categoryString.split("-");
		var i;
		for (i = 0; i < categoryListType.length; ++i) {
		 if(shapeInfoMapping[parseInt(categoryListType[i],10)].elementName == elementName)
			{
				log.debug("FunctionOut: getShapeTypeOfSameCategory");
				return parseInt(categoryListType[i],10);
			}
		}
	}
	
}
