/* 
 * Created by veer.singh 17th Jan15
 * Modified by r.k.pandey 31th Jan15
 * Dependent Files : template.js
 */
/* -------FRAME INFO OBJECT---------*/
var frameInfo=function(x, y, w, h, bMain){
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.id="";
    this.xOffset = 0;
    this.yOffset = 0;
    this.scale = 1;
    this.element = [];    
    this.activeEleIndex = 0;
    this.controlPoints = [];
    this.ctrlPtCount = 0;
    this.table = null;
    this.active=false;
    this.transitionEffect="None";
    this.bSlideshow=false;
    this.isEditable=true;
    this.rotation=0;
    this.duration=5;
    this.common = {
        scaleFactor:0,
        prevPt:null,
        hammerObj:null,
    };
    this.groupId=null;
};
/*-------TABLE INFO OBJECT--------*/
var tableInfo=function(x,y,w,h){
    this.headerElement=null;
    this.headerMargin = 0;
    this.col = [];
    this.initRowCount = 0;
    this.separator = null;
    this.separatorCP = null;
    this.minWidth = 0;
    this.minHeight = 0;
    this.x=x;
    this.y=y;
    this.h=h;
    this.w=w;
    this.pSeparator=[];
};
/* -------ELEMENT INFO OBJECT---------*/
var elementInfo=function(w, h, imgSrc, type){
    this.orgW = w;
    this.orgH = h;
    this.scale = 1;
    this.imageSrc = imgSrc;
    this.thumbPath="";    
    this.OriginalPath = "";
    this.elementType = type;
    this.fileName="";
    this.x = 0;
    this.y = 0;
    this.w = 0;
    this.h = 0;
    this.minW=0;
    this.minH=0;
    this.xOffset = 0;
    this.yOffset = 0;
    this.rotation = 0;
    this.opacity = 100;
    this.margin={t:0,r:0,b:0,l:0};
    this.initXOffset = 0;
    this.initYOffset = 0;
    this.textElms=[];
    this.actvTxtElmIndx=0;    
    this.duration=0;
    this.weather=null;
    this.timeZoneOffset='';//getGMTTimeZoneList(0, 'default');
    this.timeZoneName="Indian Standard Time";
    this.shapeDetails=null;    
    this.dayLightSaving=0;  
    this.mediaRssInfo={};
    this.groupId=null;
    this.webRefreshInterval = "00:01:00";
};

var shapeInfoTempObj=function()
{   
	this.x = 0;
	this.y = 0;
	this.w = 0;
	this.h = 0;
	this.thumbOrgW=0;
	this.thumbOrgH=0;
	this.divID=null;
	this.FigureRoundRatio=0; // rect
    this.LineColor="rgb(56,93,138)",
    this.FigureStrokeWidth=3,
    this.FigureStrokePattern=0,
    this.FillColor="rgb(79,129,189)";
    this.typeName = "";
    this.FillOpacity=100;
    this.FigureStrokeOpacity=100;
    this.Slope=30; // parallelogram,trapezoid
    this.FrameWidth=50; // frame
    this.ApexRatio=50; // tringle
    this.Arrowtype=4; // arrow
    this.ArrowHeadLength=40;
    this.ArrowBodyWidth=50;
    this.ylowPts=[{x:40,y:50}];
    this.FoldedRatio=50; // folder
    this.StartWidth=31; // start and start24p
    this.elementName=0;
    this.FillRange=0;
    this.imgSrc=""; 
	this.PolygonWidth = 35;
	this.BendingType = 0; // for line
	this.DonutWidth = 20;//Donut
	this.BarWidth = 50; // for cross
	this.EllipseSize = 35; // for sun
    this.StartAngle = 50;// for arc
    this.EndAngle = -90; // for arc: if set to 270, it creates full ellipse
    this.VertexPosition = 50; // for brace
    this.RoundCornerRatio = 100; // for brace
    this.CurvedRatio = 50; // for wave
    this.HorizontalSlope = 50; // for wave
    this.previewMode = false;
    // for rectangular callout
    this.InnerRect = {x: 0, y: 0, w: 100, h: 78};
    this.CalloutPoint = {x: 30, y: 100, direction: 6};
};


var WebElmAddFrstTym=false;
var weatherInfo=function()
{   
    this.unit=0;
    this.city="Abilene",
    this.country="United States",
    this.cityId=331108,
    this.dateTimeformat=3;
    this.refrshIntrvl=0;
    this.bgType=0;   
	this.locatnGMT="";
	this.landscapeCityImgUrl="";
	this.portraitCityImgUrl=""; 
	this.wthrIcon=-1;
	this.wthrText="";
	this.currentTemp=NaN; 	
};
/* -------ELEMENT INFO OBJECT---------*/
var textInfo=function(x,y,w,h){   
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.minW=0;
    this.minH=0;
    this.text="";
    this.textImageSrc = "";
    this.textImageName = "";
    this.textHTML = "";
    this.fontSize=40;
    this.fontColor="rgb(0,0,0)";
    this.bgColor="rgb(0,0,0)";//blank means transparent
    this.bgAlpha=0;
    this.alpha=0;
    this.fontFamily="NotoSans-Regular";
    this.hAlign="center";
    this.vAlign="middle";
    this.fontItalic=false;  
    this.fontBold = false;
    this.fontUnderLine = false;
    this.bTextSlide = false;
    this.slideType = 1;
    this.slideSpeed = 25;
    this.bMenuOrPrice=false;
    this.format=0;
    this.timeZoneOffset='';//getGMTTimeZoneList(0, 'default');
    this.timeZoneName="";
    this.dayLightSaving=0;    
    this.rssInfo={};
    this.isStrkApplied =false;
    this.strkClr="rgb(0,0,0)";
    this.strkOpc = 100;
    this.strkDpt = 3;
    this.isShdwApplied =false;
    this.shdwClr="rgb(0,0,0)";
    this.shdwOpc = 40;
    this.shdwDpt = 3;
    this.shdwDir = 45;
    this.rotation=0;
    this.groupId=null;
    this.DisplayLanguage=1;
};
var rssInformation=function()
{
  this.url="";
  this.reloadDuration=0;
  this.title={};
  this.flipSpeed = 5;
  this.date={};
  this.description={};    
};
var mediaRssInfo=function()
{
  this.url="";
  this.reloadDuration=5;// Set as 5 by default
  this.aspectFill=0;
};
var styleInfo=function(visible,color,hAlign,fSize)
{
    this.visible=visible;
    this.color=color;
    this.hAlign=hAlign;
    this.fontSize=fSize;
};
var transitionEffectInfo={
	"None":"../resource/img/icon_transition_l/icon_transition_l_none.png"
	,"Cut_Black_Fade":"../resource/img/icon_transition_l/icon_transition_l_cut_black_fade.png"
	,"ShortFade_East":"../resource/img/icon_transition_l/icon_transition_l_shortfade_east.png"
	,"ShortFade_South":"../resource/img/icon_transition_l/icon_transition_l_shortfade_south.png"
	,"ShortFade_North":"../resource/img/icon_transition_l/icon_transition_l_shortfade_north.png"
	,"ShortFade_West":"../resource/img/icon_transition_l/icon_transition_l_shortfade_west.png"
	,"Wipe_East":"../resource/img/icon_transition_l/icon_transition_l_wipe_east.png"
	,"Wipe_West":"../resource/img/icon_transition_l/icon_transition_l_wipe_west.png"
	,"Wipe_South":"../resource/img/icon_transition_l/icon_transition_l_wipe_south.png"
	,"Wipe_North":"../resource/img/icon_transition_l/icon_transition_l_wipe_north.png"
	,"Curtain":"../resource/img/icon_transition_l/icon_transition_l_curtain.png"
	,"Quadrant":"../resource/img/icon_transition_l/icon_transition_l_quadrant.png"
	,"Zoom_up":"../resource/img/icon_transition_l/icon_transition_l_zoomup.png"
	,"Swiss":"../resource/img/icon_transition_l/icon_transition_l_swiss.png"	
	,"Uncover":"../resource/img/icon_transition_l/icon_transition_l_uncover.png"
};
/* -------FRAME CONTROL POINT OBJECT---------*/
var controlPoint=function(x, y, direction, side){
    this.x = x;
    this.y = y;
    this.direction = direction;
    this.side = side;
};
/*---------MAIN FRAME DIVIDING LINES ---------*/
var gridLine=function(pt1, pt2, type){
    this.pt1 = pt1;
    this.pt2 = pt2;
    this.affectedFrameIds = [];
    this.type = type;
};

var gridLineRange=function(xRange, yRange){
    this.xRange = xRange;
    this.yRange = yRange;
};
/*----------TABLE SEPARATOR LINE OBJECT-------*/
var tableSeparator=function(x,y,w,h){
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.controlPoint = null;
};

var cropInfo=function(frameId, xOffset, yOffset, scale, rotation){
    this.id = frameId;
    this.xOffset = xOffset;
    this.yOffset = yOffset;
    this.scale = scale;
    this.rotation = rotation;
};

cropInfo.prototype.setCropInfo=function(frameId, xOffset, yOffset, scale, rotation){
    this.id = frameId;
    this.xOffset = xOffset;
    this.yOffset = yOffset;
    this.scale = scale;
    this.rotation = rotation;
};

cropInfo.prototype.clearCropInfo=function(){
    this.id = "";
    this.xOffset = 0;
    this.yOffset = 0;
    this.scale = 1;
    this.rotation = 0;
};

var stickerCopyInfo=function(direction, x, y){
    this.direction = direction;
    this.x = x;
    this.y = y;
};

stickerCopyInfo.prototype.setStickerCopyInfo=function(direction, x, y){
    this.direction = direction;
    this.x = x;
    this.y = y;
};

stickerCopyInfo.prototype.clearStickerCopyInfo=function(){
    this.direction = TStickerCopyDir.NONE;
    this.x = 0;
    this.y = 0;
};

frameInfo.prototype.setElement = function(element){
    this.element.push(element);
};

frameInfo.prototype.getActiveElement = function(){
    if(this.activeEleIndex!=DEFAULT_VALUE)
    {
    	return this.element[this.activeEleIndex];
    }
    else
    {
    	return null;
    }
};

frameInfo.prototype.addControlPoint = function(id, cp){
    this.controlPoints.push(cp);
    this.ctrlPtCount++;
    console.log("control pt :: "+cp.x+" "+cp.y+" "+cp.direction+" "+cp.side);
};

frameInfo.prototype.getCntlPtForSide = function(side){
    var cp = null;
    for(var count =0; count<this.ctrlPtCount;count++){
        cp = this.controlPoints[count];
        if(cp.side == side){
            break;
        }
    }
    return cp;
};

function getMergedLine(pt1, pt2, line){
    if((pt1.x == line.pt2.x) && (pt1.y == line.pt2.y)){
        return {pt1:line.pt1,pt2:pt2};
    }else if((pt2.x == line.pt1.x) && (pt2.y == line.pt1.y)){
        return {pt1:pt1,pt2:line.pt2};
    }else{
        return line;
    }
}

function isPointsOnLine(pt1, pt2, line, type){
    if((pt1.x == line.pt1.x) && (pt2.x == line.pt2.x)  && (((pt1.y>= line.pt1.y) && (pt1.y<= line.pt2.y)) || ((pt2.y>= line.pt1.y) && (pt2.y<= line.pt2.y))) && (type == VERTICAL)){
        return true;//vertical line
    }else if((pt1.y == line.pt1.y) && (pt2.y == line.pt2.y) && (((pt1.x>= line.pt1.x) && (pt1.x<= line.pt2.x)) || ((pt2.x>= line.pt1.x) && (pt2.x<= line.pt2.x))) && (type == HORIZONTAL)){
        return true;//Horizontal line
    }else{
        return false;
    }
}

function isPointOnLine(pt, line){
    if((pt.x == line.pt1.x) && (pt.y>line.pt1.y) && (pt.y<line.pt2.y)){
        return true;//vertical line
    }else if((pt.y == line.pt1.y) && (pt.x>line.pt1.x) && (pt.x<line.pt2.x)){
        return true;//Horizontal line
    }else{
        return false;
    }
}

function isPointApproxOnLine(pt, line){
    if((Math.round(pt.x) == Math.round(line.pt1.x)) && (Math.round(pt.y)>Math.round(line.pt1.y)) && (Math.round(pt.y)<Math.round(line.pt2.y))){
        return true;//vertical line
    }else if((Math.round(pt.y) == Math.round(line.pt1.y)) && (Math.round(pt.x)>Math.round(line.pt1.x)) && (Math.round(pt.x)<Math.round(line.pt2.x))){
        return true;//Horizontal line
    }else{
        return false;
    }
}

function isLinesOverlap(line1, line2, type){
    if((((line1.pt1.y == line2.pt1.y) && (line1.pt2.y == line2.pt2.y)) ||
        ((line1.pt1.y<=line2.pt1.y) && (line1.pt2.y > line2.pt1.y)) ||
        ((line1.pt1.y>=line2.pt1.y) && (line1.pt1.y < line2.pt2.y)) ||
        ((line1.pt1.y>line2.pt1.y) && (line1.pt1.y < line2.pt2.y) && (line1.pt2.y>line2.pt1.y) && (line1.pt2.y < line2.pt2.y)) ||
        ((line1.pt1.y<line2.pt1.y) && (line1.pt1.y < line2.pt2.y) && (line1.pt2.y>line2.pt1.y) && (line1.pt2.y > line2.pt2.y))
        ) && (type == VERTICAL)){
        return true;//vertical line
    }else if((((line1.pt1.x == line2.pt1.x) && (line1.pt2.x == line2.pt2.x)) ||
              ((line1.pt1.x<=line2.pt1.x) && (line1.pt2.x > line2.pt1.x)) ||
              ((line1.pt1.x>=line2.pt1.x) && (line1.pt1.x < line2.pt2.x)) ||
              ((line1.pt1.x>line2.pt1.x) && (line1.pt1.x < line2.pt2.x) && (line1.pt2.x>line2.pt1.x) && (line1.pt2.x < line2.pt2.x)) ||
              ((line1.pt1.x<line2.pt1.x) && (line1.pt1.x < line2.pt2.x) && (line1.pt2.x>line2.pt1.x) && (line1.pt2.x > line2.pt2.x))
              ) && (type == HORIZONTAL)){
        return true;//Horizontal line
    }else{
        return false;
    }
}

function isRectIntersect(a, b){
    return (a.x <= (b.x + b.w) &&
            b.x <= (a.x + a.w) &&
            a.y <= (b.y + b.h) &&
            b.y <= (a.y + a.h));
}
/*
function isRectIntersectExceptBoundary(a, b){
    return (a.x < (b.x +b.w) &&
            b.x < (a.x + a.w) &&
            a.y < (b.y + b.h) &&
            b.y < (a.y + a.h));
}*/

function isRectIntersectExceptBoundary(a, b){
    return (a.x < (b.x +(b.w<1?1:b.w)) &&
            b.x < (a.x + (a.w<1?1:a.w)) &&
            a.y < (b.y + (b.h<1?1:b.h)) &&
            b.y < (a.y + (a.h<1?1:a.h)));
}

function isPointsOnRect(pt1, pt2, rect, side){
    if(side == LEFT_SIDE){
        if((pt1.x == rect.x) && (pt2.x == rect.x)){
            return true;
        }
    }else if(side == TOP_SIDE){
        if((pt1.y == rect.y) && (pt2.y == rect.y)){
            return true;
        }
    }else if(side == BOTTOM_SIDE){
        if((pt1.y == (rect.y+rect.h)) && (pt2.y == (rect.y+rect.h))){
            return true;
        }
    }else if(side == RIGHT_SIDE){
        if((pt1.x == (rect.x+rect.w)) && (pt2.x == (rect.x+rect.w))){
            return true;
        }
    }else{
        console.log("ERROR:: SIDE PARAMETER INCORRECT!!");
    }
    
    return false;
}

function isRelPointsOnRect(pt1, pt2, rect, side){
    var x1 = pt1.x + rect.x;
    var x2 = pt2.x + rect.x;
    var y1 = pt1.y + rect.y;
    var y2 = pt2.y + rect.y;
    if(side == LEFT_SIDE){
        if((x1 == rect.x) && (x2 == rect.x)){
            return true;
        }
    }else if(side == TOP_SIDE){
        if((y1 == rect.y) && (y2 == rect.y)){
            return true;
        }
    }else if(side == BOTTOM_SIDE){
        if((y1  == (rect.y+rect.h)) && (y2 == (rect.y+rect.h))){
            return true;
        }
    }else if(side == RIGHT_SIDE){
        if((x1 == (rect.x+rect.w)) && (x2 == (rect.x+rect.w))){
            return true;
        }
    }else{
        console.log("ERROR:: SIDE PARAMETER INCORRECT!!");
    }
    
    return false;
}

function isPointInsideRect(pt, rect){
    return pt.x>=rect.x && pt.x <= (rect.x+rect.w) && pt.y>=rect.y && pt.y <= (rect.y+rect.h);
}

function getCtrlPtForLine(pt1, pt2, side){
    if(pt1.x == pt2.x){
        return new controlPoint(pt1.x, Math.round((pt2.y + pt1.y)/2), DIRECTION_HORIZONTAL, side);
    }else if(pt1.y == pt2.y){
        return new controlPoint(Math.round((pt2.x + pt1.x)/2), pt1.y, DIRECTION_VERTICAL, side);
    }else{
        console.log("ERROR::LINE POINTS NOT ON VERTICAL OR HORIZONTAL STRAIGHT LINE");
    }
}

var pointerEventToXY = function(e){
      var out = {x:0, y:0};
      if(e.type == 'touchstart' || e.type == 'touchmove' || e.type == 'touchend' || e.type == 'touchcancel'){
        var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
        out.x = touch.pageX;
        out.y = touch.pageY;
      } else if (e.type == 'mousedown' || e.type == 'mouseup' || e.type == 'mousemove' || e.type == 'mouseover'|| e.type=='mouseout' || e.type=='mouseenter' || e.type=='mouseleave') {
        out.x = e.pageX;
        out.y = e.pageY;
      }
      return out;
};

function getCoordinatesAfterRotation(rect, angle){
//This function is not working as per requiremnt Try using getBoundingClientRect()
    log.debug("STARTED","getCoordinatesAfterRotation");
    var x1 = Math.round((rect.x * Math.cos(angle)) - (rect.y * Math.sin(angle)));
    var y1 = Math.round((rect.x * Math.sin(angle)) + (rect.y * Math.cos(angle)));
    var x2 = Math.round(((rect.x+rect.w)*Math.cos(angle)) - ((rect.y + rect.h) * Math.sin(angle)));
    var y2 = Math.round(((rect.x+rect.w)*Math.sin(angle)) + ((rect.y + rect.h) * Math.cos(angle)));
    var x3 = Math.round((rect.x * Math.cos(angle)) - ((rect.y + rect.h) * Math.sin(angle)));
    var y3 = Math.round((rect.x * Math.sin(angle)) + ((rect.y + rect.h) * Math.cos(angle)));
    var x4 = Math.round(((rect.x + rect.w)* Math.cos(angle)) - (rect.y * Math.sin(angle)));
    var y4 = Math.round(((rect.x + rect.w) * Math.sin(angle)) + (rect.y * Math.cos(angle)));
    var xCordArr = [x1, x2,x3,x4];
    xCordArr.sort(function(a,b){return a-b;});
    var yCordArr = [y1, y2,y3,y4];
    yCordArr.sort(function(a,b){return a-b;});
    log.debug("INPUT RECT = "+rect.x+" rect.y = "+rect.y+" rect.w = "+rect.w+" rect.h = "+rect.h +" angle = "+angle,"getCoordinatesAfterRotation");
    log.debug("Rotated RECT = "+xCordArr[0]+" y1 = "+yCordArr[0]+" x2 = "+xCordArr[3]+" y2 = "+yCordArr[3] ,"getCoordinatesAfterRotation");
    return {x1:xCordArr[0],y1:yCordArr[0],x2:xCordArr[3],y2:yCordArr[3]};
}

function getRotationDegrees(obj) {
    var matrix = obj.css("-webkit-transform") ||
    obj.css("-moz-transform")    ||
    obj.css("-ms-transform")     ||
    obj.css("-o-transform")      ||
    obj.css("transform");
    if(matrix !== 'none') {
        var values = matrix.split('(')[1].split(')')[0].split(',');
        var a = values[0];
        var b = values[1];
        var angle = Math.round(Math.atan2(b, a) * (180/Math.PI));
    } else { var angle = 0; }

    if(angle < 0) angle +=360;
    return angle;
}

function getModelInStr(iModelNo)
{
    iModelNo=getParseIntInDec(iModelNo);
    if(iModelNo!=RMD_MODEL)
    {
        return "RHE";
    }
    else
    {
        return "RMD";
    }
}



function getAllTemplatesIDArray(iModelNo)
{
    var templtObj={
    	"landscape":null
    	,"portrait":null
    };
    var modelStr=getModelInStr(iModelNo);
    var modeArray=["landscape","portrait"];
	var catArray=["M","L","S","P","I"];
	var catArrayLen=catArray.length;
	var xmlObj;
	var tempObj;
	var tempModel;
	for(var j=0;j<2;j++)
	{ 	
        tempObj={
        	"M":[]
        	,"L":[]
        	,"S":[]
        	,"P":[]
        	,"I":[]
        	,"All":[]
        };
		var templates = jsonPath(templateJSONObj, "$..templates[?(@.mode == '" + modeArray[j] +"')]");
		var templateObj = jsonPath(templates, "$..template")[0];
		$.each(templateObj, function(templateIndex, template) {
            tempModel=template.Model;
            if(tempModel.indexOf(modelStr)!=-1)
            {
            	for(var i=0;i<catArrayLen;i++)
            	{			        	
    	        	if(isValidForCategory(template.id,catArray[i]))
    	        	{
    	        	    fillTempltObj(catArray[i], tempObj, template.id, template.type);
    	        	}
            	}
            	fillTempltObj("All", tempObj, template.id, template.type);
            }
		});			
       templtObj[modeArray[j]]=tempObj;
    }
    return templtObj;
}


function fillTempltObj(index, tempObj, templateId, templateType){
    if(!isValidFreeTemplate(templateId))
    {
       tempObj[index].push(templateId);
    }
    else
    {
       tempObj[index].push(templateId+"_"+templateType);
    }
}


function isValidForCategory(id,category)
{
	if(id.indexOf("_"+category+"(")!=-1)
	{
		return true;
	}	
	return false;	
}
function isValidFreeTemplate(id)
{
    if(getParseIntInDec(id.split("_")[2])>=500)
    {
        return true;
    }
    return false;
}
function getUpdtIdForTempl(id)
{
    return id.replace("_Download","").replace("_Embedded","");
}
function getXmlObjProp(obj,prop,numFlag)
{
    if(numFlag)
    {
        return getParseIntInDec($(obj).find(prop).text());
    }
    else
    {
        return $(obj).find(prop).text();
    }
};

function getTemplateJSONObj()
{
  var dfd = $.Deferred();
  printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Template xml ajax call ");
  templateJSONObj=null;
   var playerType=Utils.getActivePlayerType();
  $.ajax({
        type: "GET",
        url: "../resource/JSON/"+(playerType==STRETCH_MODEL?"templates_stretch.json":"templates.json"),
        dataType: "json",
        async:true,
        success: function(json) {
            printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Template xml ajax call Success Method");
            templateJSONObj=json;
            printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Template xml ajax call Success Method");
            dfd.resolve();
        },
        error:function(jqXHR, textStatus, errorThrown)
        {
            //log.debug("JSON LOAD Error :: " + textStatus + " :: "+ errorThrown,"gettemplateXmlObj");
        }
    });
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Template xml ajax call ");
  return dfd.promise();
};



function getXMLColorInRGB(rgbStr)
{
    var color=rgbStr.split(";");
    return "rgb("+color[0]+","+color[1]+","+color[2]+")";
}
function getRGBColorInRGBA(rgbColor,alpha)
{   
    if(typeof(alpha) == "undefined")
    {
        alpha=100;        
    }
     alpha=getParseIntInDec(alpha);
    if(rgbColor.indexOf("#")==-1)
    {
        if(rgbColor.indexOf("rgba(")==-1)
        {
            rgbColor=$.trim(rgbColor.replace("rgb(","").replace(")",""));        
            if(rgbColor!="")
            {
                rgbColor="rgba("+rgbColor+","+opctyToPrsntNvisVrsa(alpha,true)+")";
            }        
            else
            {
                rgbColor="rgba(0,0,0,0)";
            }
        }
    }        
    return rgbColor;
};
function resetMenuPos()
{
  try
  {
     $.resetMenuPosition();
  }
  catch(ex)
  {
    log.debug("Unable to reset menu!");    
  }  
}
var curAuthorMenuId = "";
function closeAuthorMenu()
{    
    try
    {
        curAuthorMenuId = ""; 
        menuObj.hideEditMenu();        
    }
    catch(ex)
    {
        log.debug("Unable to close menu!");
    }  
}

function showAuthorMenu(id){
	log.debug("Start ID:"+id,"showAuthorMenu");
    if(id.indexOf("frameCover-") != -1){
        var frame = templateObj.getInnerFrameForId(TemplateUtils.getInnerFrameIdFromCoverId(id));
        if(frame!=null && frame.table != null){
            log.debug("TABLE FRAME HAS NO MENU", "showAuthorMenu");
            return;
        }
    }
    /* if(curAuthorMenuId == id){
        log.debug("ALREADY OPEN MENU FOR ID = "+id, "showAuthorMenu");
        return;
    }*/
    closeAuthorMenu();
    	if(templateObj.multiSelectMode || TemplateUtils.isElementTypeGroup(id))
        {
        	templateObj.showAuthorMenuForMultiSelectAndGroup(id);
        }
        else
        {
	        if(id.indexOf("frameCover-") != -1){
	            templateObj.showAuthorMenuForFrame(id);
	        }else if(id.indexOf("-elm_") != -1){
	            templateObj.showAuthorMenuForMnFrmElm(id);
	        }else{
	            //No author menu
	        }
        }
        curAuthorMenuId = id;
}
var getAuthorMenuBoundingRect=function(){
    var x = 0;
    var y = 0;
    var w = 0;
    var h = 0;
    if(templateObj.bListViewVisible){
        x = screenWidth * (0.0875 + 0.248);
    }else{
        x = screenWidth * 0.0875;
    }
    w = screenWidth - x;
    y = screenHeight * 0.0925;
    h = screenHeight * 0.74;
    return {x:x,y:y,w:w,h:h};
};

var getCurrentStageScale=function(){
    return templateObj.mainFrame.scale;
};

function updateTime(frame,val) {
    var currentTimeVal=val;
    templateObj.isEdited=true;
    $("#durTxtSecId").text(currentTimeVal);
    frame.duration=currentTimeVal;
}
function checkIpSrcForRegion(newRegion,inpSrctype){
    console.log("newRegion "+newRegion+" inpSrctype "+ inpSrctype);
    var regionArr = getRegionArray(newRegion);
    console.log("regionArr "+regionArr);
    if($.inArray(getParseIntInDec(inpSrctype), regionArr) == -1){       
        return false;
    }else{
        return true;
    }
}
function getDfltIpSrcForRegion(region){
    var regionArr = getRegionArray(region);
    return regionArr[0];
}
function getRegionArray(newRegion){
    var newRegionArray;
    switch(newRegion)
    {
        case REGION_US:
            newRegionArray = regionUSArr;
        break;
        case REGION_CANADA:
            newRegionArray = regionCanadaArr;
        break;
        case REGION_MEXICO:
            newRegionArray = regionMexicoArr;
        break;      
        case REGION_KOREA:
            newRegionArray = regionKoreaArr;
        break;
        default:
            newRegionArray = regionOthersArr;
        break;
    }
    return newRegionArray;
}
function opctyToPrsntNvisVrsa(iVal,flag)
{
    if(flag)
    {
        return getParseIntInDec(iVal)/100;
    }
    else
    {
        return getParseIntInDec(parseFloat(iVal)*100);
    }
}
function getSlidSpdFrMarq(iVal)
{
    var spd=10;
    switch(iVal.toLowerCase())
    {
        case "fast":
            spd=200;
        break;
        case "slow":
            spd=10;
        break;
        case "normal":
            spd=100;
        break;
        default:
        break;
    }
    return spd;
}
function getSlidTypFrMarq(iVal)
{
    var type="none";
    switch(getParseIntInDec(iVal))
    {
        case 1:
            type="right";
        break;
        case 2:
            type="left";
        break;
        case 3:
            type="down";
        break;
        case 4:
            type="up";
        break;
        default:
            type="none";
        break;        
    }
    return type;
}
function invalidURLPopup(iToken,txtObj,iDivId,iUrl)
{
    genericPopUpObj.createPopUp("","Type1","invalidURL");
    genericPopUpObj.appendHTMLData([langObj.template.COM_TV_SID_INVALID_URL_FORMAT_URL]);
    genericPopUpObj.addFooterBtns([{"btntxt":COM_SID_CANCEL,"callback":function(){
    	   var prevUrl = "";
           if(iToken=="rss")
           {
               Utils.showToast(langObj.template.MIA_SID_RSS_FEED_NOT_DISPLAYED_PORPERLY);
               prevUrl = txtObj.rssInfo.url;
               txtObj.rssInfo.url=iUrl; 
               if(UNDO_REDO_ALLOWED){
                    templateObj.createUndoRedoDataFrRssOrWebUrl(txtObj, iUrl, prevUrl,iDivId, TEXT);
               }
           }
           else
           {
             Utils.showToast(langObj.template.MIA_SID_WEBSITE_NOT_DISPLAYED_PORPERLY);
             prevUrl = txtObj.OriginalPath;
             txtObj.OriginalPath=iUrl;
             $("#"+iDivId+"_webDivId").html(iUrl); 
	        if(UNDO_REDO_ALLOWED){
	     	    templateObj.createUndoRedoDataFrRssOrWebUrl(txtObj, iUrl, prevUrl, iDivId, widgetInfo.WEB);
	        }
             if(WebElmAddFrstTym==true)
                {
                	templateObj.openMenuAftrDrop(widgetInfo.WEB);
                	WebElmAddFrstTym=false;
                }               
           } 
        }},{"btntxt":COM_SID_OK,"callback":function(){                                  
              if(iToken=="rss")
              {
                setRssUrl(iDivId,iUrl);  
              }
              else
              {
                 setWebUrl(iDivId,iUrl);   
              }                   
         }
        }]); 
    genericPopUpObj.showPopUp();
}
function setWebUrl(iDivId,tempUrl)
{
    log.debug("START","setRssUrl");    
    if(templateObj!=null)
    {
        var elmObj=templateObj.getInnerFrameForId(iDivId);
        if(elmObj!=null && elmObj.element.length>0)
        {
            elmObj=elmObj.element[0];
        }
        else
        {
            return;
        }
        if(tempUrl=="")
        {           
           tempUrl=elmObj.elementType==widgetInfo.WEB?elmObj.OriginalPath:elmObj.mediaRssInfo.url;
        }       
        
             
        $("#editWebDoneBtnId").off("tap").on("tap", function(e) {
		 	var iUrl=$.trim($("#webEditAreaId").val());
            tempUrl=iUrl;                                    
            if(validateWebUrl(iUrl))
            {
		var prevUrl = "";
        		if(elmObj.elementType==widgetInfo.WEB){
				    prevUrl = elmObj.OriginalPath;
                	elmObj.OriginalPath=iUrl;
                	if(UNDO_REDO_ALLOWED){
                        templateObj.createUndoRedoDataFrRssOrWebUrl(elmObj, iUrl, prevUrl, iDivId, widgetInfo.WEB);
                    }
                }
                else{
			        prevUrl = elmObj.mediaRssInfo.url;
					elmObj.mediaRssInfo.url=iUrl;
					if(UNDO_REDO_ALLOWED){
					    templateObj.createUndoRedoDataFrRssOrWebUrl(elmObj, iUrl, prevUrl,iDivId, widgetInfo.MEDIARSS);
					}
				}
			    $("#"+iDivId+"_webDivId").html(iUrl);
                if(WebElmAddFrstTym==true)
                {
                	templateObj.openMenuAftrDrop(widgetInfo.WEB);
                	WebElmAddFrstTym=false;
                }                
            }
            else
            {
               invalidURLPopup("web",elmObj,iDivId,iUrl); 
            }    
			$("#enterURL").hide();	
			$('.textInputCls:focus').trigger('blur'); 
			return false;
		});
       $('#webEditAreaId').val(tempUrl);
       $('#enterURL').show();       
       $("#webEditAreaId").focus();
    }
}
function setRssUrl(iDivId,tempUrl)
{
    log.debug("START","setRssUrl");
    if(templateObj!=null)
    {
        var txtObj=templateObj.getTextObjectFromId(iDivId);
        if(txtObj==null)
        {
            return;
        }
        if(tempUrl=="")
        {           
           tempUrl=txtObj.rssInfo.url;
        }
        if(tempUrl=="")
        {
            //tempUrl="http://www.samsung.com/us/function/rss/rssFeedItemList.do?typeCd=NEWS";
        }
        $('#editRssDoneBtnId').off('tap').on('tap', function(){
			var iUrl=$.trim($("#rssEditAreaId").val());
		    if(validateWebUrl(iUrl))
            {
		        var prevUrl = txtObj.rssInfo.url;
                txtObj.rssInfo.url=iUrl;
                if(UNDO_REDO_ALLOWED){
 		            templateObj.createUndoRedoDataFrRssOrWebUrl(txtObj, iUrl, prevUrl,iDivId, TEXT);
 		        }
            }
            else
            {
               invalidURLPopup("rss",txtObj,iDivId,iUrl); 
            }          
            $('#enterRssURL').hide();     
            $('.textInputCls:focus').trigger('blur');   
            return false;
		});
   
       	$('#rssEditAreaId').val(tempUrl);
		$('#enterRssURL').show();
		$("#rssEditAreaId").focus();
    }
}