﻿var sourceType = {
    VIDEO : 'VIDEO',
    TV : 18,
    DVI : 4,
    HDMI1 : 7,
    HDMI2 : 11,
    HDMI3 : 17,
    AV : 2,
    RGB : 3,
    DP : 14,
    COMPONENT : 1
};
var widgetInfo = {
	MEDIARSS:50,
    WEB:51,
    RSS:52,
    WEATHER_TODAY:53,
    WEATHER_WEEK:54,
    WEATHER_HOUR:55,
    DIGITAL_CLOCK:56,
    ANALOG_CLOCK_1:57,
    ANALOG_CLOCK_2:58,
    ANALOG_CLOCK_3:59,
    ANALOG_CLOCK_4:60,
    ANALOG_CLOCK_5:61
  };  

widgetInfo.widgetList=[{
			"name" : langObj.template.IDS_WEB_KR_WEB,
			"type" : widgetInfo.WEB,
			"bg" : "img_widget_web",
			"web":1
		  }, {
			"name" : langObj.template.IDS_RSS_XML,
			"type" : widgetInfo.RSS,
			"bg" : "img_widget_rss",
		  }, 
		  {
              "name" : langObj.template.MIA_SID_MEDIA_RSS,
              "type" : widgetInfo.MEDIARSS,
              "bg" : "ss_icon_widget_media_rss",
            },
             {
			"name" : langObj.template.VC_IDS_DATEPICKER_TODAY,
			"type" : widgetInfo.WEATHER_TODAY,
			"bg" : "img_widget_weather1",
		 }, {
			"name" : langObj.template.MIA_SID_7_DAY,
			"type" : widgetInfo.WEATHER_WEEK,
			"bg" : "img_widget_weather2",
		 }, {
			"name" : langObj.template.MIA_SID_HOURLY,
			"type" : widgetInfo.WEATHER_HOUR,
			"bg" : "img_widget_weather3",
		 }, {
			"name" : langObj.template.MIA_SID_DIGITAL_CLOCK_KR_DIGITAL,
			"type" : widgetInfo.DIGITAL_CLOCK,
			"bg" : "img_widget_clock7",
		 }, {
			"name" : langObj.template.IDS_ANALOGCLOCK_XML,
			"type" : widgetInfo.ANALOG_CLOCK_1,
			"bg" : "img_widget_clock1",
			"dialImg":"clock_back1.png",
			"hrImg":"time1.png",
			"minImg":"minute1.png",
			"secImg":"second1.png"
		 }, {
			"name" : langObj.template.IDS_ANALOGCLOCK_XML,
			"type" : widgetInfo.ANALOG_CLOCK_2,
			"bg" : "img_widget_clock2",
			"dialImg":"clock_back2.png",
            "hrImg":"time1.png",
            "minImg":"minute1.png",
            "secImg":"second3.png"
		 }, {
			"name" : langObj.template.IDS_ANALOGCLOCK_XML,
            "type" : widgetInfo.ANALOG_CLOCK_3,
    
            "bg" : "img_widget_clock3",
         
            "dialImg":"clock_back3.png",
      
            "hrImg":"time2.png",
        
            "minImg":"minute2.png",
            "secImg":"second2.png"
                       }, {
			"name" : langObj.template.IDS_ANALOGCLOCK_XML,
			"type" : widgetInfo.ANALOG_CLOCK_4,
			"bg" : "img_widget_clock4",
			"dialImg":"clock_back4.png",
            "hrImg":"time3.png",
            "minImg":"minute3.png",
            "secImg":"second4.png"
		 }, {
			"name" : langObj.template.IDS_ANALOGCLOCK_XML,
            "type" : widgetInfo.ANALOG_CLOCK_5,
       
            "bg" : "img_widget_clock5",
        
            "dialImg":"clock_back5.png",
         
            "hrImg":"time4.png",
            
            "minImg":"minute4.png",
           
            "secImg":"second1.png"
                      
		 }];
		 
		 


shapeInfo.shapeList = [

{
	"name" : langObj.template.LineId,
	"type" : shapeInfo.LINE,
	"bg" : "img_shapetype_01",
},
{
	"name" : langObj.template.ARCId,
	"type" : shapeInfo.ARC,
	"bg" : "img_shapetype_02",

},
{
	"name" : langObj.template.RECTId,
	"type" : shapeInfo.RECT,
	"bg" : "img_shapetype_03",

},
{

	"name" : langObj.template.CIRCLEId,
	"type" : shapeInfo.CIRCLE,
	"bg" : "img_shapetype_04",

},  {
	"name" : langObj.template.TrngleId,
	"type" : shapeInfo.TRI,
	"bg" : "img_shapetype_05",

},

{
	"name" : langObj.template.ParallelogramId,
	"type" : shapeInfo.PARLGRM,
	"bg" : "img_shapetype_06",

},
{
	"name" : langObj.template.TrapezoidId,
	"type" : shapeInfo.TRPZOID,
	"bg" : "img_shapetype_07",

},

 {
	"name" : langObj.template.DIAMONDId,
	"type" : shapeInfo.DIAMOND,
	"bg" : "img_shapetype_08",

},
{
	"name" : langObj.template.pentagonId,
	"type" : shapeInfo.PENTGN,
	"bg" : "img_shapetype_09",

},
/*{
	"name" : langObj.template.hexagonId,
	"type" : shapeInfo.HEXAGN,
	"bg" : "img_shapetype_10",

},
{
	"name" : langObj.template.octagonId,
	"type" : shapeInfo.OCTAGN,
	"bg" : "img_shapetype_11",

},*/
{
	"name" : langObj.template.FrameId,
	"type" : shapeInfo.FRAME,
	"bg" : "img_shapetype_12"

},
{
	"name" : langObj.template.CrossId,
	"type" : shapeInfo.CROSS,
	"bg" : "img_shapetype_13"

},
 {
	"name" : langObj.template.DonutId,
	"type" : shapeInfo.DONUT,
	"bg" : "img_shapetype_14"

},
{
	"name" : langObj.template.FolderCorId,
	"type" : shapeInfo.FOLDEDCOR,
	"bg" : "img_shapetype_15"

},

{
	"name" : langObj.template.HeartId,
	"type" : shapeInfo.HEART,
	"bg" : "img_shapetype_16",

},
{
	"name" : langObj.template.lftbraceId,
	"type" : shapeInfo.LEFTBRACE,
	"bg" : "img_shapetype_17"

},
{
	"name" : langObj.template.rghtbraceId,
	"type" : shapeInfo.RIGHTBRACE,
	"bg" : "img_shapetype_18"

},


{
	"name" : langObj.template.OneSideArrId,
	"type" : shapeInfo.ONESDEARROW,
	"bg" : "img_shapetype_19",

},
{
	"name" : langObj.template.TwoSideArrId,
	"type" : shapeInfo.TWOSDEARROW,
	"bg" : "img_shapetype_20",

},

{
	"name" : langObj.template.sunId,
	"type" : shapeInfo.SUN,
	"bg" : "img_shapetype_21"

},


{
	"name" : langObj.template.StarId,
	"type" : shapeInfo.STAR,
	"bg" : "img_shapetype_22",

},
{
	"name" : langObj.template.star24pId,
	"type" : shapeInfo.STAR24P,
	"bg" : "img_shapetype_23",

},
{
	"name" : langObj.template.waveId,
	"type" : shapeInfo.WAVE,
	"bg" : "img_shapetype_24",

},

{
	"name" : langObj.template.rectCalloutId,
	"type" : shapeInfo.RECTCAL,
	"bg" : "img_shapetype_25",

}
/*,

, {
	"name" : langObj.template.CURVEId,
	"type" : shapeInfo.CURVE,
	"bg" : "ss_icon_widget_clock4"
}, {
	"name" : langObj.template.CURVE2Id,
	"type" : shapeInfo.CURVE2,
	"bg" : "ss_icon_widget_clock5"
}*/


];


var regionOthersArr = [sourceType.TV, sourceType.HDMI1, sourceType.HDMI2, sourceType.AV, sourceType.RGB];
var regionUSArr = [sourceType.TV, sourceType.HDMI1, sourceType.HDMI2, sourceType.AV, sourceType.HDMI3];
var regionCanadaArr = [sourceType.TV, sourceType.HDMI1, sourceType.HDMI2, sourceType.AV, sourceType.HDMI3];
var regionMexicoArr = [sourceType.TV, sourceType.HDMI1, sourceType.HDMI2, sourceType.AV, sourceType.HDMI3];
var regionKoreaArr = [sourceType.TV, sourceType.HDMI1, sourceType.HDMI2, sourceType.AV, sourceType.HDMI3];

//var fontListArr = ["NanumBrush", "NanumPen", "NotoSans-Bold", "NotoSans-BoldItalic", "NotoSans-Italic", "NotoSans-Regular", "NotoSerif-Bold", "NotoSerif-BoldItalic", "NotoSerif-Italic", "NotoSerif-Regular", "SamsungSmart_Latin_Bold", "SamsungSmart_Latin_Light", "SamsungSmart_Latin_Medium", "SamsungSmart_Latin_Thin", "SamsungSVDScript_Latin"];

var fontListArr = [];

var isTmpltDownloaded = Utils.isTemplateDownloaded();
var goToHomeFlag = false;
var goToStep1Flag = false;
var prevClickObj = null;
var ipSrcObj = null;
var templatePath;
var updateTemplateName = null;
var isBgGalleryOpen=false;
var saveAsFlag = false;
var drop = $('#tplGalleyDropArea');
var currModel = 0;
var ALL_CATEGORY = 'All';
var LIVE_TV_PORTRAIT_IMG=2;
var ipSrcFlag=false;
function saveAndSaveAsTemplate() {
    var prevTemplateName = SaveTemplate.templateName;
    if (SaveTemplate.templateName == "" || saveAsFlag==true) {
        SaveTemplate.templateName = createNewTemplate();
    }
    genericPopUpObj.createPopUp("","Type2","renameProj");
    genericPopUpObj.appendHTMLData(['<div id="tmpltTitle">'+langObj.Schedule.IDS_BTN_SAVEAS+'</div>'                            
                                +'<div>'+langObj.template.MIA_SID_TENTER_FILE_NAME_SAVE_FILE+'</div><br/>'
                                +'<div id="renameProjInputId" class="renamePrjInputCls">'
                                    +'<input type="text" maxlength="25" name="TemplateInput" class="tmpltInputCls disableCopy" value="Template 01"  data-role="none" id="tmpltInputId" />'
                                +'</div>'
                               // +'<div id="TplNameWarning_msg" class="MIA_SID_YOU_CAN_ENTER_UP_TO_25_CHARACTERS Tpl_Can_Not_Selected" ></div>'
                                ]);
    genericPopUpObj.addFooterBtns([{"btntxt":COM_SID_CANCEL,"callback":function(){
	                                    if(saveAsFlag == true){
	                                            saveAsFlag = false;
	                                    }
	                                    SaveTemplate.templateName = prevTemplateName;
	                                    $("#tmpltInputId").blur();                                    
	                                    Utils.hideKeyboardForcely();
                                    }}
                                 ,{"btntxt":langObj.Schedule.COM_BUTTON_SAVE,"callback":function(){
                                       //setTimeout(function() {                                            
                                            if(saveAsFlag == true){
                                                saveAsFlag = false;
                                            }                                                                                        
                                            var templateName = $("#tmpltInputId").val();
                                            
                                            if(templateName.length>25){
                                                templateName = templateName.substring(0,25);    
                                            }                                                                                  
                                            $("#tmpltInputId").blur();                                            
                                            var templateNameList = getTemplateNameList();  
                                           
                                            //Template name already exists in MyTemplateDb                                      
                                            if (templateNameList.indexOf(templateName) != -1) {
                                                setTimeout(function() {                                                    
                                                    genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
                                                    genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_NAME_ALREAY_USE_OVERWRITE]);
                                                    genericPopUpObj.addFooterBtns([{
                                                        "btntxt" : COM_TV_SID_NO,
                                                        "callback" : function(){
                                                            SaveTemplate.templateName = prevTemplateName;
                                                            saveAndSaveAsTemplate();
                                                        }
                                                    }, {
                                                        "btntxt" : COM_TV_SID_YES,
                                                        "callback" : function() {
                                                            SaveTemplate.saveCount = 0;
                                                            SaveTemplate.templateName = templateName;                                                           
                                                            SaveTemplate.overWriteFlag = true; 
                                                            doTempltProcessForSave();
                                                        }
                                                    }]);
                                                    genericPopUpObj.showPopUp();
                                                }, 100);
                                            } else { //Template name does not exist in MyTemplateDb
                                                if (Utils.isAddTemplateAllowed()) {
                                                    SaveTemplate.saveCount = 0;                                                    
                                                    SaveTemplate.templateName = $("#tmpltInputId").val();
                                                    if(SaveTemplate.templateName.length>25){
                                                        SaveTemplate.templateName = SaveTemplate.templateName.substring(0,25);    
                                                    }
                                                    setTimeout(function() {// added timeout to fix issue related to white strip at bottom of screen for S8 mobile
                                                   	    doTempltProcessForSave();
                                                   	},100);
                                                }
                                            }                                            
                                        //}, 0);
                                        Utils.hideKeyboardForcely();
                                   }}]);
    genericPopUpObj.showPopUp();
    $("#tmpltInputId").val(SaveTemplate.templateName).focus();      
}

function clickInpSrcDropDown(country, htmlText){    
    $(".customdropDownTextDiv").html(htmlText);
    currRegion = country;       
    if (Utils.currStep == STEP_TWO) {//in step-2
        templateObj.setInputSrcRegion(currRegion);        
        templateObj.setDfltIpSrcForRegion(currRegion);
    }else{//in step-1
        if(isSourceExist() && !checkIpSrcForRegion(currRegion, getInputSourceTypeFrmArray())){
            deleteIpSrcObj();
            $("#tplGalleyDropArea div.drpAreaIpSrcCls").remove();
                showGuideMsg();
        }
    }        
    if(Utils.currStep == STEP_ONE){
        inptSrcUIObj.setSourceMenuGuiHandler($("#inpSrcArea1"));
    }else{
        inptSrcUIObj.setSourceMenuGuiHandler($("#inpSrcArea"));        
    }        
}
function getInputSrcTextHtml(){
    var textHtml;
    switch(currRegion)
    {
        case REGION_US:
            textHtml = langObj.template.COM_SID_UNITED_STATES;
        break;
        case REGION_CANADA:
            textHtml = langObj.template.COM_SID_COUNTRY_CANADA;
        break;
        case REGION_MEXICO:
            textHtml = langObj.template.COM_TV_SID_COUNTRY_MEXICO;
        break;        
        case REGION_KOREA:
            textHtml = langObj.template.COM_TV_SID_KOREA;
        break;
        default:
            textHtml = langObj.template.COM_SID_COUNTRY_OTHERS;
        break;
    }
    return textHtml;
}
function isSourceExist() {   
    if(ipSrcObj!=null)
    {
        return true;
    }
    else
    {
        return false;
    }    
}

function getInputSourceTypeFrmArray() {
    if(ipSrcObj!=null)
    {
       return ipSrcObj.orgImgPath; 
    }
    else
    {
        return null;
    }
    
}

function doTempltProcessForSave() {
    refreshScreen(1100);
    templateObj.isEdited = false;    
    templateObj.doProcessForSnapShot();
    var imagePath = Utils.getSystemRootPath() + SaveTemplate.myTemplatePath + SaveTemplate.templateName + ".LFD.PNG";
    
   setTimeout(function(){
          createTemplateImage(imagePath, FRAME_ID_PREFIX + "Main");
    },100);   
};
function getIpSrcName(value) {
    var name = tvTxt;
    value = getParseIntInDec(value);
    if ( typeof value == "number") {
        switch(value) {
            case sourceType.COMPONENT:
                name = compTxt;
                break;
            case sourceType.AV:
                name = avTxt;
                break;
            case sourceType.RGB:
                name = pcTxt;
                break;
            case sourceType.DVI:
                name = dviTxt;
                break;
            case sourceType.HDMI1:
                name = hdmi1Txt;
                break;
            case sourceType.HDMI2:
                name = hdmi2Txt;
                break;
            case sourceType.HDMI3:
                name = hdmi3Txt;
                break;
            case sourceType.DP:
                name = dpTxt;
                break;
            case sourceType.TV:
                name = tvTxt;
                break;
            default:
                break;
        }
    }
    return name;
};
function getIpSrcIconPath(value) {
    var path = "../resource/img/";
    value = getParseIntInDec(value);
    if ( typeof value == "number") {
        switch(value) {
            case sourceType.COMPONENT:
                path = path + "ss_source_component.png";
                break;
            case sourceType.AV:
                path = path + "ss_source_av.png";
                break;
            case sourceType.RGB:
                path = path + "ss_source_rgb.png";
                break;
            case sourceType.DVI:
                path = path + "ss_source_dvi.png";
                break;
            case sourceType.HDMI1:
            case sourceType.HDMI2:
            case sourceType.HDMI3:
                path = path + "ss_source_hdmi.png";
                break;
            case sourceType.DP:
                path = path + "ss_source_dp.png";
                break;
            case sourceType.TV:
                path = path + "ss_source_tv.png";
                break;
            default:
                path = path + "ss_source_tv.png";
                break;
        }
    }
    return path;
};
function getSourceIconPath(value) {
    var path = "../resource/img/";
    value = getParseIntInDec(value);
    if ( typeof value == "number") {
        switch(value) {
            case sourceType.COMPONENT:
                path = path + "ss_icon_source_component.png";
                break;
            case sourceType.AV:
                path = path + "ss_icon_source_av.png";
                break;
            case sourceType.RGB:
                path = path + "ss_icon_source_rgb.png";
                break;
            case sourceType.DVI:
                path = path + "ss_icon_source_dvi.png";
                break;
            case sourceType.HDMI1:
            case sourceType.HDMI2:
            case sourceType.HDMI3:
                path = path + "ss_icon_source_hdmi.png";
                break;
            case sourceType.DP:
                path = path + "ss_icon_source_dp.png";
                break;
            case sourceType.TV:
                path = path + "ss_icon_source_tv.png";
                break;
            default:
                path = path + "ss_icon_source_tv.png";
                break;
        }
    }
    return path;
};
function uploadAllTemplateRelatedFiles()
{
	var filArr=["TemplateMagnetEffect.js","CanvasToImage.js","CustomImageEffects.js",
	            		"HorizontalScroll.js","Lfd.js","LfdContent.js",
	            		"LfdCreator.js","Stack.js",
	            		"StickerCopyHandler.js","TemplateEmptyAreaFinder.js",
	            		"TemplatePreview.js","previewTextStickerLayer.js","TemplateRMDExt.js"
	            		];
	setTimeout(function(){
		var len=filArr.length;
		for(var i=0;i<len;i++)
			{
				loadjscssfile("js/"+filArr[i],"js");
			}
		loadjscssfile("../js/jquery.authorColorPicker.js","js");		
		loadjscssfile("../js/time.spinner.js","js");
	},500);
};
$(document).ready(function() {
	getDefaultCityLangJSONObj();
	
    setTimeout(function(){
            countryjsonObject=Utils.getCountryJSONObj();
    },5000);

    globlePlayerType = Utils.getActivePlayerType();
    $(document).keydown("div[contenteditable=true]", function(e) {
        // trap the return key being pressed
        if (e.keyCode == 13) {
            // insert 2 br tags (if only one br tag is inserted the cursor won't go to the second line)
            document.execCommand('insertHTML', false, '<br>&nbsp;');           
            // prevent the default behaviour of return key pressed
            return false;            
        }
    });
  
    //Input source Element Drag and drop
    handleDragEvent('drag_sourceMenuDiv', INPUT_SOURCE);
    //Sticker Element Drag and drop
    handleDragEvent('stickerMenuDiv', STICKER);
    //Widget Element Drag and drop
    handleDragEvent('widgetMenuDiv', '');
    handleDragEvent('shapeMenuDiv', SHAPE);
    handleDragEvent('textMenuDivP', TEXT);
   	uploadAllTemplateRelatedFiles();
});
//Ready Closed

function handleDragEvent(elem, elemType){
	
	 $(document).off('touchstart',"."+elem).on('touchstart', '.'+elem, function(event) {
	 	 var $this = $(this);
	 	 var widgetId = $this.attr("widget-id");
	 	 var localElemType = widgetId!=undefined ? widgetId : elemType;
	 	 if(elemType==SHAPE){
	 	 	localElemType = $this.attr("shape-id");
	 	 }
	 	 console.log("localElemType "+localElemType);
         event.stopPropagation();
         clearTimeout(tapholdTimeout);
         tapholdTimeout = null;
         if($('.clonedCls').length == 0){
        	leftElementDragStart(event, $this, localElemType); 	
         }
        
        
    }).off('touchmove',"."+elem).on('touchmove', '.'+elem, function(e) {
        if(TAPHOLD)
        {
            e.stopPropagation();
            e.preventDefault();
        }
       	var widgetId = $(this).attr("widget-id");
	 	var localElemType = widgetId!=undefined ? widgetId : elemType;
        leftElementDragMove(e, $(this), localElemType);
    }).off('touchend touchcancel',"."+elem).on('touchend touchcancel', '.'+elem, function(e) {
        leftElementDragEnd(e, $(this));
    });

}
function drawSource(divC, id) {    
    var pageWidth = window.innerWidth;    
    var fontSize = pageWidth * 0.025;    
    path = getSourceIconPath(id);
    text = getIpSrcName(id);
    var srcHW=(pageWidth * 0.178);
    var sourceDiv = $('<div>').attr("id", id + "_sourcedrp").css({
        "height" : srcHW + 'px',
        "width" : srcHW + 'px',
        "background-color" : divC                 
    }).addClass("drpAreaIpSrcCls");

    var iconDiv = $('<div class="drpAraIpIcnCls">').css({
        "height" : srcHW * 0.38 + 'px',
        "width" : srcHW * 0.50 + 'px',
        "margin" : "auto",
        "margin-top" : srcHW * 0.16 + 'px',
        "background-image" : "url('" + path + "')"            
    });
    var iconDivText = $('<div  class="drpAraIpTxtCls">').css({        
        "width" : srcHW + 'px',
        "margin-top" : srcHW * 0.10 + 'px',       
        "font-size" : fontSize + 'px'
    }).html(text);

    sourceDiv.append(iconDiv);
    sourceDiv.append(iconDivText);
    $("#tplGalleyDropArea").append(sourceDiv);    
    galleryContentSel.setAnimFrDrpAraElm({id:id + "_sourcedrp",cntr:0,w:srcHW,h:srcHW});
    showTostForIpSrc(id,false);
    galleryContentSel.setStylFrDrpAreaElm(id + "_sourcedrp",30);    
}
function getSchListLength() {
    var schLength=0;
    try
    {
        var schInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
        var schLength = schInfo.myScheduleInfoArrs.length;
    }
    catch(ex)
    {
        schLength=0;
    }
    return schLength;
}

var TAPHOLD = false;
var tapholdTimeout = null;
var box, cloneWidth, cloneHeight;
var mouse_init_x = 0;
var mouse_init_y = 0;
var mouse_move_x = 0;
var mouse_move_y = 0;

function leftElementDragStart(event, currElem, elemType) {
    $('.clonedCls').remove();
    var mouse_x = pointerEventToXY(event).x;
    var mouse_y = pointerEventToXY(event).y;
    mouse_init_x = mouse_x;
    mouse_init_y = mouse_y;
    tapholdTimeout = setTimeout(function(e){
            
                event.preventDefault();
                TAPHOLD = true;
                hideBottomMenu();
                //Clone and drag
                
                createDraggableClone(currElem, mouse_x, mouse_y, elemType);
            }, TAPHOLDTIME);       
}

function leftElementDragMove(event, currElem, elemType) {
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
         if(TAPHOLD)
        {
             event.preventDefault();
            mouse_move_x = pointerEventToXY(event).x;
            mouse_move_y = pointerEventToXY(event).y;
            var absX = Math.abs(mouse_move_x - mouse_init_x);
            var absY = Math.abs(mouse_move_y - mouse_init_y);  
            $('#draggableClone').css({
                'top' : (mouse_move_y - (cloneHeight / 2)) + 'px',
                'left' : (mouse_move_x - (cloneWidth / 2)) + 'px'
            });
            if(elemType==INPUT_SOURCE || elemType==widgetInfo.WEB || elemType==widgetInfo.MEDIARSS)
            {                
                callTemplateFunc(constForTmpl.SHOW_SEL_FRAME,{pt:{x:mouse_move_x,y:mouse_move_y},frameId:""});
            }
        } 
}

function leftElementDragEnd(event, currElem) {
    
    if (tapholdTimeout != null) {
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
    }
    var type = $('#draggableClone').attr('clone-type');
    if (TAPHOLD) {
        event.stopPropagation();
        event.preventDefault();
        if (templateObj != null) {
            var top = getParseIntInDec($('#draggableClone').css("top"));
            var left = getParseIntInDec($('#draggableClone').css("left"));            
            templateObj.addElmToTemplate(currElem, top, left, type);
        }
        else
        {
            revertDragElementPos();
        }
    }
    $('#draggableClone').remove();
    TAPHOLD = false;
}

function updateBGRecycleArea(areaShoW, aHeight) {
    if (areaShoW) {
        $("#bgDelHeader").css({
            "height" : aHeight,
            "background-color" : "#3196ff"
        }).addClass("bGDelExtended").html(langObj.template.var_tpBGDelText);

    } else {
        $("#bgDelHeader").css({
            "height" : aHeight,
            "background-color" : "#ffffff"
        }).remove("bGDelExtended").html("");
    }
}
function showHideSourceTab(orientation)
{
   if(orientation==PORTRAIT)
   {
        $(".source").addClass("icon-disabled");    
   }
   else
   {
       $(".source").removeClass("icon-disabled");
   } 
}
function createDraggableClone(currElem, mouse_x, mouse_y, elemType, elTop, elLeft)
{
    if(elemType==undefined)
    {
        elemType = "";
    }
    
    if($('#draggableClone').length==0)
    {
        var angle = 0;
        if(elemType!=TEXT)
        {
            angle = '-15deg';
        }
        var clone = currElem.clone();
        cloneWidth = currElem.width();
        cloneHeight = currElem.height();
        var bgcolor = currElem.css('background-color');
        if (elemType == STICKER) {
            bgcolor = '';
        }              
        if(elTop==undefined)
	    {
	        var elTop = (cloneHeight / 2);
	    }
	    if(elLeft==undefined)
	    {
	        var elLeft = (cloneWidth / 2);
	    }
        clone.css({
            "width" : cloneWidth + 'px',
            "height" : cloneHeight + 'px',
            "z-index" : "999999999",
            "-webkit-transform" : "rotate("+angle+")",
            'top' : (mouse_y - elTop) + 'px',
            'left' : (mouse_x - elLeft) + 'px',
            'position' : 'absolute',
            'margin':'0',
            'background-color' : bgcolor
        }).attr('id', 'draggableClone').attr('clone-type', elemType).attr('org-id', currElem.attr('id'));
        clone.addClass('clonedCls');
        
           if(elemType==TEXT)
           {
               clone.css({'border-color':'#3196ff'});
           }
        clone.appendTo('body');
        box = '#draggableClone';
       
    }
}
function revertDragElementPos()
{
    //Revert the clone place to its initial position as the clone has been dropped to wrong position
    $('#draggableClone').animate({left:(mouse_init_x-50), top:(mouse_init_y-50)}, 500, function(){
        $('#draggableClone').remove();
    });
}

function highlightFrmSuccess(frameId)
{
 if(frameId=="-1")
 {
     callTemplateFunc(constForTmpl.OUTSIDETAP);     
 }
 else
 {
     callTemplateFunc(constForTmpl.SHOW_SEL_FRAME,{pt:null,frameId:frameId});     
 }   
}
function highlightFrmError(data)
{
 callTemplateFunc(constForTmpl.SHOW_SEL_FRAME,{pt:null,frameId:""});  
}
function showTostForIpSrc(srcID,transitionFlag)
{
    log.debug("CurrModel: "+ currModel+",srcID:"+srcID+",ipSrcFlag:"+ipSrcFlag,"showTostForIpSrc");
    if(currModel!=RMD_MODEL && !ipSrcFlag)
    {
        var name=getIpSrcName(getParseIntInDec(srcID));
        var flag=false;
        switch(name)
        {
            case pcTxt:
            case hdmi3Txt:
            case dpTxt:
            case dviTxt:
            case compTxt:
                flag=true;
            break;
            default: 
                flag=false;           
            break;
            
        }
        if(flag)
        {
            ipSrcFlag=true;
            Utils.showToast(langObj.template.MIA_SID_SOURCE_TYPE_NOT_SUPPORT_NOT_DISPROPERLY);
            if(transitionFlag!=undefined && transitionFlag)
            {
            	setTimeout(function(){	
						Utils.showToast(MIA_SID_INPUT_SOURCE_SLIDESHOW_NOT_SUPPORTED_PORTRAIT);
				},2500);
            }
        }
    }
    log.debug("Completed","showTostForIpSrc");
}
function getAnlgClokIcnsByType(iType)
{
    var length=widgetInfo.widgetList.length;
    var iconPath={};
    var currObj;
    var rootPath="../resource/img/widget/";
    for(var i=0;i<length;i++)
    {
        currObj=widgetInfo.widgetList[i];
        if(currObj.type==iType)
        {
            iconPath.bg=rootPath+currObj.bg;
            iconPath.ClockBackImage=rootPath+currObj.dialImg;
            iconPath.ClockHourImage=rootPath+currObj.hrImg;
            iconPath.ClockMinuteImage=rootPath+currObj.minImg;
            iconPath.ClockSecondImage=rootPath+currObj.secImg;
            break;
        }
    }
    if(iconPath.bg!="")
    {
        iconPath.bg=iconPath.bg.replace(/.png/ig,"");
        iconPath.bg=iconPath.bg+"_big.png";
    }
    return iconPath;
}


function validateWebUrl(webUrl) {
    //var re = /^(http[s]?:\/\/){0,1}(www\.){0,1}[a-zA-Z0-9\.\-]+\.[a-zA-Z]{2,5}[\.]{0,1}/;
    var re= /(((http|ftp|https):\/{2})+(([0-9A-Za-z_-]+\.)+(aero|asia|biz|cat|com|coop|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|tel|travel|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mn|mn|mo|mp|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|nom|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ra|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw|arpa)(:[0-9]+)?((\/([~0-9a-zA-Z\#\+\%@\.\/_-]+))?(\?[0-9a-zA-Z\+\%@\/&\[\];=_-]+)?)?))\b/i;
    
    var spclSyblArr = ["%F0", "%E2", "%EF%BF%A6", "%E3%8A%99", "%E3%8A%97", "%E3%80%B0", "%E3%80%BD"];
    var len = spclSyblArr.length;
    var pos = -1;
    var validateTxt = encodeURIComponent(webUrl);
    for (var i = 0; i < len; i++) {
        pos = validateTxt.indexOf(spclSyblArr[i]);
        if (pos != -1) {                  
            return false;           
        }
    }
    
    if (!re.test(webUrl)) {
        return false;
    } else {
        return true;
    }
}