define('Heart', ['Shape'], function (Shape) {
    var prop ={};
     return {
         draw : function (options){
                var def = $.Deferred();
                prop = $.extend(true, {},Shape.default, options);
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                var context = Shape.context;
                this.drawOutline(prop,true,'');
                var $this = this; 
                Shape.fillImage(prop).done(function(value) {
                   
                     if(prop.shapeDetails.FillRange==1){
                        $this.drawOutline(prop,true,'source-over');
                      }else{
                          $this.drawOutline(prop,true,'');
                      }
                    def.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });
                return def.promise();
            },
         drawOutline : function (prop, borderFlag, composite){
              	var context = Shape.context;
                var width = Shape.width;
                var height = Shape.height;
                var d =Shape.width;
                var d1=Shape.height;
                var k = Shape.canvasMargin/2;
				Shape.resetAlpha(composite);
                context.beginPath();
                context.moveTo(k, k + d1 / 4);
                context.quadraticCurveTo(k, k, k + d / 4, k);//1
                context.quadraticCurveTo(k + d * 3/8, k, k + d / 2, k + d1 / 4);//2
                context.quadraticCurveTo(k + d * 5/8, k, k + d * 3/4, k);//3
                context.quadraticCurveTo(k + d, k, k + d, k + d1 / 4);//4
                context.quadraticCurveTo(k + d, k + d1 / 2, k + d * 3/4, k + d1 * 3/4);//5
                context.lineTo(k + d / 2, k + d1);//6
                context.lineTo(k + d / 4, k + d1 * 3/4);//7
                context.quadraticCurveTo(k, k + d1 / 2, k, k + d1 / 4);//8
                context.closePath();
                Shape.drawStroke(prop); 
         }
     };
});