define('Line', ['Shape'], function (Shape) {
     return {
         draw : function (options){
                var d = $.Deferred();
                var prop = $.extend(true, {},Shape.default, options);
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                var context = Shape.context;
                borderWidth=borderWidth*3/4;
                context.beginPath();
                var canvasMargin = Shape.canvasMargin/2;
                context.moveTo(canvasMargin,canvasMargin);
                context.lineTo(prop.w+canvasMargin,prop.h+canvasMargin);
                Shape.drawStroke(prop);
                
                Shape.fillImage(prop).done(function(value) {
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                }).fail(function() {
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });    
                return d.promise();
            }
     };
});